#if !defined(__GNUC__) && !defined(_CONSOLE)		// VC GUI Platform
// Contents.cpp : implementation file
//

#include "stdafx.h"
#include "newpgen.h"
#include "Contents.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CContents dialog


CContents::CContents(bool fShowWhatsNew, CWnd* pParent /*=NULL*/)
	: CDialog(CContents::IDD, pParent), m_fShowWhatsNew (fShowWhatsNew)
{
	//{{AFX_DATA_INIT(CContents)
	//}}AFX_DATA_INIT
}


void CContents::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CContents)
	DDX_Control(pDX, IDC_EDIT1, m_Edit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CContents, CDialog)
	//{{AFX_MSG_MAP(CContents)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

char *ContentsText = 
"NewPGen 2.82. Written by Paul Jobling.\r\n"
"Assembly magic by Yves Gallot."
"\r\n\r\n"
"NewPGen generates input files for Proth, PFGW, or PRP. Proth performs primality tests for numbers of the form "
"k.b^n+1 and k.b^n-1; PRP performs very rapid pseudo-primality tests for these numbers; "
" PFGW performs primality tests for more general forms. "
"\r\n\r\n"
"Most of NewPGen's sieves require n to be fixed, since if this is the case then you can "
"very quickly sieve a large number of k values in parallel."
"\r\n\r\n"
"NewPGen can be used to generate a file from scratch, or to continue sieving a previously "
"generated file. "
"To create a new file, enter the value of b to be used (the base), the value of n, and the first and last "
"k values to use (kmin and kmax). Then select the type of sieving that you wish to perform "
"on these numbers."
"\r\n\r\n"
"Hit the Start button, and NewPGen will start sieving the numbers that you have specified, by going up through the primes and removing those k's where the expression that you have specified is divisible by the prime."
"\r\n\r\n"
"In general, you ought to sieve until the rate at which NewPGen is throwing out composites is equal to the rate "
"at which Proth/PRP/PFGW can perform a primality test on the numbers. Actually, you should stop a little sooner - the idea is to "
"find primes, after all."
"\r\n\r\n"
"To set the names of the files to use, either type in the names of the files or drag an existing file into the edit box."
"\r\n\r\n"
"The supported sieves are:"
"\r\n\r\n"
"k.b^n+1"
"\r\n\r\n"
"k.b^n-1"
"\r\n\r\n"
"k.b^n1 \r\n- this sieves for twin primes.\r\n\r\n"
"k.b^n+1 and 2k.b^n+1 \r\n- Cunningham Chains of the 2nd kind."
"\r\n\r\n"
"k.b^n-1 and 2k.b^n-1 \r\n- Sophie Germain prime."
"\r\n\r\n"
"k.b^n1 & 2k.b^n1 \r\n- this is a BiTwin chain of four primes (1 link)."
"\r\n\r\n"
"k.b^n1 & 2k.b^n-1 \r\n- this sieves for a twin prime and also a SG pair of primes (this type of search "
"was used by  Wassing, Jrai, and Indlekofer to find their record twin and SG primes). To use the output file in Proth "
"specify the mode as k.b^n-1, and if Proth finds that this is prime it will automatically check the primality "
"of k.b^n+1 and 2k.b^n-1."
"\r\n\r\n"
"k.b^n1 & 2k.b^n+1 \r\n- this is the same as the above except that the sieving is for a twin and a CC. In a "
"similar way to the above test, Proth should be set to use the mode k.b^n+1."
"\r\n\r\n"
"For the CC, SG, Bitwin, Twin/SG, and Twin/CC sieves you can look for generalized chains if the base is not 2. "
"If you set this then rather than sieve k.b^n+1 and 2k.b^n+1 (say), NewPGen will sieve k.b^n+1 and k.b^(n+1)+1."
"\r\n\r\n"
"k.b^n1 & k.b^(n-1)+1 & k.b^(n+1)+1 \r\n- this is 'Lucky Plus' mode. Here you are looking for a prime of the form k.b^n+1, but "
"the sieving ensures that k.b^n-1, k.b^(n-1)+1, and k.b^(n+1)+1 do not have any small prime "
"divisors either. The hope is that if you find that k.b^n+1 is prime, you might also get really lucky and find that one of the other three "
"is prime as well, giving you (if the base is 2) either a twin prime or a CC of the 2nd kind."
"\r\n\r\n"
"k.b^n1 & k.b^(n-1)-1 & k.b^(n+1)-1 \r\n- this is 'Lucky Minus' mode. Here you are looking for a prime of the form k.b^n-1, but "
"the sieving ensures that k.b^n+1, k.b^(n-1)-1, and k.b^(n+1)-1 do not have any small prime "
"divisors either. Again, the hope is that if you find that k.b^n-1 is prime, you might also get really lucky and find that one of the other three "
"is prime as well, giving you (if the base is 2) either a twin prime or a Sophie Germain."
"\r\n\r\n"
"NewPGen can also generate files to help search for long chains of primes. These modes are:"
"\r\n\r\n"
"CC 1st kind \r\n- if the base is 2 this is a Cunningham Chain of the first kind of length 3 or more; "
"if the base is not 2 you can choose to have a generalized chain:\r\n" 
"p[n+1] = base*p[n]+(base-1)." 
"\r\n\r\n" 
"CC 2nd kind \r\n- this is the same except that the CC is of the second kind:\r\n" 
"p[n+1] = base*p[n]-(base-1)." 
"\r\n\r\n"
"BiTwin \r\n- this is a chain of BiTwin primes, or a generalized chain if the base is not 2."
"\r\n\r\n"
"Note that for the three searches above, NewPGen will set the value of n in the file to one more than you specify. This is because if Proth "
"finds that (say) k.b^n+1 is prime, it will look at k.b^(n-1)+1 and k.b^(n+1)+1."
"\r\n\r\n"
"b^n+2k-1."
"\r\n- this is to search for primes in arithmetic progression, or consecutive primes in arithmetic progression. "
"A general primality prover must be used to prove them prime after PFGW has found probable primes."
"\r\n\r\n"
"k.b^n1 & k.b^n+5\r\n"
"- this is a prime triplet (or 3-tuple), where p, p+2, and p+6 are all prime. If you use this sieve note "
"that you can prove the first two (k.b^n1) prime using Proth, however the third (k.b^n+5) must be proved using "
"a general primality prover such as Primo, APRT-CLE, or VFYPR. PRP or PFGW should be used to find a k where all 3 numbers "
"are PRPs before attempting the proof."
"\r\n\r\n"
"k.b^n-1, +1, +5, +7\r\n"
"- this is a prime quadruplet (or 4-tuple), where p, p+2, p+6, and p+8 are all prime. If you use this sieve note "
"that you can prove the first two (k.b^n1) prime using Proth, and the other two using a general primality proving program (for example Primo)."
"\r\n\r\n"
"k.b^n+1 with k fixed\r\n- this sieves a range of n values with a fixed k value. This type of sieve is a lot "
"slower than the fixed n sieves, since the speed depends upon the range of n that is being sieved. However this is useful "
"if you want to generate an input file for PRP, and the sieving is usually faster than using Proth to perform trial division. To get the best "
"performance, it is recommended that you use a wide range of n values (at least 3,000), as then NewPGen can use an algorithm that "
"has a speed that is proportional to the square root of the range of n values being sieved (so a range that is 4 times as wide only takes twice as long to sieve)."
"\r\n"
"With this sieve and the next, you can also enter an expression for k. This expression must be of the form num*num*num*...*num, for example 3*5*11*13*19*29*37*41*107"
"\r\n\r\n"
"k.b^n-1 with k fixed\r\n- this sieves a range of n values with a fixed k value. Again this is slower than the fixed n sieves."
"\r\n\r\n"
"k.b^n+1 & 2k.b^n+3\r\n"
"- this is another SG mode. Note that the primality of 2k.b^n+3 can only be tested by Proth if the base is 2."
"\r\n\r\n"
"\r\n\r\n"
"There is a checkbox that can be used to generate output to be used with PFGW. If the \"Use primorial mode\" checkbox is checked, "
"NewPGen will sieve for k.n# rather than k.b^n. Most of the sieves can be used in primorial mode. "
"If you sieve for a chain in primorial mode then the sieving is for k.n#1, 2.k.n#1, 4.k.n#1, etc."
"\r\n\r\n"
"\r\n\r\n"
"NewPGen writes out to the output file occasionally, so that you do not lose your work in the event of a crash. "
"If you are sieving a large number of k's with a fast sieve (typically k.2^n+1 or -1), the time taken to do this "
"saving can be significant. You can change the number of minutes between these saves from the Options menu. "
"To avoid problems where the computer crashes while the save is being performed, if you set the 'Use two save files' option then the previous contents of the output file are saved in a file with the same name followed by a ~, for example the previous contents of 'work.dat' would be saved in 'work.dat~'."
"\r\n\r\n"
"If \"Verify results\" is checked, NewPGen will do a careful check to make sure that the prime actually does divide the number that it thinks it does. "
"This will make NewPGen very slightly slower, but it is recommended that it is always checked, particularly as p gets large (where the scope for "
"programming errors increases), and only uncheck it during the early parts of the sieving if you are using a primorial mode and many k's are being thrown out every second. "
"If you are not using a primorial sieve then leave this checked, as then it makes no difference to NewPGen's performance."
"\r\n\r\n"
"You can automatically control the extent to which the sieving is performed using the \"Sieve Until...\" dialog on the \"Options\" menu. "
"NewPGen will sieve until the criterion that you set has been reached, at which point it will stop, and optionally at this point it will pass the results to PFGW for testing. "
"This also gives you the option to automatically increment n and start sieving again, and to set an end point for the sieving (a maximum value of n to use)."
"\r\n\r\n"
"When generating a new file, NewPGen uses a bitmap to store the k values. "
"By default, 47.7 Mb of RAM is used for the bitmap, though this can be controlled from the Options menu. "
"If the range of k that you specify is too large to fit into the bitmap, NewPGen will break up the range into a number of smaller ranges, each of which fits into the bitmap, and will then "
"sieve each of these in turn up to p=1 billion. Once it has done this, it will combine the results together and sieve them as normal. "
"\r\n\r\n"
"Some technical words now. NewPGen is much faster if the base is 2. This is because division by 2 modulo a prime is easy (you "
"shift it right if it is even, otherwise you add the prime then shift it). Division by other bases isn't so straightforward, however."
"\r\n\r\n"
"NewPGen is happy with lots of k's to sieve - there is nothing to be gained by dividing a range of k's up and sieving each subrange in turn. NewPGen will do this for you anyway, as was mentioned above."
"The value of n doesn't matter too much to NewPGen either."
"\r\n\r\n"
"\r\n"
"If you find a large prime with the help of NewPGen, Chris Caldwell would love to know about it - see http://www.utm.edu/research/primes"
"\r\n\r\n"
"If you find a large Cunningham Chain, Dirk Augustin is interested - see http://groups.yahoo.com/group/primenumbers/files/Prime%20Tables/Cunningham_Chain_records.txt"
"\r\n\r\n"
"Henri Lifchitz keeps a list of large BiTwin chains - see http://ourworld.compuserve.com/homepages/hlifchitz/\r\n"
"(remember, though, that Henri counts the links, which is one less than the length of the chain)."
"\r\n\r\n"
"If you find a large prime triplet or quadruplet, Tony Forbes maintains a very interesting site on k-tuplets at http://www.ltkz.demon.co.uk/ktuplets.htm"
"\r\n\r\n"
"On a personal note I would like to thank Bob Burrowes and Chris Nash for their support "
"and advice during the early development of this program (shame we never got the twin record though, guys), and Dirk Augustin "
"for being a willing and very able beta tester. "
"Many thanks to David Underbakke for his contributions to the find_k0 routine (making k.2^n sieves a lot faster); for the SSE2 version of find_k0; and also for pushing me to use a bitmap representation in the internal Sieve of Eratosthenes, which has also boosted performance. "
"Thanks also to Phil Carmody for all manner of optimisation suggestions - the bitmap option and demonstrating its usefulness; lots of useful input on the fixed k sieves; and a great algorithm for the primorial sieves. "
"Jack Brennen contributed a marvellous idea to the fixed k sieves, making them a lot faster if the range is wide enough. "
"Payam Samidoost found a number-theoretical relationship that made the fixed k sieves twice as fast. "
"Reto Keiser found that with the large ranges of k now possible, the plain array implementation was not optimal. "
"Didier Boivin suggested that it would be nice if the program could automatically continue sieving the last file when it is started. "
"Jean Penn has my gratitude for his fine work in creating a single codebase for NewPGen to allow Linux and FreeBSD versions to be easily created."
"\r\n\r\n"
"George Woltman and the PFGW development team have my gratitude for directly supporting the NewPGen output file format in their great programs, PRP and PFGW."
"\r\n\r\n"
"Huge thanks must go to Prof. Chris Caldwell for hosting this software, and for filling the role of \"the keeper of the flame\". His pages are a never-ending source of "
"ideas, proofs, and definitions - long may that continue."
"\r\n\r\n"
"Finally, I would like to give massive thanks to Yves Gallot. This program would have *never* been written if Yves hadn't developed Proth.exe and made it publicly available to all - "
"without him there would be about 3000 fewer primes in the top 5000 and about 100 fewer Titans. "
"Yves' assembler input into this program has been invaluable, and for that he has my eternal gratitude."
"\r\n\r\n"
"And, of course, I would like to thank *you* for making use of this software. I hope that you find it useful, and I really hope that you find a few records - that is why it was written and made available for all."
"\r\n\r\n"
"The software that has been mentioned can be found in the following places:\r\n"
"Proth:\thttp://www.utm.edu/research/primes/programs/gallot/\r\n"
"PRP:\tftp://mersenne.org/gimps/prp.zip\r\n"
"PFGW:\thttp://groups.yahoo.com/group/primeform/files/\r\n"
"Primo:\thttp://www.znz.freesurf.fr/\r\n"
"VFYPR:\thttp://www.ltkz.demon.co.uk/ar2/vfypr.htm\r\n"
"\r\nThe latest version of NewPGen should be available at:\r\n\thttp://www.utm.edu/research/primes/programs/NewPGen/\r\n"
"\r\n\r\n"
"Paul Jobling, Reading, 12 January 2003"
"\r\n\r\n"
"If you have any suggestions, I ought to be contactable at p_jobling@hotmail.com";

char *WhatsNewText = 
"Version 2.82.\r\n"
" A bugfix: for the fixed k k.2^n1 sieves, if k was even, some divisors were missed.\r\n"
" Another bugfix: the AP b^n+2k-1 mode would only look at even numbers if b was odd! This has been changed so that in this instance, the sieve is for b^n+2k-2. A new version of PFGW will be required to test the output!\r\n"
"\r\n\r\n"
"Version 2.81.\r\n"
" A bug fix: for the fixed k k.2^n1 sieves, if nmin was 1 and you continued sieving an old file, incorrect results were returned.\r\n"
"\r\n\r\n"
"Version 2.80.\r\n"
" The fixed n k.2^n sieves use SSE2 instructions if the CPU supports them.\r\n"
" The fixed k k.2^n1 sieves are a lot faster.\r\n"
" The b^nk sieves use bases other than 2.\r\n"
" For the fixed k k.2^n1 sieves, you can enter an expression for k. This must be of the form num*num*num*...*num, for example 3*5*11*13*19*29*37*41*107.\r\n"
" There is an option to ensure that NewPGen automatically continues sieving the last file when it starts. To use this option, place a shortcut to NewPGen in the Startup folder.\r\n"
" The fixed k k.b^n1 sieves can be used with any base<=255255 now.\r\n"
" The exponent can be 1 now, to sieve k.b+1.\r\n"
"\r\n\r\nVersion 2.70.\r\n"
" The sieves have been further optimised and are all faster - in the same amount of time this version can sieve up to 40% further than version 2.60 (the speedup is dependent on the type of sieve - k.2^n sieves get the biggest gain).\r\n"
" The fixed k sieves are a lot faster when the range of n is more than ~3000, due to a great idea from Jack Brennen. "
"Payam Samidoost also indicated a relationship that could be used to double the speed of most fixed k sieves.\r\n"
" Now that very large ranges of k can be sieved, the plain array implementation is no longer optimal in every case. "
" A faster implementation is used instead, if possible.\r\n"
" To spread the work of sieving across different machines, there are two new services - Duplicate and Merge.\r\n"
" To help investigate the 'Dual Sierpinksi' problem, two new sieves have been added: 2^n+k and 2^n-k, with k fixed.\r\n"
" The AP sieve (b^n+2k-1) can be used with bases other than 2.\r\n"
" The input/output file can be selected from a dialog.\r\n"
"\r\n\r\nVersion 2.60.\r\n"
" Improved performance for small p : all sieves are faster for p<1 billion, and sieves that have more than "
"one strike-out per p (ie twin, CC, etc) are especially improved.\r\n"
" The maximum bitmap size is increased from 255.99Mb to 485Mb.\r\n"
" There is a new option to automatically start PFGW once the sieving is finished.\r\n"
" Two 'PrimoProth' sieves have been added: k#.2^n+1 and k#.2^n-1 with k fixed.\r\n"
" For very sparse sieves where the bitmap is not used (for example, if you look for a BiTwin len 6 for k=1 to 300 billion), the sieving of the aggregated file is a lot faster.\r\n"
" The 'Use two save files' option has been added.\r\n"
" For the k.2^n sieves, even k's can also be included in the sieve.\r\n"
" The 'Hide' option has been added.\r\n"
" 'Verify Results' is turned off by default.\r\n"
" This 'What's New' dialog has been added.\r\n"
" Fixed bug with empty sub ranges: the sub-range handling is much better, particularly for long CCs and BiTwins.\r\n"
" Fixed bug where if you continue to sieve an old file and use the same name for the output file, you lose the contents of the file.\r\n"
" Fixed bug where the time spent saving the file was not ignored for the purposes of the rate calculation.\r\n"
" Various cosmetic improvements.\r\n"
"\r\n\r\nVersion 2.54.\r\n"
" The range of allowable k values is increased from 2^31 to 2^63.\r\n"
" Improved performance for all sieves when p>2^32.\r\n"
" Further improved performance for the primorial sieves.\r\n"
" Further improved performance for the k.b^n sieves where b is not 2.\r\n"
" The maximum value of p for the k.2^n sieves is increased to 2^60; for the other sieves it remains at 2^48."
;

/////////////////////////////////////////////////////////////////////////////
// CContents message handlers

BOOL CContents::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if (m_fShowWhatsNew)	m_Edit.SetWindowText (WhatsNewText);
	else					m_Edit.SetWindowText (ContentsText);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

#else				// GNUC or CONSOLE platform ; Jean Penn, November 2003, November 2007

#include <stdio.h>

/*#ifdef __GNUC__

char *AboutText =
"NewPGen 2.82. Written by Paul Jobling.\r\n"
"Assembly magic by Yves Gallot.\n"
"Adapted to GNUC and command line mode by Jean Penn.\n";

char *ContentsText =  
"NewPGen 2.82. Written by Paul Jobling.\r\n" 
"Assembly magic by Yves Gallot.\n" 
"Adapted to GNUC and command line mode by Jean Penn."
"\r\n\r\n" 
"NewPGen generates input files for Proth, PFGW, or PRP.\n"
"Proth performs primality tests for numbers of the form " 
"k.b^n+1 and k.b^n-1;\n"
"PRP performs very rapid pseudo-primality tests for these numbers;\n" 
"PFGW performs primality tests for more general forms." 
"\r\n\r\n" 
"Most of NewPGen's sieves require n to be fixed, since if this is the case,\n"
"then you can very quickly sieve a large number of k values in parallel." 
"\r\n\r\n" 
"NewPGen can be used to generate a file from scratch,\n"
"or to continue sieving a previously generated file.\n" 
"To create a new file, enter the value of b to be used (the base),\n"
"the value of n, and the first and last " 
"k values to use (kmin and kmax).\n"
"Then select the type of sieving that you wish to perform " 
"on these numbers." 
"\r\n\r\n" 
"Hit the Start button, and NewPGen will start sieving the numbers that\n"
"you have specified, by going up through the primes and removing those k's\n"
"where the expression that you have specified is divisible by the prime." 
"\r\n\r\n" 
"In general, you ought to sieve until the rate at which NewPGen\n"
"is throwing out composites is equal to the rate " 
"at which\n"
"Proth/PRP/PFGW can perform a primality test on the numbers.\n"
"Actually, you should stop a little sooner.\n"
" - the idea is to " 
"find primes, after all." 
"\r\n\r\n" 
"To set the names of the files to use, either type in the names of the files\n"
"or drag an existing file into the edit box." 
"\r\n\r\n" 
"The supported sieves are:" 
"\r\n\r\n" 
"k.b^n+1" 
"\r\n\r\n" 
"k.b^n-1" 
"\r\n\r\n" 
"k.b^n1 \r\n- this sieves for twin primes.\r\n\r\n" 
"k.b^n+1 and 2k.b^n+1 \r\n- Cunningham Chains of the 2nd kind." 
"\r\n\r\n" 
"k.b^n-1 and 2k.b^n-1 \r\n- Sophie Germain prime." 
"\r\n\r\n" 
"k.b^n1 & 2k.b^n1 \r\n- this is a BiTwin chain of four primes (1 link)." 
"\r\n\r\n" 
"k.b^n1 & 2k.b^n-1 \r\n- this sieves for a twin prime and also a SG pair of primes\n"
"(this type of search " 
"was used by  Wassing, Jrai, and Indlekofer to find\n"
"their record twin and SG primes).\n"
"To use the output file in Proth, " 
"specify the mode as k.b^n-1, and if Proth finds\n"
"that this is prime it will automatically check the primality " 
"of k.b^n+1\nand 2k.b^n-1." 
"\r\n\r\n" 
"k.b^n1 & 2k.b^n+1 \r\n- this is the same as the above except that the sieving is for a twin and a CC.\n"
"In a " 
"similar way to the above test, Proth should be set to use the mode k.b^n+1." 
"\r\n\r\n" 
"For the CC, SG, Bitwin, Twin/SG, and Twin/CC sieves you can look for\n"
"generalized chains if the base is not 2.\n" 
"If you set this then rather than sieve k.b^n+1 and 2k.b^n+1 (say),\n"
"NewPGen will sieve k.b^n+1 and k.b^(n+1)+1." 
"\r\n\r\n" 
"k.b^n1 & k.b^(n-1)+1 & k.b^(n+1)+1 \r\n- this is 'Lucky Plus' mode. Here you are looking for\n"
"a prime of the form k.b^n+1, but " 
"the sieving ensures that k.b^n-1, k.b^(n-1)+1,\n"
"and k.b^(n+1)+1 do not have any small prime " 
"divisors either.\n"
"The hope is that if you find that k.b^n+1 is prime, you might also\n"
"get really lucky and find that one of the other three " 
"is prime as well,\n"
"giving you (if the base is 2) either a twin prime or a CC of the 2nd kind." 
"\r\n\r\n" 
"k.b^n1 & k.b^(n-1)-1 & k.b^(n+1)-1 \r\n- this is 'Lucky Minus' mode. Here you are looking for\n"
"a prime of the form k.b^n-1, but " 
"the sieving ensures that k.b^n+1, k.b^(n-1)-1,\n"
"and k.b^(n+1)-1 do not have any small prime " 
"divisors either.\n"
"Again, the hope is that if you find that k.b^n-1 is prime, you might also\n"
"get really lucky and find that one of the other three " 
"is prime as well,\n"
"giving you (if the base is 2) either a twin prime or a Sophie Germain." 
"\r\n\r\n" 
"NewPGen can also generate files to help search for long chains of primes.\n"
"These modes are:" 
"\r\n\r\n" 
"CC 1st kind \r\n- if the base is 2 this is a Cunningham Chain of the first kind of length 3\n"
"or more; " 
"if the base is not 2 you can choose to have a generalized chain:\r\n"  
"p[n+1] = base*p[n]+(base-1)."  
"\r\n\r\n"  
"CC 2nd kind \r\n- this is the same except that the CC is of the second kind:\r\n"  
"p[n+1] = base*p[n]-(base-1)."  
"\r\n\r\n" 
"BiTwin \r\n- this is a chain of BiTwin primes, or a generalized chain if the base is not 2." 
"\r\n\r\n" 
"Note that for the three searches above, NewPGen will set the value of n\n"
"in the file to one more than you specify. This is because if Proth\n" 
"finds that (say) k.b^n+1 is prime, it will look at k.b^(n-1)+1 and k.b^(n+1)+1." 
"\r\n\r\n" 
"b^n+2k-1. " 
"\r\n- this is to search for primes in arithmetic progression,\n"
"or consecutive primes in arithmetic progression.\n" 
"A general primality prover must be used to prove them prime after PFGW\n"
"has found probable primes." 
"\r\n\r\n" 
"k.b^n1 & k.b^n+5\r\n" 
"- this is a prime triplet (or 3-tuple), where p, p+2, and p+6 are all prime.\n"
"If you use this sieve, note " 
"that you can prove the first two (k.b^n1) prime\n"
"using Proth, "
"however the third (k.b^n+5) must be proved\nusing " 
"a general primality prover such as "
"Primo, APRT-CLE, or VFYPR.\nPRP or PFGW should be used to find a k "
"where all 3 numbers " 
"are PRPs\nbefore attempting the proof." 
"\r\n\r\n" 
"k.b^n-1, +1, +5, +7\r\n" 
"- this is a prime quadruplet (or 4-tuple), where p, p+2, p+6, and p+8 are\n"
"all prime. If you use this sieve note " 
"that you can prove\nthe first two (k.b^n1) prime using Proth,\n"
"and the other two using a general primality proving program (for example Primo)." 
"\r\n\r\n" 
"k.b^n+1 with k fixed\r\n- this sieves a range of n values with a fixed k value.\n"
"This type of sieve is a lot " 
"slower than the fixed n sieves, since the speed\n"
"depends upon the range of n that is being sieved. However this is useful\n" 
"if you want to generate an input file for PRP, and the sieving is usually\n"
"faster than using Proth to perform trial division.\n"
"To get the best performance, it is recommended that you use a wide range\n" 
"of n values (at least 3,000), as then NewPGen can use an algorithm that has\n" 
"a speed that is proportional to the square root of the range of n values\n"
"being sieved (so a range that is 4 times as wide only takes twice as long\n"
"to sieve)." 
"\r\n\r\n" 
"k.b^n-1 with k fixed\r\n- this sieves a range of n values with a fixed k value.\n"
"Again this is slower than the fixed n sieves." 
"\r\n\r\n" 
"k.b^n+1 & 2k.b^n+3\r\n" 
"- this is another SG mode. Note that the primality of 2k.b^n+3 can only\n"
"be tested by Proth if the base is 2." 
"\r\n\r\n" 
"\r\n\r\n" 
"There is a checkbox that can be used to generate output to be used with PFGW.\n"
"If the \"Use primorial mode\" checkbox is checked,\n" 
"NewPGen will sieve for k.n# rather than k.b^n.\n"
"Most of the sieves can be used in primorial mode.\n" 
"If you sieve for a chain in primorial mode then the sieving is\n"
"for k.n#1, 2.k.n#1, 4.k.n#1, etc." 
"\r\n\r\n" 
"\r\n\r\n" 
"NewPGen writes out to the output file occasionally, so that\n"
"you do not lose your work in the event of a crash.\n" 
"If you are sieving a large number of k's with a fast sieve\n"
"(typically k.2^n+1 or -1), the time taken to do this " 
"saving can be significant.\n"
"You can change the number of minutes between these saves from the Options menu.\n" 
"To avoid problems where the computer crashes while the save is being performed,\n"
"if you set the 'Use two save files' option then the previous contents\n"
"of the output file are saved in a file with the same name followed by a ~,\n"
"for example the previous contents of 'work.dat' would be saved in 'work.dat~'." 
"\r\n\r\n" 
"If \"Verify results\" is checked, NewPGen will do a careful check to make sure\n"
"that the prime actually does divide the number that it thinks it does.\n" 
"This will make NewPGen very slightly slower, but it is recommended that\n"
"it is always checked, particularly as p gets large (where the scope for\n" 
"programming errors increases), and only uncheck it during the early parts\n"
"of the sieving if you are using a primorial mode and many k's are being\n"
"thrown out every second.\n" 
"If you are not using a primorial sieve then leave this checked,\n"
"as then it makes no difference to NewPGen's performance." 
"\r\n\r\n" 
"You can automatically control the extent to which the sieving is performed\n"
"using the \"Sieve Until...\" dialog on the \"Options\" menu.\n" 
"NewPGen will sieve until the criterion that you set has been reached,\n"
"at which point it will stop, and optionally at this point\n"
"it will pass the results to PFGW for testing.\n" 
"This also gives you the option to automatically increment n\n"
"and start sieving again, and to set an end point for the sieving\n"
"(a maximum value of n to use)." 
"\r\n\r\n" 
"When generating a new file, NewPGen uses a bitmap to store the k values.\n" 
"By default, 47.7 Mb of RAM is used for the bitmap, though\n"
"this can be controlled from the Options menu.\n" 
"If the range of k that you specify is too large to fit into the bitmap,\n"
"NewPGen will break up the range into a number of smaller ranges,\n"
"each of which fits into the bitmap, and will then " 
"sieve each of these in turn\n"
"up to p=1 billion. Once it has done this, it will combine the results together\n"
"and sieve them as normal. " 
"\r\n\r\n" 
"Some technical words now. NewPGen is much faster if the base is 2.\n"
"This is because division by 2 modulo a prime is easy\n"
"(you " 
"shift it right if it is even, otherwise you add the prime then shift it).\n"
"Division by other bases isn't so straightforward, however." 
"\r\n\r\n" 
"NewPGen is happy with lots of k's to sieve - there is nothing to be gained\n"
"by dividing a range of k's up and sieving each subrange in turn.\n"
"NewPGen will do this for you anyway, as was mentioned above.\n" 
"The value of n doesn't matter too much to NewPGen either." 
"\r\n\r\n" 
"\r\n" 
"If you find a large prime with the help of NewPGen,\n"
"Chris Caldwell would love to know about it\n"
" - see http://www.utm.edu/research/primes" 
"\r\n\r\n" 
"If you find a large Cunningham Chain, Dirk Augustin is interested.\n"
" - see\nhttp://groups.yahoo.com/group/primenumbers/files/Prime%20Tables/Cunningham_Chain_records.txt" 
"\r\n\r\n" 
"Henri Lifchitz keeps a list of large BiTwin chains\n"
" - see http://ourworld.compuserve.com/homepages/hlifchitz/\r\n" 
"(remember, though, that Henri counts the links, which is\n"
"one less than the length of the chain)." 
"\r\n\r\n" 
"If you find a large prime triplet or quadruplet, Tony Forbes\n"
"maintains a very interesting site on k-tuplets at\n"
"http://www.ltkz.demon.co.uk/ktuplets.htm" 
"\r\n\r\n" 
"On a personal note I would like to thank Bob Burrowes and Chris Nash\n"
"for their support " 
"and advice during the early development of this program\n"
"(shame we never got the twin record though, guys), and Dirk Augustin\n"
"for being a willing and very able beta tester.\n" 
"Many thanks also to Phil Carmody for all manner of optimisation suggestions\n"
" - the bitmap option and demonstrating its usefulness;\n"
"lots of useful input on the fixed k sieves; and a great algorithm\n"
"for the primorial sieves.\n" 
"Thanks also to David Underbakke for his contributions to the find_k0 routine,\n"
"making k.2^n sieves a lot faster; and also for pushing me to use\n"
"a bitmap representation in the internal Sieve of Erastosthenes,\n"
"which has also boosted performance.\n" 
"Jack Brennen contributed a marvellous idea to the fixed k sieves, making them\n"
"a lot faster if the range is wide enough. Payam Samidoost found a\n"
"number-theoretical relationship that made the fixed k sieves twice as fast.\n" 
"Reto Keiser found that with the large ranges of k now possible, the plain array\n"
"implementation was not optimal.\n" 
"Didier Boivin suggested that it would be nice if the program could automatically\n"
"continue sieving the last file when it is started.\n"
"Jean Penn has my gratitude for his fine work in creating a single codebase\n"
"for NewPGen to allow Linux and FreeBSD versions to be easily created." 
"\r\n\r\n" 
"George Woltman and the PFGW development team have my gratitude\n"
"for directly supporting the NewPGen output file format in their great programs,\n"
"PRP and PFGW." 
"\r\n\r\n" 
"Huge thanks must go to Prof. Chris Caldwell for hosting this software,\n"
"and for filling the role of \"the keeper of the flame\".\n"
"His pages are a never-ending source of " 
"ideas, proofs, and definitions.\n - long may that continue." 
"\r\n\r\n" 
"Finally, I would like to give massive thanks to Yves Gallot.\n"
"This program would have *never* been written if Yves hadn't developed\n"
"Proth.exe and made it publicly available to all\n"
" - " 
"without him there would be about 3000 fewer primes in the top 5000\n"
"and about 100 fewer Titans. " 
"Yves' assembler input into this program\nhas been invaluable, "
"and for that he has my eternal gratitude." 
"\r\n\r\n" 
"And, of course, I would like to thank *you* for making use of this software.\n"
"I hope that you find it useful, and I really hope that you find\n"
"a few records - that is why it was written and made available for all." 
"\r\n\r\n" 
"The software that has been mentioned can be found in the following places:\r\n" 
"Proth:\thttp://www.utm.edu/research/primes/programs/gallot/\r\n" 
"PRP:\tftp://mersenne.org/gimps/prp.zip\r\n" 
"PFGW:\thttp://www.egroups.com/files/primeform/pfgw.zip\r\n" 
"Primo:\thttp://www.znz.freesurf.fr/\r\n" 
"VFYPR:\thttp://www.ltkz.demon.co.uk/ar2/vfypr.htm\r\n" 
"\r\nThe latest version of NewPGen should be available at:\r\n\thttp://www.utm.edu/research/primes/programs/NewPGen/\r\n" 
"\r\n\r\n" 
"Paul Jobling, Reading, 12 January 2003"
"\r\n\r\n" 
"If you have any suggestions, I ought to be contactable at p_jobling@hotmail.com\n"; 

char *WhatsNewText =  
"Version 2.82.\r\n"
" A bugfix: for the fixed k k.2^n1 sieves, if k was even, some divisors were missed.\r\n"
" Another bugfix: the AP b^n+2k-1 mode would only look at even numbers if b was odd! This has been changed so that in this instance, the sieve is for b^n+2k-2. A new version of PFGW will be required to test the output!\r\n"
"\r\n\r\n"
"Version 2.81.\r\n"
" A bug fix: for the fixed k k.2^n1 sieves, if nmin was 1 and you continued sieving an old file, incorrect results were returned.\r\n"
"\r\n\r\n"
"Version 2.80.\r\n"
" The fixed n k.2^n sieves use SSE2 instructions if the CPU supports them.\r\n"
" The fixed k k.2^n1 sieves are a lot faster.\r\n"
" The b^nk sieves use bases other than 2.\r\n"
" For the fixed k k.2^n1 sieves, you can enter an expression for k. This must be of the form num*num*num*...*num, for example 3*5*11*13*19*29*37*41*107.\r\n"
" There is an option to ensure that NewPGen automatically continues sieving the last file when it starts. To use this option, place a shortcut to NewPGen in the Startup folder.\r\n"
" The fixed k k.b^n1 sieves can be used with any base<=255255 now.\r\n"
" The exponent can be 1 now, to sieve k.b+1.\r\n"
"\r\n\r\nVersion 2.70.\r\n" 
" The sieves have been further optimised and are all faster - in the same amount\n of time this version can sieve up to 40% further than version 2.60 (the speedup\n is dependent on the type of sieve - k.2^n sieves get the biggest gain).\r\n" 
" The fixed k sieves are a lot faster when the range of n is more than ~3000,\n due to a great idea from Jack Brennen. " 
"Payam Samidoost also indicated\n a relationship that could be used to double the speed of most fixed k sieves.\r\n" 
" Now that very large ranges of k can be sieved, the plain array implementation\n is no longer optimal in every case. " 
" A faster implementation is used instead,\n if possible.\r\n" 
" To spread the work of sieving across different machines, there are two new\n services - Duplicate and Merge.\r\n" 
" To help investigate the 'Dual Sierpinksi' problem, two new sieves have been\n added: 2^n+k and 2^n-k, with k fixed.\r\n" 
" The AP sieve (b^n+2k-1) can be used with bases other than 2.\r\n" 
" The input/output file can be selected from a dialog.\r\n" 
"\r\n\r\n"
"Version 2.60.\r\n" 
" Improved performance for small p : all sieves are faster for p<1 billion,\n"
" and sieves that have more than one strike-out per p (ie twin, CC, etc)\n"
" are especially improved.\r\n" 
" The maximum bitmap size is increased from 255.99Mb to 485Mb.\r\n" 
" There is a new option to automatically start PFGW\n"
" once the sieving is finished.\r\n" 
" Two 'PrimoProth' sieves have been added: k#.2^n+1 and k#.2^n-1 with k fixed.\r\n" 
" For very sparse sieves where the bitmap is not used\n"
" (for example, if you look for a BiTwin len 6 for k=1 to 300 billion),\n"
" For the k.2^n sieves, even k's can also be included in the sieve.\r\n"
" For k.b^n sieves where the base is even, even k's can also be included in the sieve.\r\n"
" The 'Use two save files' option has been added.\r\n" 
" The 'Hide' option has been added.\r\n" 
" 'Verify Results' is turned off by default.\r\n" 
" This 'What's New' dialog has been added.\r\n" 
" Fixed bug with empty sub ranges :\n"
" The sub-range handling is much better, particularly for long CCs and BiTwins.\r\n" 
" Fixed bug where if you continue to sieve an old file and use the same name\n"
" for the output file, you lose the contents of the file.\r\n" 
" Fixed bug where the time spent saving the file was not ignored.\n"
" for the purposes of the rate calculation.\r\n" 
" Various cosmetic improvements.\r\n" 
"\r\n\r\nVersion 2.54.\r\n" 
" The range of allowable k values is increased from 2^31 to 2^63.\r\n" 
" Improved performance for all sieves when p>2^32.\r\n" 
" Further improved performance for the primorial sieves.\r\n" 
" Further improved performance for the k.b^n sieves where b is not 2.\r\n" 
" The maximum value of p for the k.2^n sieves is increased to 2^60;\n"
" for the other sieves it remains at 2^48.\n"; 

#else
*/
char *AboutText =
"NewPGen 2.82. Written by Paul Jobling.\r\n"
"Assembly magic by Yves Gallot.\n"
"Adapted to GNUC and command line mode by Jean Penne.\n";

char *ContentsText =  
"NewPGen 2.82. Written by Paul Jobling.\r\n" 
"Assembly magic by Yves Gallot.\n" 
"Adapted to GNUC and command line mode by Jean Penne."
"\r\n\r\n" 
"NewPGen generates input files for Proth, PFGW, or PRP.\n"
"Proth performs primality tests for numbers of the form " 
"k.b^n+1 and k.b^n-1;\n"
"PRP performs very rapid pseudo-primality tests for these numbers;\n" 
"PFGW performs primality tests for more general forms." 
"\r\n\r\n" 
"Most of NewPGen's sieves require n to be fixed, since if this is the case,\n"
"then you can very quickly sieve a large number of k values in parallel." 
"\r\n\r\n" 
"NewPGen can be used to generate a file from scratch,\n"
"or to continue sieving a previously generated file.\n" 
"To create a new file, enter the value of b to be used (the base),\n"
"the value of n, and the first and last " 
"k values to use (kmin and kmax).\n"
"Then select the type of sieving that you wish to perform " 
"on these numbers." 
"\r\n\r\n" 
"Hit the Start button, and NewPGen will start sieving the numbers that\n"
"you have specified, by going up through the primes and removing those k's\n"
"where the expression that you have specified is divisible by the prime." 
"\r\n\r\n" 
"In general, you ought to sieve until the rate at which NewPGen\n"
"is throwing out composites is equal to the rate " 
"at which\n"
"Proth/PRP/PFGW can perform a primality test on the numbers.\n"
"Actually, you should stop a little sooner.\n"
" - the idea is to " 
"find primes, after all." 
"\r\n\r\n" 
"To set the names of the files to use, either type in the names of the files\n"
"or drag an existing file into the edit box." 
"\r\n\r\n" 
"The supported sieves are:" 
"\r\n\r\n" 
"k.b^n+1" 
"\r\n\r\n" 
"k.b^n-1" 
"\r\n\r\n" 
"k.b^n+/-1 \r\n- this sieves for twin primes.\r\n\r\n" 
"k.b^n+1 and 2k.b^n+1 \r\n- Cunningham Chains of the 2nd kind." 
"\r\n\r\n" 
"k.b^n-1 and 2k.b^n-1 \r\n- Sophie Germain prime." 
"\r\n\r\n" 
"k.b^n+/-1 & 2k.b^n+/-1 \r\n- this is a BiTwin chain of four primes (1 link)." 
"\r\n\r\n" 
"k.b^n+/-1 & 2k.b^n-1 \r\n- this sieves for a twin prime and also a SG pair of primes\n"
"(this type of search " 
"was used by  Wassing, Jrai, and Indlekofer to find\n"
"their record twin and SG primes).\n"
"To use the output file in Proth, " 
"specify the mode as k.b^n-1, and if Proth finds\n"
"that this is prime it will automatically check the primality " 
"of k.b^n+1\nand 2k.b^n-1." 
"\r\n\r\n" 
"k.b^n+/-1 & 2k.b^n+1 \r\n- this is the same as the above except that the sieving is for a twin and a CC.\n"
"In a " 
"similar way to the above test, Proth should be set to use the mode k.b^n+1." 
"\r\n\r\n" 
"For the CC, SG, Bitwin, Twin/SG, and Twin/CC sieves you can look for\n"
"generalized chains if the base is not 2.\n" 
"If you set this then rather than sieve k.b^n+1 and 2k.b^n+1 (say),\n"
"NewPGen will sieve k.b^n+1 and k.b^(n+1)+1." 
"\r\n\r\n" 
"k.b^n+/-1 & k.b^(n-1)+1 & k.b^(n+1)+1 \r\n- this is 'Lucky Plus' mode. Here you are looking for\n"
"a prime of the form k.b^n+1, but " 
"the sieving ensures that k.b^n-1, k.b^(n-1)+1,\n"
"and k.b^(n+1)+1 do not have any small prime " 
"divisors either.\n"
"The hope is that if you find that k.b^n+1 is prime, you might also\n"
"get really lucky and find that one of the other three " 
"is prime as well,\n"
"giving you (if the base is 2) either a twin prime or a CC of the 2nd kind." 
"\r\n\r\n" 
"k.b^n+/-1 & k.b^(n-1)-1 & k.b^(n+1)-1 \r\n- this is 'Lucky Minus' mode. Here you are looking for\n"
"a prime of the form k.b^n-1, but " 
"the sieving ensures that k.b^n+1, k.b^(n-1)-1,\n"
"and k.b^(n+1)-1 do not have any small prime " 
"divisors either.\n"
"Again, the hope is that if you find that k.b^n-1 is prime, you might also\n"
"get really lucky and find that one of the other three " 
"is prime as well,\n"
"giving you (if the base is 2) either a twin prime or a Sophie Germain." 
"\r\n\r\n" 
"NewPGen can also generate files to help search for long chains of primes.\n"
"These modes are:" 
"\r\n\r\n" 
"CC 1st kind \r\n- if the base is 2 this is a Cunningham Chain of the first kind of length 3\n"
"or more; " 
"if the base is not 2 you can choose to have a generalized chain:\r\n"  
"p[n+1] = base*p[n]+(base-1)."  
"\r\n\r\n"  
"CC 2nd kind \r\n- this is the same except that the CC is of the second kind:\r\n"  
"p[n+1] = base*p[n]-(base-1)."  
"\r\n\r\n" 
"BiTwin \r\n- this is a chain of BiTwin primes, or a generalized chain if the base is not 2." 
"\r\n\r\n" 
"Note that for the three searches above, NewPGen will set the value of n\n"
"in the file to one more than you specify. This is because if Proth\n" 
"finds that (say) k.b^n+1 is prime, it will look at k.b^(n-1)+1 and k.b^(n+1)+1." 
"\r\n\r\n" 
"b^n+2k-1. " 
"\r\n- this is to search for primes in arithmetic progression,\n"
"or consecutive primes in arithmetic progression.\n" 
"A general primality prover must be used to prove them prime after PFGW\n"
"has found probable primes." 
"\r\n\r\n" 
"k.b^n+/-1 & k.b^n+5\r\n" 
"- this is a prime triplet (or 3-tuple), where p, p+2, and p+6 are all prime.\n"
"If you use this sieve, note " 
"that you can prove the first two (k.b^n+/-1) prime\n"
"using Proth, "
"however the third (k.b^n+5) must be proved\nusing " 
"a general primality prover such as "
"Primo, APRT-CLE, or VFYPR.\nPRP or PFGW should be used to find a k "
"where all 3 numbers " 
"are PRPs\nbefore attempting the proof." 
"\r\n\r\n" 
"k.b^n-1, +1, +5, +7\r\n" 
"- this is a prime quadruplet (or 4-tuple), where p, p+2, p+6, and p+8 are\n"
"all prime. If you use this sieve note " 
"that you can prove\nthe first two (k.b^n+/-1) prime using Proth,\n"
"and the other two using a general primality proving program (for example Primo)." 
"\r\n\r\n" 
"k.b^n+1 with k fixed\r\n- this sieves a range of n values with a fixed k value.\n"
"This type of sieve is a lot " 
"slower than the fixed n sieves, since the speed\n"
"depends upon the range of n that is being sieved. However this is useful\n" 
"if you want to generate an input file for PRP, and the sieving is usually\n"
"faster than using Proth to perform trial division.\n"
"To get the best performance, it is recommended that you use a wide range\n" 
"of n values (at least 3,000), as then NewPGen can use an algorithm that has\n" 
"a speed that is proportional to the square root of the range of n values\n"
"being sieved (so a range that is 4 times as wide only takes twice as long\n"
"to sieve)." 
"\r\n\r\n" 
"k.b^n-1 with k fixed\r\n- this sieves a range of n values with a fixed k value.\n"
"Again this is slower than the fixed n sieves." 
"\r\n\r\n" 
"k.b^n+1 & 2k.b^n+3\r\n" 
"- this is another SG mode. Note that the primality of 2k.b^n+3 can only\n"
"be tested by Proth if the base is 2." 
"\r\n\r\n" 
"\r\n\r\n" 
"There is a checkbox that can be used to generate output to be used with PFGW.\n"
"If the \"Use primorial mode\" checkbox is checked,\n" 
"NewPGen will sieve for k.n# rather than k.b^n.\n"
"Most of the sieves can be used in primorial mode.\n" 
"If you sieve for a chain in primorial mode then the sieving is\n"
"for k.n#+/-1, 2.k.n#+/-1, 4.k.n#+/-1, etc." 
"\r\n\r\n" 
"\r\n\r\n" 
"NewPGen writes out to the output file occasionally, so that\n"
"you do not lose your work in the event of a crash.\n" 
"If you are sieving a large number of k's with a fast sieve\n"
"(typically k.2^n+1 or -1), the time taken to do this " 
"saving can be significant.\n"
"You can change the number of minutes between these saves from the Options menu.\n" 
"To avoid problems where the computer crashes while the save is being performed,\n"
"if you set the 'Use two save files' option then the previous contents\n"
"of the output file are saved in a file with the same name followed by a ~,\n"
"for example the previous contents of 'work.dat' would be saved in 'work.dat~'." 
"\r\n\r\n" 
"If \"Verify results\" is checked, NewPGen will do a careful check to make sure\n"
"that the prime actually does divide the number that it thinks it does.\n" 
"This will make NewPGen very slightly slower, but it is recommended that\n"
"it is always checked, particularly as p gets large (where the scope for\n" 
"programming errors increases), and only uncheck it during the early parts\n"
"of the sieving if you are using a primorial mode and many k's are being\n"
"thrown out every second.\n" 
"If you are not using a primorial sieve then leave this checked,\n"
"as then it makes no difference to NewPGen's performance." 
"\r\n\r\n" 
"You can automatically control the extent to which the sieving is performed\n"
"using the \"Sieve Until...\" dialog on the \"Options\" menu.\n" 
"NewPGen will sieve until the criterion that you set has been reached,\n"
"at which point it will stop, and optionally at this point\n"
"it will pass the results to PFGW for testing.\n" 
"This also gives you the option to automatically increment n\n"
"and start sieving again, and to set an end point for the sieving\n"
"(a maximum value of n to use)." 
"\r\n\r\n" 
"When generating a new file, NewPGen uses a bitmap to store the k values.\n" 
"By default, 47.7 Mb of RAM is used for the bitmap, though\n"
"this can be controlled from the Options menu.\n" 
"If the range of k that you specify is too large to fit into the bitmap,\n"
"NewPGen will break up the range into a number of smaller ranges,\n"
"each of which fits into the bitmap, and will then " 
"sieve each of these in turn\n"
"up to p=1 billion. Once it has done this, it will combine the results together\n"
"and sieve them as normal. " 
"\r\n\r\n" 
"Some technical words now. NewPGen is much faster if the base is 2.\n"
"This is because division by 2 modulo a prime is easy\n"
"(you " 
"shift it right if it is even, otherwise you add the prime then shift it).\n"
"Division by other bases isn't so straightforward, however." 
"\r\n\r\n" 
"NewPGen is happy with lots of k's to sieve - there is nothing to be gained\n"
"by dividing a range of k's up and sieving each subrange in turn.\n"
"NewPGen will do this for you anyway, as was mentioned above.\n" 
"The value of n doesn't matter too much to NewPGen either." 
"\r\n\r\n" 
"\r\n" 
"If you find a large prime with the help of NewPGen,\n"
"Chris Caldwell would love to know about it\n"
" - see http://www.utm.edu/research/primes" 
"\r\n\r\n" 
"If you find a large Cunningham Chain, Dirk Augustin is interested.\n"
" - see\nhttp://groups.yahoo.com/group/primenumbers/files/Prime%20Tables/Cunningham_Chain_records.txt" 
"\r\n\r\n" 
"Henri Lifchitz keeps a list of large BiTwin chains\n"
" - see http://ourworld.compuserve.com/homepages/hlifchitz/\r\n" 
"(remember, though, that Henri counts the links, which is\n"
"one less than the length of the chain)." 
"\r\n\r\n" 
"If you find a large prime triplet or quadruplet, Tony Forbes\n"
"maintains a very interesting site on k-tuplets at\n"
"http://www.ltkz.demon.co.uk/ktuplets.htm" 
"\r\n\r\n" 
"On a personal note I would like to thank Bob Burrowes and Chris Nash\n"
"for their support " 
"and advice during the early development of this program\n"
"(shame we never got the twin record though, guys), and Dirk Augustin\n"
"for being a willing and very able beta tester.\n" 
"Many thanks also to Phil Carmody for all manner of optimisation suggestions\n"
" - the bitmap option and demonstrating its usefulness;\n"
"lots of useful input on the fixed k sieves; and a great algorithm\n"
"for the primorial sieves.\n" 
"Thanks also to David Underbakke for his contributions to the find_k0 routine,\n"
"making k.2^n sieves a lot faster; and also for pushing me to use\n"
"a bitmap representation in the internal Sieve of Erastosthenes,\n"
"which has also boosted performance.\n" 
"Jack Brennen contributed a marvellous idea to the fixed k sieves, making them\n"
"a lot faster if the range is wide enough. Payam Samidoost found a\n"
"number-theoretical relationship that made the fixed k sieves twice as fast.\n" 
"Reto Keiser found that with the large ranges of k now possible, the plain array\n"
"implementation was not optimal.\n" 
"Didier Boivin suggested that it would be nice if the program could automatically\n"
"continue sieving the last file when it is started.\n"
"Jean Penne has my gratitude for his fine work in creating a single codebase\n"
"for NewPGen to allow Linux and FreeBSD versions to be easily created." 
"\r\n\r\n" 
"George Woltman and the PFGW development team have my gratitude\n"
"for directly supporting the NewPGen output file format in their great programs,\n"
"PRP and PFGW." 
"\r\n\r\n" 
"Huge thanks must go to Prof. Chris Caldwell for hosting this software,\n"
"and for filling the role of \"the keeper of the flame\".\n"
"His pages are a never-ending source of " 
"ideas, proofs, and definitions.\n - long may that continue." 
"\r\n\r\n" 
"Finally, I would like to give massive thanks to Yves Gallot.\n"
"This program would have *never* been written if Yves hadn't developed\n"
"Proth.exe and made it publicly available to all\n"
" - " 
"without him there would be about 3000 fewer primes in the top 5000\n"
"and about 100 fewer Titans. " 
"Yves' assembler input into this program\nhas been invaluable, "
"and for that he has my eternal gratitude." 
"\r\n\r\n" 
"And, of course, I would like to thank *you* for making use of this software.\n"
"I hope that you find it useful, and I really hope that you find\n"
"a few records - that is why it was written and made available for all." 
"\r\n\r\n" 
"The software that has been mentioned can be found in the following places:\r\n" 
"Proth:\thttp://www.utm.edu/research/primes/programs/gallot/\r\n" 
"PRP:\tftp://mersenne.org/gimps/prp.zip\r\n" 
"PFGW:\thttp://www.egroups.com/files/primeform/pfgw.zip\r\n" 
"Primo:\thttp://www.znz.freesurf.fr/\r\n" 
"VFYPR:\thttp://www.ltkz.demon.co.uk/ar2/vfypr.htm\r\n" 
"\r\nThe latest version of NewPGen should be available at:\r\n\thttp://www.utm.edu/research/primes/programs/NewPGen/\r\n" 
"\r\n\r\n" 
"Paul Jobling, Reading, 12 January 2003"
"\r\n\r\n" 
"If you have any suggestions, I ought to be contactable at p_jobling@hotmail.com\n"; 

char *WhatsNewText =  
"Version 2.82.\r\n"
">> A bugfix: for the fixed k k.2^n+/-1 sieves, if k was even, some divisors were missed.\r\n"
">> Another bugfix: the AP b^n+2k-1 mode would only look at even numbers if b was odd! This has been changed so that in this instance, the sieve is for b^n+2k-2. A new version of PFGW will be required to test the output!\r\n"
"________________\r\n\r\n"
"Version 2.81.\r\n"
">> A bug fix: for the fixed k k.2^n+/-1 sieves, if nmin was 1 and you continued sieving an old file, incorrect results were returned.\r\n"
"________________\r\n\r\n"
"Version 2.80.\r\n"
">> The fixed n k.2^n sieves use SSE2 instructions if the CPU supports them.\r\n"
">> The fixed k k.2^n+/-1 sieves are a lot faster.\r\n"
">> The b^n+/-k sieves use bases other than 2.\r\n"
">> For the fixed k k.2^n+/-1 sieves, you can enter an expression for k. This must be of the form num*num*num*...*num, for example 3*5*11*13*19*29*37*41*107.\r\n"
">> There is an option to ensure that NewPGen automatically continues sieving the last file when it starts. To use this option, place a shortcut to NewPGen in the Startup folder.\r\n"
">> The fixed k k.b^n+/-1 sieves can be used with any base<=255255 now.\r\n"
">> The exponent can be 1 now, to sieve k.b+1.\r\n"
"________________\r\n\r\nVersion 2.70.\r\n" 
">> The sieves have been further optimised and are all faster - in the same amount\n of time this version can sieve up to 40% further than version 2.60 (the speedup\n is dependent on the type of sieve - k.2^n sieves get the biggest gain).\r\n" 
">> The fixed k sieves are a lot faster when the range of n is more than ~3000,\n due to a great idea from Jack Brennen. " 
"Payam Samidoost also indicated\n a relationship that could be used to double the speed of most fixed k sieves.\r\n" 
">> Now that very large ranges of k can be sieved, the plain array implementation\n is no longer optimal in every case. " 
" A faster implementation is used instead,\n if possible.\r\n" 
">> To spread the work of sieving across different machines, there are two new\n services - Duplicate and Merge.\r\n" 
">> To help investigate the 'Dual Sierpinksi' problem, two new sieves have been\n added: 2^n+k and 2^n-k, with k fixed.\r\n" 
">> The AP sieve (b^n+2k-1) can be used with bases other than 2.\r\n" 
">> The input/output file can be selected from a dialog.\r\n" 
"________________\r\n\r\n"
"Version 2.60.\r\n" 
">> Improved performance for small p : all sieves are faster for p<1 billion,\n"
">> and sieves that have more than one strike-out per p (ie twin, CC, etc)\n"
">> are especially improved.\r\n" 
">> The maximum bitmap size is increased from 255.99Mb to 485Mb.\r\n" 
">> There is a new option to automatically start PFGW\n"
">> once the sieving is finished.\r\n" 
">> Two 'PrimoProth' sieves have been added: k#.2^n+1 and k#.2^n-1 with k fixed.\r\n" 
">> For very sparse sieves where the bitmap is not used\n"
">> (for example, if you look for a BiTwin len 6 for k=1 to 300 billion),\n"
">> For the k.2^n sieves, even k's can also be included in the sieve.\r\n"
">> For k.b^n sieves where the base is even, even k's can also be included in the sieve.\r\n"
">> The 'Use two save files' option has been added.\r\n" 
">> The 'Hide' option has been added.\r\n" 
">> 'Verify Results' is turned off by default.\r\n" 
">> This 'What's New' dialog has been added.\r\n" 
">> Fixed bug with empty sub ranges :\n"
">> The sub-range handling is much better, particularly for long CCs and BiTwins.\r\n" 
">> Fixed bug where if you continue to sieve an old file and use the same name\n"
">> for the output file, you lose the contents of the file.\r\n" 
">> Fixed bug where the time spent saving the file was not ignored.\n"
">> for the purposes of the rate calculation.\r\n" 
">> Various cosmetic improvements.\r\n" 
"________________\r\n\r\nVersion 2.54.\r\n" 
">> The range of allowable k values is increased from 2^31 to 2^63.\r\n" 
">> Improved performance for all sieves when p>2^32.\r\n" 
">> Further improved performance for the primorial sieves.\r\n" 
">> Further improved performance for the k.b^n sieves where b is not 2.\r\n" 
">> The maximum value of p for the k.2^n sieves is increased to 2^60;\n"
">> for the other sieves it remains at 2^48.\n"; 

//#endif

//  Display the "about" info.

void printAbout() {
    printf("%s\n", AboutText);
}

//  Display the "contents" info.

void printContents() {
    printf("%s\n", ContentsText);
}

// Diplay the "WhatsNew" info

void printWhatsNew() {
    printf("%s\n", WhatsNewText);
}

#endif
