// DlgMaxBitmapSize.cpp : implementation file
//

#include "stdafx.h"
#include "newpgen.h"
#include "DlgMaxBitmapSize.h"
#include "newpgen2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DlgMaxBitmapSize dialog


DlgMaxBitmapSize::DlgMaxBitmapSize(CWnd* pParent /*=NULL*/)
	: CDialog(DlgMaxBitmapSize::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgMaxBitmapSize)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void DlgMaxBitmapSize::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgMaxBitmapSize)
	DDX_Control(pDX, IDC_EDIT1, m_EditSize);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DlgMaxBitmapSize, CDialog)
	//{{AFX_MSG_MAP(DlgMaxBitmapSize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DlgMaxBitmapSize message handlers

void DlgMaxBitmapSize::OnOK() 
{
	// TODO: Add extra validation here
	double Size;
	char buff[1024];
	m_EditSize.GetWindowText (buff, 1024);
	Size = atof (buff) * 1024 * 1024 * 8;

	if (atof (buff) < 0.0 || atof (buff) > 485.0 /*2047.99*/)
	{
		MessageBox ("That is not a valid size!", "Invalid size - the allowable range is 0 to 485 Mb");
		char buff[1024];
		sprintf (buff, "%.1f", BitMapThreshold/(1024.0 * 1024.0 * 8));
		m_EditSize.SetWindowText (buff);
		m_EditSize.SetFocus ();
	}
	else
	{
		MEMORYSTATUS stat;
		GlobalMemoryStatus (&stat);
		if (stat.dwTotalPhys*8.0*0.9 < Size)
		{
			sprintf (buff, "Warning - this machine has only %.1f Mb of physical memory.\r\nIf you try to use more memory than is available, NewPGen will run a lot more slowly.\r\nAre you sure you wish to continue?", stat.dwTotalPhys/(1024*1024.0));
			if (AfxMessageBox (buff, MB_ICONQUESTION|MB_OKCANCEL|MB_DEFBUTTON2) != IDOK)
			{
				return;
			}
		}

		BitMapThreshold = (__int64)Size;
		CDialog::OnOK();
	}

}

BOOL DlgMaxBitmapSize::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	char buff[1024];
	sprintf (buff, "%.1f", BitMapThreshold/(1024.0 * 1024.0 * 8));
	m_EditSize.SetWindowText (buff);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
