// FrmSplit.cpp : implementation file
//

#include "stdafx.h"
#include "newpgen.h"
#include "FrmSplit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define LL_FORMAT "%I64d"

/////////////////////////////////////////////////////////////////////////////
// FrmSplit dialog


FrmSplit::FrmSplit(CWnd* pParent /*=NULL*/)
	: CDialog(FrmSplit::IDD, pParent)
{
	//{{AFX_DATA_INIT(FrmSplit)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void FrmSplit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(FrmSplit)
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDC_EDITRANGE, m_Range);
	DDX_Control(pDX, IDC_EDITNFILES, m_NFiles);
	DDX_Control(pDX, IDC_INFILE, m_EditInFile);
	DDX_Control(pDX, IDC_STATICTEXT, m_StaticText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(FrmSplit, CDialog)
	//{{AFX_MSG_MAP(FrmSplit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// FrmSplit message handlers

static char *helptext = 
"Duplicating a file up allows it to be sieved across several different machines.\r\n"
"Each machine sieves a different range of p, for example the first could sieve from "
"10 billion to 20 billion; the second from 20 billion to 30 billion, etc. "
"You must make sure (using the 'Sieve Until' option on each machine) that the entire range "
"of p is completed."
"\r\n"
"The name of each output file indicates what the 'Sieve Until' value should be. For example, "
"if you duplicate the file Twin.txt (which has been sieved up to 1 billion) into two files, which are to "
"be sieved for another 5 billion p each, then the first file will be called 6000000000_Twin.txt; the second "
"will be 11000000000_Twin.txt"
"\r\n"
"Once the entire range has been sieved, use the 'Merge' service to merge the data back "
"together.";

BOOL FrmSplit::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_StaticText.SetWindowText (helptext);	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void getnewfilename (char *outbuff, __int64 num, char *inbuff) 
{ 
	// Prepend '<num>_' at the start of the file name, but handle directories. 
 
	char *slash = strrchr (inbuff, '\\'); 
 
	if (slash) 
	{ 
		strncpy (outbuff, inbuff, (slash+1)-inbuff); 
		outbuff[(slash+1)-inbuff] = '\0'; 
		slash++; 
	} 
	else 
	{ 
		slash = inbuff; 
		outbuff[0] = '\0'; 
	} 
	sprintf (outbuff+strlen (outbuff), LL_FORMAT"_", num); 
	strcat (outbuff, slash); 
 
} 
 

void FrmSplit::OnOK() 
{
	// TODO: Add extra validation here
	char buff[10240];
	char infile[10240];
	FILE *ifptr, **ofptr;
	int i, nFiles;
	__int64 Range;
	__int64 OrigRange;
	bool bOK = false;
	char rest[1024];

	m_EditInFile.GetWindowText (infile, 10240);
	ifptr = fopen (infile, "r");
	if (!ifptr)
	{
		MessageBeep (0xFFFFFFFF);
		m_EditInFile.SetFocus ();
		return;
	}

	m_NFiles.GetWindowText (buff, 10240);
	nFiles = atoi (buff);
	if (nFiles < 2 || nFiles > 25) 
	{
		MessageBeep (0xFFFFFFFF);
		m_NFiles.SetFocus ();
		return;
	}
	
	m_Range.GetWindowText (buff, 10240);
	Range = _atoi64 (buff);
	if (Range < 2) 
	{
		MessageBeep (0xFFFFFFFF);
		m_Range.SetFocus ();
		return;
	}

	if (fgets (buff, 1024, ifptr) != NULL)
	{
		buff[strlen (buff)-1] = '\0';
		
		// This contains the sieve limit and the type.
		if (sscanf (buff, LL_FORMAT"%s", &OrigRange, rest) == 2)
		{
			bOK = true;
		}
	}

	if (!bOK)
	{
		AfxMessageBox ("That does not seem to be a valid NewPGen file!\n"); 
		fclose (ifptr);
		return;
	}

	ofptr = new FILE *[nFiles];
	
	for (i = 0; i < nFiles; i++)
	{
		char NewName[10240];
		getnewfilename (NewName, OrigRange+Range*(i+1), infile);
		if (!(ofptr[i] = fopen (NewName, "w")))
		{
			sprintf (buff, "Cannot open an output file called %s!", NewName);
			AfxMessageBox (buff); 
			fclose (ifptr);
			while (--i >= 0) fclose (ofptr[i]);
			return;
		}
		fprintf (ofptr[i], LL_FORMAT"%s\n", OrigRange+Range*i, rest);
	}

	this->BeginWaitCursor ();

	while (!feof (ifptr))
	{
		if (fgets (buff, 1024, ifptr) != NULL)
		{
			for (i = 0; i < nFiles; i++)
			{
				fputs (buff, ofptr[i]);
			}
		}
	}
	fclose (ifptr);
	for (i = 0; i < nFiles; i++) fclose (ofptr[i]);

	this->EndWaitCursor ();

	strcpy (buff, "The output files have been created. They are called ");
	for (i = 0; i < nFiles; i++)
	{
		char NewName[10240];
		getnewfilename (NewName, OrigRange+Range*(i+1), infile);
		strcat (buff, NewName);
		if (i < nFiles-1) strcat (buff, ", ");
		if (i == nFiles-2) strcat (buff, "and ");
	}

	AfxMessageBox (buff); 

	CDialog::OnOK();
}

