#if !defined(__GNUC__) && !defined(_CONSOLE)		// VC GUI Platform

// newpgen.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "newpgen.h"
#include "newpgen2.h"
#include "newpgenDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewpgenApp

BEGIN_MESSAGE_MAP(CNewpgenApp, CWinApp)
	//{{AFX_MSG_MAP(CNewpgenApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewpgenApp construction

CNewpgenApp::CNewpgenApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CNewpgenApp object

CNewpgenApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CNewpgenApp initialization

BOOL CNewpgenApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
	// AfxEnableControlContainer();

#if 1

	m_pMainWnd = new CNewpgenDlg;

	if (m_pMainWnd) return TRUE; else return FALSE;

#else
	CNewpgenDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
#endif
}

#else				// GNUC or CONSOLE Platform ; Jean Penn, November 2001, November 2007

#include <sys/types.h> 
#include <stdio.h>
#include <signal.h>
#ifdef __GNUC__
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#endif
#include <stdlib.h>
#include <string.h> 
#include <ctype.h>
#include "Newpgen.h"
#include "Newpgen2.h"
#include "Primetable.h"

//  Interrupt current sieve and save data when required (Control-C) or process terminated.

void  sigterm_handler(int signo) {
    if (State == 0) {
    }
    else if (State == 1)
	    State = 4;
	else if (State == 2) {
	    State = 4;
	    printf ("Stopping...\n");
	}
	else {
	    // State == 4.
	}
    (void) signal(SIGTERM, (void (__cdecl *)(int))sigterm_handler);	// Catch interrupts
    (void) signal(SIGINT, (void (__cdecl *)(int))sigterm_handler);
}

//  Main program.

int __cdecl main(int argc, char *argv[]) {
    int i;
    char *p;
    FILE *fptr;
	
    (void) signal(SIGTERM, (void (__cdecl *)(int))sigterm_handler);	// Catch interrupts
    (void) signal(SIGINT, (void (__cdecl *)(int))sigterm_handler);
    setvbuf(stdout, NULL, _IONBF, 0);		// No buffering of standard output
    FillPrimetable();				// Init. the prime table
    initialise ();				// Initialise the small bitmaps
    ResetToDefaults();				// Set parameters to default values

//  Read .ini file if possible

    fptr = fopen ("NewPGen.ini", "r");
    if (fptr) { 
	char buff[1024], param[1024], value[1024]; 
	while (!feof (fptr)) { 
	    if (fgets (buff, 1024, fptr) == NULL) break; 
	    buff[strlen(buff) - 1] = 0; 
	    sscanf (buff, "%[^= ] = %[a-z,A-Z,0-9,.]", param, value); 
	    if (!strcmp (param, "WorkerThreadPriorityLowest"))
		WorkerThreadPriority = (atoi (value)) ? 20 : 0;
	    else if (!strcmp (param, "BitmapThreshold"))
		BitMapThreshold = _atoi64 (value);
	    else if (!strcmp (param, "IterationsBetweenWrites"))
		WriteIterations = atoi (value)*3;
	    else if (!strcmp (param, "MinutesBetweenWrites")) {
		WriteIterations = atoi (value);
		if (WriteIterations < 10) WriteIterations = 10; 
	    }
	    else if (!strcmp (param, "DSM_LogDeleted")) 
		DSM_LogDeleted = (atoi (value) == 1); 
	    else if (!strcmp (param, "DSM_TwoSaveFiles")) 
		DSM_TwoSaveFiles = (atoi (value) == 1); 
	    else if (!strcmp (param, "DSM_AlwaysSave")) 
		DSM_DSMYNC = (atoi (value) == 1); 
	    else if (!strcmp (param, "TwoSaveFiles")) { 
		fTwoSaveFilesInIniFile = true; 
		TwoSaveFiles = (atoi (value) == 1); 
	    }
	    else if (!strcmp (param, "PJTEST"))
		fTest = true;
	    else if (!strcmp (param, "InputFileName")) {
		strcpy (AutoRunFile, value);
		fAutoStart = true;
	    }
	    else if (!strcmp (param, "Hidden"))
		fAutoStartHidden = (atoi (value) == 1);
	} 
 	fclose (fptr); 
    } 

//  Process command line arguments, if any.

    for (i=1; i<argc; i++) {
	p = argv[i]; 
	if (*p++ != '-') break;
	switch (*p++) {
	case 'C' :			// Continue sieving an old file
	case 'c' :
	    fGenerateFile = false;
	    State = 0;
	    switch (*p++) {
	    case 'I' :			// Get input file name
	    case 'i' :
		if (*p == '=') strcpy (inbuff, p+1);
		break;
	    case 'O' :			// Get output file name
	    case 'o' :
	    case 'P' :
	    case 'p' :
		if (*p == '=') strcpy (outbuff, p+1);
		break;
	    }
	    break;
	case 'W' :			// Create a new file
	case 'w' :
	    fGenerateFile = true;
	    State = 0;
	    switch (*p++) {
	    case 'O' :			// Get output file name
	    case 'o' :
	    case 'P' :
	    case 'p' :
		if (*p == '=') strcpy (outbuff, p+1);
		break;
	    }
	    break;
	case 'T' :			// Get type of sieve
	case 't' :
	    strcpy (tbuff, "0");	// Set default type
	    if ((*p == '=') && isDigitString(p+1))
		strcpy (tbuff, p+1);
	    break;
	case 'L' :			// Get chain length, when relevant
	case 'l' :
	    if ((*p == '=') && isDigitString(p+1))
		strcpy (lbuff, p+1);
	    break;
	case 'B' :			// Get the base
	case 'b' :
	    strcpy (bbuff, "2");	// Set default base
	    if (!strncmp(p, "ase=", 4) && isDigitString(p+4))
		strcpy (bbuff, p+4);
	    break;
	case 'N' :			// Get n, or limits for k fixed
	case 'n' :
	    if ((*p == '=') && isDigitString(p+1))
		strcpy (nbuff, p+1);
	    else if (!strncmp(p, "min=", 4) && isDigitString(p+4))
		strcpy (kminbuff, p+4);
	    else if (!strncmp(p, "max=", 4) && isDigitString(p+4))
		strcpy (kmaxbuff, p+4);
	    break;
	case 'K' :			// Get k, or limits for n fixed
	case 'k' :
	    if ((*p == '=') && isDigitStringorExpression(p+1))
		strcpy (nbuff, p+1);
	    else if (!strncmp(p, "min=", 4) && isDigitString(p+4))
		strcpy (kminbuff, p+4);
	    else if (!strncmp(p, "max=", 4) && isDigitString(p+4))
		strcpy (kmaxbuff, p+4);
	    break;
	case 'E' :			// Include Even k's, when relevant. 
	case 'e' : 
	    IncludeEvenKs = true; 
	    break; 
	case 'Z' :			// Require generalized chains, when relevant.
	case 'z' :
	    GeneralizedChains = true;
	    break;
	case 'U' :			// Require primorial mode
	case 'u' :
	    PrimorialMode = true;
	    primorialdefault = 'y';
	    break;
	case 'O' :			// Options
	case 'o' :
	    switch (*p++) {
	    case 'W' :			// Worker Thread Priority
	    case 'w' :
			switch (*p++) {
			case 'N' :		// Normal
			case 'n' :
				WorkerThreadPriority = 0;
				break;
			default :		// Lowest
				WorkerThreadPriority = 20;
				break;
		}
		break;
	    case 'A' :			// Automatically continue sieving of last file
	    case 'a' :
			fAutoStartRequired = true;
			break;
	    case 'S' :		// Sieve until...
	    case 's' :
			switch (*p++) {
			case 'P' :	// Sieve up to p = (1000).
			case 'p' :
				StopCriterion = MAXP;
				StopValue = 1000;
				if ((*p == '=') && isDigitString(p+1))
					StopValue = _atoi64(p+1);
				if (StopValue < 1000) StopValue = 1000; 
				break;
			case 'U' :	// Sieve until there are (1000) k's or n's remaining.
			case 'u' :
				StopCriterion = KSREMAINING;
				StopValue = 1000;
				if ((*p == '=') && isDigitString(p+1))
					StopValue = atoi(p+1);
				if (StopValue < 1) StopValue = 1000; 
				break;
			case 'F' :	// Sieve for (24) hours.
			case 'f' :
				StopCriterion = DATETIME;
				StopValue = 24;
				if ((*p == '=') && isDigitString(p+1))
					StopValue = atoi(p+1);
				if (StopValue < 1) StopValue = 24; 
				break;
			case 'R' :	// Sieve until the rate is (0.1) seconds per k or n.
			case 'r' :
				StopCriterion = RATE;
				StopValue = 1;
				if ((*p == '=') && (strtod(p+1, NULL) != 0.0))
					StopValue = (__int64) (10*strtod(p+1, NULL));
				if (StopValue < 1) StopValue = 1; 
				break;
			case 'W' :	// Require autoincrement, if relevant ;
			case 'w' :	// When complete, automatically increment n or k by (1).
				fAutoIncrement = true;
				AutoIncrementAmount = 1;
				if ((*p == '=') && isDigitString(p+1))
					AutoIncrementAmount = atoi(p+1);
				if (AutoIncrementAmount < 1) AutoIncrementAmount = 1; 
				break;
			case 'N' :	// Stop when n gets to (1)(autoincrement mode only).
			case 'n' :
			case 'K' :	// Stop when k gets to (1)(autoincrement mode only).
			case 'k' :
				MaxN = 1;
				if ((*p == '=') && isDigitString(p+1)) {
					MaxN = atoi(p+1);
					if (MaxN < 1) MaxN = 1;
				}
				break;
			case 'G' :	// When complete, pass the file to PFGW for PRP testing.
			case 'g' :
				if (!fAutoIncrement) {
					fPFGW = true;
					PFGWParameters[0] = 0;
				if (*p == '=') strcpy (PFGWParameters, p+1); 
				}
				else
					fPFGW = false;
				break;
			default :
				StopCriterion = NONE;
				fAutoIncrement = false;
				fPFGW = false;
				MaxN = 0;
				break;
			}
			break;
			case 'B' :			// Max RAM to use for the bitmap (47.7) Mb.
			case 'b' :
				if ((*p == '=') && (strtod(p+1, NULL) != 0.0)) {
					BitMapThreshold = (__int64) (strtod(p+1, NULL) * 1024.0 * 1024.0 * 8.0);
					if (BitMapThreshold > (__int64) (/*2047.99*/ 485.0 * 1024.0 * 1024.0 * 8.0))
						BitMapThreshold = 400000000;
				}
				else
					BitMapThreshold = 400000000;
				break;
	    case 'M' :			// Minutes between automatic saves (30).
	    case 'm' :
			if ((*p == '=') && isDigitString(p+1))
		    WriteIterations = atoi(p+1);
		if (WriteIterations < 1)
		    WriteIterations = 30;
		break;
	    case 'L' :			// Append the removed k's or n's in a file
	    case 'l' :
		LogDeleted = true;
		LogDefault = 'y';
		break;
	    case 'U' :			// Use two save files
	    case 'u' :
		TwoSaveFiles = true;
	    }
	    break;
	case 'H' :			// Display help
	case 'h' :
	case '?' :
	    printf("\n");
	    switch (*p++) {
	    case 'A' :			// Display help About...
	    case 'a' :
		printAbout();
		break;
	    case 'C' :			// Display help Contents...
	    case 'c' :
		printContents();
		break;
	    case 'W' :			// Display help What's New
	    case 'w' :
		printWhatsNew();
		break;
	    case 'T' :			// Display the list of types of sieve.
	    case 't' :
		printTypes();
		break;
	    case 'O' :			// Display the list of options.
	    case 'o' :
		printOptions();
		break;
	    default :			// Display program usage.
		printUsage();
		break;
	    }
	    return(0);			// Exit after displaying help
	case 'V' :			// Set verify option
	case 'v' :
	    fVerify = true;
	    verifydefault = 'y';
	    break;
	default :
	    printf ("%s : Invalid option\n", p);
	    printUsage();
	    break;
	}
    }

    if (!fTwoSaveFilesInIniFile && !TwoSaveFiles) 
	printf ("\nThere is a new Option to use two save files.\nIt is highly recommended that you use this option right now.\n"); 

    DoSieving();			// Call the user interface function

    fptr = fopen ("NewPGen.ini", "w");	// Update Ini. file, if possible, then exit. 
    if (fptr) { 
	fprintf (fptr, "TrayIcon = %d\n", 1);  
	fprintf (fptr, "WorkerThreadPriorityLowest = %d\n", WorkerThreadPriority ? 1 : 0);  
	fprintf (fptr, "Priority = %s\n", "Normal");  
#ifdef	__GNUC__
	fprintf (fptr, "BitmapThreshold = %qi\n", BitMapThreshold);  
#else
	fprintf (fptr, "BitmapThreshold = %I64d\n", BitMapThreshold);  
#endif
	fprintf (fptr, "MinutesBetweenWrites = %d\n", WriteIterations);  
	fprintf (fptr, "DSM_TwoSaveFiles = %d\n", DSM_TwoSaveFiles ? 1 : 0); 
	fprintf (fptr, "DSM_AlwaysSave = %d\n", DSM_DSMYNC ? 1 : 0); 
	fprintf (fptr, "TwoSaveFiles = %d\n", TwoSaveFiles ? 1 : 0); 
	fprintf (fptr, "DSM_LogDeleted = %d\n", DSM_LogDeleted ? 1 : 0); 
	if (fAutoStartRequired) {
	    if (outbuff[0]) {
		fprintf (fptr, "InputFileName = %s\n", outbuff);
	    }
	}
	if (fTest) fprintf (fptr, "PJTEST = 1\n");
	if (fAutoStartHidden) {
	    fprintf (fptr, "Hidden = 1\n");
	}
	fclose (fptr);
    }  
	return(0);
}					// End of main code

#endif
