// NewPGen2.h - contains definition for the NewPGen2 routines called from NewPGen.

#ifndef _GOT_NEWPGEN2_H
#define _GOT_NEWPGEN2_H

#define	EXTERNC extern "C" 
 
#ifdef __GNUC__ 
 
#ifndef	__int64 
#define __int64 long long 
#endif 
#ifndef __cdecl
#define __cdecl
#endif
#define LPVOID void *
#define pp64 _pp64
#define bb64 _bb64
#define firstb64 _firstb64
#define mode _mode
#define bitmap _bitmap
#define onebits _onebits
#define nvalsleft _nvalsleft
#define num32 _num32
#define max32 _max32
#define MinNum32 _MinNum32
#define MaxNum32 _MaxNum32
#define addnum32 _addnum32
#define subnum32 _subnum32
#define first32 _first32
#define n32 _n32
#define base _base
#define baseinverse _baseinverse
#define	nvalue _nvalue

#define fastclearasm _fastclearasm
#define fastclear2asm _fastclear2asm
#define revfastclearasm _revfastclearasm
#define doksieveasm1 _doksieveasm1
#define doksieveasm2 _doksieveasm2
#define sievefileasm _sievefileasm 
 

EXTERNC void soe2_iterateasm();
EXTERNC void soe2_fillasm(); 

/* 
 * Intel User FPU Control Word Mask and bit definitions (Windoze uses abtract ones...) 
 */ 
 
#define _MCW_EM         0x0000003f              /* interrupt Exception Masks */ 
#define _EM_INEXACT     0x00000020              /*   inexact (precision) */ 
#define _EM_UNDERFLOW   0x00000010              /*   underflow */ 
#define _EM_OVERFLOW    0x00000008              /*   overflow */ 
#define _EM_ZERODIVIDE  0x00000004              /*   zero divide */ 
#define _EM_DENORMAL    0x00000002              /* denormal exception mask (_control87 only) */ 
#define _EM_INVALID     0x00000001              /*   invalid */ 
 
#define _MCW_RC         0x00000c00              /* Rounding Control */ 
#define _RC_NEAR        0x00000000              /*   near */ 
#define _RC_DOWN        0x00000400              /*   down */ 
#define _RC_UP          0x00000800              /*   up */ 
#define _RC_CHOP        0x00000c00              /*   chop */ 
 
#define _MCW_PC         0x00000300              /* Precision Control */ 
#define _PC_64          0x00000300              /*    64 bits */ 
#define _PC_53          0x00000200              /*    53 bits */ 
#define _PC_24          0x00000000              /*    24 bits */ 
 
#define _MCW_IC         0x00001000              /* Infinity Control */ 
#define _IC_AFFINE      0x00001000              /*   affine */ 
#define _IC_PROJECTIVE  0x00000000              /*   projective */ 
 
/* initial Control Word value */ 
 
#define _CW_DEFAULT ( _RC_NEAR + _PC_64 + _EM_INVALID + _EM_ZERODIVIDE + _EM_OVERFLOW + _EM_UNDERFLOW + _EM_INEXACT + _EM_DENORMAL) 
 
 
#define MCW_EM                  _MCW_EM 
#define EM_INVALID              _EM_INVALID 
#define EM_DENORMAL             _EM_DENORMAL 
#define EM_ZERODIVIDE           _EM_ZERODIVIDE 
#define EM_OVERFLOW             _EM_OVERFLOW 
#define EM_UNDERFLOW            _EM_UNDERFLOW 
#define EM_INEXACT              _EM_INEXACT 
 
#define MCW_IC                  _MCW_IC 
#define IC_AFFINE               _IC_AFFINE 
#define IC_PROJECTIVE           _IC_PROJECTIVE 
 
#define MCW_RC                  _MCW_RC 
#define RC_CHOP                 _RC_CHOP 
#define RC_UP                   _RC_UP 
#define RC_DOWN                 _RC_DOWN 
#define RC_NEAR                 _RC_NEAR 
 
#define MCW_PC                  _MCW_PC 
#define PC_24                   _PC_24 
#define PC_53                   _PC_53 
#define PC_64                   _PC_64 
 
#define CW_DEFAULT              _CW_DEFAULT 
 
__int64 _atoi64(char * s);		// Does not exist in Gnu C 
 
#endif					// __GNUC__ defined 

void FillPrimes ();
void Stop ();
bool readinfile (char *infile);
void initialise ();

#ifdef _CONSOLE			// Dec. 2007
#define LPVOID void *
#endif
EXTERNC unsigned int __cdecl SieveFile (LPVOID fGenerateFile); 

void TuneBase2_init ();
void TuneWorkProcBase2_NoCMOV_Bigp (__int64 &p);
void TuneWorkProcBase2_Bigp (__int64 &p);

extern bool fCMOV;

typedef enum {NONE, MAXP, DATETIME, RATE, KSREMAINING} StopEnum;
 
extern StopEnum StopCriterion;		// The criterion used to stop
extern __int64 StopValue;
extern unsigned int MaxN;

// Variables defined in Assembler code 
 
EXTERNC __int64	pp64; 
EXTERNC __int64	bb64; 
EXTERNC __int64	firstb64; 
EXTERNC	unsigned int MinNum32; 
EXTERNC	unsigned int MaxNum32; 
EXTERNC unsigned int mode; 
EXTERNC unsigned int *bitmap; 
EXTERNC unsigned int *onebits; 
EXTERNC unsigned int nvalsleft; 
EXTERNC unsigned int num32; 
EXTERNC unsigned int max32; 
EXTERNC unsigned int addnum32; 
EXTERNC unsigned int subnum32; 
EXTERNC unsigned int first32; 
EXTERNC unsigned int n32; 
EXTERNC unsigned int base;		// The base.  
EXTERNC __int64		 baseinverse;	// The inverse of the base mod p 
EXTERNC unsigned int nvalue; 		// The value of n (or k, if k-fixed mode)
 
// ********************************** 

extern char outbuff[1024];		// Contains the name of the output file
extern int State;			// 0 - stopped. 1 - generating. 2 - sieving. 4- Stop
extern bool fGenerateFile;
extern __int64 firstp;
extern unsigned int ProthSecs;
extern bool fVerify;
extern __int64 BitMapThreshold;
extern bool UseBitmapHint;

extern bool LogDeleted;
extern bool TwoSaveFiles;

extern unsigned int WriteIterations;

extern bool fTest;

extern bool fMyPrimorial;
extern unsigned int nMyPrimorial;
extern __int64 MyPrimorial[1000];

// Functions defined in Assembler code 
 
EXTERNC void __cdecl fastclearasm(); 
EXTERNC void __cdecl fastclear2asm(); 
EXTERNC void __cdecl revfastclearasm(); 
EXTERNC void __cdecl doksieveasm1(); 
EXTERNC void __cdecl doksieveasm2(); 
EXTERNC void __cdecl sievefileasm(); 
 
// *********************************** 
 
#define	MODE_PLUS			0x0001		// n+1
#define	MODE_MINUS			0x0002		// n-1
#define MODE_MINUS_GNUC		"0x0002"	// n-1 (for use in GNUC assembler code)
#define MODE_2PLUS			0x0004		// 2n+1
#define MODE_2MINUS			0x0008		// 2n-1
#define MODE_4PLUS			0x0010		// 4n+1
#define MODE_4MINUS			0x0020		// 4n-1
#define MODE_PRIMORIAL		0x0040
#define MODE_PLUS5			0x0080
#define MODE_KSIEVE			0x0100
#define MODE_AP				0x0200
#define MODE_NOTGENERALISED 0x0400
#define MODE_PLUS7			0x0800
#define MODE_2PLUS3			0x1000
#define MODE_MOREHEAD		0x2000
#define MODE_EVENKS			0x4000
#define MODE_DUAL			0x8000

#define MASK_2		(MODE_2PLUS | MODE_2MINUS)
#define MASK_4		(MODE_4PLUS | MODE_4MINUS)

#define	MODE_TWIN    (MODE_PLUS | MODE_MINUS)

#define MODE_3TUPLE  (MODE_TWIN | MODE_PLUS5)
#define MODE_4TUPLE  (MODE_TWIN | MODE_PLUS5 | MODE_PLUS7)

#define	MODE_CC      (MODE_PLUS | MODE_2PLUS)
#define	MODE_SG      (MODE_MINUS | MODE_2MINUS)
#define MODE_BI      (MODE_PLUS | MODE_MINUS | MODE_2PLUS | MODE_2MINUS)
#define MODE_SG3	 (MODE_PLUS | MODE_2PLUS3)


#define MODE_IJ		 (MODE_PLUS | MODE_MINUS | MODE_2MINUS)
#define MODE_IJ2	 (MODE_PLUS | MODE_MINUS | MODE_2PLUS)

#define MODE_LP		 (MODE_PLUS | MODE_2PLUS | MODE_2MINUS | MODE_4PLUS)
#define MODE_LM		 (MODE_MINUS | MODE_2MINUS | MODE_2PLUS | MODE_4MINUS)

#define MODE_CC23	 (MODE_PLUS | MODE_2PLUS | MODE_4PLUS)
#define MODE_CC13	 (MODE_MINUS | MODE_2MINUS | MODE_4MINUS)
#define MODE_BI3     (MODE_PLUS | MODE_MINUS | MODE_2PLUS | MODE_2MINUS | MODE_4PLUS | MODE_4MINUS)

#define MODE_PLUSKSIEVE (MODE_PLUS | MODE_KSIEVE)
#define MODE_MINUSKSIEVE (MODE_MINUS | MODE_KSIEVE)

#define MODE_PLUSDUAL   (MODE_PLUS | MODE_DUAL)
#define MODE_MINUSDUAL  (MODE_MINUS | MODE_DUAL)

extern int len3plus;		// Set to the length if we are looking at lengths >= 3.
extern __int64 MinNum;		// The minimum k read in from the file 
extern __int64 MaxNum;		// The maximum k read in from the file 

#define NEWFIXEDKTHRESHOLD 3000

#endif
