 
// newpgenDlg.cpp : GNUC or CONSOLE platform implement. file ; Jean Penn, March 2003, Nov. 2007

#include <sys/types.h>  
#include <stdio.h> 
#ifdef __GNUC__
#include <sys/time.h> 
#include <sys/resource.h> 
#include <sys/stat.h> 
#include <unistd.h> 
#define LL_FORMAT "%qi"  
#define  PRGN "newpgen"
//#define PLUSMINUS "" 
//#define ONEHALF ""
#else
#include <io.h>
#include <time.h> 
#include <SYS/stat.h> 
#include <process.h>
#include "stdafx.h"
#define  S_IXUSR _S_IEXEC
#define LL_FORMAT "%I64d" 
#define  PRGN "cnewpgen"
//#define PLUSMINUS "+/-" 
//#define ONEHALF "(1/2)"
#endif
#define PLUSMINUS "+/-" 
#define ONEHALF "(1/2)"
#include <stdlib.h> 
#include <string.h>  
#include <ctype.h> 
#ifdef __GNUC__
#include <dirent.h>
#endif
#include "Newpgen.h" 
#include "Newpgen2.h" 
#include "Primetable.h" 
 
 
//				Initialized data : 
 
int tcode = 0; 
int WorkerThreadPriority = 20; 
bool fAutoStartHidden = false;
bool fAutoStartRequired = false;
bool fAutoStart = false;
bool PrimorialMode = false; 
bool GeneralizedChains = false; 
bool IncludeEvenKs = false; 
bool fAutoIncrement = false;  
int AutoIncrementAmount = 1;  
bool fDoingAutoIncrement = false; 
bool DSM_LogDeleted = false;  
bool DSM_TwoSaveFiles = false;  
bool DSM_DSMYNC = false;  
bool fTwoSaveFilesInIniFile = false; 
bool Ready = false; 
char verifydefault = 'n'; 
char primorialdefault = 'n'; 
char LogDefault = 'n'; 
char SaveDefault = 'y'; 
 
char *UsageText = 
"Usage :\n\n" 
"0) : "PRGN"\n" 
"\n  No command line options ; the program is in full interactive mode.\n\n" 
"1) : "PRGN"  -[c[i=Inputfilename]] [-c[p=Outputfilename]] [-v]\\\n" 
"     [-oOption1] [-oOption2] ...\n" 
"\n  Continue to sieve an old file.\n" 
"     -v : Set the Verify option.\n\n" 
"2) : "PRGN"  -[w[p=Outputfilename]] [-v] [-z] [-u] [-t=number] [-l=number]\\\n" 
"     [-base=number] [-n=number] [-kmin=number] [-kmax=number] (n fixed types)\\\n" 
"     [-base=number] [-k=number] [-nmin=number] [-nmax=number] (k fixed types)\\\n" 
"     [-oOption1] [-oOption2] ...\n" 
"\n  Create a new file.\n" 
"     -v : Set the Verify option.\n" 
"     -z : Generalized chains (Normal mode only).\n" 
"     -u : Use Primorial mode.\n" 
"     -t=number : Type of sieving ; Use "PRGN" -ht to see them.\n" 
"     -l=number : Chain length ; relevant only for general. CC and BiTwin types.\n\n" 
"3) : "PRGN" -h\n" 
"  Display this.\n\n" 
"4) : "PRGN" -ha\n" 
"  Display the Version number of the program.\n\n" 
"5) : "PRGN" -hc\n" 
"  Display a detailed description of the program.\n\n" 
"6) : "PRGN" -hw\n"  
"  Display What is new in this release.\n\n"  
"7) : "PRGN" -ht\n" 
"  Display a list of the available types of sieving.\n\n" 
"8) : "PRGN" -ho\n" 
"  Display a detailed description of the other command line options.\n"; 
 
static char *Split_helptext =  
"Duplicating a file up allows it to be sieved across several different machines.\r\n" 
"Each machine sieves a different range of p, for example the first could sieve from " 
"10 billion to 20 billion; the second from 20 billion to 30 billion, etc. " 
"You must make sure (using the 'Sieve Until' option on each machine) that the entire range " 
"of p is completed." 
"\r\n" 
"The name of each output file indicates what the 'Sieve Until' value should be. For example, " 
"if you duplicate the file Twin.txt (which has been sieved up to 1 billion) into two files, which are to " 
"be sieved for another 5 billion p each, then the first file will be called 6000000000_Twin.txt; the second " 
"will be 11000000000_Twin.txt" 
"\r\n" 
"Once the entire range has been sieved, use the 'Merge' service to merge the data back " 
"together."; 
 
static char *Merge_helptext =  
"After a file has been split across multiple machines and sieved, the files must be merged together.\r\n" 
"Start off with an empty directory, and place all of the files to be merged in this directory. Note that " 
"all of the files in the directory will be merged together, so make sure that there are no " 
"other files present!\r\n" 
"The files will be merged together, and the result of the merge will be placed in the same directory, " 
"with the name Merged.npg."; 
 
static char *TestSplit_helptext =  
"This will split a NewPGen output file up so that it can be tested on various machines. " 
"Enter the name of the file to be split up, and the number of machines to spread the work among. " 
"Then for each machine, enter its processor speed (MHz).\r\n" 
"Each machine will be given a proportion of the file to test, relative to its speed - so faster machines get more work."; 
 
#define nMainMenu 6 
char *MainMenu[nMainMenu] = { 
    "To create a new file.", 
    "To continue sieving an old file.", 
    "To change one or several option(s).", 
    "To get a service.", 
    "To get some help.", 
    "To exit from this program." 
}; 
 
#define nServices 3 
char *Services[nServices] = { 
	"Sieve across multiple machines - Duplicate.", 
	"Sieve across multiple machines - Merge.",
	"Primality test on several machines - Split."
}; 
 
#define nPtypes 18 
char *Ptypes[nPtypes] = { 
    "k.n#+1", 
    "k.n#-1", 
    "Twin: k.n#"PLUSMINUS"1", 
    "SG: k.n#-1 & 2.k.n#-1", 
    "CC: k.n#+1 & 2.k.n#+1", 
    "BiTwin: k.n#"PLUSMINUS"1 & 2.k.n#"PLUSMINUS"1", 
    "Twin/SG: k.n#"PLUSMINUS"1 & 2.k.n#-1", 
    "Twin/CC: k.n#"PLUSMINUS"1 & 2.k.n#+1", 
    "LP: k.n#"PLUSMINUS"1 & "ONEHALF".k.n#+1 & 2.k.n#+1", 
    "LM: k.n#"PLUSMINUS"1 & "ONEHALF".k.n#-1 & 2.k.n#-1", 
    "CC 1st kind", 
    "CC 2nd kind", 
    "BiTwin", 
    "AP: n#+2k-1", 
    "3-tuple: k.n#/5"PLUSMINUS"1 & k.n#/5+5", 
    "4-tuple: k.n#/35"PLUSMINUS"1, +5, +7", 
    "PrimoProth: k#.2^n+1 with k fixed", 
    "PrimoProth: k#.2^n-1 with k fixed" 
}; 
 
#define nGtypes 21 
char *Gtypes[nGtypes] = { 
    "k.b^n+1", 
    "k.b^n-1", 
    "Twin: k.b^n"PLUSMINUS"1", 
    "SG: k.b^n-1 & k.b^(n+1)-1", 
    "CC: k.b^n+1 & k.b^(n+1)+1", 
    "BiTwin: k.b^n"PLUSMINUS"1 & k.b^(n+1)"PLUSMINUS"1", 
    "Twin/SG: k.b^n"PLUSMINUS"1 & k.b^(n+1)-1", 
    "Twin/CC: k.b^n"PLUSMINUS"1 & k.b^(n+1)+1", 
    "LP: k.b^n"PLUSMINUS"1 & k.b^(n-1)+1 & k.b^(n+1)+1", 
    "LM: k.b^n"PLUSMINUS"1 & k.b^(n-1)-1 & k.b^(n+1)-1", 
    "CC 1st kind", 
    "CC 2nd kind", 
    "BiTwin", 
    "AP: b^n+2k-1 (-2 if b is odd)", 
    "3-tuple: k.b^n"PLUSMINUS"1 & k.b^n+5", 
    "4-tuple: k.b^n"PLUSMINUS"1, +5, +7", 
    "k.b^n+1 with k fixed", 
    "k.b^n-1 with k fixed", 
    "SG: k.b^n+1 & 2k.b^n+3",
    "b^n+k with k fixed", 
    "b^n-k with k fixed"
}; 
 
#define nNGtypes 21 
char *NGtypes[nNGtypes] = { 
    "k.b^n+1", 
    "k.b^n-1", 
    "Twin: k.b^n"PLUSMINUS"1", 
    "SG: k.b^n-1 & 2k.b^n-1", 
    "CC: k.b^n+1 & 2k.b^n+1", 
    "BiTwin: k.b^n"PLUSMINUS"1 & 2k.b^n"PLUSMINUS"1", 
    "Twin/SG: k.b^n"PLUSMINUS"1 & 2k.b^n-1", 
    "Twin/CC: k.b^n"PLUSMINUS"1 & 2k.b^n+1", 
    "LP: k.b^n"PLUSMINUS"1 & k.b^(n-1)+1 & k.b^(n+1)+1", 
    "LM: k.b^n"PLUSMINUS"1 & k.b^(n-1)-1 & k.b^(n+1)-1", 
    "CC 1st kind", 
    "CC 2nd kind", 
    "BiTwin", 
    "AP: b^n+2k-1 (-2 if b is odd)", 
    "3-tuple: k.b^n"PLUSMINUS"1 & k.b^n+5", 
    "4-tuple: k.b^n"PLUSMINUS"1, +5, +7", 
    "k.b^n+1 with k fixed", 
    "k.b^n-1 with k fixed", 
    "SG: k.b^n+1 & 2k.b^n+3", 
    "b^n+k with k fixed", 
    "b^n-k with k fixed"
}; 
 
#define nOptions 7 
char *Options[nOptions] = { 
    "Worker thread priority", 
    "Automatically continue sieving the last file on startup", 
    "Sieve until...", 
    "Set max Mb RAM to store values...", 
    "Minutes between automatic saves...", 
    "Log the numbers removed", 
    "Use two save files" 
}; 
 
#define nPrios 2 
char *Prios[nPrios] = { 
    "Normal", 
    "Lowest" 
}; 
 
#define nSuntil 5 
char *Suntil[nSuntil] = { 
    "Sieve until manually stopped", 
    "Sieve up to p = (1000)", 
    "Sieve until there are (1000) k's or n's remaining", 
    "Sieve for (24) hours", 
    "Sieve until the rate is (0.1) seconds per k or n" 
}; 
 
#define	nHelps 6 
char *Helps[nHelps] = { 
    "Usage", 
    "About", 
    "Contents", 
    "What's new in this release", 
    "Types of sieve", 
    "Options" 
};  
 
#define nResponses 3 
char *Responses[nResponses] = { 
    "Save", 
    "Don't save", 
    "Cancel" 
}; 
 
//				Uninitialized data 
 
bool fPFGW;  
char PFGWParameters[100];  
 
//				I/O buffers 
 
char inbuff[1024]; 
char tbuff[1024]; 
char bbuff[1024]; 
char nbuff[1024]; 
char kminbuff[1024]; 
char kmaxbuff[1024]; 
char lbuff[1024]; 
char origfilename[1024]; 
char infile[10240]; 
char nFbuff[10240]; 
char Rbuff[10240]; 
char Sbuff[1024];
char AutoRunFile[1024];
 
 
//				Utility functions 
 
//  Display the list of non-primorial types of sieve. 
 
void printNormalTypes() { 
    int i; 
    for (i=0; i<nGtypes; i++) 
	if (i>2 && i<5) 
	    printf ("%d : %s if genzed chains, %s if not.\n", i, Gtypes[i], NGtypes[i]+4); 
	else if (i==5) 
	    printf ("%d : %s if genzed chains, %s if not.\n", i, Gtypes[i], NGtypes[i]+8); 
	else if (i>5 && i<8) 
	    printf ("%d : %s if genzed chains, %s if not.\n", i, Gtypes[i], NGtypes[i]+9); 
	else 
	    printf ("%d : %s\n", i, Gtypes[i]); 
    printf ("\n"); 
}  
 
//  Display the list of primorial types of sieve. 
 
void printPrimorialTypes() { 
    int i; 
    for (i=0; i<nPtypes; i++) 
	printf ("%d : %s\n", i, Ptypes[i]); 
    printf ("\n"); 
} 
 
//  Display the "usage" info. 
 
void printUsage() { 
    printf("%s\n", UsageText); 
} 
 
//  Display the additional command line options. 
 
void printOptions() { 
    printf ("\nHere is the list of all additional command line options.\n"); 
    printf ("(These options may also be changed using the interactive menu).\n\n"); 
    printf ("-own :        Worker Thread Priority Normal.\n"); 
    printf ("-ow[^n] :     Worker Thread Priority Lowest(default)\n\n"); 
    printf ("-oa :         Automatically continue sieving of last file.\n"); 
    printf ("-os :         Sieve until manually stopped(default).\n"); 
    printf ("-osp[=nnnn] : Sieve up to p=nnnn(default=1000).\n"); 
    printf ("-osu[=nnnn] : Sieve until there are nnnn k or n remaining(default=1000).\n"); 
    printf ("-osf[=nn] :   Sieve for nn hours(default=24).\n"); 
    printf ("-osr[=dd.d] : Sieve until the rate is dd.d seconds per k or n(default=0.1).\n"); 
    printf ("              Note : The five previous options are mutually exclusive !\n"); 
    printf ("-osw[=nn] :   Automatically increment n or k [by nn, default = 1] when complete.\n"); 
    printf ("              Note : Only taken into account if there is a stop criterion.\n"); 
    printf ("-osg[=\"string\"]:Pass the file to PFGW (with <string> as parameters) when complete.\n");  
    printf ("              Note : Only taken into account if there is a stop criterion.\n");  
    printf ("-osn[=nnnn] : Stop when n gets to nnnn (default = 1)(autoincrement mode only).\n"); 
    printf ("-osk[=nnnn] : Stop when k gets to nnnn (default = 1)(autoincrement mode only).\n\n"); 
    printf ("-ob[=dd.d] :  Set max RAM to use for the bitmap(default=47.7Mb.).\n\n"); 
    printf ("-om[=nn] :    Set Minutes between automatic saves(default=30).\n\n"); 
    printf ("-ol :         Append the removed k's or n's in a file.\n\n"); 
} 
 
//  Display all the types of sieve. 
 
void printTypes() { 
    printf ("The available types of sieve are :\n\n"); 
    printf ("     - If not using primorial mode (no option -u) :\n"); 
    printNormalTypes(); 
    printf ("     - If using primorial mode (option -u) :\n"); 
    printPrimorialTypes(); 
} 
 
/* The two functions below are adapted from George Woltman's "Menu.c"  code */ 
/* (Copyright 1995-2000 Just For Fun Software, Inc).*/  
 
/* Get line from the user (stdin) */  
  
void get_line(char *buf) {  
    char c;  
    int	i;  
    for (i = 0; ; i++) {  
	if (read (0, &c, 1) != 1) break;  
	if (c == '\n' || c == 0) break;  
	if (i < 1024) *buf++ = c;  
    }  
    *buf++ = 0;  
}  
 
/* Ask user if he is satisfied with his dialog responses */  
  
bool askYesNo(char dflt) {  
    char buf[1024];  
    printf (" (%c) : ", dflt);  
    get_line (buf);  
    if (buf[0] == 0) buf[0] = dflt;  
    return (buf[0] == 'Y' || buf[0] == 'y');  
}  
 
//  Test if a string contains only valid digits. 
 
bool isDigitString(char *s) { 
    while (*s) { 
	if (!isdigit(*s)) return false; 
	s++; 
    } 
    return true; 
} 
 
//  Test if a string contains only valid digits or infix '*'. 
 
bool isDigitStringorExpression(char *s) { 
    while (*s) { 
	if (!isdigit(*s) && *s != '*') return false; 
	s++; 
	if (*(s-1) == '*' && (*s == '*' || *s == 0)) return false;
    } 
    return true; 
} 
 
// Generate a new file name, in AutoIncrement mode, or for Split service 
 
void getnewfilename (char *outbuff, int num, char *inbuff)  
{  
	// Prepend '<num>_' at the start of the file name, but handle directories.  
  
	char *slash = strrchr (inbuff, '\\');  
  
	if (slash)  
	{  
		strncpy (outbuff, inbuff, (slash+1)-inbuff);  
		outbuff[(slash+1)-inbuff] = '\0';  
		slash++;  
	}  
	else  
	{  
		slash = inbuff;  
		outbuff[0] = '\0';  
	}  
	sprintf (outbuff+strlen (outbuff), "%d_", num);  
	strcat (outbuff, slash);  
  
}  
  
 
void Lgetnewfilename (char *outbuff, __int64 num, char *inbuff)  
{  
	// Prepend '<num>_' at the start of the file name, but handle directories.  
  
	char *slash = strrchr (inbuff, '\\');  
  
	if (slash)  
	{  
		strncpy (outbuff, inbuff, (slash+1)-inbuff);  
		outbuff[(slash+1)-inbuff] = '\0';  
		slash++;  
	}  
	else  
	{  
		slash = inbuff;  
		outbuff[0] = '\0';  
	}  
	sprintf (outbuff+strlen (outbuff), LL_FORMAT"_", num);  
	strcat (outbuff, slash);  
  
}  
  
//  Ask for generalized chains, if relevant. 
 
bool HandleGeneralized() { 
    if (PrimorialMode || (base == 2)) return false; 
    if (tcode < 3 || tcode > 7) return false; 
    if (Ready) 
	return (!GeneralizedChains);		// Don't ask if batch mode ! 
    printf ("Generalized chains ?"); 
    if (GeneralizedChains) 
	GeneralizedChains = askYesNo ('y'); 
    else 
	GeneralizedChains = askYesNo ('n'); 
    return (!GeneralizedChains); 
} 
 
//  Ask for even k's included, if relevant. 
 
bool HandleEven() { 
    if (PrimorialMode || base != 2) 
	return false; 
    if (tcode == 13 || tcode == 16 || tcode == 17 || tcode == 19 || tcode == 20) 
	return false;			// AP and fixed k sieves. 
    if (Ready) 
	return (IncludeEvenKs);		// Don't ask if batch mode ! 
    printf ("Include even k's ?");  
    if (IncludeEvenKs)  
	IncludeEvenKs = askYesNo ('y');  
    else  
	IncludeEvenKs = askYesNo ('n');  
    return (IncludeEvenKs);  
} 
 
//  Get or display the base value. 
 
int getBase() { 
    printf("Base = "); 
    if (!bbuff[0]) 
	get_line(bbuff); 
    else  
	printf("%s\n", bbuff); 
    while (!bbuff[0] || !isDigitString(bbuff)) { 
	printf("Invalid number ; Base = "); 
	get_line(bbuff); 
    } 
    return atoi(bbuff); 
} 
 
//  Get or display the n or k value. 
 
void getNorK() { 
   while (true) { 
	if (mode & (MODE_KSIEVE|MODE_DUAL)) 
	    printf("k = "); 
	else 
	    printf("n = "); 
	if (!nbuff[0]) 
	    get_line(nbuff); 
	else  
	    printf("%s\n", nbuff); 
	while (!nbuff[0]) { 
	    if (mode & (MODE_KSIEVE|MODE_DUAL)) 
		printf("Invalid number ; k = "); 
	    else 
		printf("Invalid number ; n = "); 
	    get_line(nbuff); 
	} 
	if (strchr (nbuff, '*')) {
	    // This ought to be a k.2^n fixed k sieve.
	    if (base != 2 || !(mode & MODE_KSIEVE) || (mode & MODE_PRIMORIAL)) {
		printf ("This ought to be a k.2^n fixed k sieve...\n");
		if (Ready)
		    exit(1);
		else {
		    nbuff[0] = 0;
		    continue;
		}
	    }
	    // OK, get the values into my array
	    fMyPrimorial = true;
	    nvalue = 1;
	    char *x = nbuff;
	    __int64 *MyPrimorialptr = MyPrimorial;

	    do {
		*MyPrimorialptr++ = _atoi64 (x);
		x = strchr (x, '*');
		if (x) x++;
	    } while (x);

	    nMyPrimorial = MyPrimorialptr - MyPrimorial;
	    mode |= MODE_PRIMORIAL;
	    break;
	}
	else {
	    if (!isDigitString(nbuff)) {
		if (Ready) {
		    printf("Invalid number.\n"); 
		    exit(1);
		}
		else {
		    printf("Invalid number ; "); 
		    nbuff[0] = 0;
		    continue;
		}
	    }
	    else {
		nvalue = atoi (nbuff);
		if ((mode & (MODE_KSIEVE|MODE_DUAL)) && !(mode & MODE_PRIMORIAL) && (nvalue & 1) && (base & 1))
		{
		    printf ("k ought to be even for that fixed k sieve.\n");
		    if (Ready) {
			exit(1);
		    }
		    else {
			nbuff[0] = 0;
			continue;
		    }
		}
		break;
	    }
	}
   } 
} 
 
//  Get or display the limits of the current sieving. 
 
void getLimits() { 
    while (true) { 
	if (mode & (MODE_KSIEVE|MODE_DUAL)) 
	    printf("nmin = "); 
	else 
	    printf("kmin = "); 
	if (!kminbuff[0]) 
	    get_line(kminbuff); 
	else  
	    printf("%s\n", kminbuff); 
	while (!kminbuff[0] || !isDigitString(kminbuff)) { 
	    if (mode & (MODE_KSIEVE|MODE_DUAL)) 
		printf("Invalid number ; nmin = "); 
	    else 
		printf("Invalid number ; kmin = "); 
	    get_line(kminbuff); 
	} 
	MinNum = _atoi64(kminbuff); 
	if (mode & (MODE_KSIEVE|MODE_DUAL)) 
	    printf("nmax = "); 
	else 
	    printf("kmax = "); 
	if (!kmaxbuff[0]) 
	    get_line(kmaxbuff); 
	else  
	    printf("%s\n", kmaxbuff); 
	while (!kmaxbuff[0] || !isDigitString(kmaxbuff)) { 
	    if (mode & (MODE_KSIEVE|MODE_DUAL)) 
		printf("Invalid number ; nmax = "); 
	    else 
		printf("Invalid number ; kmax = "); 
	    get_line(kmaxbuff); 
	} 
	MaxNum = _atoi64(kmaxbuff); 
	if (MaxNum < MinNum) {  
	    printf ("High limit must be >= Low limit !\n"); 
	    kminbuff[0] = kmaxbuff[0] = 0;  
	    if (Ready) exit (1);	// Exit in batch mode 
	} 
	else 
	    break; 
    } 
} 
 
//  Get an integer number. 
 
int getNb(char *name, int dflt) { 
    char buff[1024]; 
    printf("%s", name); 
    get_line(buff); 
    if (!buff[0]) return dflt; 
    while (buff[0] && !isDigitString(buff)) { 
	printf("Invalid number ; %s", name); 
	get_line(buff); 
    } 
    if (!buff[0]) return dflt; 
    return atoi(buff); 
} 
 
//  Get a 64 bits integer number. 
 
__int64 getNb64(char *name, int dflt) { 
    char buff[1024]; 
    printf("%s", name); 
    get_line(buff); 
    if (!buff[0]) return dflt; 
    while (buff[0] && !isDigitString(buff)) { 
	printf("Invalid number ; %s", name); 
	get_line(buff); 
    } 
    if (!buff[0]) return dflt; 
    return _atoi64(buff); 
} 

//  Get a double precision number. 
 
double getDNb(char *name, double dflt) { 
    char buff[1024]; 
    printf("%s", name); 
    get_line(buff); 
    if (!buff[0]) return dflt; 
    if (!strcmp (buff, "0.0") || !strcmp (buff, "0")) 
	return 0.0; 
    while (buff[0] && (strtod(buff, NULL) == 0.0)) { 
	printf("Invalid number ; %s", name); 
	get_line(buff); 
	if (!strcmp (buff, "0.0") || !strcmp (buff, "0")) 
	    return 0.0; 
    } 
    if (!buff[0]) return dflt; 
    return strtod(buff, NULL); 
} 
 
//  Choose a string in an array of strings. 
 
int ChooseString(char *tab[], int ntab, int dflt) { 
    char buf[1024]; 
    int i; 
    for (i = 0; i < ntab; i++) 
	printf ("\t%d : %s\n", i, tab[i]); 
    printf ("Please, enter your choice (%d) : ", dflt); 
    while (true) { 
	get_line(buf); 
	if (!buf[0]) return dflt; 
	while (buf[0] && !isDigitString(buf)) { 
	    printf("Invalid number ; enter your choice again (%d) : ", dflt); 
	    get_line(buf); 
	    if (!buf[0]) return dflt; 
	} 
	i = atoi (buf); 
	if (i < 0 || i >= ntab) 
	    printf("Number out of range ; enter your choice again (%d) : ", dflt); 
	else 
	    return i; 
    } 
} 
 
//  See and change one ore more option(s). 
 
void getOptions() { 
    int opt, su; 
    while (true) { 
	printf ("\nWhat option do you want to change ?\n"); 
	opt = ChooseString (Options, nOptions, 0); 
	switch (opt) { 
	case 0 : 
	    printf ("\nChanging the Worker thread priority :\n"); 
	    WorkerThreadPriority = 20 * ChooseString (Prios, nPrios, 1); 
	    break; 
	case 1 : 
	    printf ("Automatically continue sieving the last file on startup ?"); 
	    fAutoStartRequired = askYesNo('n'); 
	    break; 
	case 2 :
	    printf ("\nSieve until :\n"); 
	    su = ChooseString (Suntil, nSuntil, 0); 
	    switch (su) { 
	    case 0 : 
		StopCriterion = NONE; 
		fAutoIncrement = false; 
		break; 
	    case 1 : 
		StopCriterion = MAXP; 
		StopValue = getNb64("\nSieve up to p = (1000) ", 1000); 
		if (StopValue < 1000) StopValue = 1000;  
		break; 
	    case 2 : 
		StopCriterion = KSREMAINING; 
		StopValue = getNb64("\nSieve until there are nnnn k's or n's remaining (1000) : ", 1000); 
		if (StopValue < 1) StopValue = 1000;  
		break; 
	    case 3 : 
		StopCriterion = DATETIME; 
		StopValue = getNb64("\nSieve for nn hours (24) : ", 24); 
		if (StopValue < 1) StopValue = 24;  
		break; 
	    case 4 : 
		StopCriterion = RATE; 
		StopValue = (__int64) (10*getDNb("\nSieve until the rate is nn.n seconds per k or n (0.1) : ", 0.1)); 
		if (StopValue < 1) StopValue = 1;  
		break; 
	    } 
	    if (StopCriterion != NONE) { 
		printf ("\nAutomatically increment n or k when complete ?"); 
		if (fAutoIncrement = askYesNo('n')) { 
		    AutoIncrementAmount = getNb("\nWhen complete, increment n or k by (1) : ", 1); 
		    if (AutoIncrementAmount < 1) AutoIncrementAmount = 1;  
		    printf ("\nDo you want to stop when n or k gets a limit ?"); 
		    if (askYesNo('n')) { 
			MaxN = getNb("\nStop when n or k gets to (1) : ", 1); 
			if (MaxN < 1) MaxN = 1;  
		    } 
		    else 
			MaxN = 0; 
		} 
		else { 
		  printf ("\nPass the file to PFGW for PRP testing when complete ?");  
		  if (fPFGW = askYesNo('n')) {  
		    struct stat sts; 
 		    if (stat ("./pfgw", &sts) != 0) { 
			printf ("I cannot find \"pfgw\" in the current directory.\nTo automatically call PFGW, it must be in the current directory.");  
			fPFGW = false;  
			PFGWParameters[0] = 0;  
		    } 
		    else if (sts.st_mode & S_IXUSR) { 
			printf("Enter additionnal PFGW parameters, e.g. -n for low priority : "); 
			get_line(PFGWParameters);  
  
			// Strip leading/trailing whitespace from the parameters  
			while (isspace (PFGWParameters[strlen (PFGWParameters)-1]))  
			{  
				PFGWParameters[strlen (PFGWParameters)-1] = 0;  
			}  
			while (isspace (PFGWParameters[0]))  
			{  
				memmove (PFGWParameters, PFGWParameters+1, strlen (PFGWParameters));  
			}  
		    }  
		    else {  
			printf("\"pfgw\" is not an executable file.\n"); 
			fPFGW = false;  
			PFGWParameters[0] = 0;  
		    }  
		  }  
		} 
	    } 
	    break; 
	case 3 : 
	    while ((BitMapThreshold = (__int64) (getDNb ("\nMax RAM to use for the bitmap, Mb (47.7) : ", 47.6837159) * 1024.0 * 1024.0 * 8.0)) > (__int64) (485.0*1024.0*1024.0*8.0)) 
		printf ("That is not a valid size!\nThe allowable range is 0 to 485.0 Mb\n"); 
	    break; 
	case 4 : 
	    while ((WriteIterations = getNb("\nMinutes between saves (30) : ", 30)) < 1) 
		printf ("That is not a valid number of minutes!\n"); 
	    break; 
	case 5 : 
	    printf ("Log the numbers deleted ?"); 
	    LogDeleted = askYesNo(LogDefault); 
	    LogDefault = (LogDeleted) ? 'y' : 'n'; 
	    if (LogDeleted && !DSM_LogDeleted) { 
		printf("The removed k's or n's will be appended to the file NEWPGEN.DEL, one per line.\nNote that this will only be done once p exceeds 2^32 (~4.3 billion), for the sake of performance.\nShow me this again ? "); 
		DSM_LogDeleted = !askYesNo('n'); 
	    } 
	    break; 
	case 6 : 
	    printf ("Use two save files ?"); 
	    TwoSaveFiles = askYesNo(SaveDefault); 
	    SaveDefault = (TwoSaveFiles) ? 'y' : 'n'; 
	    if (TwoSaveFiles && !DSM_TwoSaveFiles) { 
		printf("Before the output file is written, the previous contents will be saved to a file with the same name followed by a tilde\r\n(For example, work.dat would be saved to work.dat~).\nShow me this again ? "); 
		DSM_TwoSaveFiles = !askYesNo('n'); 
	    } 
	    break; 
	} 
//	ResetToDefaults();
	printf ("\nWould you change any more option ?"); 
	if (!askYesNo ('n')) break; 
    }	 
} 
 
//  Display some in-line help. 
 
void getHelp() { 
    int thelp; 
    while (true) { 
	printf ("\nWhat kind of help do you want to get ?\n"); 
	thelp = ChooseString (Helps, nHelps, 0); 
	printf ("\n"); 
	switch (thelp) { 
	case 0 : 
	    printUsage(); 
	    break; 
	case 1 : 
	    printAbout(); 
	    break; 
	case 2 : 
	    printContents(); 
	    break; 
	case 3 : 
	    printWhatsNew(); 
	    break; 
	case 4 : 
	    printTypes(); 
	    break; 
	case 5 : 
	    printOptions(); 
	    break; 
	} 
//	ResetToDefaults();
	printf ("Would you get any more help ?"); 
	if (!askYesNo ('n')) break; 
    } 
} 
 
//  Test if the sieving is really ready to start(used in full command line mode). 
 
bool isReadyToStart() { 
    FILE *fptr; 
    if (fAutoStart) {
	fptr = fopen (AutoRunFile, "r");  
	if (fptr) { 
	    fclose (fptr);
	    strcpy (inbuff, AutoRunFile);
	    strcpy (outbuff, AutoRunFile);
	    fGenerateFile = false;
	    State = 0;
	}
	else
	    printf ("The sieve could not continue sieving the previous file!\n");
    }
    if (fGenerateFile)			// Creating a new file 
	return (outbuff[0] != 0 && tbuff[0] != 0 && bbuff[0] != 0 && nbuff[0] != 0 
		&& kminbuff[0] != 0 && kmaxbuff[0] != 0); 
    else				// Continue sieving an old file 
	return (inbuff[0] != 0 && outbuff[0] != 0); 
} 
 
//  Reset the sieve parameters to their default values. 
 
void ResetToDefaults() { 
    State = 4; 
    fGenerateFile = true; 
    fVerify = false; 
    StopCriterion = NONE; 
    fAutoIncrement = false; 
    fDoingAutoIncrement = false; 
    AutoIncrementAmount = 1; 
    fMyPrimorial = false;
    fPFGW = false; 
    MaxN = 0; 
    LogDeleted = false; 
    if (!fAutoStartRequired) {
	outbuff[0] = 0; 
	inbuff[0] = 0; 
    }
    tbuff[0] = 0; 
    bbuff[0] = 0; 
    nbuff[0] = 0; 
    infile[0] = 0;
    nFbuff[0] = 0;
    Rbuff[0] = 0;
    Sbuff[0] = 0;
    kminbuff[0] = 0; 
    kmaxbuff[0] = 0; 
    strcpy (lbuff, "3"); 
    len3plus = 1; 
    WriteIterations = 30;      
    Ready = false; 
} 
 
void FrmSplit()  
{ 
	// TODO: Add extra validation here 
	char buff[10240]; 
	FILE *ifptr, **ofptr; 
	int i, nFiles; 
	__int64 Range; 
	__int64 OrigRange; 
	bool bOK = false; 
	char rest[1024]; 
 
	printf ("%s\n\nNewPGen file to split : ", Split_helptext); 
	if (!infile[0]) 
		get_line (infile); 
	else 
		printf ("%s\n", infile); 
 
		ifptr = fopen (infile, "r"); 
	if (!ifptr) 
	{ 
		printf ("Cannot open file %s\n", infile); 
		return; 
	} 
	printf ("Split into "); 
	if (!nFbuff[0]) { 
		get_line (nFbuff); 
		printf ("files, and sieve over\na range of "); 
	} 
	else 
		printf ("%s files, and sieve over\na range of ", nFbuff); 
	if (!isDigitString (nFbuff)) { 
		printf ("%s : Invalid number\n", nFbuff); 
		return; 
	} 
	nFiles = atoi (nFbuff); 
	if (nFiles < 2 || nFiles > 25)  
	{ 
		printf ("This number must be at least 2 and at most 25\n"); 
		return; 
	} 
	 
	if (!Rbuff[0]) { 
		get_line (Rbuff); 
		printf ("p's\n\n"); 
	} 
	else 
		printf ("%s p's\n\n", Rbuff); 
	if (!isDigitString (Rbuff)) { 
		printf ("%s : Invalid number\n", Rbuff); 
		return; 
	} 
	Range = _atoi64 (Rbuff); 
	if (Range < 2)  
	{ 
		printf ("The range must be at least 2 p's\n"); 
		return; 
	} 
 
	if (fgets (buff, 1024, ifptr) != NULL) 
	{ 
		buff[strlen (buff)-1] = '\0'; 
		 
		// This contains the sieve limit and the type. 
		if (sscanf (buff, LL_FORMAT"%s", &OrigRange, rest) == 2) 
		{ 
			bOK = true; 
		} 
	} 
 
	if (!bOK) 
	{ 
		printf ("That does not seem to be a valid NewPGen file!\n");  
		fclose (ifptr); 
		return; 
	} 
 
	ofptr = new FILE *[nFiles]; 
	 
	for (i = 0; i < nFiles; i++) 
	{ 
		char NewName[10240]; 
		Lgetnewfilename (NewName, OrigRange+Range*(i+1), infile); 
		if (!(ofptr[i] = fopen (NewName, "w"))) 
		{ 
			sprintf (buff, "Cannot open an output file called %s!\n", NewName); 
			printf ("%s", buff);  
			fclose (ifptr); 
			while (--i >= 0) fclose (ofptr[i]); 
			return; 
		} 
		fprintf (ofptr[i], LL_FORMAT"%s\n", OrigRange+Range*i, rest); 
	} 
 
	while (!feof (ifptr)) 
	{ 
		if (fgets (buff, 1024, ifptr) != NULL) 
		{ 
			for (i = 0; i < nFiles; i++) 
			{ 
				fputs (buff, ofptr[i]); 
			} 
		} 
	} 
	fclose (ifptr); 
	for (i = 0; i < nFiles; i++) fclose (ofptr[i]); 
 
 
	strcpy (buff, "The output files have been created. They are called "); 
	for (i = 0; i < nFiles; i++) 
	{ 
		char NewName[10240]; 
		Lgetnewfilename (NewName, OrigRange+Range*(i+1), infile); 
		strcat (buff, NewName); 
		if (i < nFiles-1) strcat (buff, ", "); 
		if (i == nFiles-2) strcat (buff, "and "); 
	} 
 
	printf ("%s\n\n", buff);  
 
} 
 
char Directory[10240]; 
 
void frmMerge()  
{ 
	// TODO: Add extra validation here 
	 
	// Hacked together in an hour of just writing code. Very little regard for neatness. 
	// Check out the gotos! 
#ifdef __GNUC__
	char OutFileName[10240]; 
	char tmpFileName[10240]; 
	DIR *dir;
	struct dirent *fileinfo; 
	FILE *ifptrs[256]; 
	int nifptrs = 0; 
	FILE *ofptr; 
	long findhandle; 
	__int64 SievedUpTo = 0; 
	__int64 ks[256]; 
	char rest[1024]; 
	char buff[1024]; 
	bool fnsieve; 
	__int64 kvalue; 
	int nvalue; 
	int count = 0; 
 
 
	printf ("%s\n\nDirectory containing files to merge : ", Merge_helptext); 
	if (!Directory[0]) 
		get_line (Directory); 
	else 
		printf ("%s\n", Directory); 

	if (!Directory[0]) 
		return;

	if (Directory[strlen (Directory)-1] != '/') 
	{ 
		Directory[strlen (Directory)+1] = 0; 
		Directory[strlen (Directory)] = '/'; 
	} 
 
	strcpy (OutFileName, Directory); 
	strcat (OutFileName, "Merged.npg"); 
 
	strcpy (tmpFileName, Directory); 
	strcat (tmpFileName, "*"); 

	
 
	if ((dir = opendir (Directory)) == NULL) 
	{ 
		printf ("The directory is invalid!\n"); 
		return; 
	} 
 
	while ((fileinfo = readdir (dir)) != NULL)
	{ 
		if (!strcmp (fileinfo->d_name, ".")) continue; 
		if (!strcmp (fileinfo->d_name, "..")) continue; 
		if (!strcmp (fileinfo->d_name, "Merged.npg"))  
		{ 
			// Unix file names are case-sensitive, hence strcmp 
			while (--nifptrs >= 0) fclose (ifptrs[nifptrs]); 
			closedir (dir); 
			printf ("There is already a file called Merged.npg present in the directory!\n"); 
			return; 
		} 
 
		sprintf (tmpFileName, "%s%s", Directory, fileinfo->d_name); 
 
		if ((ifptrs[nifptrs] = fopen (tmpFileName, "r")) == NULL) 
		{ 
			while (--nifptrs >= 0) fclose (ifptrs[nifptrs]); 
			closedir (dir); 
			printf ("One of the input files could not be read!\n"); 
			return; 
		} 
		if (fgets (buff, 1024, ifptrs[nifptrs]) != NULL) 
		{			// Read the first line of a file 
			buff[strlen (buff)-1] = '\0'; 
			 
			__int64 Range; 
			char thisrest[1024]; 
 
			// This contains the sieve limit and the type. 
			if (sscanf (buff, LL_FORMAT"%s", &Range, thisrest) != 2) 
			{ 
				while (--nifptrs >= 0) fclose (ifptrs[nifptrs]); 
				closedir (dir); 
				printf ("One of the input files contained a bad first line!\n"); 
				return; 
			} 
			if (nifptrs == 0) 
			{		// Get the type of sieve from the first file. 
				SievedUpTo = Range; 
				strcpy (rest, thisrest); 
 
				char *modeptr = rest+strlen (rest); 
				while (*modeptr != ':') modeptr--; 
				int type = atoi (modeptr+1); 
				fnsieve = ((type & (MODE_KSIEVE | MODE_DUAL)) != 0); 
			} 
			else		// Verify the type and compute the sieve limit 
			{ 
				if (strcmp (rest, thisrest)) 
				{ 
					while (--nifptrs >= 0) fclose (ifptrs[nifptrs]); 
					closedir (dir); 
					printf ("One of the input files was for a different type of sieve (the top line differed)!\n"); 
					return; 
				} 
				if (Range > SievedUpTo) SievedUpTo = Range; 
			} 
		} 
 
 
		if (fgets (buff, 1024, ifptrs[nifptrs]) != NULL) 
		{		// Get the first k/n value from the second line. 
			buff[strlen (buff)-1] = '\0'; 
 
			if (sscanf (buff, LL_FORMAT" %d", &kvalue, &nvalue) != 2) 
			{ 
				while (--nifptrs >= 0) fclose (ifptrs[nifptrs]); 
				closedir (dir); 
				printf ("One of the input files contained an invalid line!\n"); 
				return; 
			} 
 
			ks[nifptrs] = (fnsieve) ? nvalue : kvalue; 
		} 
		else 
		{ 
			while (--nifptrs >= 0) fclose (ifptrs[nifptrs]); 
			closedir (dir); 
			printf ("One of the input files is empty, so the output file will be empty!\n"); 
			return; 
		} 
		nifptrs++; 
	} 
 
	closedir (dir); 
 
	if (nifptrs == 0) 
	{ 
		closedir (dir); 
		printf ("The directory is empty!\n"); 
		return; 
	} 
 
	ofptr = fopen (OutFileName, "w"); 
	if (!ofptr) 
	{ 
		printf ("The output file could not be created!\n"); 
		return; 
	} 
	fprintf (ofptr, LL_FORMAT"%s\n", SievedUpTo, rest); 
 
 
	__int64 max = 0;// max will be the current (not decreasing) candidate value.  
	int matchnum = -1; 
 
	for (;;)	// To be copied, a value must be found in all files. 
	{ 
again: 
		for (int i = 0; i < nifptrs; i++) 
		{	// Search in all the files for current candidate value 
			if (i == matchnum) continue; 
				// This file is already known to contain the value.
			while (ks[i] < max) 
			{	// Search in this file for current candidate value. 
				if (fgets (buff, 1024, ifptrs[i]) != NULL) 
				{ 
					buff[strlen (buff)-1] = '\0'; 
 
					if (sscanf (buff, LL_FORMAT" %d", &kvalue, &nvalue) != 2) 
					{ 
						while (--nifptrs >= 0) fclose (ifptrs[nifptrs]); 
						fclose (ofptr); 
						printf ("One of the input files contained an invalid line!\n"); 
						return; 
					} 
 
					ks[i] = (fnsieve) ? nvalue : kvalue; 
				} 
				else 
				{	// EOF on one file ==> merge completed 
					goto done; 
				} 
			}		// End of "while" loop into a file. 
			 
			if (ks[i] > max) 
			{	// max value not found in this file, skip this value. 
				max = ks[i];	// update the max value 
				matchnum = i;	// Mark this file as containing max 
				goto again;	// Search for max in the other files 
			} 
		}		// End of "for" loop on all the input files. 
		if (fnsieve)	// max found in all files ; record it.
		{ 
			fprintf (ofptr, LL_FORMAT" "LL_FORMAT"\n", kvalue, ks[0]); 
		} 
		else 
		{ 
			fprintf (ofptr, LL_FORMAT" %d\n", ks[0], nvalue); 
		} 
		max = ks[0] + 1;	// Next candidate must be greater. 
		matchnum = -1;		// Search it in all files. 
		count++;		// Update the count of the result file. 
	}			// End of infinite loop. 
 
done: 
	while (--nifptrs >= 0) fclose (ifptrs[nifptrs]); 
	fclose (ofptr); 
 
	sprintf (tmpFileName, "Merged file %s generated, contains %u %c's", OutFileName, count, fnsieve ? 'n' : 'k');  
	printf ("%s\n\n", tmpFileName); 
#else
	char OutFileName[10240];
	char tmpFileName[10240];
	struct _finddata_t fileinfo;
	FILE *ifptrs[256];
	int nifptrs = 0;
	FILE *ofptr;
	long findhandle;
	__int64 SievedUpTo = 0;
	__int64 ks[256];
	char rest[1024];
	char buff[1024];
	bool fnsieve;
	__int64 kvalue;
	int nvalue;
	int count = 0;

	printf ("%s\n\nDirectory containing files to merge : ", Merge_helptext); 
	if (!Directory[0]) 
		get_line (Directory); 
	else 
		printf ("%s\n", Directory); 

	if (!Directory[0]) 
		return;

	if (Directory[strlen (Directory)-1] != '/') 
	{ 
		Directory[strlen (Directory)+1] = 0; 
		Directory[strlen (Directory)] = '/'; 
	} 
 
	strcpy (OutFileName, Directory); 
	strcat (OutFileName, "Merged.npg"); 
 
	strcpy (tmpFileName, Directory); 
	strcat (tmpFileName, "*"); 

	if ((findhandle = _findfirst (tmpFileName, &fileinfo)) == -1)
	{ 
		printf ("The directory is invalid!\n"); 
		return; 
	} 
 
	do
	{
		if (!strcmp (fileinfo.name, ".")) continue;
		if (!strcmp (fileinfo.name, "..")) continue;
		if (!_stricmp (fileinfo.name, "Merged.npg")) 
		{
			// Windows file names are case-insensitive, hence _stricmp
			while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
			_findclose (findhandle);
			printf ("There is already a file called Merged.npg present in the directory!\n"); 
			return;
		}

		sprintf (tmpFileName, "%s%s", Directory, fileinfo.name);

		if ((ifptrs[nifptrs] = fopen (tmpFileName, "r")) == NULL)
		{
			while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
			_findclose (findhandle);
			printf ("One of the input files could not be read!\n"); 
			return;
		}
		if (fgets (buff, 1024, ifptrs[nifptrs]) != NULL)
		{
			buff[strlen (buff)-1] = '\0';
			
			__int64 Range;
			char thisrest[1024];

			// This contains the sieve limit and the type.
			if (sscanf (buff, LL_FORMAT"%s", &Range, thisrest) != 2)
			{
				while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
				_findclose (findhandle);
				printf ("One of the input files contained a bad first line!\n"); 
				return;
			}
			if (nifptrs == 0)
			{
				SievedUpTo = Range;
				strcpy (rest, thisrest);

				char *modeptr = rest+strlen (rest);
				while (*modeptr != ':') modeptr--;
				int type = atoi (modeptr+1);
				fnsieve = ((type & (MODE_KSIEVE | MODE_DUAL)) != 0);
			}
			else
			{
				if (strcmp (rest, thisrest))
				{
					while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
					_findclose (findhandle);
					printf ("One of the input files was for a different type of sieve (the top line differed)!\n"); 
					return;
				}
				if (Range > SievedUpTo) SievedUpTo = Range;
			}
		}


		if (fgets (buff, 1024, ifptrs[nifptrs]) != NULL)
		{
			buff[strlen (buff)-1] = '\0';

			if (sscanf (buff, LL_FORMAT" %d", &kvalue, &nvalue) != 2)
			{
				while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
				_findclose (findhandle);
				printf ("One of the input files contained an invalid line!\n"); 
				return;
			}

			ks[nifptrs] = (fnsieve) ? nvalue : kvalue;
		}
		else
		{
			while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
			_findclose (findhandle);
			printf ("One of the input files is empty, so the output file will be empty!\n"); 
			return;
		}
		nifptrs++;
	} while (_findnext (findhandle, &fileinfo) == 0);

	_findclose (findhandle);

	if (nifptrs == 0)
	{
		_findclose (findhandle);
		printf ("The directory is empty!\n"); 
		return;
	}

	ofptr = fopen (OutFileName, "w");
	if (!ofptr)
	{
		printf ("The output file could not be created!\n"); 
		return;
	}
	fprintf (ofptr, LL_FORMAT"%s\n", SievedUpTo, rest);

	__int64 max = 0;
	int matchnum = -1;

	for (;;)
	{
again:
		for (int i = 0; i < nifptrs; i++)
		{
			if (i == matchnum) continue;
			while (ks[i] < max)
			{
				if (fgets (buff, 1024, ifptrs[i]) != NULL)
				{
					buff[strlen (buff)-1] = '\0';

					if (sscanf (buff, LL_FORMAT" %d", &kvalue, &nvalue) != 2)
					{
						while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
						fclose (ofptr);
						printf ("One of the input files contained an invalid line!\n"); 
						return;
					}

					ks[i] = (fnsieve) ? nvalue : kvalue;
				}
				else
				{
					goto done;
				}
			}
			
			if (ks[i] > max)
			{
				max = ks[i];
				matchnum = i;
				goto again;
			}
		}
		if (fnsieve)
		{
			fprintf (ofptr, LL_FORMAT" "LL_FORMAT"\n", kvalue, ks[0]);
		}
		else
		{
			fprintf (ofptr, LL_FORMAT" %d\n", ks[0], nvalue);
		}
		max = ks[0] + 1;
		matchnum = -1;
		count++;
	}

done:
	while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
	fclose (ofptr);

	sprintf (tmpFileName, "Merged file %s generated, contains %u %c's", OutFileName, count, fnsieve ? 'n' : 'k');  
	printf ("%s\n\n", tmpFileName); 

#endif
} 
 
void frmTestSplit () {
 
	int i; 
//	char buff[1024]; 

	printf ("%s\n\nNewPGen file to split : ", TestSplit_helptext); 
	if (!infile[0]) 
		get_line (infile); 
	else 
		printf ("%s\n", infile); 
 
 
	FILE *ifptr = fopen (infile, "r"); 

	if (!ifptr) 
	{ 
		printf ("Cannot open file %s\n", infile); 
		return; 
	} 
 
	printf ("Number of PCs to use (Max. = 100) : "); 
	if (!nFbuff[0]) 
		get_line (nFbuff); 
	else 
		printf ("%s\n", nFbuff); 
	if (atoi (nFbuff) < 1 || atoi (nFbuff) > 100)  
	{ 
		printf ("Illegal number : %s\n", nFbuff); 
		return; 
	} 
 
	int nFiles = atoi (nFbuff); 
	int *Speeds = new int[nFiles]; 
 
	for (i = 1; i <= nFiles; i++) 
	{ 
		// Jean: frmPCSpeed just gets the speed. On exit:  
		// dlg.m_Button == IDCANCEL (Cancel or Back pressed) or IDOK. 
		// dlg.m_SpeedMHz is the speed that was entered. 
		// The dialog does not accept speeds of <50. 
		Speeds[i-1] = 0;
		while (!Sbuff[0] || Speeds[i-1] < 50) {
		    printf ("\rSpeed of machine %d in Mhz (Min. = 50) : ", i); 
		    get_line (Sbuff);
		    if (!Sbuff[0]) {
			i--;
			if (!i)
			    return;
		    }
		    else
			Speeds[i-1] = atoi (Sbuff);
		}
	} 
 
	printf("\nThe output files will be created - are you sure ?"); 

	if (askYesNo ('y'))
	{ 
		// Do the work! 
		FILE **ofptrs = new FILE *[nFiles]; 
		int totspeed = 0; 
 
		for (i = 0; i  <nFiles; i++) 
		{ 
			char fname[1024]; 
			sprintf (fname, "%s_%d_%d", infile, Speeds[i], i+1); 
 
			ofptrs[i] = fopen (fname, "w"); 
 
			if (!ofptrs[i]) 
			{ 
				printf ("One of the output files could not be opened !\n"); 
				while (i--) 
				{ 
					fclose (ofptrs[i]); 
				} 
				fclose (ifptr); 
				return; 
			} 
			totspeed += Speeds[i]; 
		} 
 
		// OK, lets write out the first line to each file. 
 
		char buff[1024]; 
 
		fgets (buff, 1024, ifptr); 
		for (i = 0; i < nFiles; i++) fputs (buff, ofptrs[i]); 
 
		// Now do the rest of the lines. 
		while (!feof (ifptr)) 
		{ 
			if (!fgets (buff, 1024, ifptr)) 
				break;
 
			int random = rand () % totspeed; 
			int sofar = 0; 
 
			for (i = 0; i < nFiles; i++) 
			{ 
				sofar += Speeds[i]; 
				if (sofar > random) 
				{ 
					fputs (buff, ofptrs[i]);		/*# Should check for no disk space or error (EOF return)! */ 
					break; 
				} 
			} 
		} 
 
		for (i = 0; i < nFiles; i++) 
		{ 
			fclose (ofptrs[i]); 
		} 
		fclose (ifptr); 
 
		printf ("All done. The output files have the speed appended to them, then a number - for example a %d MHz machine's file could be called '%s_%d_1'\n", Speeds[0], infile, Speeds[0]); 
 
	} 
	else 
	{ 
		return; 
	} 
}

void getService () {
    int serv;
    while (true) {
	printf ("\nAvailable Services are :\n");
	serv = ChooseString (Services, nServices, 0);
	printf ("\n");
	switch (serv) {
	case 0 : 
	    FrmSplit(); 
	    break; 
	case 1 : 
	    frmMerge(); 
	    break; 
	case 2 : 
	    frmTestSplit(); 
	    break; 
	} 
	ResetToDefaults();
	printf ("Any more Service ?"); 
	if (!askYesNo ('n')) break; 
    } 
} 
	
    

//  User interface main code 
 
void DoSieving() { 
    int Choice; 
    bool bReadOK; 
    FILE *fptr; 
 
    printf ("\nNewPGen 2.82 - Use Control-C to manually stop the current sieving.\n"); 
 
    Ready = isReadyToStart();	// Set this flag if all parameters already known. 

    if (StopCriterion == NONE) 
	fAutoIncrement = false; 
 
//  Enter main loop to get parameters, and to do sieving. 
 
    while (true) { 
	if (fAutoStartRequired && !TwoSaveFiles)
	    printf ("You have not checked the 'Use Two Save Files' option.\r\nIt is *highly recommended* that you check this option as well, otherwise you may lose your work.");

	if (State == 4) {	// Really restarting, or no command line option 
 
//  Display the main menu. 
 
	    printf ("\nWhat do you want to do now ?\n"); 
	    Choice = ChooseString (MainMenu, nMainMenu, 0); 
	    switch (Choice) { 
	    case 0 :		// Create a new file 
		fGenerateFile = true; 
		break; 
	    case 1 :		// Sieve an old file 
		fGenerateFile = false; 
		break; 
	    case 2 :		// Get Option(s) 
		getOptions(); 
		continue; 
		case 3 :		// Get a Service 
		getService();
		continue; 
	    case 4 :		// Get Help 
		getHelp(); 
		continue; 
	    case 5 :		// Exit 
		printf ("\n"); 
		return; 
	    default :		// Create a new file 
		fGenerateFile = true; 
		break; 
	    } 
	    State = 0; 
	} 
 
//  Ask for verifying results 
 
	if (!fDoingAutoIncrement && !Ready) { 
	    printf ("Verify results ?"); 
	    fVerify = askYesNo (verifydefault); 
	} 
 
	if (fGenerateFile == false) { 
 
// 				Sieving an old file : 
 
//  Get input file name. 
 
	    printf("Sieving an old file ; Input file name = "); 
	    if (!inbuff[0]) 
		get_line(inbuff); 
	    else  
		printf("%s\n", inbuff); 
	    while (!inbuff[0]) { 
		printf("Input file name = "); 
		get_line(inbuff); 
	    } 
 
//  Get output file name. 
 
	    printf("Output file name = "); 
	    if (!outbuff[0]) 
		get_line(outbuff); 
	    else  
		printf("%s\n", outbuff); 
	    while (!outbuff[0]) { 
		printf("Output file name = "); 
		get_line(outbuff); 
	    } 
 
	    bReadOK = readinfile(inbuff);	// Read input file. 
 
//  Display base, n or k, and the limits of the sieve. 
 
	    if (bReadOK) { 
		if (fMyPrimorial || !(mode & MODE_PRIMORIAL)) 
		    printf ("base = %d, ", base); 
		if (mode == MODE_LP || mode == MODE_LM) 
		    // Increment n - it was an old file that we were sieving,  
		    // and readfile() will have decremented it.  
		    // DoSieve() will decrement it again.  
		    nvalue++; 
		if (mode & (MODE_KSIEVE|MODE_DUAL)) { 
		    if (fMyPrimorial) {
			nbuff[0] = 0;
			for (unsigned int i = 0; i < nMyPrimorial; i++) {
			    char buff1[20];
			    sprintf (buff1, "%qi*", MyPrimorial[i]);
			    strcat (nbuff, buff1);
			}
			nbuff[strlen (nbuff) - 1] = 0;
			printf ("k = %s, ", nbuff);  
		    }
		    else
			printf ("k = %d, ", nvalue);  
		    printf ("nmin = "LL_FORMAT", ", MinNum);  
		    printf ("nmax = "LL_FORMAT"\n", MaxNum); 
		} 
		else { 
		    printf ("n = %d, ", nvalue);  
		    printf ("kmin ="LL_FORMAT", ", MinNum);  
		    printf ("kmax = "LL_FORMAT"\n", MaxNum); 
		} 
 
//  Compute the external code for the type of sieve. 
 
 		switch (mode & ~(MODE_PRIMORIAL | MODE_NOTGENERALISED | MODE_EVENKS | MODE_MOREHEAD)){ 
		case MODE_PLUS:  
		    tcode = 0;  
		    break;  
		case MODE_MINUS:  
		    tcode = 1;  
		    break;  
		case MODE_TWIN:  
		    tcode = 2;  
		    break;  
		case MODE_SG:  
		    tcode = 3;  
		    break;  
		case MODE_CC:  
		    tcode = 4;  
		    break;  
		case MODE_BI:  
		    tcode = 5;  
		    break;  
		case MODE_IJ:  
		    tcode = 6;  
		    break;  
		case MODE_IJ2:  
		    tcode = 7;  
		    break;  
		case MODE_LP:  
		    tcode = 8;  
		    break;  
		case MODE_LM:  
		    tcode = 9;  
		    break;  
		case MODE_CC13:  
		    tcode = 10;  
		    break;  
		case MODE_CC23:  
		    tcode = 11;  
		    break;  
		case MODE_BI3:  
		    tcode = 12;  
		    break;  
		case MODE_AP:  
		    tcode = 13;  
		    break;  
		case MODE_3TUPLE:  
		    tcode = 14;  
		    break;  
		case MODE_4TUPLE:  
		    tcode = 15;  
		    break;  
		case MODE_PLUSKSIEVE:  
		    tcode = 16;  
		    break;  
		case MODE_MINUSKSIEVE:  
		    tcode = 17;  
		    break;  
		case MODE_SG3:  
		    tcode = 18;  
		    break;  
		case MODE_PLUSDUAL:  
		    tcode = 19;  
		    break;  
		case MODE_MINUSDUAL:  
		    tcode = 20;  
		    break;  
		} 
 
//  Display the type of the current sieve. 
 
		if (!fMyPrimorial && (mode & MODE_PRIMORIAL)) 
		    printf ("Type : %s", Ptypes[tcode]); 
		else if (mode & MODE_NOTGENERALISED) 
		    printf ("Type : %s", NGtypes[tcode]); 
		else 
		    printf ("Type : %s", Gtypes[tcode]); 
 
		if (tcode >= 10 && tcode <= 12) 
		    printf ("\tchain length = %d\n", len3plus); 
		else 
		    printf ("\n"); 
 
		if (!fMyPrimorial && (mode & MODE_PRIMORIAL)) 
		    printf ("Use primorial mode"); 
		else 
		    printf ("Use normal mode"); 
 
		if (mode & MODE_EVENKS) 
		    printf (", Include even k's"); 
  
		if (mode & MODE_NOTGENERALISED) 
		    if ((mode & MODE_PRIMORIAL) || (base == 2) || tcode < 3 || tcode > 7) 
			printf("\n");  
		    else 
			printf(", No Generalized chains\n"); 
		else 
		    if ((mode & MODE_PRIMORIAL) || (base == 2) || tcode < 3 || tcode > 7) 
			printf("\n");  
		    else 
			printf(", Generalized chains\n");  
	    }  
	    else {			// Cancel if input file could not be read. 
		if (Ready) 
		    return;		// Exit in batch mode. 
		else { 
		    ResetToDefaults();  
		    continue; 
		} 
	    } 
	} 
	else { 
 
// 				Creating a new file : 
 
	    if (!fDoingAutoIncrement) {	// Then, get the parameters. 
 
// Get the output file name. 
 
		printf("Creating a new file ; Output file name = "); 
		if (!outbuff[0]) 
		    get_line(outbuff); 
		else  
		    printf("%s\n", outbuff); 
		while (!outbuff[0]) { 
		    printf("Output file name = "); 
		    get_line(outbuff); 
		} 
 
//  Ask for primorial mode. 
 
		if (!Ready) { 
		    printf ("Using primorial mode ?"); 
		    PrimorialMode = askYesNo (primorialdefault); 
		} 
 
//  Get the type of sieve. 
 
		if (tbuff[0]) { 
		    tcode = atoi (tbuff); 
		    if ((!PrimorialMode && tcode >= nGtypes) || (PrimorialMode && tcode >= nPtypes)) { 
			if (Ready) { 
			    printf ("%d : Invalid type of sieve.\n", tcode); 
			    return;	// Exit in batch mode. 
			} 
			else 
			    tcode = -1;	// Mark tcode as invalid... 
		    } 
		} 
		else 
		    tcode = -1;		// Mark tcode as invalid... 
		if (tcode < 0) { 
		    printf ("What type of sieve do you want to do ?\n"); 
		    printf ("The available types of sieve are :\n"); 
		    if(PrimorialMode) 
			tcode = ChooseString(Ptypes, nPtypes, 0); 
		    else 
			if (GeneralizedChains) 
			    tcode = ChooseString(Gtypes, nGtypes, 0); 
			else 
			    tcode = ChooseString(NGtypes, nNGtypes, 0); 
		} 
 
// Get the base. 
 
		if (PrimorialMode) 
		    base = 2; 
		else 
		    base = getBase(); 
 
// Compute the internal mode for this sieve. 
 
		mode = PrimorialMode ? MODE_PRIMORIAL : 0; 
		if (HandleGeneralized()) 
		    mode |= MODE_NOTGENERALISED; 
		if (HandleEven()) 
		    mode |= MODE_EVENKS; 
		switch (tcode) {  
		case 0:   
		    mode |= MODE_PLUS;  
		    break;  
		case 1:  
		    mode |= MODE_MINUS;  
		    break;  
		case 2:  
		    mode |= MODE_TWIN;  
		    break;  
		case 3:  
		    mode |= MODE_SG;  
		    break;  
		case 4:  
		    mode |= MODE_CC;  
		    break;  
		case 5:  
		    mode |= MODE_BI;  
		    break;  
		case 6:  
		    mode |= MODE_IJ;  
		    break;  
		case 7:  
		    mode |= MODE_IJ2;  
		    break;  
		case 8:  
		    mode |= MODE_LP;  
		    break;  
		case 9:  
		    mode |= MODE_LM;  
		    break;  
		case 10:  
		    mode |= MODE_CC13;  
		    break;  
		case 11:  
		    mode |= MODE_CC23;  
		    break;  
		case 12:  
		    mode |= MODE_BI3;  
		    break;  
		case 13:  
		    mode |= MODE_AP;  
		    break;  
		case 14:  
		    mode |= MODE_3TUPLE;  
		    break;  
		case 15:  
		    mode |= MODE_4TUPLE;  
		    break;  
		case 16:  
		    mode |= MODE_PLUSKSIEVE;  
		    break;  
		case 17:  
		    mode |= MODE_MINUSKSIEVE;  
		    break;  
		case 18:  
		    mode |= MODE_SG3;  
		    break;  
		case 19:  
		    mode |= MODE_PLUSDUAL;  
		    break;  
		case 20:  
		    mode |= MODE_MINUSDUAL;  
		    break;  
		}  
		getNorK();	// Get n, or k, if k fixed mode. 
	    }			// End 	if (!fDoingAutoIncrement) 
 
// Do the autoincrement of n or k if required. 
 
	    if (fDoingAutoIncrement) { 
		bool TimeToStopSieving = false;  
 
		if (mode & MODE_PRIMORIAL) { 
		    // Move up to the next prime number.  
		    // Unless we have got to the top, of course.  
		    int i = 0;  
		    while (nvalue > primetable[i]) i++;  
		    if (i+AutoIncrementAmount < PRIMETABLELEN)  
			nvalue = primetable[i+AutoIncrementAmount];  
		    else  
			TimeToStopSieving = true;  
		}  
		else { 
		    nvalue += AutoIncrementAmount;  
		    if ((mode & (MODE_KSIEVE|MODE_DUAL)) && !(mode & MODE_PRIMORIAL) && !(nvalue & 1)) nvalue++;  
		}  
 
		if (MaxN && nvalue > MaxN)  
		    TimeToStopSieving = true;  
 
		if (TimeToStopSieving) { 
		    printf ("The sieve limit has been reached\n"); 
		    if (Ready) 
			return;		// Exit in batch mode. 
		    else { 
			ResetToDefaults(); 
			continue; 
		    } 
		} 
 
		if (mode & (MODE_KSIEVE|MODE_DUAL))  
		    printf ("Next value for k = %d\n", nvalue);  
		else 
		    printf ("Next value for n = %d\n", nvalue);  
	    } 				// End if fDoingAutoIncrement 
 
// In primorial mode, compute the required prime value for n. 
 
	    if (mode & MODE_PRIMORIAL && !fMyPrimorial) { 
		while (nvalue > MAXPRIMORIAL) { 
		    printf ("The maximum value for a primorial is %d#.\nWhat are you thinking of? That has got about %d decimal digits!\n", MAXPRIMORIAL, (int)(MAXPRIMORIAL/2.302585));  
		    if ((rand () % 5) == 2) { 
			// Here's the easter egg!  
			// I could have put up a 3d game... but that would have been needless software bloat.  
			// Instead I will just throw up a few daft message boxes.  
			printf ("Don't curse *me*, blame the idiot who wrote me!");  
			printf ("Actually, now you have got me into this particular bit of code, it all comes flooding back.\nAah, those sweet memories of long debugging sessions into the night...\n");  
		    }  
		    if (!Ready) { 
			nbuff[0] = 0; 
			getNorK();  
		    } 
		    else 
			return;		// Exit in batch mode. 
		}  
		// Find the largest prime <= nvalue, and set nvalue to that.  
		int i = 0;  
		while (nvalue >= primetable[i])  i++;  
		nvalue = primetable[i-1];  
		if (!fDoingAutoIncrement) 
		    if (mode & MODE_KSIEVE) 
			printf ("Prime value for k = %d\n", nvalue);  
		    else 
			printf ("Prime value for n = %d\n", nvalue);   
	    } 
 
//  Eliminate some sieves which would trivially give no result... 
 
	    while ((mode == MODE_3TUPLE || mode == MODE_4TUPLE) && (base%5) == 0) { 
		printf ("5 will always divide k.%d^n+5 - choose a different base.\n", base);  
		if (Ready) return;		// Exit in batch mode. 
		bbuff[0] = 0;  
		base = getBase(); 
	    }  
	    while (mode == MODE_4TUPLE && (base%7) == 0) { 
		printf ("7 will always divide k.%d^n+7 - choose a different base.\n", base);  
		if (Ready) return;		// Exit in batch mode. 
		bbuff[0] = 0;  
		base = getBase(); 
	    }  
	    while ((mode == MODE_SG3) && (base%3) == 0) { 
		printf ("3 will always divide 2k.%d^n+3 - choose a different base.\n", base);  
		if (Ready) return;		// Exit in batch mode. 
		bbuff[0] = 0;  
		base = getBase(); 
	    }  
	    while ((mode & MODE_KSIEVE) && !(mode & MODE_PRIMORIAL) && (mode & MODE_DUAL) && base != 2)
	    {
		printf ("The fixed k 2^n+k sieves only work with base 2 at the moment.\n");
		if (Ready) return;		// Exit in batch mode. 
		bbuff[0] = 0;  
		base = getBase(); 
	    }
	    while ((mode & MODE_KSIEVE) && !(mode & MODE_PRIMORIAL) && !(mode & MODE_DUAL) && base > 255255)
	    {
		printf ("The fixed k sieves requires the base to be <= 255255 at the moment.\n");
		if (Ready) return;		// Exit in batch mode. 
		bbuff[0] = 0;  
		base = getBase(); 
	    }
 
//  Get or display the limits of the current sieving. 
 
	    static __int64 SaveMinNum, SaveMaxNum; 
	    if (!fDoingAutoIncrement) { 
		getLimits(); 
		if (!Ready && MaxNum - MinNum > BitMapThreshold) { 
		    printf ("The range of k that you have specified ("LL_FORMAT") is too large to fit into the bitmap, which can hold %d k's.\nThis is not too much of a problem, as NewPGen will break this up into %d smaller ranges and sieve each in turn up to 1 billion before combining them and sieving together.\nHowever, you might like to consider increasing the bitmap size. Do you wish to continue?", 1+MaxNum-MinNum, BitMapThreshold, (int)(1+(1+MaxNum-MinNum)/BitMapThreshold));  
		    if (!askYesNo('y')) { 
			ResetToDefaults(); 
			continue; 
		    }  
		}   
		SaveMinNum = MinNum;  
		SaveMaxNum = MaxNum;  
	    } 
	    else { 
		MinNum = SaveMinNum;  
		MaxNum = SaveMaxNum;   
		if (mode & (MODE_KSIEVE|MODE_DUAL)) { 
		    printf ("nmin = "LL_FORMAT"\n", MinNum);  
		    printf ("nmax = "LL_FORMAT"\n", MaxNum);  
		} 
		else { 
		    printf ("kmin = "LL_FORMAT"\n", MinNum);  
		    printf ("kmax = "LL_FORMAT"\n", MaxNum); 
		} 
	    }  
 
// Display the type of sieve ; get chain length if relevant. 
 
	    if (mode & MODE_PRIMORIAL && !fMyPrimorial) 
		printf ("Type : %s", Ptypes[tcode]); 
	    else if (mode & MODE_NOTGENERALISED) 
		printf ("Type : %s", NGtypes[tcode]); 
	    else 
		printf ("Type : %s", Gtypes[tcode]); 
 
	    if (tcode >= 10 && tcode <= 12) { 
	      if (!Ready) {  
		printf("\tchain length = (%s) ", lbuff);  
		if (!strcmp (lbuff, "3")) get_line(lbuff);  
		while (lbuff[0] && !isDigitString(lbuff)) {  
		    printf("Invalid number ; chain length = (3) ");  
		    get_line(lbuff);  
		}  
		if (!lbuff[0]) strcpy (lbuff, "3");  
		while (atoi (lbuff) < 3) {  
		    printf("Too small value ; chain length = (3) ");  
		    get_line(lbuff);  
		    while (lbuff[0] && !isDigitString(lbuff)) {  
			printf("Invalid number ; chain length = (3) ");  
			get_line(lbuff);  
		    }  
		    if (!lbuff[0]) strcpy (lbuff, "3");  
		}  
	      } 			// End if (!Ready) 
	      else  
		printf ("\n");   
 
	      len3plus = atoi (lbuff);   
 
	      if (len3plus < 3)		// Verify for batch mode...  
		len3plus = 3;  
	    }				// End (tcode >= 10 && tcode <= 12) 
	    else  
	      printf ("\n");   
	}				// End Creating a new file 
 
// Test if autoincrement will be done. 
 
	if (!fDoingAutoIncrement && fAutoIncrement) { 
	    if (MaxN && nvalue > MaxN) { 
		printf ("You have indicated that %c should be incremented up to %d, but the starting value of %d is less than this!\n", (mode & MODE_KSIEVE) ? 'k' : 'n', MaxN, nvalue);  
		if (Ready) 
		    return;		// Exit in batch mode. 
		else { 
		    ResetToDefaults(); 
		    continue; 
		} 
	    } 
	    strcpy (origfilename, outbuff); 
	    if (mode & (MODE_KSIEVE|MODE_DUAL)) { 
		char newfile1[1024], newfile2[1024];  
  
		getnewfilename (newfile1, nvalue, outbuff);  
		getnewfilename (newfile2, nvalue+2, outbuff);  
		if (!Ready) 
		    printf ("The autoincrement 'k' flag is set.\r\nThis means that once this range has been sieved, 'k' will be incremented and the sieving will start again.\r\nThe output files will be called %s, %s, etc - is this okay?", newfile1, newfile2);  
		else 
		    printf ("The autoincrement 'k' flag is set.\r\nThis means that once this range has been sieved, 'k' will be incremented and the sieving will start again.\r\nThe output files will be called %s, %s, etc...", newfile1, newfile2);  
	    } 
	    else { 
		int nextn; 
		if (mode & MODE_PRIMORIAL) { 
		    // Find the next prime number.  
		    int i = 0;  
		    while (nvalue > primetable[i]) i++;  
		    if (i+AutoIncrementAmount < PRIMETABLELEN)  
			nextn = primetable[i+AutoIncrementAmount];  
		    else 
			// No need to bother searching.  
			// This might look plausible!  
			nextn = MAXPRIMORIAL+4;  
		} 
		else { 
		    nextn = nvalue + AutoIncrementAmount;  
		    if ((mode & (MODE_KSIEVE|MODE_DUAL)) && !(nextn & 1)) 
			nextn++; 
		} 
  
		char newfile1[1024], newfile2[1024];  
  
		getnewfilename (newfile1, nvalue, outbuff);  
		getnewfilename (newfile2, nextn, outbuff);  
  
		if (!Ready) 
		    printf ("The autoincrement 'n' flag is set.\r\nThis means that once this range has been sieved, 'n' will be incremented and the sieving will start again.\r\nThe output files will be called %s, %s, etc - is this okay?", newfile1, newfile2);  
		else 
		    printf ("The autoincrement 'n' flag is set.\r\nThis means that once this range has been sieved, 'n' will be incremented and the sieving will start again.\r\nThe output files will be called %s, %s, etc...", newfile1, newfile2);  
	    }  
	    if (!Ready && !askYesNo('y')) { 
		ResetToDefaults(); 
		continue; 
	    }  
	}  
 
// If autoincrement, set new output file name 
 
	if (fAutoIncrement) { 
	    char newfile[1024];  
	    getnewfilename (newfile, nvalue, origfilename);  
	    strcpy (outbuff, newfile);  
	}   
 
// Is there a stop criterion ? 
 
	if (!fDoingAutoIncrement && StopCriterion != NONE) { 
	    char errbuff[1024];   
	    if (StopCriterion == MAXP) 
		sprintf (errbuff, "Sieve up to p = %qi", StopValue);  
	    else if (StopCriterion == DATETIME) 
		sprintf (errbuff, "Sieve for %qi hours", StopValue);  
	    else if (StopCriterion == RATE) 
		sprintf (errbuff, "Sieve until k's or n's are being removed every %.1f seconds", StopValue/10.0);  
	    else if (StopCriterion == KSREMAINING) 
		sprintf (errbuff, "Sieve until fewer than %qi k's or n's remain", StopValue); 
	    if (!Ready) { 
		printf ("There is a stop criterion for this sieve:\n\n%s.\n\nDo you want to continue?", errbuff);  
		if (!askYesNo('y')) { 
		    ResetToDefaults(); 
		    continue; 
		}  
	    } 
	    else 
		printf ("There is a stop criterion for this sieve:\n\n%s.\n\n", errbuff);  
  	} 
 

	// Ask for seaching prime divisors of a Fermat number 

	if (!fAutoIncrement && !Ready && base == 2 && nvalue == 3 && (mode == MODE_PLUSKSIEVE)) { 
	    printf ("You are sieving 3.2^n+1. Are you looking for a divisor of a Fermat number? \r\n(If you are then I will ignore even values of n, as these can never divide a Fermat number by Morehead's Theorem)"); 
	    if (askYesNo('n')) 
		mode |= MODE_MOREHEAD;  
	}  
	if (!fAutoIncrement && !Ready && base == 2 && nvalue == 9 && (mode == MODE_PLUSKSIEVE)) { 
	    printf ("You are sieving 9.2^n+1. Are you looking for a divisor of a Fermat number? \r\n(If you are then I will ignore even values of n, as these can never divide a Fermat number by Morehead's Theorem)"); 
	    if (askYesNo('n')) 
		mode |= MODE_MOREHEAD;  
	}  
// Test the output file.  
 
	fptr = fopen (outbuff, "r");  
	if (fptr) { 
	    // Already exists...  
	    char newname[10240]; 
	    fclose (fptr);  
	    if (!fDoingAutoIncrement && !Ready) { 
		if (TwoSaveFiles) { 
		  if(!DSM_DSMYNC) { 
		    int resp; 
		    printf ("The output file %s already exists.\nShall I save its contents to %s~ ?\n", outbuff, outbuff);   
		    resp = ChooseString(Responses, nResponses, 0); 
		    printf("Don't show me this again, aways save it ? "); 
		    DSM_DSMYNC = askYesNo('y'); 
		    switch (resp) { 
		    case 0 : 
			sprintf (newname, "%s~", outbuff); 
			remove (newname);  
			rename (outbuff, newname);  
			break; 
		    case 2 : 
			ResetToDefaults();  
			continue;  
		    case 1 : 
		    default : 
			break; 
		    } 
		  } 
		  else { 
		    sprintf (newname, "%s~", outbuff); 
		    remove (newname);  
		    rename (outbuff, newname);  
		  } 
		} 
		else { 
		    printf ("The output file %s already exists - continue?", outbuff);  
		    if (!askYesNo('y')) { 
			ResetToDefaults(); 
			continue; 
		    }  
		} 
	    } 
	    else if (!fDoingAutoIncrement && TwoSaveFiles) { 
		sprintf (newname, "%s~", outbuff); 
		remove (newname);  
		rename (outbuff, newname);  
	    } 
	}  
 
	fptr = fopen (outbuff, "w");  
	if (!fptr) { 
	    // Cannot write  
	    printf ("The output file could not be opened.\n");  
	    if (Ready) 
		return;			// Exit if batch mode 
	    else { 
		ResetToDefaults(); 
		continue;  
	    } 
	}  
	fclose (fptr);  
	remove (outbuff);  
 
// Ask if all is OK. 
 
	if (!fDoingAutoIncrement && !Ready) { 
	    printf ("Are you ready to start sieving ?"); 
	    if (!askYesNo('y')) { 
		ResetToDefaults(); 
		continue; 
	    } 
	} 
 
// Let's go !  

#ifdef __GNUC__

	setpriority (PRIO_PROCESS, getpid(), WorkerThreadPriority); 

#else

	if (WorkerThreadPriority) {
		SetPriorityClass (GetCurrentProcess (), IDLE_PRIORITY_CLASS);
		SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_IDLE);
	}
	else {
		SetPriorityClass (GetCurrentProcess (), NORMAL_PRIORITY_CLASS);
		SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_NORMAL);
	}

#endif
 
	try 
	{ 
		SieveFile (&fGenerateFile);	// Do the required work 
	} 
	catch (...) 
	{ 
		// Sieving is ended with a "throw 1", we end up here. 
	} 
 
#ifdef __GNUC__

	setpriority (PRIO_PROCESS, getpid(), 0); 

#else

	SetPriorityClass (GetCurrentProcess (), NORMAL_PRIORITY_CLASS);
	SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_NORMAL);

#endif

	if (State != 4 && fAutoIncrement) { 
	    fDoingAutoIncrement = true; 
	    fGenerateFile = true;	// To avoid a loop when continuing... 
	} 
	else if (fPFGW) {  
	    bool DoPFGW = true; 
	    if (State == 4) { 
	      if (!Ready) { 
		printf ("The sieving was stopped before the Stop Criterion was reached.\nDo you want to send the data to PFGW anyway ? "); 
		DoPFGW = askYesNo('y'); 
	      } 
	      else { 
		printf ("The sieving was stopped before the Stop Criterion was reached, Program terminated.\n"); 
		return; 
	      } 
	    } 
	    if (DoPFGW) {  
		char _PFGWParameters[100];  
		char *args[50];  
		int argc = 2;  
		// Call PFGW with the output file  
		printf ("\n*** SIEVING COMPLETE - CALLING PFGW...\n");  
  
		strcpy (_PFGWParameters, PFGWParameters);  
  
		args[0] = "pfgw";  
		args[1] = outbuff;  
  
		args[argc++] = strtok (_PFGWParameters, " \t\n");  
  
		while (args[argc-1] != NULL) 
		    args[argc++] = strtok (NULL, " \t\n");  
  
		if (execv ("pfgw", args) == -1)  
		    printf ("...failed!\n");  
		else  
		    printf ("...succeeded\n");  
	    }  
	    if (Ready) 
		return;			// Quit the program if full command line mode  
	    else 
		ResetToDefaults();  
	}  
	else if (Ready) 
	    return;			// Quit the program if full command line mode 
	else { 
	    ResetToDefaults(); 
	} 
    }					// End of main loop 
}					// End of function 
 

