;/***************************************************
; *
; *          File : newpgena.asm - this does the real work.
; *
; *        Author : AP Jobling; assembly optimisations by Yves Gallot
; *
; * Last Modified : 28-Aug-2000
; * 
; ***************************************************
; *
; * This file may be freely distributed, but you must retain this header.
; *
; * Oh, and don't criticise my code 'goto' has its uses, you know!
; *
; **************************************************/

TITLE   newpgena

	.386

cmove_edi_ecx macro
	db 00fh, 044h, 0f9h
endm

_TEXT32	SEGMENT USE32 PARA PUBLIC 'DATA'

PUBLIC	_pp64, _bb64, _firstb64
PUBLIC	_MinNum32, _MaxNum32, _mode, _bitmap, _onebits
PUBLIC	_nvalsleft, _num32, _max32, _addnum32, _subnum32
PUBLIC	_first32, _n32

		align	16

_pp64		DQ	0
_bb64		DQ	0
_firstb64	DQ	0
_MinNum32	DD	0
_MaxNum32	DD	0
_mode		DD	0
_bitmap		DD	0
_onebits	DD	0
_nvalsleft 	DD	0
_num32		DD	0
_max32		DD	0
_addnum32	DD	0
_subnum32	DD	0
_first32	DD	0
_n32		DD	0

po2		DD	0

p			EQU	_pp64
b			EQU	_bb64
firstb		EQU	_firstb64
MinNum  	EQU	_MinNum32
MaxNum  	EQU	_MaxNum32
mode	  	EQU	_mode
bitmap  	EQU	_bitmap
nvalsleft	EQU	_nvalsleft
num			EQU	_num32
max			EQU _max32
addnum		EQU	_addnum32
subnum		EQU	_subnum32
first		EQU	_first32
n		EQU	_n32
nums		EQU _addnum32
lastnums	EQU _num32
MODE_PLUS	EQU	01h

_TEXT32	ENDS

	ASSUME  CS: _TEXT32, DS: _TEXT32, SS: _TEXT32, ES: _TEXT32

_TEXT32	SEGMENT

;/**********************
; * This routine is some fast assembler used to clear with the bitmap.
; **********************/

;__inline void fastclear (unsigned int num, unsigned int max, unsigned int addnum)

ALIGN 16

		PUBLIC	_fastclearasm
_fastclearasm PROC		near
		push	edi
		push	esi
		push	ebp
		push	ebx

		mov eax, num
		mov esi, dword ptr _onebits
		mov edi, dword ptr bitmap
loop0:
		add eax, addnum
		mov ebx, eax
		shr ebx, 5
		mov edx, dword ptr [edi+ebx*4]
		mov ecx, eax
		and ecx, 31
		mov ecx, dword ptr [esi+ecx*4]
		test edx, ecx
		jne	bitset

		cmp eax, max
		jb loop0

		jmp	endproc
bitset:
		xor ecx, -1
		and dword ptr [edi+ebx*4], ecx
		dec nvalsleft
		cmp eax, max
		jb loop0

endproc: 	
		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_fastclearasm ENDP

;__inline void fastclear2 (unsigned int *num, unsigned int *lastnums, unsigned int max)

ALIGN 16

		PUBLIC	_fastclear2asm
_fastclear2asm PROC		near
		push	edi
		push	esi
		push	ebp
		push	ebx

		mov eax, lastnums
		mov eax, dword ptr [eax]
		mov esi, dword ptr _onebits
		mov edi, dword ptr bitmap
		mov edx, dword ptr nums
loop0_1:
		mov ebx, eax
		shr ebx, 5
		mov ecx, eax
		add eax, dword ptr [edx]
		add edx, 4
		cmp edx, lastnums
		jne DoNotResetEdx
		mov edx, dword ptr nums
DoNotResetEdx:
		and ecx, 31
		mov ecx, dword ptr [esi+ecx*4]
		test dword ptr [edi+ebx*4], ecx
		jne	bitset_1

		cmp eax, max
		jbe loop0_1

		jmp	endproc_1

bitset_1:
		xor ecx, -1
		and dword ptr [edi+ebx*4], ecx
		dec nvalsleft
		cmp eax, max
		jbe loop0_1

endproc_1: 	
		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_fastclear2asm ENDP


;__inline void revfastclear (unsigned int num, unsigned int subnum)

ALIGN 16

		PUBLIC	_revfastclearasm
_revfastclearasm PROC	near
		push	edi
		push	esi
		push	ebp
		push	ebx

		mov eax, num
		mov ebx, subnum
		mov esi, dword ptr bitmap
loop0a:
		mov edx, eax
		mov ecx, eax
		mov edi, 1
		and ecx, 31
		shr edx, 5
		shl edi, cl
		test edi, dword ptr [esi+edx*4]
		jne	bitseta
		sub eax, ebx
		jge loop0a

		jmp	endproca
bitseta:
		not edi
		dec nvalsleft
		and dword ptr [esi+edx*4], edi
		sub eax, ebx
		jge loop0a
endproca:	nop

		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_revfastclearasm ENDP

			PUBLIC _doksieveasm1
_doksieveasm1	PROC	near
		push	edi
		push	esi
		push	ebp
		push	ebx

		mov eax, dword ptr p
		mov ebx, dword ptr b
		shr eax, 1
		mov ecx, MaxNum
		inc eax
		mov edi, -1
		mov dword ptr po2, eax
		sub ecx, MinNum
		mov	eax, dword ptr b

		test mode, MODE_PLUS
		je   minus_loop1
	
		mov	esi, dword ptr p
		dec esi

	plus_loop1:
		cmp  ebx, esi
		jne  plus_halve1
		mov  edi, ecx
	plus_halve1:
		shr  ebx, 1
		sbb	 edx, edx
		and  edx, dword ptr po2
		add  ebx, edx
		cmp  ebx, eax
		je	 end1
		dec  ecx
		jge	 plus_loop1
		jmp  end1

	minus_loop1:
		cmp  ebx, 1
		jne  minus_double1
		mov  edi, ecx
	minus_double1:

		shr  ebx, 1
		sbb	 edx, edx
		and  edx, dword ptr po2
		add  ebx, edx
		cmp  ebx, eax
		je	 end1
		dec  ecx
		jge	 minus_loop1

	end1:
		cmp edi, -1
		jz  all_done1
		mov edx, dword ptr MaxNum
		add ecx, MinNum
		inc edx
		add edi, MinNum
		sub edx, ecx
		mov dword ptr first, edi
		mov dword ptr n, edx
	all_done1:

		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_doksieveasm1	ENDP

ALIGN 16

			PUBLIC	_doksieveasm2
_doksieveasm2	PROC	near
	push	edi
	push	esi
	push	ebp
	push	ebx

	mov ecx, MinNum
	mov edx, dword ptr b+4	;	// edx:eax = b
	mov	eax, dword ptr b
	mov edi, -1

	test mode, MODE_PLUS
	je   bigminus_loop

	mov	esi, dword ptr p
	dec esi

bigplus_loop:
	cmp  eax, esi
	jne  bigplus_double
	cmp  edx, dword ptr p+4
	jne	bigplus_double
	mov edi, ecx

bigplus_double:
	shld edx, eax, 1
	shl  eax, 1
	cmp  edx, dword ptr p+4
	jb	 bigplus_checkfirst
	ja	 bigplus_subtractp
	cmp	 eax, dword ptr p
	jb   bigplus_checkfirst
bigplus_subtractp:
	sub  eax, dword ptr p
	sbb  edx, dword ptr p+4

bigplus_checkfirst:
	cmp  eax, dword ptr firstb
	je   bigplus_checktopoffirst

bigplus_endloop:
	inc	 ecx
	cmp  ecx, dword ptr MaxNum
	jbe	 bigplus_loop
	jmp  bigend

bigplus_checktopoffirst:
	cmp	edx, dword ptr firstb+4
	jne	bigplus_endloop
	jmp bigend


bigminus_loop:
	cmp  eax, 1
	jne  bigminus_double
	cmp  edx, 0
	jne	bigminus_double
	mov  edi, ecx

bigminus_double:
	shld edx, eax, 1
	shl  eax, 1
	cmp  edx, dword ptr p+4
	jb	 bigminus_checkfirst
	ja	 bigminus_subtractp
	cmp	 eax, dword ptr p
	jb   bigminus_checkfirst
bigminus_subtractp:
	sub  eax, dword ptr p
	sbb  edx, dword ptr p+4

bigminus_checkfirst:
	cmp  eax, dword ptr firstb
	je   bigminus_checktopoffirst

bigminus_endloop:
	inc	 ecx
	cmp  ecx, dword ptr MaxNum
	jbe	 bigminus_loop
	jmp  bigend

bigminus_checktopoffirst:
	cmp	edx, dword ptr firstb+4
	jne	bigminus_endloop
;	// jmp bigend

bigend:
	mov dword ptr n, ecx
	mov dword ptr first, edi

	pop	ebx
	pop	ebp
	pop	esi
	pop	edi
	ret
_doksieveasm2	ENDP


_TEXT32	ENDS
	END
