/****************************
 * Supporting math routines.
 ***************************/

#ifndef GOT_SUPMATH_H
#define GOT_SUPMATH_H

#define	EXTERNC extern "C" 
 
#ifdef __GNUC__ 

#ifndef	__int64 
#define __int64 long long 
#endif 
#ifndef __cdecl
#define __cdecl
#endif
#define	a64 _a64 
#define	b64 _b64
#define	b164 _b164
#define	b264 _b264
#define	p64 _p64
#define	p064 _p064
#define	p164 _p164
#define	p264 _p264
#define	p364 _p364
#define	p464 _p464
#define	p564 _p564
#define	k064 _k064
#define	k164 _k164
#define	k264 _k264
#define	k364 _k364
#define	k464 _k464
#define	k564 _k564
#define	res64 _res64
#define	i64 _i64
#define	n64 _n64
#define	r64 _r64
#define	r32 _r32
#define	r164 _r164
#define	r264 _r264
#define	x64 _x64
#define	tmp64 _tmp64
#define firstbit32 _firstbit32
#define k3642 _k3642
#define nvalue _nvalue
#define firstbit2 _firstbit2
#define nvalue2 _nvalue2
#define nvalue32 _nvalue32
#define	speedup32 _speedup32
#define oldfpcntrl _oldfpcntrl
#define newfpcntrl _newfpcntrl
#define CPUIDval _CPUIDval
#define Cval1 _Cval1
#define Cval2 _Cval2
#define Cval3 _Cval3
#define Cval4 _Cval4
#define twoto62 _twoto62
#define three  _three
#define convert _convert
#define pinverse _pinverse

#define PackPrimorial _PackPrimorial
#define nPackPrimorial _nPackPrimorial
#define SmallPackPrimorial _SmallPackPrimorial
#define nSmallPackPrimorial _nSmallPackPrimorial

#define	getcw87 _getcw87
#define	setcw87 _setcw87
#define	mulmodp2asm1 _mulmodp2asm1
#define	mulmodp2asm2 _mulmodp2asm2
#define	mulmodp2invasm1 _mulmodp2invasm1
#define	mulmodp2invasm2 _mulmodp2invasm2
#define	modpasm _modpasm
#define	getbaseinverseasm _getbaseinverseasm
#define	get48bitinverseasm1 _get48bitinverseasm1
#define	get48bitinverseasm2 _get48bitinverseasm2
#define	get48bitinverseasm3 _get48bitinverseasm3
#define	pair_getprimorialmodpasm _pair_getprimorialmodpasm
#define	getprimorialmodpasm _getprimorialmodpasm
#define	pair_findbbase2asm _pair_findbbase2asm
#define	findbotherbasesasm _findbotherbasesasm
#define	pair_find2pownmodpasm _pair_find2pownmodpasm
#define	findk2pownmodpasm _findk2pownmodpasm
#define	find2pownmodpasm _find2pownmodpasm 
#define	findhalfpownmodpasm _findhalfpownmodpasm 
#define	findbasepownmodpasm _findbasepownmodpasm 
#define find_k0asm _find_k0asm  
#define find_k0_bigpasm _find_k0_bigpasm  
#define find_k0_nocmov_bigpasm _find_k0_nocmov_bigpasm  
#endif 			// __GNUC__ defined
 
// Variables defined in Assembler code 

EXTERNC	__int64	a64; 
EXTERNC	__int64	b64; 
EXTERNC	__int64	b164; 
EXTERNC	__int64	b264; 
EXTERNC	__int64	p64; 
EXTERNC	__int64	p064; 
EXTERNC	__int64	p164; 
EXTERNC	__int64	p264; 
EXTERNC	__int64	p364; 
EXTERNC	__int64	p464; 
EXTERNC	__int64	p564; 
EXTERNC	__int64	k064; 
EXTERNC	__int64	k164; 
EXTERNC	__int64	k264; 
EXTERNC	__int64	k364; 
EXTERNC	__int64	k464; 
EXTERNC	__int64	k564; 
EXTERNC	__int64	res64; 
EXTERNC	__int64	i64; 
EXTERNC	__int64	n64; 
EXTERNC	__int64	r64; 
EXTERNC	int r32; 
EXTERNC	__int64	r164; 
EXTERNC	__int64	r264; 
EXTERNC	__int64	x64; 
EXTERNC	__int64	tmp64; 
EXTERNC	unsigned int firstbit32; 
EXTERNC	unsigned int k3642; 
EXTERNC	unsigned int nvalue; 
EXTERNC	unsigned int firstbit2; 
EXTERNC	unsigned int nvalue2; 
EXTERNC	unsigned int nvalue32; 
EXTERNC	unsigned int speedup32;
EXTERNC	unsigned int oldfpcntrl; 
EXTERNC	unsigned int newfpcntrl; 
EXTERNC unsigned int CPUIDval;
EXTERNC unsigned int Cval1;
EXTERNC unsigned int Cval2;
EXTERNC unsigned int Cval3;
EXTERNC unsigned int Cval4;
EXTERNC	const __int64 twoto62;	// =0x4000000000000000; 
EXTERNC	const double three;	// =3.0; 
EXTERNC	double convert; 
EXTERNC	double pinverse; 

extern __int64 MAXGUAR;


// *********************************** 
 
const double half=0.5;

EXTERNC
{
__int64 mulmodp2 (const __int64 a, const __int64 b, const __int64 p);
__int64 mulmodp2inv (const __int64 a, const __int64 b, const __int64 p, const double pinv);
unsigned int GetInverse (unsigned int firstj, unsigned int n, unsigned int p);
__int64 GetBaseInverse (const __int64 p);
__int64 Get48bitInverse (const __int64 n, const __int64 p);
void FillPrimorial (unsigned int maxp);
__int64 GetPrimorialModP (__int64 p);
__int64 fastkbasepownmodp (__int64 k, const unsigned int n, const __int64 p);
void pair_findbbase2(const __int64 p1, const __int64 p2, __int64 &r1, __int64 &r2);
__int64 findbotherbases(const __int64 p);
__int64 findb2(const __int64 p);
__int64 find2pownmodp (const __int64 p);
__int64 findbasepownmodp (const __int64 p);
void pair_find2pownmodp (const __int64 p1, const __int64 p2, __int64 &r1, __int64 &r2);
void FillPackPrimorial (unsigned int n);
void FillMyPackPrimorial ();
unsigned int  findk2pownmodp (unsigned int k, unsigned int nvalue, __int64 p1);
void pair_GetPrimorialModP (const __int64 p1, const __int64 p2, __int64 &r1, __int64 &r2);
__int64 halfpownmodp (int n, int topbit, const __int64 p);

void find_k0();
void find_k0_bigp();
void find_k0_nocmov_bigp();
}

extern bool fFPURoundDown;

// Functions defined in Assembler code 
 
EXTERNC void __cdecl	getcw87(); 
EXTERNC void __cdecl	setcw87(); 
EXTERNC void __cdecl	mulmodp2asm1(); 
EXTERNC void __cdecl	mulmodp2asm2(); 
EXTERNC void __cdecl	mulmodp2invasm1(); 
EXTERNC void __cdecl	mulmodp2invasm2(); 
EXTERNC void __cdecl	modpasm(); 
EXTERNC void __cdecl	getbaseinverseasm(); 
EXTERNC void __cdecl	get48bitinverseasm1(); 
EXTERNC void __cdecl	get48bitinverseasm2(); 
EXTERNC void __cdecl	get48bitinverseasm3(); 
EXTERNC void __cdecl	pair_getprimorialmodpasm(); 
EXTERNC void __cdecl	getprimorialmodpasm(); 
EXTERNC void __cdecl	pair_findbbase2asm(); 
EXTERNC void __cdecl	findbotherbasesasm(); 
EXTERNC void __cdecl	pair_find2pownmodpasm(); 
EXTERNC void __cdecl	findk2pownmodpasm(); 
EXTERNC void __cdecl	find2pownmodpasm(); 
EXTERNC void __cdecl	findbasepownmodpasm(); 
EXTERNC void __cdecl	find_k0asm(); 
EXTERNC void __cdecl	find_k0_bigpasm(); 
EXTERNC void __cdecl	find_k0_nocmov_bigpasm();
EXTERNC void __cdecl	findhalfpownmodpasm();
// *********************************** 
 
#endif
