;/****************************
; * Supporting math routines.
; ***************************/

TITLE   supmath

	.386

cmovs_edx_ecx  macro
	db 00fh, 048h, 0d1h
endm

cmovs_eax_ebx  macro
	db 00fh, 048h, 0c3h
endm

cmovz_ebx_eax macro
	db 00fh, 044h, 0d8h
endm

cmovz_ecx_eax macro
	db 00fh, 044h, 0c8h
endm

ffreep_st0 macro
	db 0dfh, 0c0h
endm

cpuid macro
	db 00fh, 0a2h
endm

_TEXT32	SEGMENT USE32 PARA PUBLIC 'DATA'

EXTRN	_PackPrimorial:QWORD
EXTRN	_SmallPackPrimorial:DWORD
EXTRN	_nSmallPackPrimorial:DWORD
EXTRN	_nPackPrimorial:DWORD

PUBLIC	_twoto62, _three, _convert
PUBLIC	_a64,_b64,_b164,_b264,_p64,_p064,_p164,_p264,_p364,_p464,_p564
PUBLIC	_k064,_k164,_k264,_k364,_k464,_k564
PUBLIC	_res64,_i64,_n64,_r64,_r32,_r164,_r264,_x64
PUBLIC	_baseinverse,_tmp64,_pinverse
PUBLIC	_base,_firstbit32,_k3642,_nvalue,_nvalue32,_firstbit2,_nvalue2
PUBLIC	_CPUIDval,_Cval1, _Cval2, _Cval3, _Cval4
PUBLIC	_oldfpcntrl,_newfpcntrl

	align	16

_twoto62 	DQ	4000000000000000h
_three		DQ	3.0
_convert	DQ	0
_a64	DQ	0
_b64	DQ	0
_b164	DQ	0
_b264	DQ	0
_p64	DQ	0
_p064	DQ	0
_p164	DQ	0
_p264	DQ	0
_p364	DQ	0
_p464	DQ	0
_p564	DQ	0
_res64	DQ	0
_i64	DQ	0
_n64	DQ	0
_r64	DQ	0
_r32	DD	0
_r064	DQ  0
_r164	DQ	0
_r264	DQ	0
_r364	DQ	0
_r464	DQ	0
_r564	DQ	0
_r664	DQ	0
_x64	DQ	0
_k064	DQ	0
_k164	DQ	0
_k264	DQ	0
_k364	DQ	0
_k464	DQ	0
_k564	DQ	0
_pinverse DQ 0

_baseinverse	DQ	0
_tmp64	DQ	0
twoto48 	DQ	1000000000000h 
_base	DD	2
_firstbit32	DD	0
_k3642	DD	0
_nvalue DD	0
_firstbit2	DD	0
_nvalue2 DD	0
_nvalue32 DD	0
_oldfpcntrl DD	0
_newfpcntrl DD	0
_CPUIDval DD 00
_Cval1 DD 00
_Cval2 DD 00
_Cval3 DD 00
_Cval4 DD 00

p1o2	DD	0
p2o2	DD	0
One	DD	1

twoto62			EQU	_twoto62
three			EQU	_three
convert			EQU	_convert
PackPrimorial 		EQU	_PackPrimorial
SmallPackPrimorial	EQU	_SmallPackPrimorial
nSmallPackPrimorial	EQU	_nSmallPackPrimorial
nPackPrimorial 		EQU	_nPackPrimorial
pinverse		EQU _pinverse
a	EQU	_a64
b	EQU	_b64
b1	EQU	_b164
b2	EQU	_b264
p	EQU	_p64
p1	EQU	_p164
p2	EQU	_p264
res	EQU	_res64
i	EQU	_i64
n	EQU	_n64
r	EQU	_r64
r0	EQU	_r064
r1	EQU	_r164
r2	EQU	_r264
r3	EQU	_r364
r4	EQU	_r464
r5	EQU	_r564
r6	EQU	_r664
x	EQU	_x64
nBit	DD	0
baseinverse EQU	_baseinverse
tmp	EQU	_tmp64
base	EQU	_base
firstbit EQU	_firstbit32
k	EQU	_k3642
nvalue	EQU	_nvalue
nvalue32 EQU	_nvalue32

_TEXT32	ENDS

	ASSUME  CS: _TEXT32, DS: _TEXT32, SS: _TEXT32, ES: _TEXT32

_TEXT32	SEGMENT

	PUBLIC	_getcw87
_getcw87 PROC	near
	fstcw	WORD PTR _oldfpcntrl
	ret
_getcw87 ENDP


	PUBLIC	_setcw87
_setcw87 PROC	near
	fldcw	WORD PTR _newfpcntrl
	ret
_setcw87 ENDP


		PUBLIC	_sievefileasm
_sievefileasm	PROC	near
;    //Set up convert, and do a CPUID, getting the result into CPUIDval
		fild qword ptr twoto62
		fmul three
		fstp convert

		mov eax, 1
		cpuid
		mov dword ptr _CPUIDval, edx

		mov eax, 2
		cpuid

		mov dword ptr _Cval1, eax
		mov dword ptr _Cval2, ebx
		mov dword ptr _Cval3, ecx
		mov dword ptr _Cval4, edx

		ret
_sievefileasm	ENDP

;//
;// find_k0 - find k0 assuming
;//   firstbit - top bit on n
;//   nvalue - n value
;//   k0...k6 are global output variables
;// this handles 6 independent k0 and p values in parallel for speed.
;// This code is dependent upon cmovxx instructions in Athlon or Pentium III or higher
;// For older CPUs, a different branching logic is required.

ALIGN 16

		PUBLIC	_find_k0asm
_find_k0asm	PROC	near
	push	edi 
	push	esi 
	push	ebp 
	push	ebx 

	; prime the FP stack
	fild	QWORD PTR _p564
	fild	QWORD PTR _p464
	fild	QWORD PTR _p364
	fild	QWORD PTR _p264
	fild	QWORD PTR _p164
	fild	QWORD PTR _p064
	fld1
	fdivr	ST(1), ST(0)
	
	;We have got a few instructions to fill while the div goes on - lets make sure 
	;everything is in cache.
	mov eax, dword ptr _k064
	mov ebx, dword ptr _k164
	mov ecx, dword ptr _k264
	fdivr	ST(2), ST(0)
	mov edx, dword ptr _k364
	mov eax, dword ptr _k464
	mov ebx, dword ptr _k564
	fdivr	ST(3), ST(0)
	mov ecx, dword ptr R0
	mov edx, dword ptr R1
	mov eax, dword ptr R2
	fdivr	ST(4), ST(0)
	mov ebx, dword ptr R3
	mov ecx, dword ptr R4
	mov edx, dword ptr R5
	fdivr	ST(5), ST(0)

	; initialize nBit
	mov		eax, dword ptr firstbit
	mov		dword ptr nBit, eax


	; k<n> = (1+p<n>) >> 1
	; Except for startup/finish, no dependencies less than 4 instructions
	mov		eax, dword ptr _p064
	mov		ebx, dword ptr _p064+4
	mov		ecx, dword ptr _p164
	mov		edx, dword ptr _p164+4
	fdivrp	ST(6), ST(0)
	mov		esi, dword ptr _p264
	mov		edi, dword ptr _p264+4
	add		eax, 1
	adc		ebx, 0
	add		ecx, 1
	adc		edx, 0
	add		esi, 1
	adc		edi, 0
	shr		ebx, 1
	rcr		eax, 1
	shr		edx, 1
	rcr		ecx, 1
	shr		edi, 1
	rcr		esi, 1
	mov		dword ptr _k064, eax
	mov		dword ptr _k064+4, ebx
	mov		dword ptr _k164, ecx
	mov		dword ptr _k164+4, edx
	mov		dword ptr _k264, esi
	mov		dword ptr _k264+4, edi

	mov		eax, dword ptr _p364
	mov		ebx, dword ptr _p364+4
	mov		ecx, dword ptr _p464
	mov		edx, dword ptr _p464+4
	mov		esi, dword ptr _p564
	mov		edi, dword ptr _p564+4
	add		eax, 1
	adc		ebx, 0
	add		ecx, 1
	adc		edx, 0
	add		esi, 1
	adc		edi, 0
	shr		ebx, 1
	rcr		eax, 1
	shr		edx, 1
	rcr		ecx, 1
	shr		edi, 1
	rcr		esi, 1
	mov		dword ptr _k364, eax
	mov		dword ptr _k364+4, ebx
	mov		dword ptr _k464, ecx
	mov		dword ptr _k464+4, edx
	mov		dword ptr _k564, esi
	mov		dword ptr _k564+4, edi


MainLp:
	; prime FP pipeline
	fild	qword ptr _k064			; _k064, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(1)
	fistp	qword ptr R0

	fild	qword ptr _k164			; _k164, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(2)
	fistp	qword ptr R1

	fild	qword ptr _k264			; _k264, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(3)
	fistp	qword ptr R2

	fild	qword ptr _k364			; _k364, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(4)
	fistp	qword ptr R3

	fild	qword ptr _k464			; _k464, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(5)
	fistp	qword ptr R4

	fild	qword ptr _k564			; _k564, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(6)
	fistp	qword ptr R5

	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		StartNoHalve

	;_k064 = (_k064*_k064) mod _p064
	mov		eax, dword ptr _k064
	mul		eax
	mov		esi, eax
	mov		eax, dword ptr _k064+4
	mov		edi, edx
	mul		dword ptr _k064

	; R0 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k064 in edi:esi
	mov		ebx, dword ptr _p064
	mov		ecx, dword ptr _p064+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R0
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R0+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R0
	mul		ecx
	sub		edi, eax

	;  edi:esi has _k064 - ecx:ebx has _p064

	;if (_k064 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k064 += _p064
	cmovz_ebx_eax
	cmovz_ecx_eax

	add		esi, ebx
	adc		edi, ecx

	; _k064 >> 1
	shr		edi, 1
	rcr		esi, 1

;endk0:
	mov		dword ptr _k064, esi
	mov		dword ptr _k064+4, edi


	;_k164 = (_k164*_k164) mod _p164
	mov		eax, dword ptr _k164
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k164+4
	mul		dword ptr _k164

	; R1 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k164 in edi:esi
	mov		ebx, dword ptr _p164
	mov		ecx, dword ptr _p164+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R1
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R1+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R1
	mul		ecx
	sub		edi, eax

	;if (_k164 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k164 += _p164
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k164 >> 1
	shr		edi, 1
	rcr		esi, 1

;endk1:
	mov		dword ptr _k164, esi
	mov		dword ptr _k164+4, edi


	;_k264 = (_k264*_k264) mod _p264
	mov		eax, dword ptr _k264
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k264+4
	mul		dword ptr _k264

	; R2 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k264 in edi:esi
	mov		ebx, dword ptr _p264
	mov		ecx, dword ptr _p264+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R2
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R2+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R2
	mul		ecx
	sub		edi, eax

	;if (_k264 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k264 += _p264
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k264 >> 1
	shr		edi, 1
	rcr		esi, 1

;endk2:
	mov		dword ptr _k264, esi
	mov		dword ptr _k264+4, edi


	;_k364 = (_k364*_k364) mod _p364
	mov		eax, dword ptr _k364
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k364+4
	mul		dword ptr _k364

	; R3 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k364 in edi:esi
	mov		ebx, dword ptr _p364
	mov		ecx, dword ptr _p364+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R3
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R3+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R3
	mul		ecx
	sub		edi, eax

	;if (_k364 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k364 += _p364
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k364 >> 1
	shr		edi, 1
	rcr		esi, 1

;endk3:
	mov		dword ptr _k364, esi
	mov		dword ptr _k364+4, edi

	;_k464 = (_k464*_k464) mod _p464
	mov		eax, dword ptr _k464
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k464+4
	mul		dword ptr _k464

	; R4 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k464 in edi:esi
	mov		ebx, dword ptr _p464
	mov		ecx, dword ptr _p464+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R4
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R4+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R4
	mul		ecx
	sub		edi, eax

	;if (_k464 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k464 += _p464
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k464 >> 1
	shr		edi, 1
	rcr		esi, 1

;endk4:
	mov		dword ptr _k464, esi
	mov		dword ptr _k464+4, edi


	;_k564 = (_k564*_k564) mod _p564
	mov		eax, dword ptr _k564
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k564+4
	mul		dword ptr _k564

	; R5 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k564 in edi:esi
	mov		ebx, dword ptr _p564
	mov		ecx, dword ptr _p564+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R5
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R5+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R5
	mul		ecx
	sub		edi, eax

	;if (_k564 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k564 += _p564
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k564 >> 1
	shr		edi, 1
	rcr		esi, 1

;endk5:
	mov		dword ptr _k564, esi
	mov		dword ptr _k564+4, edi

	; bit >> 1
	; while (bit)
	shr		dword ptr nBit, 1
	jnz		MainLp
	jmp		AllDone

StartNoHalve:

	;_k064 = (_k064*_k064) mod _p064
	mov		eax, dword ptr _k064
	mul		eax
	mov		esi, eax
	mov		eax, dword ptr _k064+4
	mov		edi, edx
	mul		dword ptr _k064

	; R0 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k064 in edi:esi
	mov		ebx, dword ptr _p064
	mov		ecx, dword ptr _p064+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R0
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R0+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R0
	mul		ecx
	sub		edi, eax

;endk0:
	mov		dword ptr _k064, esi
	mov		dword ptr _k064+4, edi


	;_k164 = (_k164*_k164) mod _p164
	mov		eax, dword ptr _k164
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k164+4
	mul		dword ptr _k164

	; R1 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k164 in edi:esi
	mov		ebx, dword ptr _p164
	mov		ecx, dword ptr _p164+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R1
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R1+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R1
	mul		ecx
	sub		edi, eax

;endk1:
	mov		dword ptr _k164, esi
	mov		dword ptr _k164+4, edi


	;_k264 = (_k264*_k264) mod _p264
	mov		eax, dword ptr _k264
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k264+4
	mul		dword ptr _k264

	; R2 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k264 in edi:esi
	mov		ebx, dword ptr _p264
	mov		ecx, dword ptr _p264+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R2
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R2+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R2
	mul		ecx
	sub		edi, eax

;endk2:
	mov		dword ptr _k264, esi
	mov		dword ptr _k264+4, edi


	;_k364 = (_k364*_k364) mod _p364
	mov		eax, dword ptr _k364
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k364+4
	mul		dword ptr _k364

	; R3 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k364 in edi:esi
	mov		ebx, dword ptr _p364
	mov		ecx, dword ptr _p364+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R3
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R3+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R3
	mul		ecx
	sub		edi, eax

;endk3:
	mov		dword ptr _k364, esi
	mov		dword ptr _k364+4, edi

	;_k464 = (_k464*_k464) mod _p464
	mov		eax, dword ptr _k464
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k464+4
	mul		dword ptr _k464

	; R4 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k464 in edi:esi
	mov		ebx, dword ptr _p464
	mov		ecx, dword ptr _p464+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R4
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R4+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R4
	mul		ecx
	sub		edi, eax

;endk4:
	mov		dword ptr _k464, esi
	mov		dword ptr _k464+4, edi


	;_k564 = (_k564*_k564) mod _p564
	mov		eax, dword ptr _k564
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k564+4
	mul		dword ptr _k564

	; R5 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k564 in edi:esi
	mov		ebx, dword ptr _p564
	mov		ecx, dword ptr _p564+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R5
	mul		ebx
	sub		esi, eax
	mov		eax, dword ptr R5+4
	sbb		edi, edx
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R5
	mul		ecx
	sub		edi, eax

;endk5:
	mov		dword ptr _k564, esi
	mov		dword ptr _k564+4, edi

	; bit >> 1
	; while (bit)
	shr		dword ptr nBit, 1
	jnz		MainLp

AllDone:
	; return final results, reduced address dependencies
	; if (k564>=p564) k564 -= p564;
	cmp edi, dword ptr _p564+4
	jl  k5OK
	jg  k5Sub
	cmp esi,dword ptr  _p564
	jb k5OK
k5Sub:
	sub esi, dword ptr _p564
	sbb edi, dword ptr _p564+4
	mov dword ptr _k564, esi
	mov dword ptr _k564+4, edi
k5OK:

	; if (k064>=p064) k064 -= p064;
	mov ebx, dword ptr _k064+4
	mov eax, dword ptr _k064
	cmp ebx, dword ptr _p064+4
	jl  k0OK
	jg  k0Sub
	cmp eax,dword ptr  _p064
	jb k0OK
k0Sub:
	sub eax, dword ptr _p064
	sbb ebx, dword ptr _p064+4
	mov dword ptr _k064, eax
	mov dword ptr _k064+4, ebx
k0OK:

	; if (k164>=p164) k164 -= p164;
	mov ebx, dword ptr _k164+4
	mov eax, dword ptr _k164
	cmp ebx, dword ptr _p164+4
	jl  k1OK
	jg  k1Sub
	cmp eax,dword ptr  _p164
	jb k1OK
k1Sub:
	sub eax, dword ptr _p164
	sbb ebx, dword ptr _p164+4
	mov dword ptr _k164, eax
	mov dword ptr _k164+4, ebx
k1OK:

	; if (k264>=p264) k264 -= p264;
	mov ebx, dword ptr _k264+4
	mov eax, dword ptr _k264
	cmp ebx, dword ptr _p264+4
	jl  k2OK
	jg  k2Sub
	cmp eax,dword ptr  _p264
	jb k2OK
k2Sub:
	sub eax, dword ptr _p264
	sbb ebx, dword ptr _p264+4
	mov dword ptr _k264, eax
	mov dword ptr _k264+4, ebx
k2OK:

	; if (k364>=p364) k364 -= p364;
	mov ebx, dword ptr _k364+4
	mov eax, dword ptr _k364
	cmp ebx, dword ptr _p364+4
	jl  k3OK
	jg  k3Sub
	cmp eax,dword ptr  _p364
	jb k3OK
k3Sub:
	sub eax, dword ptr _p364
	sbb ebx, dword ptr _p364+4
	mov dword ptr _k364, eax
	mov dword ptr _k364+4, ebx
k3OK:

	; if (k464>=p464) k464 -= p464;
	mov ebx, dword ptr _k464+4
	mov eax, dword ptr _k464
	cmp ebx, dword ptr _p464+4
	jl  k4OK
	jg  k4Sub
	cmp eax,dword ptr  _p464
	jb k4OK
k4Sub:
	sub eax, dword ptr _p464
	sbb ebx, dword ptr _p464+4
	mov dword ptr _k464, eax
	mov dword ptr _k464+4, ebx
k4OK:

	fcompp
	fcompp
	fcompp

	pop		ebx 
	pop		ebp 
	pop		esi 
	pop		edi 
	ret

_find_k0asm	ENDP

;// find_k0 - find k0 assuming
;//   firstbit - top bit on n
;//   nvalue - n value
;//   k0, k1, k2, and k3 are global output variables
;// this handles 6 independent k0 and p values in parallel for speed.
;// This code is dependent upon cmovxx instructions in Athlon or Pentium III or higher
;// For older CPUs, a different branching logic is required.
;// To test, execute CPUID with eax set to 1.  If edx bit 15 is set, cmovxx is supported.

ALIGN 16

		PUBLIC	_find_k0_bigpasm
_find_k0_bigpasm	PROC	near

	push	edi 
	push	esi 
	push	ebp 
	push	ebx 

	; prime the FP stack
	fild	QWORD PTR _p564
	fild	QWORD PTR _p464
	fild	QWORD PTR _p364
	fild	QWORD PTR _p264
	fild	QWORD PTR _p164
	fild	QWORD PTR _p064
	fld1
	fdivr	ST(1), ST(0)
	fdivr	ST(2), ST(0)
	
	;We have got a few instructions to fill while the div goes on - lets make sure 
	;everything is in cache.
	mov eax, dword ptr _k064
	mov ebx, dword ptr _k164
	mov ecx, dword ptr _k264
	mov edx, dword ptr _k364
	mov eax, dword ptr _k464
	mov ebx, dword ptr _k564
	fdivr	ST(3), ST(0)
	fdivr	ST(4), ST(0)
	mov ecx, dword ptr R0
	mov edx, dword ptr R1
	mov eax, dword ptr R2
	mov ebx, dword ptr R3
	mov ecx, dword ptr R4
	mov edx, dword ptr R5

	; initialize nBit
	mov		eax, dword ptr firstbit
	mov		dword ptr nBit, eax

	fdivr	ST(5), ST(0)
	fdivrp	ST(6), ST(0)

	; k<n> = (1+p<n>) >> 1
	; Then we do the first two square and multiplies, out of the FPU (which is busy,
	; doing the division), since these are just some number of halvings.

	mov		edi, 2
	mov		esi, dword ptr nvalue
	test	esi, dword ptr nBit
	jz      BPdontadd2
	add     edi, 2
BPdontadd2:
	shr		dword ptr nBit, 1
	test	esi, dword ptr nBit
	jz      BPdontadd1
	add     edi, 1
BPdontadd1:
	shr		dword ptr nBit, 1

	mov		eax, dword ptr _p064
	mov		ebx, dword ptr _p064+4
	mov		ecx, dword ptr _p164
	mov		edx, dword ptr _p164+4
	add		eax, 1
	adc		ebx, 0
	add		ecx, 1
	adc		edx, 0
	shr		ebx, 1
	rcr		eax, 1
	shr		edx, 1
	rcr		ecx, 1

	mov     esi, edi

BPhalveloop1:

	test	eax, 1
	jz		short BPnoadd11
	add		eax, dword ptr _p064
	adc		ebx, dword ptr _p064+4
BPnoadd11:
	shr		ebx, 1
	rcr		eax, 1

	test	ecx, 1
	jz		short BPnoadd21
	add		ecx, dword ptr _p164
	adc		edx, dword ptr _p164+4
BPnoadd21:
	shr		edx, 1
	rcr		ecx, 1

	dec		esi
	jns		BPhalveloop1

	mov		dword ptr _k064, eax
	mov		dword ptr _k064+4, ebx
	mov		dword ptr _k164, ecx
	mov		dword ptr _k164+4, edx
	
	mov		eax, dword ptr _p264
	mov		ebx, dword ptr _p264+4
	mov		ecx, dword ptr _p364
	mov		edx, dword ptr _p364+4
	add		eax, 1
	adc		ebx, 0
	add		ecx, 1
	adc		edx, 0
	shr		ebx, 1
	rcr		eax, 1
	shr		edx, 1
	rcr		ecx, 1

	mov     esi, edi

BPhalveloop2:

	test	eax, 1
	jz		short BPnoadd12
	add		eax, dword ptr _p264
	adc		ebx, dword ptr _p264+4
BPnoadd12:
	shr		ebx, 1
	rcr		eax, 1

	test	ecx, 1
	jz		short BPnoadd22
	add		ecx, dword ptr _p364
	adc		edx, dword ptr _p364+4
BPnoadd22:
	shr		edx, 1
	rcr		ecx, 1

	dec		esi
	jns		BPhalveloop2

	mov		dword ptr _k264, eax
	mov		dword ptr _k264+4, ebx
	mov		dword ptr _k364, ecx
	mov		dword ptr _k364+4, edx

	mov		eax, dword ptr _p464
	mov		ebx, dword ptr _p464+4
	mov		ecx, dword ptr _p564
	mov		edx, dword ptr _p564+4
	add		eax, 1
	adc		ebx, 0
	add		ecx, 1
	adc		edx, 0
	shr		ebx, 1
	rcr		eax, 1
	shr		edx, 1
	rcr		ecx, 1

	mov     esi, edi

BPhalveloop3:

	test	eax, 1
	jz		short BPnoadd13
	add		eax, dword ptr _p464
	adc		ebx, dword ptr _p464+4
BPnoadd13:
	shr		ebx, 1
	rcr		eax, 1

	test	ecx, 1
	jz		short BPnoadd23
	add		ecx, dword ptr _p564
	adc		edx, dword ptr _p564+4
BPnoadd23:
	shr		edx, 1
	rcr		ecx, 1

	dec		esi
	jns		BPhalveloop3

	mov		dword ptr _k464, eax
	mov		dword ptr _k464+4, ebx
	mov		dword ptr _k564, ecx
	mov		dword ptr _k564+4, edx

BPMainLp:
	; prime FP pipeline
	fild	qword ptr _k064			; _k064, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(1)
	fistp	qword ptr R0

	fild	qword ptr _k164			; _k164, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(2)
	fistp	qword ptr R1

	fild	qword ptr _k264			; _k264, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(3)
	fistp	qword ptr R2

	fild	qword ptr _k364			; _k364, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(4)
	fistp	qword ptr R3

	fild	qword ptr _k464			; _k464, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(5)
	fistp	qword ptr R4

	fild	qword ptr _k564			; _k564, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(6)
	fistp	qword ptr R5

	;_k064 = (_k064*_k064) mod _p064
	mov		eax, dword ptr _k064
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k064+4
	mul		ecx
	; R0 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k064 in edi:esi
	mov		ebx, dword ptr _p064
	mov		ecx, dword ptr _p064+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R0
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R0+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R0
	mul		ecx
	xor		edx, edx
	sub		edi, eax
	mov		eax, 0
	cmovs_edx_ecx
	cmovs_eax_ebx
	add		esi, eax
	adc		edi, edx

	;  edi:esi has _k064 - ecx:ebx has _p064
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		BPendk064

	;if (_k064 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k064 += _p064
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k064 >> 1
	shr		edi, 1
	rcr		esi, 1

BPendk064:
	mov		dword ptr _k064, esi
	mov		dword ptr _k064+4, edi


	;_k164 = (_k164*_k164) mod _p164
	mov		eax, dword ptr _k164
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k164+4
	mul		ecx

	; R1 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k164 in edi:esi
	mov		ebx, dword ptr _p164
	mov		ecx, dword ptr _p164+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R1
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R1+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R1
	mul		ecx
	xor		edx, edx
	sub		edi, eax
	mov		eax, 0
	cmovs_edx_ecx
	cmovs_eax_ebx
	add		esi, eax
	adc		edi, edx

	;  edi:esi has _k164 - ecx:ebx has _p164
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		BPendk164

	;if (_k164 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k164 += _p164
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k164 >> 1
	shr		edi, 1
	rcr		esi, 1

BPendk164:
	mov		dword ptr _k164, esi
	mov		dword ptr _k164+4, edi


	;_k264 = (_k264*_k264) mod _p264
	mov		eax, dword ptr _k264
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k264+4
	mul		ecx

	; R2 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k264 in edi:esi
	mov		ebx, dword ptr _p264
	mov		ecx, dword ptr _p264+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R2
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R2+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R2
	mul		ecx
	xor		edx, edx
	sub		edi, eax
	mov		eax, 0
	cmovs_edx_ecx
	cmovs_eax_ebx
	add		esi, eax
	adc		edi, edx

	;  edi:esi has _k264 - ecx:ebx has _p264
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		BPendk264

	;if (_k264 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k264 += _p264
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k264 >> 1
	shr		edi, 1
	rcr		esi, 1

BPendk264:
	mov		dword ptr _k264, esi
	mov		dword ptr _k264+4, edi


	;_k364 = (_k364*_k364) mod _p364
	mov		eax, dword ptr _k364
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k364+4
	mul		ecx

	; R3 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k364 in edi:esi
	mov		ebx, dword ptr _p364
	mov		ecx, dword ptr _p364+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R3
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R3+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R3
	mul		ecx
	xor		edx, edx
	sub		edi, eax
	mov		eax, 0
	cmovs_edx_ecx
	cmovs_eax_ebx
	add		esi, eax
	adc		edi, edx

	;  edi:esi has _k364 - ecx:ebx has _p364
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		BPendk364

	;if (_k364 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k364 += _p364
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k364 >> 1
	shr		edi, 1
	rcr		esi, 1

BPendk364:
	mov		dword ptr _k364, esi
	mov		dword ptr _k364+4, edi

	;_k464 = (_k464*_k464) mod _p464
	mov		eax, dword ptr _k464
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k464+4
	mul		ecx

	; R4 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k464 in edi:esi
	mov		ebx, dword ptr _p464
	mov		ecx, dword ptr _p464+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R4
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R4+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R4
	mul		ecx
	xor		edx, edx
	sub		edi, eax
	mov		eax, 0
	cmovs_edx_ecx
	cmovs_eax_ebx
	add		esi, eax
	adc		edi, edx

	;  edi:esi has _k464 - ecx:ebx has _p464
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		BPendk464

	;if (_k464 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k464 += _p464
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k464 >> 1
	shr		edi, 1
	rcr		esi, 1

BPendk464:
	mov		dword ptr _k464, esi
	mov		dword ptr _k464+4, edi

	;_k564 = (_k564*_k564) mod _p564
	mov		eax, dword ptr _k564
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k564+4
	mul		ecx

	; R5 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k564 in edi:esi
	mov		ebx, dword ptr _p564
	mov		ecx, dword ptr _p564+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R5
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R5+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R5
	mul		ecx
	xor		edx, edx
	sub		edi, eax
	mov		eax, 0
	cmovs_edx_ecx
	cmovs_eax_ebx
	add		esi, eax
	adc		edi, edx

	;  edi:esi has _k564 - ecx:ebx has _p564
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		BPendk564

	;if (_k564 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k564 += _p564
	cmovz_ebx_eax
	cmovz_ecx_eax
	add		esi, ebx
	adc		edi, ecx

	; _k564 >> 1
	shr		edi, 1
	rcr		esi, 1

BPendk564:
	mov		dword ptr _k564, esi
	mov		dword ptr _k564+4, edi


	; bit >> 1
	; while (bit)
	shr		dword ptr nBit, 1
	jnz		BPMainLp

	; return final results, reduced address dependencies
	fcompp
	fcompp
	fcompp
	fstp	ST(0)

	pop		ebx 
	pop		ebp 
	pop		esi 
	pop		edi 
	ret

_find_k0_bigpasm	ENDP

;// find_k0 - find k0 assuming
;//   firstbit - top bit on n
;//   nvalue - n value
;//   k0, k1, k2, and k3 are global output variables
;// this handles 6 independent k0 and p values in parallel for speed.
;// This code does not require cmovxx instructions

ALIGN 16

		PUBLIC	_find_k0_nocmov_bigpasm
_find_k0_nocmov_bigpasm	PROC	near

	push	edi 
	push	esi 
	push	ebp 
	push	ebx 

	; prime the FP stack
	fild	QWORD PTR _p564
	fild	QWORD PTR _p464
	fild	QWORD PTR _p364
	fild	QWORD PTR _p264
	fild	QWORD PTR _p164
	fild	QWORD PTR _p064
	fld1
	fdivr	ST(1), ST(0)
	fdivr	ST(2), ST(0)
	
	;We have got a few instructions to fill while the div goes on - lets make sure 
	;everything is in cache.
	mov eax, dword ptr _k064
	mov ebx, dword ptr _k164
	mov ecx, dword ptr _k264
	mov edx, dword ptr _k364
	mov eax, dword ptr _k464
	mov ebx, dword ptr _k564
	fdivr	ST(3), ST(0)
	fdivr	ST(4), ST(0)
	mov ecx, dword ptr R0
	mov edx, dword ptr R1
	mov eax, dword ptr R2
	mov ebx, dword ptr R3
	mov ecx, dword ptr R4
	mov edx, dword ptr R5

	; initialize nBit
	mov		eax, dword ptr firstbit
	mov		dword ptr nBit, eax

	fdivr	ST(5), ST(0)
	fdivrp	ST(6), ST(0)

	; k<n> = (1+p<n>) >> 1
	; Then we do the first two square and multiplies, out of the FPU (which is busy,
	; doing the division), since these are just some number of halvings.

	mov		edi, 2
	mov		esi, dword ptr nvalue
	test	esi, dword ptr nBit
	jz      NCBPdontadd2
	add     edi, 2
NCBPdontadd2:
	shr		dword ptr nBit, 1
	test	esi, dword ptr nBit
	jz      NCBPdontadd1
	add     edi, 1
NCBPdontadd1:
	shr		dword ptr nBit, 1

	mov		eax, dword ptr _p064
	mov		ebx, dword ptr _p064+4
	mov		ecx, dword ptr _p164
	mov		edx, dword ptr _p164+4
	add		eax, 1
	adc		ebx, 0
	add		ecx, 1
	adc		edx, 0
	shr		ebx, 1
	rcr		eax, 1
	shr		edx, 1
	rcr		ecx, 1

	mov     esi, edi

NCBPhalveloop1:

	test	eax, 1
	jz		short NCBPnoadd11
	add		eax, dword ptr _p064
	adc		ebx, dword ptr _p064+4
NCBPnoadd11:
	shr		ebx, 1
	rcr		eax, 1

	test	ecx, 1
	jz		short NCBPnoadd21
	add		ecx, dword ptr _p164
	adc		edx, dword ptr _p164+4
NCBPnoadd21:
	shr		edx, 1
	rcr		ecx, 1

	dec		esi
	jns		NCBPhalveloop1

	mov		dword ptr _k064, eax
	mov		dword ptr _k064+4, ebx
	mov		dword ptr _k164, ecx
	mov		dword ptr _k164+4, edx
	
	mov		eax, dword ptr _p264
	mov		ebx, dword ptr _p264+4
	mov		ecx, dword ptr _p364
	mov		edx, dword ptr _p364+4
	add		eax, 1
	adc		ebx, 0
	add		ecx, 1
	adc		edx, 0
	shr		ebx, 1
	rcr		eax, 1
	shr		edx, 1
	rcr		ecx, 1

	mov     esi, edi

NCBPhalveloop2:

	test	eax, 1
	jz		short NCBPnoadd12
	add		eax, dword ptr _p264
	adc		ebx, dword ptr _p264+4
NCBPnoadd12:
	shr		ebx, 1
	rcr		eax, 1

	test	ecx, 1
	jz		short NCBPnoadd22
	add		ecx, dword ptr _p364
	adc		edx, dword ptr _p364+4
NCBPnoadd22:
	shr		edx, 1
	rcr		ecx, 1

	dec		esi
	jns		NCBPhalveloop2

	mov		dword ptr _k264, eax
	mov		dword ptr _k264+4, ebx
	mov		dword ptr _k364, ecx
	mov		dword ptr _k364+4, edx

	mov		eax, dword ptr _p464
	mov		ebx, dword ptr _p464+4
	mov		ecx, dword ptr _p564
	mov		edx, dword ptr _p564+4
	add		eax, 1
	adc		ebx, 0
	add		ecx, 1
	adc		edx, 0
	shr		ebx, 1
	rcr		eax, 1
	shr		edx, 1
	rcr		ecx, 1

	mov     esi, edi

NCBPhalveloop3:

	test	eax, 1
	jz		short NCBPnoadd13
	add		eax, dword ptr _p464
	adc		ebx, dword ptr _p464+4
NCBPnoadd13:
	shr		ebx, 1
	rcr		eax, 1

	test	ecx, 1
	jz		short NCBPnoadd23
	add		ecx, dword ptr _p564
	adc		edx, dword ptr _p564+4
NCBPnoadd23:
	shr		edx, 1
	rcr		ecx, 1

	dec		esi
	jns		NCBPhalveloop3

	mov		dword ptr _k464, eax
	mov		dword ptr _k464+4, ebx
	mov		dword ptr _k564, ecx
	mov		dword ptr _k564+4, edx

NCBPMainLp:
	; prime FP pipeline
	fild	qword ptr _k064			; _k064, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(1)
	fistp	qword ptr R0

	fild	qword ptr _k164			; _k164, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(2)
	fistp	qword ptr R1

	fild	qword ptr _k264			; _k264, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(3)
	fistp	qword ptr R2

	fild	qword ptr _k364			; _k364, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(4)
	fistp	qword ptr R3

	fild	qword ptr _k464			; _k464, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(5)
	fistp	qword ptr R4

	fild	qword ptr _k564			; _k564, 1/_p064, 1/_p164, 1/_p264, 1/_p364, 1/_p464, 1/_p564
	fmul	ST(0), ST(0)
	fmul	ST(0), ST(6)
	fistp	qword ptr R5

	;_k064 = (_k064*_k064) mod _p064
	mov		eax, dword ptr _k064
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k064+4
	mul		ecx
	; R0 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k064 in edi:esi
	mov		ebx, dword ptr _p064
	mov		ecx, dword ptr _p064+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R0
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R0+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R0
	mul		ecx
	sub		edi, eax
	jns		NoAdd1p0
	add		esi, ebx
	adc		edi, ecx
NoAdd1p0:

	;  edi:esi has _k064 - ecx:ebx has _p064
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		NCBPendk064

	;if (_k064 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k064 += _p064
	jz		NCnoaddp0
	add		esi, ebx
	adc		edi, ecx
NCnoaddp0:
	; _k064 >> 1
	shr		edi, 1
	rcr		esi, 1

NCBPendk064:
	mov		dword ptr _k064, esi
	mov		dword ptr _k064+4, edi


	;_k164 = (_k164*_k164) mod _p164
	mov		eax, dword ptr _k164
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k164+4
	mul		ecx

	; R1 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k164 in edi:esi
	mov		ebx, dword ptr _p164
	mov		ecx, dword ptr _p164+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R1
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R1+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R1

	mul		ecx
	sub		edi, eax
	jns		NoAdd1p1
	add		esi, ebx
	adc		edi, ecx
NoAdd1p1:

	;  edi:esi has _k164 - ecx:ebx has _p164
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		NCBPendk164

	;if (_k164 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k164 += _p164
	jz		NCnoaddp1
	add		esi, ebx
	adc		edi, ecx
NCnoaddp1:
	; _k164 >> 1
	shr		edi, 1
	rcr		esi, 1

NCBPendk164:
	mov		dword ptr _k164, esi
	mov		dword ptr _k164+4, edi


	;_k264 = (_k264*_k264) mod _p264
	mov		eax, dword ptr _k264
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k264+4
	mul		ecx

	; R2 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k264 in edi:esi
	mov		ebx, dword ptr _p264
	mov		ecx, dword ptr _p264+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R2
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R2+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R2
	mul		ecx
	sub		edi, eax
	jns		NoAdd1p2
	add		esi, ebx
	adc		edi, ecx
NoAdd1p2:

	;  edi:esi has _k264 - ecx:ebx has _p264
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		NCBPendk264

	;if (_k264 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k264 += _p264
	jz		NCnoaddp2
	add		esi, ebx
	adc		edi, ecx
NCnoaddp2:
	; _k264 >> 1
	shr		edi, 1
	rcr		esi, 1

NCBPendk264:
	mov		dword ptr _k264, esi
	mov		dword ptr _k264+4, edi


	;_k364 = (_k364*_k364) mod _p364
	mov		eax, dword ptr _k364
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k364+4
	mul		ecx

	; R3 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k364 in edi:esi
	mov		ebx, dword ptr _p364
	mov		ecx, dword ptr _p364+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R3
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R3+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R3
	mul		ecx
	sub		edi, eax
	jns		NoAdd1p3
	add		esi, ebx
	adc		edi, ecx
NoAdd1p3:

	;  edi:esi has _k364 - ecx:ebx has _p364
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		NCBPendk364

	;if (_k364 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k364 += _p364
	jz		NCnoaddp3
	add		esi, ebx
	adc		edi, ecx
NCnoaddp3:

	; _k364 >> 1
	shr		edi, 1
	rcr		esi, 1

NCBPendk364:
	mov		dword ptr _k364, esi
	mov		dword ptr _k364+4, edi

	;_k464 = (_k464*_k464) mod _p464
	mov		eax, dword ptr _k464
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k464+4
	mul		ecx

	; R4 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k464 in edi:esi
	mov		ebx, dword ptr _p464
	mov		ecx, dword ptr _p464+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R4
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R4+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R4
	mul		ecx
	sub		edi, eax
	jns		NoAdd1p4
	add		esi, ebx
	adc		edi, ecx
NoAdd1p4:

	;  edi:esi has _k464 - ecx:ebx has _p464
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		NCBPendk464

	;if (_k464 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k464 += _p464
	jz		NCnoaddp4
	add		esi, ebx
	adc		edi, ecx
NCnoaddp4:
	; _k464 >> 1
	shr		edi, 1
	rcr		esi, 1

NCBPendk464:
	mov		dword ptr _k464, esi
	mov		dword ptr _k464+4, edi

	;_k564 = (_k564*_k564) mod _p564
	mov		eax, dword ptr _k564
	mov		ecx, eax
	mul		eax
	mov		esi, eax
	mov		edi, edx
	mov		eax, dword ptr _k564+4
	mul		ecx

	; R5 should be stable in level 1 cache now, prefetch can start getting it

	; get new _k564 in edi:esi
	mov		ebx, dword ptr _p564
	mov		ecx, dword ptr _p564+4
	lea		edi, [edi + 2*eax]
	mov		eax, dword ptr R5
	mul		ebx
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr R5+4
	mul		ebx
	sub		edi, eax
	mov		eax, dword ptr R5
	mul		ecx
	sub		edi, eax
	jns		NoAdd1p5
	add		esi, ebx
	adc		edi, ecx
NoAdd1p5:

	;  edi:esi has _k564 - ecx:ebx has _p564
	; if (n & bit)
	mov		eax, dword ptr nvalue
	test	eax, dword ptr nBit
	jz		NCBPendk564

	;if (_k564 & 1)
	xor		eax, eax
	test	esi, 1
	
	; _k564 += _p564
	jz		NCnoaddp5
	add		esi, ebx
	adc		edi, ecx
NCnoaddp5:
	; _k564 >> 1
	shr		edi, 1
	rcr		esi, 1

NCBPendk564:
	mov		dword ptr _k564, esi
	mov		dword ptr _k564+4, edi

	; bit >> 1
	; while (bit)
	shr		dword ptr nBit, 1
	jnz		NCBPMainLp

	; return final results, reduced address dependencies
	fcompp
	fcompp
	fcompp

	pop		ebx 
	pop		ebp 
	pop		esi 
	pop		edi 
	ret

_find_k0_nocmov_bigpasm	ENDP


; /**********************
; * This calculates a*b (mod p), with a, b, p large (<48 bits)
; **********************/
;__int64 mulmodp2 (const __int64 a, const __int64 b, const __int64 p)

ALIGN 16

		PUBLIC	_mulmodp2asm1
_mulmodp2asm1	PROC	near

			fild	dword ptr One	; Version 2.52
			fild	qword ptr p
			fdiv	ST(1), ST(0)
			fild	QWORD PTR a
			fild	QWORD PTR b
			fmul
			fld		st(0)
			fmul	st(0), st(3)
			fadd	convert
			fsub	convert
			fmul	st(0), st(2)
			fsub
;            // Stack: (a*b mod p) p 1/p 
			fistp	qword ptr res
			fcompp

		ret
_mulmodp2asm1	ENDP

ALIGN 16

		PUBLIC	_mulmodp2asm2
_mulmodp2asm2	PROC	near
		push	edi
		push	esi
		push	ebp
		push	ebx

		fild	qword ptr p
		fild	dword ptr One	; Version 2.52
		fdivrp	ST(1), ST(0)

		fild	qword ptr a
		mov		eax, dword ptr a
		fild	qword ptr b
		mul		dword ptr b
		fmul	
		mov		esi, eax
		mov		eax, dword ptr a	
		mov		edi, edx
		fmul	
		mul		dword ptr b+4
		fistp	qword ptr res
		add		edi, eax
		mov		eax, dword ptr a+4
		mul		dword ptr b
		add		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr res
		sub		esi, eax
		sbb		edi, edx
		mov		eax, dword ptr p+4
		mul		dword ptr res
		sub		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr res+4
		sub		edi, eax
		jns		label1

		add		esi, dword ptr p
		mov		edx, dword ptr p+4
		adc		edi, edx
label1:
		mov		dword ptr res, esi
		mov		dword ptr res+4, edi

		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_mulmodp2asm2	ENDP

		PUBLIC	_mulmodp2invasm1
_mulmodp2invasm1	PROC	near

			fld     pinverse
			fild	qword ptr p
			fild	QWORD PTR a
			fild	QWORD PTR b
			fmul
			fld		st(0)
			fmul	st(0), st(3)
			fadd	convert
			fsub	convert
			fmul	st(0), st(2)
			fsub
;            // Stack: (a*b mod p) p 1/p 
			fistp	qword ptr res
			fcompp

		ret
_mulmodp2invasm1	ENDP

ALIGN 16

		PUBLIC	_mulmodp2invasm2
_mulmodp2invasm2	PROC	near
		push	edi
		push	esi
		push	ebp
		push	ebx

		fld     pinverse
		fild	dword ptr One	; Version 2.52

		fild	qword ptr a
		mov		eax, dword ptr a
		fild	qword ptr b
		mul		dword ptr b
		fmul	
		mov		esi, eax
		mov		eax, dword ptr a	
		mov		edi, edx
		fmul	
		mul		dword ptr b+4
		fistp	qword ptr res
		add		edi, eax
		mov		eax, dword ptr a+4
		mul		dword ptr b
		add		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr res
		sub		esi, eax
		sbb		edi, edx
		mov		eax, dword ptr p+4
		mul		dword ptr res
		sub		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr res+4
		sub		edi, eax
		jns		label1inv

		add		esi, dword ptr p
		mov		edx, dword ptr p+4
		adc		edi, edx
label1inv:
		mov		dword ptr res, esi
		mov		dword ptr res+4, edi

		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_mulmodp2invasm2	ENDP


;/**********************
; * Calculate b such that k = b (mod p) ==> p | k.base^n-1; k = -b (mod p) ==> p | k.base^n+1
; **********************/
;unsigned int GetInverse (unsigned int firstj, unsigned int n, unsigned int p)

; Function written in C language

;/**********************
; * This calculates x such that x = base^(-1) mod p
; **********************/
;__int64 GetBaseInverse (const __int64 p)

ALIGN 16

		PUBLIC	_getbaseinverseasm
_getbaseinverseasm PROC	near
		push	edi
		push	esi
		push	ebp
		push	ebx

		fild	qword ptr p
		fild	dword ptr One	; Version 2.52
		fdivrp	ST(1), ST(0)

		mov ebx, dword ptr i
		mov	ecx, dword ptr i+4

loop0b:
		test	ebx, 1
		je		label11b

		fild	qword ptr r
		mov		eax, dword ptr r
		fild	qword ptr x
		mul		dword ptr x
		fmul	
		mov		esi, eax
		mov		edi, edx
		mov		eax, dword ptr r
		fmul	st(0), st(1)
		mul		dword ptr x+4
		fistp	qword ptr tmp
		add		edi, eax
		mov		eax, dword ptr r+4
		mul		dword ptr x
		add		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp
		sub		esi, eax
		sbb		edi, edx
		mov		eax, dword ptr p+4
		mul		dword ptr tmp
		sub		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp+4
		sub		edi, eax
		jns		label1b

		add		esi, dword ptr p
		mov		edx, dword ptr p+4
		adc		edi, edx
label1b:
		mov		dword ptr r, esi
		mov		dword ptr r+4, edi

label11b:
		shrd	ebx, ecx, 1
		shr		ecx, 1
		cmp		ebx, 0
		jne		label13b
		cmp		ecx, 0
		je		endp1b
label13b:
		fild	qword ptr x
		mov		eax, dword ptr x
		mul		dword ptr x
		fmul	st(0), st(0)
		mov		esi, eax
		mov		edi, edx
		mov		eax, dword ptr x
		fmul	st(0), st(1)
		mul		dword ptr x+4
		fistp	qword ptr tmp
		add		edi, eax
		add		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp
		sub		esi, eax
		sbb		edi, edx
		mov		eax, dword ptr p+4
		mul		dword ptr tmp
		sub		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp+4
		sub		edi, eax
		jns		label21b

		add		esi, dword ptr p
		mov		edx, dword ptr p+4
		adc		edi, edx
label21b:
		mov		dword ptr x, esi
		mov		dword ptr x+4, edi

		jmp     loop0b
endp1b:
		fild	qword ptr r
		mov		eax, dword ptr r
		fild	dword ptr base
		mul		dword ptr base
		fmul	
		mov		esi, eax
		mov		edi, edx
		fmul	st(0), st(1)
		fistp	qword ptr tmp
		mov		eax, dword ptr r+4
		mul		dword ptr base
		add		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp
		sub		esi, eax
		sbb		edi, edx
		mov		eax, dword ptr p+4
		mul		dword ptr tmp
		sub		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp+4
		sub		edi, eax
		jns		label31b

		add		esi, dword ptr p
		mov		edx, dword ptr p+4
		adc		edi, edx
label31b:
		mov		dword ptr tmp, esi
		mov		dword ptr tmp+4, edi

		fstp    st(0)

		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_getbaseinverseasm ENDP

;/**********************
; * This calculates x such that x = n^(-1) mod p
; **********************/
;__int64 Get48bitInverse (const __int64 n, const __int64 p)

		PUBLIC	_get48bitinverseasm1
_get48bitinverseasm1 PROC near
		push	edi
		push	esi
		push	ebp
		push	ebx

		mov eax, dword ptr p
		mov edi, dword ptr n
		xor edx, edx
		xor ebx, ebx
		mov esi, 1

	G481loop0:
		div edi
		mov ecx, edx
		mul esi
		xor edx, edx
		sub ebx, eax
		cmp ecx, 0
		mov eax, edi
		mov edi, ecx
		xchg ebx, esi

		jne G481loop0

		mov dword ptr _r32, ebx

		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_get48bitinverseasm1 ENDP

		PUBLIC	_get48bitinverseasm2
_get48bitinverseasm2 PROC near
		push	edi
		push	esi
		push	ebp
		push	ebx
		fild qword ptr r
		fld1
		fild qword ptr n
		fild qword ptr p
		
G482loop1:
		fld st(0)				; d d v3 v1 u
		fdiv st(0), st(2)		; d/v3 d v3 v1 u
		fistp qword ptr r		; d v3 v1 u
		fild qword ptr r		; q d v3 v1 u
		fld	 st(0)				; q q d v3 v1 u
		fmul st(0),st(3)		; q*v3 q d v3 v1 u
		fxch st(1)				; q q*v3 d v3 v1 u
		fmul st(0), st(4)		; q*v1 q*v3 d v3 v1 u
		fxch st(1)				; q*v3 q*v1 d v3 v1 u
		fsubp st(2), st(0)		; q*v1 d-q*v3 v3 v1 u
		fsubp st(4), st(0)		; d-q*v3 v3 v1 u-q*v1 

		; We've got t3 v3 v1 t1 = v3  d  u v1 (b a d c)
		; We want   v3 t3 t1 v1 =  d v3 v1  u (a b c d)

		ftst
		fxch st(1)
		fxch st(3)
		fnstsw ax
		sahf
		fxch st(2)
		fxch st(3)

		jnz G482loop1

		fcompp
		fstp st(0)
		fistp qword ptr r

		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_get48bitinverseasm2 ENDP

ALIGN 16

		PUBLIC	_get48bitinverseasm3
_get48bitinverseasm3 PROC near
		push	edi
		push	esi
		push	ebp
		push	ebx

		fild	qword ptr p
		fild	dword ptr One	; Version 2.52
		fdivrp	ST(1), ST(0)

		mov ebx, dword ptr i
		mov	ecx, dword ptr i+4

loop0c:
		test	ebx, 1
		je		label11c

		fild	qword ptr r
		mov		eax, dword ptr r
		fild	qword ptr x
		mul		dword ptr x
		fmul	
		mov		esi, eax
		mov		edi, edx
		mov		eax, dword ptr r
		fmul	st(0), st(1)
		mul		dword ptr x+4
		fistp	qword ptr tmp
		add		edi, eax
		mov		eax, dword ptr r+4
		mul		dword ptr x
		add		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp
		sub		esi, eax
		sbb		edi, edx
		mov		eax, dword ptr p+4
		mul		dword ptr tmp
		sub		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp+4
		sub		edi, eax
		jns		label1c

		add		esi, dword ptr p
		mov		edx, dword ptr p+4
		adc		edi, edx
label1c:
		mov		dword ptr r, esi
		mov		dword ptr r+4, edi

label11c:
		shrd	ebx, ecx, 1
		shr		ecx, 1

		mov		eax, ebx
		or		eax, ecx
		jz		endp2c

label13c:
		fild	qword ptr x
		mov		eax, dword ptr x
		mul		dword ptr x
		fmul	st(0), st(0)
		mov		esi, eax
		mov		edi, edx
		mov		eax, dword ptr x
		fmul	st(0), st(1)
		mul		dword ptr x+4
		fistp	qword ptr tmp
		add		edi, eax
		add		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp
		sub		esi, eax
		sbb		edi, edx
		mov		eax, dword ptr p+4
		mul		dword ptr tmp
		sub		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp+4
		sub		edi, eax
		jns		label21c

		add		esi, dword ptr p
		mov		edx, dword ptr p+4
		adc		edi, edx
label21c:
		mov		dword ptr x, esi
		mov		dword ptr x+4, edi

		jmp     loop0c
endp2c:
		fild	qword ptr r
		mov		eax, dword ptr r
		fild	qword ptr n
		mul		dword ptr n
		fmul	
		mov		esi, eax
		mov		eax, dword ptr r
		mov		edi, edx
		fmul	st(0), st(1)
		mul		dword ptr n+4
		fistp	qword ptr tmp
		add		edi, eax
		mov		eax, dword ptr r+4
		mul		dword ptr n
		add		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp
		sub		esi, eax
		sbb		edi, edx
		mov		eax, dword ptr p+4
		mul		dword ptr tmp
		sub		edi, eax
		mov		eax, dword ptr p
		mul		dword ptr tmp+4
		sub		edi, eax
		jns		label31c

		add		esi, dword ptr p
		mov		edx, dword ptr p+4
		adc		edi, edx
label31c:
		mov		dword ptr tmp, esi
		mov		dword ptr tmp+4, edi

		fstp    st(0)

		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_get48bitinverseasm3 ENDP




;void pair_GetPrimorialModP (const __int64 p1, const __int64 p2, __int64 &b1, __int64 &b2)

ALIGN 16

		PUBLIC	_pair_getprimorialmodpasm
_pair_getprimorialmodpasm PROC near

		mov	ecx, nSmallPackPrimorial	; Version 2.52
		fild	qword ptr r1			; Version 2.52
		fild	qword ptr p1
		fdiv	ST(1), ST(0)

		fild	qword ptr r2			; Version 2.52
		fild	qword ptr p2
		fdiv	ST(1), ST(0)

		xor		ecx, ecx
		fild	qword ptr r1
		fild	qword ptr r2

;		// r2 r1 p2 1/p2 p1 1/p1

loop01d:
		fimul	dword ptr [SmallPackPrimorial+4*ecx] ; Version 2.52
		fxch 
		fimul	dword ptr [SmallPackPrimorial+4*ecx] ; Version 2.52
		fxch
		fld		st(0)		
		fmul	st(0), st(4)
		fxch	st(2)		
		fld		st(0)		
		fmul	st(0), st(7)
		fxch	st(3)
		fadd	convert
		fxch	st(3)
		fadd	convert
		fxch	st(3)
		fsub	convert
		fxch	st(3)
		fsub	convert		
		fmul	st(0), st(6)
		fxch	st(3)
		fmul	st(0), st(4)
		fxch	st(3)		
		fsub				
		fxch	st(2)		
		fsub				

		add		ecx, 1
		cmp		ecx, nSmallPackPrimorial ; Version 2.52
		jb		loop01d
		fistp   qword ptr r2
		fistp   qword ptr r1
		fcompp
		fcompp

		ret
_pair_getprimorialmodpasm ENDP

;__int64 GetPrimorialModP (const __int64 p1)

;//	Only one Assembler language function in Version 2.52 :

ALIGN 16

			PUBLIC	_getprimorialmodpasm
_getprimorialmodpasm	PROC	near 
			push	edi 
			push	esi 
			push	ebp 
			push	ebx 
 
		fild	qword ptr p1 
		fild	dword ptr One 
		fdivrp	ST(1), ST(0) 
 
		mov ecx, dword ptr nPackPrimorial 
		fild qword ptr twoto48
		dec ecx 
		fild qword ptr PackPrimorial[ecx*8] 
		mov edi, dword ptr PackPrimorial[ecx*8+4] 
		fmul st(0), st(2) 
		mov esi, dword ptr PackPrimorial[ecx*8] 
		fistp qword ptr tmp			;// tmp = xyf/p1 
		mov eax, dword ptr p1 
		mul dword ptr tmp 
		sub esi, eax 
		mov eax, dword ptr p1+4 
		sbb edi, edx 
		mul dword ptr tmp 
		sub edi, eax 
 
		mov eax, dword ptr tmp+4 
		mov dword ptr tmp, esi 
		mul dword ptr p1 
		sub edi, eax 
		dec ecx 
		mov dword ptr tmp+4, edi 
 
		fild qword ptr tmp 
		jl endwhile 
 
whileloop: 
 
		fmul st(0), st(1) 
		mov esi, dword ptr PackPrimorial[ecx*8] 
		 
		fild qword ptr PackPrimorial[ecx*8] 
		mov edi, dword ptr tmp 
		 
		fadd					;// st(0) = xyf 
		shl edi, 16 
		 
		fmul st(0), st(2) 
		mov eax, dword ptr p1 
		 
		fistp qword ptr tmp			;// tmp = xyf/p1 
		add edi, dword ptr PackPrimorial[ecx*8+4] 
		 
		mul dword ptr tmp 
		sub esi, eax 
		 
		mov eax, dword ptr p1+4 
		sbb edi, edx 
		 
		mul dword ptr tmp 
 
		sub edi, eax 
		mov eax, dword ptr tmp+4 
		 
		mov dword ptr tmp, esi 
		mul dword ptr p1 
		 
		sub edi, eax 
		dec ecx 
 
		mov dword ptr tmp+4, edi		 
 
		fild qword ptr tmp 
		jge whileloop 
endwhile: 
		fcompp
		fstp st(0) 

 
			pop	ebx 
			pop	ebp 
			pop	esi 
			pop	edi 
			ret 
_getprimorialmodpasm	ENDP 
 

;/**********************
; * Given n & p, find b such that k= b(mod p) ==> p|k.2^n-1;
; *                               k=-b(mod p) ==> p|k.2^n+1.
; **********************/
;void pair_findbbase2(const __int64 p1, const __int64 p2, __int64 &r1, __int64 &r2, const unsigned int firstbit)

ALIGN 16

		PUBLIC	_pair_findbbase2asm
_pair_findbbase2asm PROC near
		push	edi
		push	esi
		push	ebp
		push	ebx

		mov eax, dword ptr p2
		mov esi, dword ptr p1
		shr	eax, 1
		shr esi, 1
		inc eax
		inc esi
		mov dword ptr p2o2, eax
		mov dword ptr p1o2, esi
		mov dword ptr b2, eax
		mov dword ptr b1, esi
		mov dword ptr b2+4, 0
		mov dword ptr b1+4, 0

		fild	dword ptr One	; Version 2.52
		fild	qword ptr p1
		fdiv	ST(1), ST(0)
		fild	dword ptr One	; Version 2.52
		fild	qword ptr p2
		fdiv	ST(1), ST(0)

		mov		ecx, DWORD PTR firstbit
		mov		ebx, DWORD PTR nvalue
		fild	QWORD PTR b1
		fild	QWORD PTR b2
;		// b2 b1 p2 1/p2 p1 1/p1
loop01g:
		fmul	st(0), st(0)	;// b2^2 b1 p2 1/p2 p1 1/p1
		fxch
		fmul	st(0), st(0)	;// b1^2 b2^2 p2 1/p2 p1 1/p1
		fxch
		fld		st(0)	;// b2^2 b2^2 b1^2 p2 1/p2 p1 1/p1
		fmul	st(0), st(4)	;// (b2^2)/p2 b2^2 b1^2 p2 1/p2 p1 1/p1
		fxch	st(2)		;// b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fld		st(0)	;// b1^2 b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fmul	st(0), st(7)	;// (b1^2)/p1 b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fxch	st(3)
		fadd	convert
		fxch	st(3)
		fadd	convert
		fxch	st(3)
		fsub	convert
		fxch	st(3)
		fsub	convert		;// (b1^2)/p1 b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fmul	st(0), st(6)	;// p1*(b1^2)/p1 b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fxch	st(3)
		fmul	st(0), st(4)	;// p2*(b2^2)/p2 b1^2 b2^2 p1*(b1^2)/p1 p2 1/p2 p1 1/p1
		fxch	st(3)		;// p1*(b1^2)/p1 b1^2 b2^2 p2*(b2^2)/p2 p2 1/p2 p1 1/p1
		fsub			;// (b1^2)modp1 b2^2 p2*(b2^2)/p2 p2 1/p2 p1 1/p1
		fxch	st(2)		;// p2*(b2^2)/p2 b2^2 (b1^2)modp1 p2 1/p2 p1 1/p1
		fsub			;// (b2^2)modp2 (b1^2)modp1 p2 1/p2 p1 1/p1

		test	ecx, ebx
		je		label02g

		fistp	qword ptr b2
		fistp	qword ptr b1

		mov		eax, dword ptr b2
		mov		esi, dword ptr b1
		shr		eax, 1
		sbb		edx, edx
		shr		esi, 1
		sbb		edi, edi
		and		edx, dword ptr p2o2
		and		edi, dword ptr p1o2
		add		eax, edx
		add		esi, edi

		mov		DWORD PTR b2, eax
		mov		DWORD PTR b1, esi

		fild	qword ptr b1
		fild	qword ptr b2

	label02g:
		shr		ecx, 1
		jne		loop01g

		fistp	qword ptr b2
		fistp	qword ptr b1
		fcompp
		fcompp

		pop	ebx
		pop	ebp
		pop	esi
		pop	edi
		ret
_pair_findbbase2asm ENDP	

;/**********************
; * Given n & p, find b such that k= b(mod p) ==> p|k.base^n-1;
; *                               k=-b(mod p) ==> p|k.base^n+1.
; **********************/
;__int64 findbotherbases(const __int64 p, const unsigned int firstbit)

ALIGN 16

			PUBLIC	_findbotherbasesasm
_findbotherbasesasm	PROC	near
			push	edi
			push	esi
			push	ebp
			push	ebx

	fild	QWORD PTR p
	fild	dword ptr One			; Version 2.52
	fdivrp	ST(1), ST(0)

	mov		eax, DWORD PTR b
	mov		edx, DWORD PTR b + 4

	mov		DWORD PTR r, eax
	mov		DWORD PTR r + 4, edx

	mov		ecx, DWORD PTR firstbit
	mov		ebx, DWORD PTR nvalue
loop0i:
	fild	QWORD PTR r
	mul		eax
	fmul	ST(0), ST(0)
	mov		esi, eax
	mov		edi, edx
	mov		eax, DWORD PTR r
	fmul	ST(0), ST(1)
	mul		DWORD PTR r + 4
	fistp	QWORD PTR r
	add		edi, eax
	add		edi, eax
	mov		eax, DWORD PTR p
	mul		DWORD PTR r
	sub		esi, eax
	sbb		edi, edx
	mov		eax, DWORD PTR p + 4
	mul		DWORD PTR r
	sub		edi, eax
	mov		eax, DWORD PTR p
	mul		DWORD PTR r + 4
	sub		edi, eax
	jns		label10i
	add		esi, dword ptr p
	mov		edx, dword ptr p+4
	adc		edi, edx
label10i:
	mov		eax, esi

;	/**** edi:esi (and edi:eax) contains b^2 mod p *****/

	test	ecx, ebx
	je		label2i


;##############

;	/**   This code performs the division by the base where the base is not 2 **/
;	/** Must multiply edi:eax by baseinverse mod p **/
	mov		DWORD PTR r, eax
	mov		DWORD PTR r + 4, edi

	fild	qword ptr r
	mul		dword ptr baseinverse
	fild	qword ptr baseinverse
	mov		esi, eax
	mov		edi, edx
	fmul	
	mov		eax, dword ptr r
	mul		dword ptr baseinverse+4
	fmul	st(0), st(1)
	add		edi, eax
	mov		eax, dword ptr r+4
	mul		dword ptr baseinverse
	fistp	qword ptr r
	add		edi, eax
	mov		eax, dword ptr p
	mul		dword ptr r
	sub		esi, eax
	sbb		edi, edx
	mov		eax, dword ptr p+4
	mul		dword ptr r
	sub		edi, eax
	mov		eax, dword ptr p
	mul		dword ptr r+4
	sub		edi, eax
	jns		label21i

	add		esi, dword ptr p
	mov		edx, dword ptr p+4
	adc		edi, edx
label21i:
	mov		eax, esi

;##############

label2i:
	mov		DWORD PTR r, eax
	mov		DWORD PTR r + 4, edi
	shr		ecx, 1
	jne		loop0i

	test	edi, edi
	jge		label4i

	add		eax, DWORD PTR p
	mov		edx, DWORD PTR p + 4
	adc		edi, edx
	mov		DWORD PTR r, eax
	mov		DWORD PTR r + 4, edi

label4i:
	fstp	ST(0)

			pop	ebx
			pop	ebp
			pop	esi
			pop	edi
			ret
_findbotherbasesasm	ENDP


;void pair_find2pownmodp (const __int64 p1, const __int64 p2, __int64 &r1, __int64 &r2, const unsigned int firstbit)

ALIGN 16

			PUBLIC	_pair_find2pownmodpasm
_pair_find2pownmodpasm	PROC	near
			push	edi
			push	esi
			push	ebp
			push	ebx

		fild	dword ptr One		; Version 2.52
		mov	ecx, DWORD PTR firstbit	; Version 2.52
		fild	qword ptr p1
		fdiv	ST(1), ST(0)
		mov	ebx, DWORD PTR nvalue	; Version 2.52
		fild	dword ptr One		; Version 2.52
		fild	qword ptr p2
		fdiv	ST(1), ST(0)

		fild	QWORD PTR b1
		fild	QWORD PTR b2
;		// b2 b1 p2 1/p2 p1 1/p1
loop01j:
		fmul	st(0), st(0)	;// b2^2 b1 p2 1/p2 p1 1/p1
		fxch
		fmul	st(0), st(0)	;// b1^2 b2^2 p2 1/p2 p1 1/p1
		fxch
		fld		st(0)	;// b2^2 b2^2 b1^2 p2 1/p2 p1 1/p1
		fmul	st(0), st(4)	;// (b2^2)/p2 b2^2 b1^2 p2 1/p2 p1 1/p1
		fxch	st(2)		;// b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fld		st(0)	;// b1^2 b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fmul	st(0), st(7)	;// (b1^2)/p1 b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fxch	st(3)
		fadd	convert
		fxch	st(3)
		fadd	convert
		fxch	st(3)
		fsub	convert
		fxch	st(3)
		fsub	convert		;// (b1^2)/p1 b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fmul	st(0), st(6)	;// p1*(b1^2)/p1 b1^2 b2^2 (b2^2)/p2 p2 1/p2 p1 1/p1
		fxch	st(3)
		fmul	st(0), st(4)	;// p2*(b2^2)/p2 b1^2 b2^2 p1*(b1^2)/p1 p2 1/p2 p1 1/p1
		fxch	st(3)		;// p1*(b1^2)/p1 b1^2 b2^2 p2*(b2^2)/p2 p2 1/p2 p1 1/p1
		fsub			;// (b1^2)modp1 b2^2 p2*(b2^2)/p2 p2 1/p2 p1 1/p1
		fxch	st(2)		;// p2*(b2^2)/p2 b2^2 (b1^2)modp1 p2 1/p2 p1 1/p1
		fsub			;// (b2^2)modp2 (b1^2)modp1 p2 1/p2 p1 1/p1

		test	ecx, ebx
		je		label02j

;		// Now we have got to multiply by the base (=2). 
;		// Since the base is 2, we can guarantee that 2*b1-p will still fit in 32 bits
		fadd	st(0), st(0)
		fxch
		fadd	st(0), st(0)
		fxch
		fsub	st(0), st(2)
		fxch
		fsub	st(0), st(4)
		fxch

	label02j:
		shr		ecx, 1
		jne		loop01j

		fistp	qword ptr b2
		fistp	qword ptr b1
		fcompp
		fcompp
			pop	ebx
			pop	ebp
			pop	esi
			pop	edi
			ret
_pair_find2pownmodpasm	ENDP


;unsigned int  findk2pownmodp (__int64 k, unsigned int nval, __int64 p1, const unsigned int firstbit)

ALIGN 16

			PUBLIC	_findk2pownmodpasm
_findk2pownmodpasm	PROC	near
			push	edi
			push	esi
			push	ebp
			push	ebx


		fild	dword ptr One		; Version 2.52
		fild	qword ptr p1
		fdiv	ST(1), ST(0)

		mov	ecx, DWORD PTR firstbit
		mov	ebx, DWORD PTR nvalue32
		fild	QWORD PTR b		; Version 2.52
;		// b p1 1/p1 
loop01k:
		fmul	st(0), st(0)	;// b^2 p1 1/p1
		fld	st(0)		;		// b^2 b^2 p1 1/p1
		fmul	st(0), st(3)	;// (b^2)/p1 b^2 p1 1/p1
		fadd	convert
		fsub	convert
		fmul	st(0), st(2)	;// p1*(b^2)/p1 b^2 p1 1/p1
		fsub			;		// (b^2)modp1 p1 1/p1

		test	ecx, ebx
		je	label02k

;		// Now we have got to multiply by the base (=2). 
;		// Since the base is 2, we can guarantee that 2*b-p will still fit in 32 bits
		fadd	st(0), st(0)
		fsub	st(0), st(1)

	label02k:
		shr		ecx, 1
		jne		loop01k

		fild	dword ptr k	;	// k b p1 1/p1
		fld	st(0)		;		// k k b p1 1/p1
		fmul	st(0), st(4)	;// k/p k b p1 1/p1
		fadd	convert
		fsub	convert		;	// [k/p] k b p1 1/p1
		fmul	st(0), st(3)	;// p*[k/p] k b p1 1/p1
		fsub			;		// kmodp 

		fmul	
		fld	st(0)			
		fmul	st(0), st(3)	
		fadd	convert
		fsub	convert
		fmul	st(0), st(2)	
		fsub					
		
		fistp	qword ptr b		; Version 2.52
		fcompp

			pop	ebx
			pop	ebp
			pop	esi
			pop	edi
			ret
_findk2pownmodpasm	ENDP


;__int64 find2pownmodp (const __int64 p, const unsigned int firstbit)

ALIGN 16

			PUBLIC	_find2pownmodpasm
_find2pownmodpasm	PROC	near
			push	edi
			push	esi
			push	ebp
			push	ebx

	fild	QWORD PTR p
	fild	dword ptr One			; Version 2.52
	fdivrp	ST(1), ST(0)

	mov		eax, DWORD PTR b
	mov		edx, DWORD PTR b + 4

	mov		DWORD PTR r, eax
	mov		DWORD PTR r + 4, edx

	mov		ecx, DWORD PTR firstbit
	mov		ebx, DWORD PTR nvalue
loop0l:
	fild	QWORD PTR r
	mul		eax
	fmul	ST(0), ST(0)
	mov		esi, eax
	mov		edi, edx
	mov		eax, DWORD PTR r
	fmul	ST(0), ST(1)
	mul		DWORD PTR r + 4
	fistp	QWORD PTR r
	add		edi, eax
	add		edi, eax
	mov		eax, DWORD PTR p
	mul		DWORD PTR r
	sub		esi, eax
	sbb		edi, edx
	mov		eax, DWORD PTR p + 4
	mul		DWORD PTR r
	sub		edi, eax
	mov		eax, DWORD PTR p
	mul		DWORD PTR r + 4
	sub		edi, eax
	jns		label10l
	add		esi, dword ptr p
	mov		edx, dword ptr p+4
	adc		edi, edx
label10l:
	mov		eax, esi

;	/**** edi:esi (and edi:eax) contains b^2 mod p *****/

	test	ecx, ebx
	je		label2l

	add		eax, eax
	adc		edi, edi
	
label2l:
	mov		DWORD PTR r, eax
	mov		DWORD PTR r + 4, edi
	shr		ecx, 1
	jne		loop0l

	test	edi, edi
	jge		label4l

	add		eax, DWORD PTR p
	mov		edx, DWORD PTR p + 4
	adc		edi, edx
	mov		DWORD PTR r, eax
	mov		DWORD PTR r + 4, edi

label4l:
	fstp	ST(0)

			pop	ebx
			pop	ebp
			pop	esi
			pop	edi
			ret
_find2pownmodpasm	ENDP


;__int64 findbasepownmodp (const __int64 p, const unsigned int firstbit)

ALIGN 16

			PUBLIC	_findbasepownmodpasm
_findbasepownmodpasm	PROC	near
			push	edi
			push	esi
			push	ebp
			push	ebx

	fild	QWORD PTR p
	fild	dword ptr One			; Version 2.52
	fdivrp	ST(1), ST(0)

	mov		eax, DWORD PTR b
	mov		edx, DWORD PTR b + 4

	mov		DWORD PTR r, eax
	mov		DWORD PTR r + 4, edx

	mov		ecx, DWORD PTR firstbit
	mov		ebx, DWORD PTR nvalue
loop0m:
	fild	QWORD PTR r
	mul		eax
	fmul	ST(0), ST(0)
	mov		esi, eax
	mov		edi, edx
	mov		eax, DWORD PTR r
	fmul	ST(0), ST(1)
	mul		DWORD PTR r + 4
	fistp	QWORD PTR r
	add		edi, eax
	add		edi, eax
	mov		eax, DWORD PTR p
	mul		DWORD PTR r
	sub		esi, eax
	sbb		edi, edx
	mov		eax, DWORD PTR p + 4
	mul		DWORD PTR r
	sub		edi, eax
	mov		eax, DWORD PTR p
	mul		DWORD PTR r + 4
	sub		edi, eax
	jns		label10m
	add		esi, dword ptr p
	mov		edx, dword ptr p+4
	adc		edi, edx
label10m:
	mov		eax, esi

;	/**** edi:esi (and edi:eax) contains b^2 mod p *****/

	mov		DWORD PTR r, eax
	mov		DWORD PTR r+4, edi

	test	ecx, ebx
	je		label2m

	fild	qword ptr r
	fild	dword ptr base
	fmul
	fistp	qword ptr r

	mov		eax, DWORD PTR r
	mov		edi, DWORD PTR r + 4

	
label2m:
	shr		ecx, 1
	jne		loop0m

	test	edi, edi
	jge		label4m

	add		eax, DWORD PTR p
	mov		edx, DWORD PTR p + 4
	adc		edi, edx
	mov		DWORD PTR r, eax
	mov		DWORD PTR r + 4, edi

label4m:
	fstp	ST(0)

			pop	ebx
			pop	ebp
			pop	esi
			pop	edi
			ret
_findbasepownmodpasm	ENDP

ALIGN 16

			PUBLIC	_findhalfpownmodpasm
_findhalfpownmodpasm	PROC	near
			push	edi
			push	esi
			push	ebp
			push	ebx

	fild	QWORD PTR _p64
	fild	dword ptr One			; Version 2.52
	fdivrp	ST(1), ST(0)

	mov		eax, DWORD PTR _b64
	mov		edx, DWORD PTR _b64 + 4

	mov		DWORD PTR _res64, eax
	mov		DWORD PTR _res64+4, edx

	mov		ecx, DWORD PTR _firstbit2
	mov		ebx, DWORD PTR _nvalue2
loop0n:
	fild	QWORD PTR _res64
	mul		eax
	fmul	ST(0), ST(0)
	mov		esi, eax
	mov		edi, edx
	mov		eax, DWORD PTR _res64
	fmul	ST(0), ST(1)
	mul		DWORD PTR _res64+4
	fistp	QWORD PTR _res64
	add		edi, eax
	add		edi, eax
	mov		eax, DWORD PTR _p64
	mul		DWORD PTR _res64
	sub		esi, eax
	sbb		edi, edx
	mov		eax, DWORD PTR _p64+4
	mul		DWORD PTR _res64
	sub		edi, eax
	mov		eax, DWORD PTR _p64
	mul		DWORD PTR _res64+4
	sub		edi, eax
	jns		label10n
	add		esi, dword ptr _p64
	mov		edx, dword ptr _p64+4
	adc		edi, edx
label10n:
	mov		eax, esi

;	/**** edi:esi (and edi:eax) contains b^2 mod p *****/

	test	ecx, ebx
	je		label2n

	test	eax, 1
	jz		evenn
	add		eax, dword ptr _p64
	adc		edi, dword ptr _p64+4

evenn:
	shr		edi, 1
	rcr		eax, 1
	
label2n:
	mov		DWORD PTR _res64, eax
	mov		DWORD PTR _res64+4, edi
	shr		ecx, 1
	jne		loop0n

	test	edi, edi
	jge		label4n

	add		eax, DWORD PTR _p64
	mov		edx, DWORD PTR _p64+4
	adc		edi, edx
	mov		DWORD PTR _res64, eax
	mov		DWORD PTR _res64+4, edi

label4n:
	fstp	ST(0)

	pop	ebx
	pop	ebp
	pop	esi
	pop	edi
	ret
_findhalfpownmodpasm  ENDP

_TEXT32	ENDS
	END
