// frmMerge.cpp : implementation file
//

#include "stdafx.h"
#include <io.h>
#include "newpgen.h"
#include "newpgen2.h"
#include "frmMerge.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define LL_FORMAT "%I64d"

/////////////////////////////////////////////////////////////////////////////
// frmMerge dialog


frmMerge::frmMerge(CWnd* pParent /*=NULL*/)
	: CDialog(frmMerge::IDD, pParent)
{
	//{{AFX_DATA_INIT(frmMerge)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void frmMerge::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(frmMerge)
	DDX_Control(pDX, IDC_INFILE, m_Directory);
	DDX_Control(pDX, IDC_STATICTEXT, m_StaticText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(frmMerge, CDialog)
	//{{AFX_MSG_MAP(frmMerge)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// frmMerge message handlers

char *helptext = 
"After a file has been split across multiple machines and sieved, the files must be merged together.\r\n"
"Start off with an empty directory, and place all of the files to be merged in this directory. Note that "
"all of the files in the directory will be merged together, so make sure that there are no "
"other files present!\r\n"
"The files will be merged together, and the result of the merge will be placed in the same directory, "
"with the name Merged.npg.";
BOOL frmMerge::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	m_StaticText.SetWindowText (helptext);	
	m_Directory.SetFocus ();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void frmMerge::OnOK() 
{
	// TODO: Add extra validation here
	
	// Hacked together in an hour of just writing code. Very little regard for neatness.
	// Check out the gotos!

	char Directory[10240];
	char OutFileName[10240];
	char tmpFileName[10240];
	struct _finddata_t fileinfo;
	FILE *ifptrs[256];
	int nifptrs = 0;
	FILE *ofptr;
	long findhandle;
	__int64 SievedUpTo = 0;
	__int64 ks[256];
	char rest[1024];
	char buff[1024];
	bool fnsieve;
	__int64 kvalue;
	int nvalue;
	int count = 0;

	m_Directory.GetWindowText (Directory, 10240);
	if (Directory[0] == 0) 
	{
		m_Directory.SetFocus ();
		return;
	}

	if (Directory[strlen (Directory)-1] != '\\')
	{
		Directory[strlen (Directory)+1] = 0;
		Directory[strlen (Directory)] = '\\';
		m_Directory.SetWindowText (Directory);
	}

	strcpy (OutFileName, Directory);
	strcat (OutFileName, "Merged.npg");

	strcpy (tmpFileName, Directory);
	strcat (tmpFileName, "*");

	if ((findhandle = _findfirst (tmpFileName, &fileinfo)) == -1)
	{
		AfxMessageBox ("The directory is invalid!");
		_findclose (findhandle);
		return;
	}

	do
	{
		if (!strcmp (fileinfo.name, ".")) continue;
		if (!strcmp (fileinfo.name, "..")) continue;
		if (!_stricmp (fileinfo.name, "Merged.npg")) 
		{
			// Windows file names are case-insensitive, hence _stricmp
			while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
			_findclose (findhandle);
			AfxMessageBox ("There is already a file called Merged.npg present in the directory!");
			return;
		}

		sprintf (tmpFileName, "%s%s", Directory, fileinfo.name);

		if ((ifptrs[nifptrs] = fopen (tmpFileName, "r")) == NULL)
		{
			while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
			_findclose (findhandle);
			AfxMessageBox ("One of the input files could not be read!");
			return;
		}
		if (fgets (buff, 1024, ifptrs[nifptrs]) != NULL)
		{
			buff[strlen (buff)-1] = '\0';
			
			__int64 Range;
			char thisrest[1024];

			// This contains the sieve limit and the type.
			if (sscanf (buff, LL_FORMAT"%s", &Range, thisrest) != 2)
			{
				while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
				_findclose (findhandle);
				AfxMessageBox ("One of the input files contained a bad first line!");
				return;
			}
			if (nifptrs == 0)
			{
				SievedUpTo = Range;
				strcpy (rest, thisrest);

				char *modeptr = rest+strlen (rest);
				while (*modeptr != ':') modeptr--;
				int type = atoi (modeptr+1);
				fnsieve = ((type & (MODE_KSIEVE | MODE_DUAL)) != 0);
			}
			else
			{
				if (strcmp (rest, thisrest))
				{
					while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
					_findclose (findhandle);
					AfxMessageBox ("One of the input files was for a different type of sieve (the top line differed)!");
					return;
				}
				if (Range > SievedUpTo) SievedUpTo = Range;
			}
		}


		if (fgets (buff, 1024, ifptrs[nifptrs]) != NULL)
		{
			buff[strlen (buff)-1] = '\0';

			if (sscanf (buff, LL_FORMAT" %d", &kvalue, &nvalue) != 2)
			{
				while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
				_findclose (findhandle);
				AfxMessageBox ("One of the input files contained an invalid line!");
				return;
			}

			ks[nifptrs] = (fnsieve) ? nvalue : kvalue;
		}
		else
		{
			while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
			_findclose (findhandle);
			AfxMessageBox ("One of the input files is empty, so the output file will be empty!");
			return;
		}
		nifptrs++;
	} while (_findnext (findhandle, &fileinfo) == 0);

	_findclose (findhandle);

	if (nifptrs == 0)
	{
		_findclose (findhandle);
		AfxMessageBox ("The directory is empty!");
		return;
	}

	ofptr = fopen (OutFileName, "w");
	if (!ofptr)
	{
		AfxMessageBox ("The output file could not be created!");
		return;
	}
	fprintf (ofptr, LL_FORMAT"%s\n", SievedUpTo, rest);

	this->BeginWaitCursor ();

	__int64 max = 0;
	int matchnum = -1;

	for (;;)
	{
again:
		for (int i = 0; i < nifptrs; i++)
		{
			if (i == matchnum) continue;
			while (ks[i] < max)
			{
				if (fgets (buff, 1024, ifptrs[i]) != NULL)
				{
					buff[strlen (buff)-1] = '\0';

					if (sscanf (buff, LL_FORMAT" %d", &kvalue, &nvalue) != 2)
					{
						while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
						fclose (ofptr);
						AfxMessageBox ("One of the input files contained an invalid line!");
						return;
					}

					ks[i] = (fnsieve) ? nvalue : kvalue;
				}
				else
				{
					goto done;
				}
			}
			
			if (ks[i] > max)
			{
				max = ks[i];
				matchnum = i;
				goto again;
			}
		}
		if (fnsieve)
		{
			fprintf (ofptr, LL_FORMAT" "LL_FORMAT"\n", kvalue, ks[0]);
		}
		else
		{
			fprintf (ofptr, LL_FORMAT" %d\n", ks[0], nvalue);
		}
		max = ks[0] + 1;
		matchnum = -1;
		count++;
	}

done:
	while (--nifptrs >= 0) fclose (ifptrs[nifptrs]);
	fclose (ofptr);

	this->EndWaitCursor ();

	sprintf (tmpFileName, "Merged file '%s' generated, contains %u %c's", OutFileName, count, fnsieve ? 'n' : 'k'); 
	AfxMessageBox (tmpFileName);

	CDialog::OnOK();
}
