
// N.B. : "fdivrp" replaced by "fdivp" in the next macro, due to a bug
// in gcc version 2.95 inline assembler...

#define Calc_P_Inverse_Macro(p_val, res_val1, res_val2) asm("
		fildq	 	"#p_val"
		fld1
		fdivp	%st(0), %st(1)
		fstpt	 	"#res_val1"
		fildq		"#p_val"+8
		fld1
		fdivp	%st(0), %st(1)
		fstpt		"#res_val2"
")

	// compute SSE2 portion of  xmm0 = (a_val * a_val) mod p_val
	// p_val is assumed to have p followed by p >> 32
	// r_val is assumed to be recent store and require
	// qword access to load the values.
	// The result is returned in xmm0
	// do not alter xmm5
	// leave p_val in xmm7

#define SSE2_SqMod_QLoad(a_val, r_val, p_val) asm("
		movdqa	"#a_val", %xmm1
		movdqa	"#p_val", %xmm7
		movdqa	"#p_val"+16, %xmm6
		movdqa	%xmm1, %xmm0
		psrlq		$32, %xmm1
		pmuludq	%xmm0, %xmm1
		movq		"#r_val", %xmm4
		movq		"#r_val"+8, %xmm3
		punpcklqdq	%xmm3, %xmm4
		movdqa	%xmm4, %xmm2
		movdqa	%xmm4, %xmm3
		psrlq		$32, %xmm4
		pmuludq	%xmm6, %xmm2
		pmuludq	%xmm7, %xmm4
		pmuludq	%xmm0, %xmm0
		pmuludq	%xmm7, %xmm3
		paddd		%xmm1, %xmm1
		psubd		%xmm2, %xmm1
		psubd		%xmm4, %xmm1
		psubq		%xmm3, %xmm0
		psllq		$32, %xmm1
		paddd		%xmm1, %xmm0
		movdqa	%xmm0, k0k1
		pxor		%xmm3, %xmm3
		pcmpgtd	%xmm0, %xmm3
		pshufd	$245, %xmm3, %xmm3
		pand		%xmm7, %xmm3
		paddq		%xmm3, %xmm0
")

	// compute SSE2 portion of  xmm0 = (a_val * a_val) mod p_val
	// p_val is assumed to have p followed by p >> 32
	// The result is returned in xmm0
	// do not alter xmm5
	// leave p_val in xmm7

#define SSE2_SqMod(a_val, r_val, p_val) asm("
		movdqa	"#p_val", %xmm7
		movdqa	"#p_val"+16, %xmm6
		movdqa	"#a_val", %xmm1
		movdqa	%xmm1, %xmm0
		psrlq		$32, %xmm1	
		pmuludq	%xmm0, %xmm1
		movdqa	"#r_val", %xmm4
		movdqa	%xmm4, %xmm2
		movdqa	%xmm4, %xmm3
		psrlq		$32, %xmm4
		pmuludq	%xmm6, %xmm2
		pmuludq	%xmm7, %xmm4
		pmuludq	%xmm0, %xmm0
		pmuludq	%xmm7, %xmm3
		paddd		%xmm1, %xmm1
		psubd		%xmm2, %xmm1
		psubd		%xmm4, %xmm1
		psubq		%xmm3, %xmm0
		psllq		$32, %xmm1
		paddd		%xmm1, %xmm0
		pxor		%xmm3, %xmm3
		pcmpgtd	%xmm0, %xmm3
		pshufd	$245, %xmm3, %xmm3
		pand		%xmm7, %xmm3
		paddq		%xmm3, %xmm0
")

//
// Perform floating point part of mulmod
//  r_val = a_val*a_val*res_val1    and
//  r_val+8 = (a_val+8)*(a_val+8)*res_val2
// where res_val1 and res_val2 are 1/p for that calculation
// Do not touch any xmm registers.
//

#define FP_K0_Macro(a_val, r_val, res_val1, res_val2) asm("
		fildq	"#a_val"
		fmul	%st(0), %st(0)
		fldt	"#res_val1"
		fmulp	%st(0), %st(1)
		fistpq	"#r_val"
		fildq	"#a_val"+8
		fmul	%st(0), %st(0)
		fldt	"#res_val2"
		fmulp	%st(0), %st(1)
		fistpq	"#r_val"+8
")

//
// perform odd test for the sieve
// if (k_val & 1)
//   k_val += r_val
// k_out = k_val >> 1
// same with kval2, r_val2, k_out2
// xmm5 is assumed to have two 64 bit values of 1, high and low
//

#define Odd_Test_Macro(k_val, r_val, k_val2, r_val2, k_out, k_out2) asm("
		movdqa	"#k_val", %xmm0
		movdqa	"#r_val", %xmm1
		movdqa	"#k_val2", %xmm2
		movdqa	"#r_val2", %xmm3
		movdqa	"#k_val", %xmm4
		pand		%xmm5, %xmm0
		pcmpeqd	%xmm5, %xmm0
		pshufd	$160,	%xmm0, %xmm0
		pand		%xmm1, %xmm0
		paddq		%xmm0, %xmm4
		psrlq		$1, %xmm4
		movdqa	%xmm4, "#k_out"
		movdqa	%xmm2, %xmm6
		pand		%xmm5, %xmm2
		pcmpeqd	%xmm5, %xmm2
		pshufd	$160, %xmm2, %xmm2
		pand		%xmm3, %xmm2
		paddq		%xmm2, %xmm6
		psrlq		$1, %xmm6
		movdqa	%xmm6, "#k_out2"
")
