/***************************************************
 *
 *          File : newpgen2.cpp - this does the real work.
 *
 *        Author : AP Jobling
 *
 * Last Modified : 18-Feb-2002
 * 
 **************************************************/

 
#ifdef	__FreeBSD__ 
#include <sys/types.h> 
#include <_G_config.h> 
#endif 
 
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <math.h>
#include <errno.h> 

  
#if defined(__GNUC__) || defined(_CONSOLE)

#define STOPSIEVING throw 1
#define COND_STATIC
#include <ctype.h> 
#include <stdarg.h>

#ifdef __GNUC__
 
#ifndef	_G_HAVE_BOOL 
enum bool {false, true}; 
#endif 
 
#include <sys/time.h>
#include <unistd.h> 
//#include <ctype.h> 
//#include <stdarg.h>
#define Sleep sleep 


typedef union _LARGE_INTEGER { 
	struct _Word { 
		long unsigned LowPart;  
	        long  HighPart; 
	} Word; 
		long long QuadPart; 
} LARGE_INTEGER; 

void QueryPerformanceFrequency(LARGE_INTEGER* C) {
	C->QuadPart = 1000000;
}

void QueryPerformanceCounter(LARGE_INTEGER* C) {
	struct timeval tv;
	gettimeofday (&tv, 0);
	C->QuadPart = 1000000*tv.tv_sec + tv.tv_usec;
}

#endif

void print(char* b) { 
	if (b[0] == '#') 
		if (b[1] != 's')
			printf("%s\n",b+2); 
		else
			printf("%s\r",b+2); 
	else 
		printf("%s\n",b); 
} 

char printbuff[1024]; 

#ifdef __GNUC__
void  fprint(char *format, ...) 
#else
void  __cdecl fprint(char *format, ...) 
#endif
{ 
	va_list params; 
 
	va_start (params, format); 
 
	vsprintf (printbuff, format, params); 
	print (printbuff); 
} 
 
#else

#define STOPSIEVING AfxEndThread (0)
#define COND_STATIC static

#endif

#ifndef  __GNUC__

#include <conio.h> 
#include "stdafx.h"

#ifndef  _CONSOLE
#include "print.h"
#endif

#endif 

#include "Newpgen2.h" 
#include "Supmath.h" 
#include "Primetable.h" 
 
#ifdef __GNUC__

#ifdef _M_IX86 
#define MAX_PRIMECANDIDATE 0x7FFFFFFFFFFFLL	// The maximum divisor, <2^48 
#define MAX_PRIMECANDIDATE_PROTHSIEVE 0x7FFFFFFFFFFFFFFLL	// The maximum divisor, <2^60 
#else 
#define MAX_PRIMECANDIDATE 0x3FFFFFFFFFFLL	// The maximum divisor, 42 bits. 
#define MAX_PRIMECANDIDATE_PROTHSIEVE 0x3FFFFFFFFFFLL	// The maximum divisor, 42 bits. 
#endif 
 
#define TWOTO32 0x100000000LL 
#define TWOTO47 0x4000000000000LL
#define TWOTO63 0x8000000000000000LL
#define TWOTO63MINUS1 0x7FFFFFFFFFFFFFFFLL
#define LL_FORMAT "%qi" 

unsigned int _control87(unsigned int n, unsigned int mask); 
 
__int64 _atoi64(char *s) { 
	__int64 temp = 0; 
	sscanf(s, LL_FORMAT, &temp); 
	return temp; 
} 

#define MILLION 1000000
#define BILLION 1000000000
#define BIGFACTOR 3500000000LL
#define TRILLION 1000000000000LL
#else 
 

#include <float.h> 

#ifdef _M_IX86
#define MAX_PRIMECANDIDATE 0x7FFFFFFFFFFF		// The maximum divisor, <2^48
#define MAX_PRIMECANDIDATE_PROTHSIEVE 0x7FFFFFFFFFFFFFF	// The maximum divisor, <2^60 
#else
#define MAX_PRIMECANDIDATE 0x3FFFFFFFFFF		// The maximum divisor, 42 bits.
#define MAX_PRIMECANDIDATE_PROTHSIEVE 0x3FFFFFFFFFF	// The maximum divisor, 42 bits. 
#endif

#define TWOTO32 0x100000000 
#define TWOTO47 0x4000000000000
#define TWOTO63 0x8000000000000000
#define TWOTO63MINUS1 0x7FFFFFFFFFFFFFFF
#define MILLION 1000000
#define BILLION 1000000000
#define BIGFACTOR 3500000000
#define TRILLION 1000000000000

#define LL_FORMAT "%I64d" 
 
#endif 

#define SPARSE_FACTOR 3.0

__int64 maxp,sievelimit;
bool AllRemoved, tiny, allprimes;
double LogPrimorial;			// Natural logarithm of n# or k#
static __int64 *vals=NULL;		// k's read in from the file
static unsigned int nvals=0;		// The number of values read in from the file

char outbuff[1024];			// Contains the name of the output file

static char modechar;

__int64 firstp = 1;

__int64 MinNum;					// The minimum k read in from the file
__int64 MaxNum;					// The maximum k read in from the file
__int64 base_power_n, k_base_power_n, tinyPrimorial, min_kp, min_km;
unsigned int maxtiny;
unsigned int range;				// MaxNum-MinNum

int State;
int len3plus;
static __int64* b_array = NULL;
bool fGenerateFile;
char k_n;


bool fAppend;

bool fVerify;
bool LogDeleted;
bool TwoSaveFiles = false;

bool fIncIsTwo;

StopEnum StopCriterion = NONE;
__int64 StopValue = 0;
time_t StopTime;
unsigned int MaxN = 0;

time_t LastTime[20];
unsigned int savenvalsleft[20];
unsigned int rateindex;
unsigned int trailrateindex;

__int64 BitMapThreshold = 400000000;
bool fUseBitMap = false;
bool fUseHash = false;

unsigned int WriteIterations = 1;

bool fTest = false;

unsigned *notonebits;


bool fMyPrimorial;
unsigned int nMyPrimorial;
__int64 MyPrimorial[1000];
char kExpression[10000];


#define DeleteBitmap() {if (bitmap) free (bitmap); bitmap = NULL;}
#define DeleteVals() {if (vals) delete[] vals; vals = NULL;}

 
// Minimal debugging tool...

void trace(int n) {
	fprint("OK until number %d", n);
}

// Computes k*base^n whith n small.

__int64 kbasepown (__int64 k, unsigned int n) {
	unsigned int i;
	__int64 r=1, x=base;

	if (n) {
	    for (i=n;i!=1;i>>=1) {
		if (i&1)
		    r *= x;
		x *= x;
	    }
	    r *= x;
	    r *= k;
	    return r;
	}
	else
	    return k;
} 

void initialise ()
{
	onebits = new unsigned int[32];
	notonebits = new unsigned int[32];

	// Set the bitmaps used by the SofE
	for (int i = 0; i < 32; i++)
	{
		notonebits[i] = ~(1<<i);
		onebits[i] = (1<<i);
	}
}

__inline void ClearBit (unsigned int Bit)
{
	bitmap[Bit >> 5] &= notonebits[Bit & 0x1F];
}

__inline void SetBit (unsigned int Bit)
{
	bitmap[Bit >> 5] |= onebits[Bit & 0x1F];
}

__inline unsigned int GetBit (unsigned int Bit)
{
	return bitmap[Bit >> 5] & onebits[Bit & 0x1F];
}

bool fCMOV;
bool fSSE2;

__int64 soe2_next ();
void soe2_init (__int64 firstp, bool fIncrease);

/****************************************************************
 *
 * THESE ROUTINES HANDLE THE HASHTABLE
 *
 ***************************************************************/
typedef struct sHash
{
	unsigned __int64 num;
	unsigned nextNumericValue;
} sHash;

sHash *Hash = NULL;
unsigned HashSize;
unsigned HashBitmap;
unsigned FirstNumericValue;
unsigned *LastNumericValue;
bool fModHashFunction;

static bool CanCreateHash (int nElements, const __int64 MaxBytes)
{
	// Have at least a 50% overhead
	nElements += nElements/2;

	// Find next larger power of 2
	__int64 z = TWOTO32;
	while ((z & nElements) == 0) z >>= 1;
	z <<= 1;

	if (z*sizeof (struct sHash) <= MaxBytes)
	{
		// OK, we can do it.
		if ((z<<1)*sizeof (struct sHash) < MaxBytes) z <<= 1;
		if ((z<<1)*sizeof (struct sHash) < MaxBytes) z <<= 1;
		HashSize = (unsigned)z;
		HashBitmap = HashSize-1;

		fModHashFunction = false;
		return true;
	}
	else if (nElements*sizeof (struct sHash) <= MaxBytes)
	{
		// We can do it, but only by using a slower hash function.
		HashSize = (unsigned)(MaxBytes/sizeof (struct sHash));

		fModHashFunction = true;
		return true;
	}
	else
	{
		return false;
	}
}

static void DeleteHash ()
{
	if (Hash) delete[] Hash;
	Hash = NULL;
}

static bool CreateHash (const int nElements)
{
	DeleteHash ();

	if (HashSize*sizeof (sHash) > 1024*1024)
	{
		fprint ("The file contains %u %c's - using fastarray: allocating %.1fMb of RAM...", nElements,  k_n, HashSize*sizeof (sHash)/(1024.0*1024)); 
	}
	else 
	{
		fprint ("The file contains %u %c's - using fastarray: allocating %.1fKb of RAM...", nElements,  k_n, HashSize*sizeof (sHash)/1024.0); 
	}

	Hash = new sHash[HashSize];
	if (!Hash) return false;

	for (unsigned i = 0; i < HashSize; i++)
	{
		Hash[i].num = TWOTO63MINUS1;
		Hash[i].nextNumericValue = (unsigned)-1;
	}
	LastNumericValue = &FirstNumericValue;
	return true;
}


static void AddToHash (const __int64 val)
{
	unsigned i;
	
	if (!fModHashFunction)  i = (unsigned)(val & HashBitmap);
	else					i = (unsigned)(val % HashSize);

	while (Hash[i].num != TWOTO63MINUS1) 
	{
		i++;
		if (i == HashSize) i = 0;
	}
	Hash[i].num = val;

	*LastNumericValue = i;
	LastNumericValue = &Hash[i].nextNumericValue;
}

static bool FindAndDeleteFromHash (const unsigned __int64 val)
{
	unsigned i;

	if (!fModHashFunction)  i = (unsigned)(val & HashBitmap);
	else					i = (unsigned)(val % HashSize);

	for (;;)
	{
		unsigned __int64 num = Hash[i].num & TWOTO63MINUS1;
		if (num > val) 
		{
			return false;
		}
		if (num == val)
		{
			if (num == Hash[i].num)
			{
				Hash[i].num |= TWOTO63;
				return true;
			}
			return false;
		}

		i++;
		if (i == HashSize) i = 0;
	}
}

/****************************************************************
 *
 * THESE ROUTINES ARE USED TO SIEVE THROUGH A FILE 
 *
 ***************************************************************/

/**********************
 * This routine is called after <n> minutes.
 * It outputs the output file. and removes any k's that have been marked for removal
 * (ie the bottom bit has been flipped - see later) from our internal data structures
 **********************/
static void outputandtidyvals (const __int64 p, const char *outbuff, const bool fAppend)
{
	unsigned int i, j;
	FILE *fptr;
	struct tm *newtime;
	char *asctim;
	bool fRenameOccurred = false;

	time_t Start = time (NULL);

	// If the output file already exists, rename it as the same name
	// with a '~' at the end.
	if (!fAppend && TwoSaveFiles)
	{
		char newname[10240];
		sprintf (newname, "%s~", outbuff);

		fRenameOccurred = (rename (outbuff, newname) == 0); 
		if (!fRenameOccurred && errno == EEXIST)
		{
			// errno == EEXIST means that the new file already exists, so delete it
			// and try again.
			remove (newname);
			fRenameOccurred = (rename (outbuff, newname) == 0); 
		}
	}

	newtime = localtime(&Start);
	asctim = asctime( newtime );
	asctim[19] = 0;
	asctim += 11;

	fprint ("%s Saving results to %s...", asctim, outbuff);

	do
	{
		if (!fAppend)
		{
			fptr = fopen (outbuff, "w");
		}
		else
		{
			fptr = fopen (outbuff, "a");
		}

		if (fptr == NULL)
		{
			Sleep (10);
		}
	} while (fptr == NULL);

	if (!fAppend) 
	{
		if (!fMyPrimorial)
		{
			fprintf (fptr, ""LL_FORMAT":%c:%d:%d:%d\n", p-1, modechar, len3plus, base, mode);
		}
		else
		{
			fprintf (fptr, "ABC ");
			for (unsigned int i = 0; i < nMyPrimorial; i++)
			{
				fprintf (fptr, LL_FORMAT"*", MyPrimorial[i]);
			}
			fprintf (fptr, "2^$b%c1 ", (mode & MODE_PLUS) ? '+' : '-');

			fprintf (fptr, "//NewPGen:"LL_FORMAT":%c:%d:%d:%d\n", p-1, modechar, len3plus, base, mode);
		}
	}

	if (fUseBitMap)
	{
		unsigned int inc = 1;

		i = 0;

		// For Proth mode, num must be odd if base is 2, even if base is odd; for even bases>2 num can be anything
		if (fIncIsTwo)
		{
			inc = 2;
			if ((MinNum & 1) == (base & 1))
			{
				i = 1;
			}
		}
		for (j = 0; i <= range; i += inc)
		{
			if (GetBit (i))
			{
				if (mode & (MODE_KSIEVE|MODE_DUAL))
				{
					fprintf (fptr, "%d %d\n", nvalue, (int)(i+MinNum));
				}
				else
				{
					if ((mode & MASK_4) && !(mode & MODE_PRIMORIAL) && (base == 2 || !(mode & MODE_NOTGENERALISED)))
					{
						fprintf (fptr, LL_FORMAT" %d\n", i+MinNum, nvalue + 1);
					}
					else
					{
						fprintf (fptr, LL_FORMAT" %d\n", i+MinNum, nvalue);
					}
				}
				j++;
			}
		}
		nvals = nvalsleft = j;
	}
	else if (fUseHash)
	{
		nvals = 0;
		MaxNum = 0;
		MinNum = TWOTO63;

		for (unsigned i = FirstNumericValue; i != -1; i = Hash[i].nextNumericValue)
		{
			if (!(Hash[i].num & TWOTO63))
			{
				nvals++;
				if ((mode & MASK_4) && !(mode & MODE_PRIMORIAL) && (base == 2 || !(mode & MODE_NOTGENERALISED)))
				{
					fprintf (fptr, LL_FORMAT" %d\n", Hash[i].num, nvalue + 1);
				}
				else
				{
					fprintf (fptr, LL_FORMAT" %d\n", Hash[i].num, nvalue);
				}
				MaxNum = Hash[i].num;
				if (MinNum == TWOTO63) MinNum = Hash[i].num;
			}
		}
		nvalsleft = nvals;
	}
	else
	{
		MinNum = TWOTO63;
		for (i = j = 0; i < nvals; i++)
		{
			if (!(vals[i] & TWOTO63))
			{
				if ((mode & MASK_4) && !(mode & MODE_PRIMORIAL) && (base == 2 || !(mode & MODE_NOTGENERALISED)))
				{
					fprintf (fptr, LL_FORMAT" %d\n", vals[i], nvalue + 1);
				}
				else
				{
					fprintf (fptr, LL_FORMAT" %d\n", vals[i], nvalue);
				}
				MaxNum = vals[j] = vals[i];
				if (MinNum == TWOTO63) MinNum = vals[i];
				j++;
			}
		}
		nvals = nvalsleft = j;
	}
	fclose (fptr);

	time_t End = time (NULL);
	newtime = localtime(&End);
	asctim = asctime( newtime );
	asctim[19] = 0;
	asctim += 11;

	fprint ("%s ...done.", asctim);

	if (fRenameOccurred)
	{
		fprint ("(The previous contents of %s have been placed in the file %s~)", outbuff, outbuff);
	}

	// Adjust the times contained in the LastTime[], so that the rate that
	// is displayed is correct. This also prevents an early exit from the sieving
	// if the 'Sieve Until' condition is the rate.

	for (i = 0; i < 20; i++)
	{
		if (LastTime[i]) LastTime[i] += End - Start;
	}
}


/**********************
 * This routine calls some fast assembler used to clear with the bitmap.
 **********************/

static void fastclear (const unsigned int num, const unsigned int addnum)
{
	num32 = num-addnum;
	max32 = (range >= addnum) ? range-addnum : num;
	addnum32 = addnum; 
 
	fastclearasm(); 
 
}

/**********************
 * As does this, but this time there is >1 value to clear for this p.
 **********************/

static void fastclear2 (const unsigned int *nums, const unsigned int nnums, const unsigned int add)
{
	unsigned int i;
	static unsigned removals[100];

	num32 = (unsigned int)&removals[nnums], max32 = range, addnum32 = (unsigned int)removals; 

	removals[nnums] = nums[0];
	for (i = 1; i < nnums; i++) removals[i-1] = nums[i] - nums[i-1];
	removals[i-1] = add+removals[nnums]-nums[i-1];

	fastclear2asm(); 
 
}

/**********************
 * This clears the bitmap, but backwards (used by the fixed k sieve).
 **********************/

__inline void revfastclear (const unsigned int num, const unsigned int subnum)
{
	num32 = num, subnum32 = subnum; 
 
	revfastclearasm(); 
 
}

/**********************
 * This routine verifies sloooowly that the number actually is divisible by the prime
 **********************/
static void Verify (const __int64 k, const unsigned int n, const __int64 prime)
{
	__int64 r;

	if (fMyPrimorial)
	{
		r = 1;

		for (unsigned int i = 0; i < nMyPrimorial; i++)
		{
			r = mulmodp2 (r, MyPrimorial[i], prime);
		}
		r = fastkbasepownmodp (r, n, prime);
	}
	else if ((mode & (MODE_PRIMORIAL|MODE_KSIEVE)) == (MODE_PRIMORIAL|MODE_KSIEVE))
	{
		// Find k#*2^n
		r = 2;
		for (int i = 0; primetable[i] <= k; i++)
		{
			r = mulmodp2 (r, primetable[i], prime);
		}

		r = fastkbasepownmodp (r, n, prime);
	}
	else if (mode & MODE_PRIMORIAL)
	{
		if (mode & MODE_AP) r = 1;
		else r = k;

		if (!(mode == (MODE_LP | MODE_PRIMORIAL) || mode == (MODE_LM | MODE_PRIMORIAL)))
		{
			r *= 2;
		}

		if (mode & MODE_PLUS5) primetable[1] = 1;
		if (mode & MODE_PLUS7) primetable[2] = 1;

		for (int i = 0; primetable[i] <= n; i++)
		{
			r = mulmodp2 (r, primetable[i], prime);
		}

		if (mode & MODE_PLUS5) primetable[1] = 5;
		if (mode & MODE_PLUS7) primetable[2] = 7;
	}
	else
	{
		if ((mode & MODE_AP) || (mode & MODE_DUAL))
		{
			r = fastkbasepownmodp (1, n, prime);
		}
		else
		{
			r = fastkbasepownmodp (k, n, prime);
		}
	}

	if (mode & MODE_DUAL)
	{
		if (mode & MODE_PLUS)
		{
			r += k;
		}
		else
		{
			r -= k;
			while (r < 0) r += prime;
		}
		r %= prime;
		if (r == 0) return;
	}
	else if (mode & MODE_AP)
	{
		if (base & 1) r += 2*k - 2;
		else r += 2*k - 1;

		r %= prime;
		if (r == 0) return;
	}
	else
	{
		if ((mode & MODE_MINUS) && (r == 1)) return;
		if ((mode & MODE_PLUS) && (r == prime-1)) return;
		if ((mode & MODE_PLUS5) && (r == prime-5 || (prime == 5 && r == 5))) return;
		if ((mode & MODE_PLUS7) && (r == prime-7 || (prime == 5 && r == 3) || (prime == 7 && r == 7))) return;
		if (mode & MASK_2)
		{
			if (base == 2 || (mode & MODE_NOTGENERALISED))
			{
				r <<= 1;
				if (r >= prime) r -= prime;
			}
			else
			{
				r = mulmodp2 (r, base, prime);
			}

			if ((mode & MODE_2MINUS) && (r == 1)) return;
			if ((mode & MODE_2PLUS) && (r == prime-1)) return;
		}

		if (mode & MODE_2PLUS3)
		{
			r <<= 1;
			while (r >= prime) r -= prime;
			if (r == prime-3) return;
		}

		if (mode & MASK_4)
		{
			for (int len = 3; len <= len3plus; len++)
			{
				if (base == 2 || (mode & MODE_NOTGENERALISED))
				{
					r <<= 1;
					if (r >= prime) r -= prime;
				}
				else
				{
					r = mulmodp2 (r, base, prime);
				}

				if ((mode & MODE_4MINUS) && (r == 1)) return;
				if ((mode & MODE_4PLUS) && (r == prime-1)) return;
			}
		}
	}
	// oh dear!

#if !defined(__GNUC__) && !defined(_CONSOLE)
	print ("#m**** Fatal error!!! - validation failed!\r\nA FILE CALLED NEWPGEN.ERR HAS BEEN CREATED CONTAINING DEBUG INFORMATION");
#else
	print ("#m**** Fatal error!!! - validation failed!\r\n");
#endif
	
	FILE *errfptr = fopen ("newpgen.err", "w");
	if (errfptr)
	{
		if (!fMyPrimorial)
		    fprintf (errfptr, " p="LL_FORMAT" \n mode=0x%x \n k="LL_FORMAT" \n n=%d \n base=%d \n len3plus=%d \n\n", 
						prime, mode, k, nvalue, base, len3plus);
		else
		    fprintf (errfptr, " p="LL_FORMAT" \n mode=0x%x \n k=%s \n n=%d \n base=%d \n len3plus=%d \n\n", 
						prime, mode, kExpression, n, base, len3plus); // n, **NOT** nvalue !
		print ("A FILE CALLED NEWPGEN.ERR HAS BEEN CREATED CONTAINING DEBUG INFORMATION");
		print ("_PLEASE_ SEND THIS TO PAUL JOBLING (p_jobling@hotmail.com) SO HE CAN FIX THE BUG (IF HE CAN FIND IT)");
		fclose (errfptr);
	}

	State = 4;

	print ("##");
	STOPSIEVING;
}

time_t LastNow;
unsigned nopsthreshold;
unsigned nops;
static double MArate;

static void ClearReport (const time_t Now, const __int64 prime, const __int64 num)
{
	struct tm *newtime;
	char *asctim;
	newtime = localtime( &Now);
	asctim = asctime( newtime );
	asctim[19] = 0;
	asctim += 11;

	fprint ("%s %u %c's remaining. p="LL_FORMAT" divides %c="LL_FORMAT"", asctim, nvalsleft, k_n, prime, k_n, num);
	fprint ("#t%s %u %c's left", asctim, nvalsleft, k_n);

	if (LastTime[trailrateindex])
	{
		double rate = (savenvalsleft[trailrateindex] - nvalsleft)*1.0/(Now - LastTime[trailrateindex]);
		if (rate > 10)
		{
			double rate = (savenvalsleft[(trailrateindex+10)%20] - nvalsleft)*1.0/(Now - LastTime[(trailrateindex+10)%20]);
			fprint ("#rRate: %.0f %c's per second", rate, k_n);
			MArate = 0.0;
		}
		else
		{
			rate = 1/rate;
			if (MArate != 0.0)
			{
				MArate = 0.8*MArate+0.2*rate;
				rate = MArate;
			}
			else
			{
				MArate = rate;
			}

			if (rate < 2*60)
			{
				fprint ("#rRate: 1 %c every %.1f seconds", k_n, rate);
			}
			else
			{
				int secs = (int)rate;
				int min = secs/60;
				secs %= 60;
				fprint ("#rRate: 1 %c every %d:%02d minutes", k_n, min, secs);
			}
			if (State == 2 && StopCriterion == RATE && rate*10 > StopValue)
			{
				State = 0;
			}
		}
	}
	rateindex++;
	rateindex %= 20;
	trailrateindex++;
	trailrateindex %= 20;
	LastTime[rateindex] = Now;
	savenvalsleft[rateindex] = nvalsleft;
}

/**********************
 * These routines removes any entries of the form 'num + i*prime' (i = 0, 1, 2, ...) from our data structure.
 * We use a pointer to a function, to avoid wasteful checks.
 **********************/

static void (*ClearRoutine) (__int64, const __int64);


/**********************
 * Comparison routine for bsearch, used in ClearArray()
 **********************/

static int __cdecl comp (const void *_a, const void *_b)
{
	unsigned int *a = (unsigned int *)_a, *b = (unsigned int *)_b;

	if ((a[1]&0x7FFFFFFF) > (b[1]&0x7FFFFFFF)) return 1;
	if ((a[1]&0x7FFFFFFF) < (b[1]&0x7FFFFFFF)) return -1;
	if (a[0] > b[0]) return 1;
	if (a[0] < b[0]) return -1;
	return 0;
}


/**********************
 * Clear routine used when we have the k's in a hash.
 **********************/

static void ClearHash (__int64 num, const __int64 prime)
{
	static time_t Now;
	__int64 add = prime;
	static time_t lastoutput;

	if (fIncIsTwo) 
	{
		add <<= 1;
		if ((num & 1) == (base & 1))
		{
			num += prime;
			if (num > MaxNum) return;
		}
	}

	if (MinNum > num)
	{
		num += add * ((MinNum - num)/add);
		while (num < MinNum) num += add;
		if (num > MaxNum) return;
	}

	for (;;)
	{
		// Find 'num' in the hash
		if (FindAndDeleteFromHash (num))
		{
			// We found it, so we are going to remove it.
			// First, verify the result
			if (fVerify)
			{
				Verify (num, nvalue, prime);
			}
			// Log the number deleted, if necessary
			if (LogDeleted && prime > 0xFFFFFFFF)
			{
				FILE *fptr;
				do
				{
					fptr = fopen ("NewPGen.del", "a");
					if (fptr == NULL) Sleep (10);
				} while (fptr == NULL);
				fprintf (fptr, "p="LL_FORMAT" divides %c="LL_FORMAT"\n", prime, k_n, num);
				fclose (fptr);
			}

			time_t Now;
			time (&Now);
			nvalsleft--;

			if (Now != LastTime[rateindex])
			{
				ClearReport (Now, prime, num);
			}

			if (State == 2 && StopCriterion == KSREMAINING && nvalsleft <= StopValue) 
			{
				State = 0;
			}

			if (nvalsleft == 0)
			{
				if (State == 2)
				{	// Don't stop if generating...
					State = 0;
					print ("#o**** All values removed! You do not need to test these values!!");
					outputandtidyvals (prime, outbuff, fAppend);
					print ("##");
					STOPSIEVING;
				}
				else
				{
					if (!AllRemoved)
					{
						print ("#r**** All values removed in this range.");
						AllRemoved = true;
					}
					return;
				}
			}
		}

		// More to do ?...
		num += add; 
		if (num > MaxNum) return;
	}
}
/**********************
 * Clear routine used when we have the ks in an array rather than a bitmap.
 **********************/

static void ClearArray (__int64 num, const __int64 prime)
{
	__int64 add = prime;
	static __int64 *valptr;
	static time_t Now;
	static time_t lastoutput;

	if (fIncIsTwo) 
	{
		add <<= 1;
		if ((num & 1) == (base & 1))
		{
			num += prime;
			if (num > MaxNum) return;
		}
	}

	if (MinNum > num)
	{
		num += add * ((MinNum - num)/add);
		while (num < MinNum) num += add;
		if (num > MaxNum) return;
	}

	for (;;)
	{
		// Call bsearch to find 'num' in vals[]
		valptr = (__int64 *) bsearch (&num, vals, nvals, sizeof (__int64), comp);
		if (valptr && !((*valptr) & TWOTO63))
		{
			// We found it, so we are going to remove it.
			// First, verify the result
			if (fVerify)
			{
				Verify (num, nvalue, prime);
			}

			*valptr |= TWOTO63;

			// Log the number deleted, if necessary
			if (LogDeleted && prime > 0xFFFFFFFF)
			{
				FILE *fptr;
				do
				{
					fptr = fopen ("NewPGen.del", "a");
					if (fptr == NULL) Sleep (10);
				} while (fptr == NULL);
				fprintf (fptr, "p="LL_FORMAT" divides %c="LL_FORMAT"\n", prime, k_n, num);
				fclose (fptr);
			}

			time_t Now;
			time (&Now);
			nvalsleft--;

			if (Now != LastTime[rateindex])
			{
				ClearReport (Now, prime, num);
			}

			if (State == 2 && StopCriterion == KSREMAINING && nvalsleft <= StopValue) 
			{
				State = 0;
			}

			if (nvalsleft == 0)
			{
				if (State == 2)
				{	// Don't stop if generating...
					State = 0;
					print ("#o**** All values removed! You do not need to test these values!!");
					outputandtidyvals (prime, outbuff, fAppend);
					print ("##");
					STOPSIEVING;
				}
				else
				{
					if (!AllRemoved)
					{
						print ("#r**** All values removed in this range.");
						AllRemoved = true;
					}
					return;
				}
			}
		}

		// More to do ?...
		num += add; 
		if (num > MaxNum) return;
	}
}

/**********************
 * Clear routine used when we have the ks in a very sparse array.
 **********************/

static void ClearSparseArray (__int64 num, const __int64 prime)
{
	__int64 add = prime;
	static __int64 *valptr;
	static time_t Now;
	static time_t lastoutput;

	if (fIncIsTwo) 
	{
		add <<= 1;
		if ((num & 1) == (base & 1))
		{
			num += prime;
			if (num > MaxNum) return;
		}
	}

	// Is it time to switch strategies?
	if ((log (nvals)*(MaxNum-MinNum))/(add*nvals) < SPARSE_FACTOR)
	{
		ClearRoutine = ClearArray;
		print ("Switching from sparse array algorithm to normal array algorithm");
	}


	// For each k in the array, see if k%add == num
	for (unsigned int i = 0; i < nvals; i++)
	{
		unsigned *x = (unsigned *)&vals[i];

		if (!(x[1] & 0x80000000))
		{
			if (vals[i] % add == num)
			{
				if (fVerify)
				{
					Verify (num, nvalue, prime);
				}

				vals[i] |= TWOTO63;

				// Log the number deleted, if necessary
				if (LogDeleted && prime > 0xFFFFFFFF)
				{
					FILE *fptr;
					do
					{
						fptr = fopen ("NewPGen.del", "a");
						if (fptr == NULL) Sleep (10);
					} while (fptr == NULL);
					fprintf (fptr, "p="LL_FORMAT" divides %c="LL_FORMAT"\n", prime, k_n, num);
					fclose (fptr);
				}

				time_t Now;
				time (&Now);
				nvalsleft--;

				if (Now != LastTime[rateindex])
				{
					ClearReport (Now, prime, num);
				}

				if (State == 2 && StopCriterion == KSREMAINING && nvalsleft <= StopValue) 
				{
					State = 0;
				}

				if (nvalsleft == 0)
				{
					if (State == 2)
					{	// Don't stop if generating...
						State = 0;
						print ("#o**** All values removed! You do not need to test these values!!");
						outputandtidyvals (prime, outbuff, fAppend);
						print ("##");
						STOPSIEVING;
					}
					else
					{
						if (!AllRemoved)
						{
							print ("#r**** All values removed in this range.");
							AllRemoved = true;
						}
						return;
					}
				}
			}
		}
	}
}


/**********************
 * Clear routine used when we have the ks in a bitmap, and p is large.
 **********************/

static void ClearBitmap (__int64 num, const __int64 prime)
{
	__int64 add = prime;
	static __int64 *valptr;
	static time_t Now;
	static time_t lastoutput;

	if (fIncIsTwo) 
	{
		add <<= 1;
		if ((num & 1) == (base & 1))
		{
			num += prime;
			if (num > MaxNum) return;
		}
	}

	if (MinNum > num)
	{
		num += add * ((MinNum - num)/add);
		while (num < MinNum) num += add;
		if (num > MaxNum) return;
	}

	for (;;)
	{
		if (GetBit ((unsigned int)(num-MinNum)))
		{
			ClearBit ((unsigned int)(num-MinNum));

			// We found it, so we are going to remove it.

			// First, verify the result
			if (fVerify)
			{
				Verify (num, nvalue, prime);
			}

			// Log the number deleted, if necessary
			if (LogDeleted && prime > 0xFFFFFFFF)
			{
				FILE *fptr;
				do
				{
					fptr = fopen ("NewPGen.del", "a");
					if (fptr == NULL) Sleep (10);
				} while (fptr == NULL);
				fprintf (fptr, "p="LL_FORMAT" divides %c="LL_FORMAT"\n", prime, k_n, num);
				fclose (fptr);
			}

			time_t Now;
			time (&Now);
			nvalsleft--;

			if (Now != LastTime[rateindex])
			{
				ClearReport (Now, prime, num);
			}

			if (State == 2 && StopCriterion == KSREMAINING && nvalsleft <= StopValue) 
			{
				State = 0;
			}

			if (nvalsleft == 0)
			{
				if (State == 2)
				{	// Don't stop if generating...
					State = 0;
					print ("#o**** All values removed! You do not need to test these values!!");
					outputandtidyvals (prime, outbuff, fAppend);
					print ("##");
					STOPSIEVING;
				}
				else
				{
					if (!AllRemoved)
					{
						print ("#r**** All values removed in this range.");
						AllRemoved = true;
					}
					return;
				}
			}
		}

		// More to do ?...
		num += add; 
		if (num > MaxNum) return;
	}
}

/**********************
 * Clear routine used when we have the ks in a bitmap, and p < 1 billion.
 **********************/

static void ClearBitmapSmallp (__int64 num, const __int64 prime)
{
	__int64 add = prime;
	static __int64 *valptr;
	static time_t Now;
	static time_t lastoutput;

	if (fIncIsTwo) 
	{
		add <<= 1;
		if ((num & 1) == (base & 1))
		{
			num += prime;
			if (num > MaxNum) return;
		}
	}

	if (MinNum > num)
	{
		num += add * ((MinNum - num)/add);
		while (num < MinNum) num += add;
		if (num > MaxNum) return;
	}

	// num is now scaled to be in the range MinNum to MaxNum
	if (prime > BILLION)
	{
		// Time to switch strategies
		ClearRoutine = ClearBitmap;
		ClearBitmap (num, prime);
		return;
	}

	unsigned int nvalsleftbefore = nvalsleft;
	fastclear ((unsigned int)(num-MinNum), (unsigned int)add);

	if (add < range) nops += range/(unsigned int)add;
	nops += 100;

	if (nvalsleftbefore != nvalsleft)
	{
		if (fVerify)
		{
			Verify (num, nvalue, prime);
		}
	}
	
	if (nops > nopsthreshold)
	{
		if (nvalsleft != savenvalsleft[rateindex])
		{
			nops = 0;
			Now = time (NULL);

			int secs = Now - LastNow;
			double factor = (secs == 0) ? 5.0 : (add < range) ? 2.0/secs : 3.0/secs;
			factor *= nopsthreshold;
			if (factor < BIGFACTOR) nopsthreshold = (unsigned)factor; else nopsthreshold = BIGFACTOR;
			LastNow = Now;

			ClearReport (Now, prime, num);
		}
		else
		{
			nops -= 100;
		}
	}

	if (State == 2 && StopCriterion == KSREMAINING && nvalsleft <= StopValue) 
	{
		State = 0;
	}

	if (nvalsleft == 0)
	{
		if (State == 2) 
		{	// Don't stop if generating...
			State = 0;
			print ("#o**** All values removed! You do not need to test these values!!");
			outputandtidyvals (prime, outbuff, fAppend);
			print ("##");
			STOPSIEVING;
		}
		else
		{
			if (!AllRemoved)   // Write this message only one time!
				print ("#r**** All values removed in this range.");
			AllRemoved = true; // so, this range is completed.
		}
	}
}


unsigned int multivals_nnums;
unsigned int multivals_nums[100];
unsigned int multivals_lastprime;
unsigned int multivals_add;

/**********************
 * Clear routine used when we have the ks in a bitmap, p is small, and >1 value is removed by each p.
 **********************/

static void ClearBitmapSmallpMultivals (__int64 num, const __int64 prime)
{
	__int64 add = prime;
	static __int64 *valptr;
	static time_t Now;
	static time_t lastoutput;

	if (fIncIsTwo) 
	{
		add <<= 1;
		if ((num & 1) == (base & 1))
		{
			num += prime;
			if (num > MaxNum) return;
		}
	}

	if (MinNum > num)
	{
		num += add * ((MinNum - num)/add);
		while (num < MinNum) num += add;
		if (num > MaxNum) return;
	}

	// num is now scaled to be in the range MinNum to MaxNum

	if (prime > 100000000)
	{
		// Time to switch strategies

		if (multivals_nnums) fastclear2 (multivals_nums, multivals_nnums, multivals_add);
		ClearRoutine = ClearBitmapSmallp;
		ClearBitmapSmallp (num, prime);
		return;
	}

	num -= MinNum;

	if (prime == multivals_lastprime)
	{
		int i;

		for (i = multivals_nnums; i > 0; i--)
		{
			if (multivals_nums[i-1] < num) break;
			multivals_nums[i] = multivals_nums[i-1];
		}
		multivals_nums[i] = (unsigned int)num;
		multivals_nnums++;
		return;
	}
	
	if (multivals_lastprime)
	{
		if (multivals_nnums == 1)
		{
			// OK, another routine is faster now
			ClearRoutine = ClearBitmapSmallp;
			ClearBitmapSmallp (multivals_nums[0]+MinNum, multivals_lastprime);
			ClearBitmapSmallp (num+MinNum, prime);
			return;
		}
		unsigned int nvalsleftbefore = nvalsleft;
		fastclear2 (multivals_nums, multivals_nnums, multivals_add);
		if (add < range) nops += multivals_nnums*(range/(unsigned int)add);
		nops += 100;

		if (nvalsleftbefore != nvalsleft)
		{
			if (fVerify)
			{
				for (unsigned int i = 0; i < multivals_nnums; i++)
					Verify (multivals_nums[i]+MinNum, nvalue, multivals_lastprime);
			}
		}
		
		if (nops > nopsthreshold)
		{
			if (nvalsleft != savenvalsleft[rateindex])
			{
				nops = 0;
				Now = time (NULL);

				int secs = Now - LastNow;
				double factor = (secs == 0) ? 5.0 : (add < range) ? 2.0/secs : 3.0/secs;
				factor *= nopsthreshold;
				if (factor < BIGFACTOR) nopsthreshold = (unsigned)factor; else nopsthreshold = BIGFACTOR;
				LastNow = Now;

				if (prime != 2)	ClearReport (Now, prime, num+MinNum);
			}
			else
			{
				nops -= 100;
			}
		}

		if (State == 2 && StopCriterion == KSREMAINING && nvalsleft <= StopValue) 
		{
			State = 0;
		}

		if (nvalsleft == 0)
		{
			if (State == 2) 
			{	// Don't stop if generating...
				State = 0;
				print ("#o**** All values removed! You do not need to test these values!!");
				outputandtidyvals (prime, outbuff, fAppend);
				print ("##");
				STOPSIEVING;
			}
			else
			{
				if (!AllRemoved)   // Write this message only one time!
				    print ("#r**** All values removed in this range.");
				AllRemoved = true; // so, this range is completed.
			}
		}
	}

	multivals_nnums = 1;
	multivals_nums[0] = (unsigned int)num;
	multivals_lastprime = (unsigned int)prime;
	multivals_add = (unsigned int)add;
}

/*******************
 * These routines are used to remove the relevant values, depending on the type of sieve.
 * Again, a pointer to a function is used to avoid operations.
 *******************/

static void (*RemoveRoutine) (const __int64 &p, __int64 b);

// A couple of useful macros, just to make the code easier to read.
#define HALVE_B if (base == 2 || (mode & MODE_NOTGENERALISED)) {if (b & 1) b += p; b >>= 1;} else b = mulmodp2 (b, baseinverse, p);
#define CLEAR(a,p) if ((a)<=MaxNum) (*ClearRoutine) (a,p)

static void Remove_AP (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
}

static void Remove_AP_tiny (const __int64 &p, __int64 b) 
{ 
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1 - tinyPrimorial)/2 : (p + 1 - base_power_n)/2;
	if (b == min_km) {
	    CLEAR (b+p, p);
	}
	else
	    CLEAR (b, p);
} 
 
static void Remove_Plus (const __int64 &p, __int64 b)
{
	CLEAR (p-b, p);
}

static void Remove_Plus_tiny (const __int64 &p, __int64 b) 
{ 
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	if (p-b == min_kp) {
	    CLEAR (p-b+p, p);
	}
	else
	    CLEAR (p-b, p);
} 
 
static void Remove_Minus (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
}

static void Remove_Minus_tiny (const __int64 &p, __int64 b) 
{ 
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	if (b == min_km) {
	    CLEAR (b+p, p);
	}
	else
	    CLEAR (b, p);
} 
 
static void Remove_Twin (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
	CLEAR (p-b, p);
}

static void Remove_Twin_tiny (const __int64 &p, __int64 b) 
{ 
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	if (b == min_km || p-b == min_kp) {
	    CLEAR (b+p, p);
	    CLEAR (p-b+p, p);
	}
	else {
	    CLEAR (b, p); 
	    CLEAR (p-b, p); 
	}
} 
 
static void Remove_3tuple (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
	CLEAR (p-b, p);
	b *= 5;
	b %= p;
	b = p - b;

	CLEAR (b, p);
}

static void Remove_3tuple_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 b1 = 5*b; 
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	b1 %= p; 
	b1 = p - b1; 
	if (b == min_km || p-b == min_kp || b1 == min_kp) {
	    CLEAR (b+p, p);
	    CLEAR (p-b+p, p);
	    CLEAR (b1+p, p);
	}
	else {
	    CLEAR (b, p); 
	    CLEAR (p-b, p); 
	    CLEAR (b1, p); 
	}
} 
 
static void Remove_4tuple (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
	CLEAR (p-b, p);

	__int64 b1 = 5*b;
	b1 %= p;
	b1 = p - b1;

	CLEAR (b1, p);

	b1 = 7*b;
	b1 %= p;
	b1 = p - b1;

	CLEAR (b1, p);
}

static void Remove_4tuple_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 b1 = 5*b; 
	__int64 b2 = 7*b;
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	b1 %= p; 
	b1 = p - b1; 
	b2 %= p; 
	b2 = p - b2; 
	if (b == min_km || p-b == min_kp || b1 == min_kp || b2 == min_kp) {
	    CLEAR (b+p, p);
	    CLEAR (p-b+p, p);
	    CLEAR (b1+p, p);
	    CLEAR (b2+p, p);
	}
	else {
	    CLEAR (b, p); 
	    CLEAR (p-b, p); 
	    CLEAR (b1, p); 
	    CLEAR (b2, p); 
	}
} 
 
static void Remove_CC (const __int64 &p, __int64 b)
{
	CLEAR (p-b, p);
	HALVE_B
	CLEAR (p-b, p);
}

static void Remove_CC_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 saveb = b;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	HALVE_B 
	if (p-saveb == min_kp || p-b == min_kp) {
	    CLEAR (p-saveb+p, p); 
	    CLEAR (p-b+p, p); 
	}
	else {
	    CLEAR (p-saveb, p); 
	    CLEAR (p-b, p); 
	}
} 
 
static void Remove_SG (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
	HALVE_B
	CLEAR (b, p);
}

static void Remove_SG_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 saveb = b;
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	HALVE_B 
	if (saveb == min_km || b == min_km) {
	    CLEAR (saveb+p, p); 
	    CLEAR (b+p, p); 
	}
	else {
	    CLEAR (saveb, p); 
	    CLEAR (b, p); 
	}
} 
 
static void Remove_Bi (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
	CLEAR (p-b, p);
	HALVE_B
	CLEAR (b, p);
	CLEAR (p-b, p);
}

static void Remove_Bi_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 saveb = b;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	HALVE_B 
	if (saveb == min_km || p-saveb == min_kp || b == min_km || p-b == min_kp) {
	    CLEAR (saveb+p, p); 
	    CLEAR (p-saveb+p, p); 
	    CLEAR (b+p, p); 
	    CLEAR (p-b+p, p); 
	}
	else {
	    CLEAR (saveb, p); 
	    CLEAR (p-saveb, p); 
	    CLEAR (b, p); 
	    CLEAR (p-b, p); 
	}
} 
 
static void Remove_SG3 (const __int64 &p, __int64 b)
{
	CLEAR (p-b, p);
	if (b & 1) b += p;
	b >>= 1;

	b *= 3;
	while (b >= p) b -= p;
	CLEAR (p-b, p);
}

static void Remove_SG3_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 saveb = b;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	if (b & 1) b += p; 
	b >>= 1; 
 
	b *= 3; 
	while (b >= p) b -= p; 
	if (p-saveb == min_kp || p-b == min_kp) {
	    CLEAR (p-saveb+p, p); 
	    CLEAR (p-b+p, p); 
	}
	else {
	    CLEAR (p-saveb, p); 
	    CLEAR (p-b, p); 
	}
} 
 
static void Remove_IJ (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
	CLEAR (p-b, p);
	HALVE_B
	CLEAR (b, p);
}

static void Remove_IJ_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 saveb = b;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	HALVE_B 
	if (saveb == min_km || p-saveb == min_kp || b == min_km) {
	    CLEAR (saveb+p, p); 
	    CLEAR (p-saveb+p, p); 
	    CLEAR (b+p, p); 
	}
	else {
	    CLEAR (saveb, p); 
	    CLEAR (p-saveb, p); 
	    CLEAR (b, p); 
	}
} 
 
static void Remove_IJ2 (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
	CLEAR (p-b, p);
	HALVE_B
	CLEAR (p-b, p);
}

static void Remove_IJ2_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 saveb = b;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	HALVE_B 
	if (saveb == min_km || p-saveb == min_kp || p-b == min_kp) {
	    CLEAR (saveb+p, p); 
	    CLEAR (p-saveb+p, p); 
	    CLEAR (p-b+p, p); 
	}
	else {
	    CLEAR (saveb, p); 
	    CLEAR (p-saveb, p); 
	    CLEAR (p-b, p); 
	}
} 
 
static void Remove_LP (const __int64 &p, __int64 b)
{
	CLEAR (p-b, p);
	HALVE_B
	CLEAR (p-b, p);
	CLEAR (b, p);
	HALVE_B
	CLEAR (p-b, p);
}

static void Remove_LP_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 saveb1 = b;
	__int64 saveb2;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	HALVE_B 
	saveb2 = b;
	HALVE_B 
	if (p-saveb1 == min_kp || p-saveb2 == min_kp || saveb2 == min_km || p-b == min_kp) {
	    CLEAR (p-saveb1+p, p); 
	    CLEAR (p-saveb2+p, p); 
	    CLEAR (saveb2+p, p); 
	    CLEAR (p-b+p, p); 
	}
	else {
	    CLEAR (p-saveb1, p); 
	    CLEAR (p-saveb2, p); 
	    CLEAR (saveb2, p); 
	    CLEAR (p-b, p); 
	}
} 
 
static void Remove_LM (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
	HALVE_B
	CLEAR (p-b, p);
	CLEAR (b, p);
	HALVE_B
	CLEAR (b, p);
}

static void Remove_LM_tiny (const __int64 &p, __int64 b) 
{ 
	__int64 saveb1 = b;
	__int64 saveb2;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	HALVE_B 
	saveb2 = b;
	HALVE_B 
	if (saveb1 == min_km || p-saveb2 == min_kp || saveb2 == min_km || b == min_km) {
	    CLEAR (saveb1+p, p); 
	    CLEAR (p-saveb2+p, p); 
	    CLEAR (saveb2+p, p); 
	    CLEAR (b+p, p); 
	}
	else {
	    CLEAR (saveb1, p); 
	    CLEAR (p-saveb2, p); 
	    CLEAR (saveb2, p); 
	    CLEAR (b, p); 
	}
} 
 
static void Remove_CC23 (const __int64 &p, __int64 b)
{
	CLEAR (p-b, p);

	for (int i = 1; i < len3plus; i++)
	{
		HALVE_B
		CLEAR (p-b, p);
	}
}

static void Remove_CC23_tiny (const __int64 &p, __int64 b) 
{ 
	bool self_dividing;
	int i;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	b_array[0] = p-b;
	self_dividing = (p-b == min_kp);

	for (i = 1; i < len3plus; i++) 
	{ 
		HALVE_B 
		b_array[i] = p-b; 
		self_dividing = self_dividing || (p-b == min_kp);
	} 

	for (i = 0; i < len3plus; i++) 
	{ 
	    if (self_dividing) {
		CLEAR (b_array[i] + p, p); 
	    }
	    else {
		CLEAR (b_array[i], p); 
	    }
	} 
} 
 
static void Remove_CC13 (const __int64 &p, __int64 b)
{
	CLEAR (b, p);

	for (int i = 1; i < len3plus; i++)
	{
		HALVE_B
		CLEAR (b, p);
	}
}

static void Remove_CC13_tiny (const __int64 &p, __int64 b) 
{ 
	bool self_dividing;
	int i;
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	b_array[0] = b;
	self_dividing = (b == min_km);

	for (i = 1; i < len3plus; i++) 
	{ 
		HALVE_B 
		b_array[i] = b; 
		self_dividing = self_dividing || (b == min_km);
	} 

	for (i = 0; i < len3plus; i++) 
	{ 
	    if (self_dividing) {
		CLEAR (b_array[i] + p, p); 
	    }
	    else {
		CLEAR (b_array[i], p); 
	    }
	} 
} 
 
static void Remove_BI3 (const __int64 &p, __int64 b)
{
	CLEAR (p-b, p);
	CLEAR (b, p);

	for (int i = 1; i < len3plus; i++)
	{
		HALVE_B
		CLEAR (p-b, p);
		CLEAR (b, p);
	}
}

static void Remove_Special (const __int64 &p, __int64 b)
{
	CLEAR (b, p);
	CLEAR (p-b, p);

	__int64 b1 = b*2;
	if (b1 > p) b1 -= p;
		
	CLEAR (p-b1, p);
	CLEAR (b1, p);

	b1 = b*3;
	if (b1 > p) b1 -= p;
	if (b1 > p) b1 -= p;

	CLEAR (p-b1, p);
}

static void Remove_BI3_tiny (const __int64 &p, __int64 b) 
{ 
	bool self_dividing;
	int i;
	min_kp = (mode & MODE_PRIMORIAL) ? (p - 1)/tinyPrimorial : (p - 1)/base_power_n;
	min_km = (mode & MODE_PRIMORIAL) ? (p + 1)/tinyPrimorial : (p + 1)/base_power_n;
	b_array[0] = b;
	self_dividing = (p-b == min_kp || b == min_km);

	for (i = 1; i < len3plus; i++) 
	{ 
		HALVE_B 
		b_array[i] = b; 
		self_dividing = self_dividing || (p-b == min_kp || b == min_km);
	} 

	for (i = 0; i < len3plus; i++) 
	{ 
	    if (self_dividing) {
		CLEAR (p-b_array[i] + p, p); 
		CLEAR (b_array[i] + p, p); 
	    }
	    else {
		CLEAR (p-b_array[i], p); 
		CLEAR (b_array[i], p); 
	    }
	} 
} 

/*********************
 * The following routines do the work for each type of sieve.
 * Yet again we use a pointer to a function.
 *********************/

static unsigned *baseinverses;

static void (*workprocedure) (const __int64 &p);

// This is set to true the first time into a sieve. It allows any extra initialisation
// to be performed by the work routine. It is left up to the work routine to set it to
// false.

static bool fFirstTime;

/**********************
 * These routines do the fixed k sieves.
 **********************/

int Kroneker (__int64 a, __int64 p)
{
	int k = 1;
	static int tab2[8] = {0,1,0,-1,0,-1,0,1};
	int v;

	for (;;)
	{
		if (a == 0) 
		{
			if (p > 1) return 0;
			if (p == 1) return k;
		}
		v = 0;
		while (!(a&1))
		{
			v++;
			a>>=1;
		}
		if (v&1)
		{
			k *= tab2[p&7];
		}
		if (a&p&2) k = -k;

		__int64 r = (a<0) ? -a : a;
		a = p%r;
		p = r;
	}
}

EXTERNC	unsigned int nPackPrimorial;
EXTERNC	unsigned __int64 PackPrimorial[20000];

#ifndef __GNUC__
#define BITMAPAND  0x1FFFF
#else
#define BITMAPAND  "0x1FFFF"
static __int64 num_i64rem asm("num");
static unsigned den_i64rem asm("den");
static unsigned retval;
#endif
#define BITMAPSIZE 0x01000

static unsigned i64rem (__int64 num, unsigned den) // returns num%den
{

#ifndef __GNUC__

	unsigned retval;

	_asm
	{
		cmp dword ptr num+4, 0
		je  notlarge

		mov eax, 0
		mov edx, 1
		div dword ptr den
		mov ebx, edx

		mov edx, 0
		mov eax, dword ptr num+4
		div dword ptr den

		mov eax, edx
		mul ebx

		add eax, dword ptr num
		adc edx, 0

		div dword ptr den
		mov dword ptr retval, edx
		jmp end

notlarge:
		mov eax, dword ptr num
		mov edx, 0
		div dword ptr den
		mov dword ptr retval, edx
end:
	}

#else

num_i64rem = num;
den_i64rem = den;

asm(		".intel_syntax noprefix");
asm(		"cmp dword ptr num+4, 0");
asm(		"je  notlarge");

asm(		"mov eax, 0");
asm(		"mov edx, 1");
asm(		"div dword ptr den");
asm(		"mov ebx, edx");

asm(		"mov edx, 0");
asm(		"mov eax, dword ptr num+4");
asm(		"div dword ptr den");

asm(		"mov eax, edx");
asm(		"mul ebx");

asm(		"add eax, dword ptr num");
asm(		"adc edx, 0");

asm(		"div dword ptr den");
asm(		"mov dword ptr retval, edx");
asm(		"jmp end");

asm("notlarge:");
asm(		"mov eax, dword ptr num");
asm(		"mov edx, 0");
asm(		"div dword ptr den");
asm(		"mov dword ptr retval, edx");
asm("end:");
asm(		".att_syntax" );

#endif

	return retval;
}

// This finds Kroneker (a|b). Since p is prime this will be the Legendre Symbol
// See Cohen, "A course in computational algebraic number theory"

static int FastKroneker (int a, __int64 p)
{
	int k = 1;
	static int tab2[8] = {0,1,0,-1,0,-1,0,1};
	int v;

	v = 0;
	while (!(a&1))
	{
		v++;
		a >>= 1;
	}
	if (v&1) k *= tab2[p&7];

	if (a&p&2) k = -k;

    int r;

    if (mode & MODE_MINUS)
	    r = a;
    else
	    r = -a;						// If a<0

	a = i64rem (p,r);

	while (a)
	{
		v = 0;
		while (!(a&1))
		{
			v++;
			a>>=1;
		}
		if (v&1) k *= tab2[r&7];
		if (a&r&2) k = -k;

		int r1 = a;
		a = r%r1;
		r = r1;
	}

	if (r == 1) return k;
	return 0;
}

int gcd (int a, int b)
{
	int t = a%b;

	while (t)
	{
		a = b;
		b = t;
		t = a%b;
	}
	return b;
}

extern bool fFPURoundDown;
#define FPUROUNDDOWN {if (!fFPURoundDown) {fFPURoundDown = true; _control87 (_RC_DOWN, _MCW_RC); }}

#ifdef __GNUC__

// These variable must be external, or at least static,
// to be seen by GNUC assembler code.

	__int64 halftoarange, halftoMinNum;
static	__int64 p;
static	__int64 kdiff;
	__int64 res64b;
static	__int64 startk;
static	__int64 *R0;
static	unsigned *R0miss;
static	unsigned *Bitmap2andR0Hash;
static	unsigned a,b;
static	unsigned arange, brange, maxval;
static	unsigned int firstbit; 
static	unsigned int nvalue1; 
static	unsigned int firstbit3; 
static	unsigned int nvalue3; 
static	int adiff;
static	unsigned astart;
	float	factor = 5.0;

#endif

// This does the work.
static void Base2KSieve ()
{
    unsigned RateAnd = 65536;

#ifndef __GNUC__

	__int64 halftoarange, halftoMinNum;
	__int64 p;
	__int64 kdiff;
	__int64 res64b;
	__int64 startk;
	__int64 *R0;
	unsigned *R0miss;
	unsigned *Bitmap2andR0Hash;
	unsigned a, b;
	unsigned arange, brange, maxval;
	unsigned int firstbit; 
	unsigned int nvalue1; 
	unsigned int firstbit3; 
	unsigned int nvalue3; 
	int adiff;
    unsigned astart;
    float factor = 5.0;

#endif

	int KronekerK;
	unsigned int last_pandexpn = (unsigned int)(firstp&RateAnd);
	time_t WriteIterationsTime = time (NULL) + 60*WriteIterations;

    int i;

    int last = 0;

    adiff = 0;
    astart = 0;

    for (i = 1; i <= MaxNum-MinNum; i++)
    {
        if (GetBit (i))
        {
            astart = i;

            if (adiff)
            {
                adiff = gcd (adiff, i-last);
                if (adiff == 1) break;
            }
            else
            {
                adiff = i-last;
            }
            last = i;
        }
    }
	if (adiff == 0) adiff = 1;

	if (adiff > 48 && !(adiff%48)) adiff = 48;
	while (adiff > 48 && !(adiff%2)) adiff /= 2;
	while (adiff > 48 && !(adiff%3)) adiff /= 3;
	while (adiff > 48 && !(adiff%5)) adiff /= 5;
	while (adiff > 48 && !(adiff%7)) adiff /= 7;
	if (adiff > 48)
	{
		fprint ("Cannot reduce gcd value of %d", adiff);
		return;
	}
	astart %= adiff;

	int maxpow = (int)(60-log(nvalue)/log(2));
	if (astart > (unsigned)maxpow)
	{
		if (!(adiff%maxpow)) adiff = maxpow;

		while (adiff > maxpow && !(adiff%2)) adiff /= 2;
		while (adiff > maxpow && !(adiff%3)) adiff /= 3;
		while (adiff > maxpow && !(adiff%5)) adiff /= 5;
		while (adiff > maxpow && !(adiff%7)) adiff /= 7;
		if (adiff > maxpow)
		{
			fprint ("Cannot reduce gcd value of %d", adiff);
			return;
		}
		astart %= adiff;
	}

    startk = nvalue;
	startk <<= astart;
	kdiff = 1;
	kdiff <<= adiff;

	if (MaxNum < MinNum) return;

	if (firstp < 2) firstp = 2;
	soe2_init (firstp, true);

	maxval = (unsigned)(1+MaxNum-MinNum);

#ifndef __GNUC__

	_asm
	{
		fild dword ptr maxval
		fld factor
		fmul
		fsqrt
		fistp dword ptr arange
	}

#else

asm("		.intel_syntax noprefix");
asm("		fild dword ptr maxval");
asm("		fld dword ptr factor");
asm("		fmulp");
asm("		fsqrt");
asm("		fistp dword ptr arange");
asm("		.att_syntax");

#endif

	while (arange%adiff) arange++;

	brange = 1+maxval/arange;

	R0 = (__int64 *)calloc (brange, sizeof (__int64));
	R0miss = (unsigned *)calloc (brange, sizeof (unsigned));
	Bitmap2andR0Hash = (unsigned *)calloc (BITMAPSIZE*2, sizeof (unsigned));

	firstbit = 0x80000000;
	nvalue1 = (unsigned)MinNum;
	while ((nvalue1 & firstbit) == 0) firstbit >>= 1;
	firstbit >>= 1;

	firstbit3 = 0x80000000;
	nvalue3 = arange;
	while ((nvalue3 & firstbit3) == 0) firstbit3 >>= 1;
	firstbit3 >>= 1;

	// OK, lets do the work

	bool fThreeDivides;

	if (nvalue >= 1073741824)
	{
		// -2k is too large to fit in a 32 bit signed integer!
		KronekerK = 0;
//		else		KronekerK = 1;
	}
	else if (nvalue%3)
	{
		if (mode & MODE_MINUS)
		{
			KronekerK = (3-(nvalue%3))*nvalue;
		}
		else
		{
			KronekerK = (nvalue%3)*nvalue;
			KronekerK = -KronekerK;
		}
		fThreeDivides = false;
	}
	else
	{
		KronekerK = nvalue;
		if (mode & MODE_PLUS)
		{
			KronekerK = -KronekerK;
		}
		fThreeDivides = true;
	}

#ifndef __GNUC__

	if (maxp > 0xFFFFFFFFFFFF) maxp = 0xFFFFFFFFFFFF;

#else

	if (maxp > 0xFFFFFFFFFFFFLL) maxp = 0xFFFFFFFFFFFFLL;

#endif

    time_t LastNow = time (NULL);
    bool fReport = true;

	for (;;)
	{
		__int64 removed = 0;

		p = soe2_next ();

		if (((unsigned)p&RateAnd) != last_pandexpn || !(State & 3) || p >= maxp)
		{
            fReport = true;

			if (p < MILLION)
			{
				fprint ("#sSieved up to "LL_FORMAT"", p);
			}
			else
			{
                double num;
                char *format;

				if (p > MILLION) {num = p /1000000.0; format = "million";}
				if (p > BILLION) {num = p /1000000000.0; format = "billion";}
				if (p > TRILLION) {num = p /1000000000000.0; format = "trillion";}

				fprint ("#sSieved up to "LL_FORMAT" (%.1f %s)", p, num-0.05, format);
			}

			time_t Now = time (NULL);

            if (Now == LastNow && RateAnd < 0x10000000) RateAnd <<= 1;
            if (Now > LastNow+2 && RateAnd > 1) RateAnd >>= 1;
            LastNow = Now;
			last_pandexpn = (unsigned)p&RateAnd;

			if (State == 2 && StopCriterion == DATETIME && Now > StopTime + StopValue*3600)
			{
				State = 0;
			}

			if (((State == 2 || State == 1) && Now > WriteIterationsTime) || (State != 2 && State != 1) || p >= maxp)
			{
				if ((State != 2 && State != 1) || p >= maxp || (State == 2 && StopCriterion == DATETIME && Now > StopTime + StopValue*3600))
				{
					outputandtidyvals (p, outbuff, false);

					if (State != 1)
					{
						fprint ("#oOutput file '%s' generated, contains %u %c's", outbuff, nvalsleft, k_n); 
					}
					firstp = p;
					return;
				}
				else
				{
					WriteIterationsTime = Now + 60*WriteIterations;
					outputandtidyvals (p, outbuff, fAppend);
				}
			}
		}

		if (p != 3 && KronekerK)
		{
			if (fThreeDivides)
			{
				if (FastKroneker (KronekerK, p) != 1 && 
					FastKroneker (KronekerK<<1, p) != 1)
					continue;
			}
			else
			{
				if (FastKroneker (KronekerK, p) != 1) continue;
			}
		}

        FPUROUNDDOWN;

		// Get the common values required by all k values

#ifndef __GNUC__

		_asm
		{
			fild	QWORD PTR p
			fld1
			fdivrp	ST(1), ST(0)

			mov		eax, DWORD PTR p
			mov		edx, DWORD PTR p+4
			add		eax, 1
			adc		edx, 0
			shr		edx, 1
			rcr		eax, 1

			mov		DWORD PTR halftoMinNum, eax
			mov		DWORD PTR halftoarange, eax
			mov		DWORD PTR halftoMinNum+4, edx
			mov		DWORD PTR halftoarange+4, edx

			mov		ecx, DWORD PTR firstbit
			mov		ebx, DWORD PTR nvalue1

			cmp		firstbit, 0
			je		FClabel3a	

		FCloop0:
			fild	QWORD PTR halftoMinNum
			mul		eax
			fmul	ST(0), ST(0)
			mov		esi, eax
			mov		edi, edx
			mov		eax, DWORD PTR halftoMinNum
			fmul	ST(0), ST(1)
			mul		DWORD PTR halftoMinNum+4
			fistp	QWORD PTR halftoMinNum
			add		edi, eax
			add		edi, eax
			mov		eax, DWORD PTR p
			mul		DWORD PTR halftoMinNum
			sub		esi, eax
			sbb		edi, edx
			mov		eax, DWORD PTR p+4
			mul		DWORD PTR halftoMinNum
			sub		edi, eax
			mov		eax, DWORD PTR p
			mul		DWORD PTR halftoMinNum+4
			sub		edi, eax
			mov		eax, esi

			test	ecx, ebx
			je		FClabel3

			mov		edx, edi
			add		esi, dword ptr p
			adc		edx, dword ptr p+4

			test	eax, 1

			cmovnz	eax, esi
			cmovnz	edi, edx

			shr		edi, 1
			rcr		eax, 1
			
		FClabel3:
			mov		DWORD PTR halftoMinNum, eax
			mov		DWORD PTR halftoMinNum+4, edi
			shr		ecx, 1
			jne		FCloop0

		FClabel3a:
			mov		eax, DWORD PTR halftoarange

			mov		ecx, DWORD PTR firstbit3
			mov		ebx, DWORD PTR nvalue3
		FCloop1:
			fild	QWORD PTR halftoarange
			mul		eax
			fmul	ST(0), ST(0)
			mov		esi, eax
			mov		edi, edx
			mov		eax, DWORD PTR halftoarange
			fmul	ST(0), ST(1)
			mul		DWORD PTR halftoarange+4
			fistp	QWORD PTR halftoarange
			add		edi, eax
			add		edi, eax
			mov		eax, DWORD PTR p
			mul		DWORD PTR halftoarange
			sub		esi, eax
			sbb		edi, edx
			mov		eax, DWORD PTR p+4
			mul		DWORD PTR halftoarange
			sub		edi, eax
			mov		eax, DWORD PTR p
			mul		DWORD PTR halftoarange+4
			sub		edi, eax
			mov		eax, esi

			test	ecx, ebx
			je		FClabel7

			mov		edx, edi
			add		esi, dword ptr p
			adc		edx, dword ptr p+4

			test	eax, 1

			cmovnz	eax, esi
			cmovnz	edi, edx
			shr		edi, 1
			rcr		eax, 1
			
		FClabel7:
			mov		DWORD PTR halftoarange, eax
			mov		DWORD PTR halftoarange+4, edi
			shr		ecx, 1
			jne		FCloop1

		// The above assembler has left 1/p on the FPU stack.
	
			test	mode, MODE_MINUS
			jnz		NoNegate

		// Negate halftoMinNum: halftoMinNum = p-halftoMinNum

			mov eax, dword ptr p
			mov	ecx, dword ptr halftoMinNum
			mov ebx, dword ptr p+4
			mov	edx, dword ptr halftoMinNum+4

			sub	eax, ecx
			sbb ebx, edx

			mov dword ptr halftoMinNum, eax
			mov dword ptr halftoMinNum+4, ebx

NoNegate:
		// OK, lets do the 'b' loop

			xor		esi, esi

			fild	qword ptr halftoarange
			fmul	st(0), st(1)

		TopOfBLoop:

			mov		eax, dword ptr R0
			mov		ecx, dword ptr halftoMinNum
			mov		edi, dword ptr halftoMinNum+4
			fild	qword ptr halftoMinNum
	
			mov		dword ptr [eax+esi*8], ecx 
			mov		dword ptr [eax+esi*8+4], edi

			and		ecx, BITMAPAND
			mov		edi, ecx
			shr		edi, 5

			mov		eax, dword ptr Bitmap2andR0Hash
			lea		edi, [eax+edi*8]
			fmul	st(0), st(1)

			mov		ebx, 1
			shl		ebx, cl
			or		dword ptr [edi], ebx
			
			// Bit set now. Now do the next byte.

			mov		edx, dword ptr R0miss
			mov		eax, dword ptr [edi+4]
			mov		dword ptr [edx+esi*4], eax

			and		eax, 0xFFFF
			mov		ebx, esi
			shl		ebx, 16
			or		eax, ebx
			mov		dword ptr [edi+4], eax

			fistp	qword ptr res64b
			
			mov		eax, dword ptr res64b			// pre-fetch

		// halftoMinNum *= halftoarange (mod p)
			mov		eax, dword ptr halftoMinNum
			mul		dword ptr halftoarange
			mov		ecx, eax
			mov		eax, dword ptr halftoMinNum	
			mov		edi, edx
			mul		dword ptr halftoarange+4
			add		edi, eax
			mov		eax, dword ptr halftoMinNum+4
			mul		dword ptr halftoarange
			add		edi, eax
			mov		eax, dword ptr p
			mul		dword ptr res64b
			sub		ecx, eax
			sbb		edi, edx
			mov		eax, dword ptr p+4
			mul		dword ptr res64b
			sub		edi, eax
			mov		eax, dword ptr p
			mul		dword ptr res64b+4
			sub		edi, eax

			mov		dword ptr halftoMinNum, ecx
			mov		dword ptr halftoMinNum+4, edi


			// End of loop:
			mov		edx, dword ptr brange
			inc		esi
			cmp		esi, edx
			jb		TopOfBLoop

			fstp	st(0)

		// OK Now for the baby-steps loop!

			mov		ebx, dword ptr astart
			mov		dword ptr a, ebx

			// Mod reduce startk by p....

			fild	qword ptr startk
			mov		eax, dword ptr startk
			xor		edi, edi
			fmul	st(0), st(1)
			fistp	qword ptr res64b
			add		edi, 0
			mov		eax, dword ptr startk+4
			mov		esi, dword ptr startk
			add		edi, eax
			mov		eax, dword ptr p
			mul		dword ptr res64b
			sub		esi, eax
			sbb		edi, edx
			mov		eax, dword ptr p+4
			mul		dword ptr res64b
			sub		edi, eax
			mov		eax, dword ptr p
			mul		dword ptr res64b+4
			sub		edi, eax

			mov		eax, esi
			mov		edx, edi

			// OK, lets go!
TopOfALoop:
			mov		ebx, dword ptr Bitmap2andR0Hash
			mov		edi, eax
			and		edi, BITMAPAND
			shr		edi, 5
			lea		edi, [ebx+edi*8]
			mov		ebx, dword ptr [edi]
			mov		ecx, eax

			mov		esi, 1
			shl		esi, cl
			test	ebx, esi
			jne		TestIt

DoubleIt:
			cmp		dword ptr adiff, 24
			ja		DoubleByMultiply

			mov		ecx, dword ptr adiff
			add		dword ptr a, ecx

DoubleByDouble:
			add		eax, eax
			adc		edx, edx

			mov		esi, eax
			mov		edi, edx

			sub		esi, dword ptr p
			sbb		edi, dword ptr p+4

			cmovnb	eax, esi
			cmovnb	edx, edi

			dec		ecx
			jnz		DoubleByDouble

			mov		ecx, dword ptr arange
			cmp		dword ptr a, ecx
			jae		EndOfKLoop

            jmp 	TopOfALoop

DoubleByMultiply:

			// Find edx:eax * kdiff (mod p) 
			mov		dword ptr res64b, eax
			mov		dword ptr res64b+4, edx
			fild	qword ptr res64b

			mov		esi, dword ptr res64b		// pre-fetch; avoiding penalty

			fild	qword ptr kdiff
			mul		dword ptr kdiff
			fmul	
			mov		esi, eax
			mov		eax, dword ptr res64b
			mov		edi, edx
			fmul	st(0), st(1)
			mul		dword ptr kdiff+4
			add		edi, eax
			mov		eax, dword ptr res64b+4
			mul		dword ptr kdiff
			fistp	qword ptr res64b
			add		edi, eax
			mov		eax, dword ptr p
			mul		dword ptr res64b
			sub		esi, eax
			sbb		edi, edx
			mov		eax, dword ptr p+4
			mul		dword ptr res64b
			sub		edi, eax
			mov		eax, dword ptr p
			mul		dword ptr res64b+4
			sub		edi, eax

			mov		eax, esi
			mov		edx, edi

//AfterDoubles:
			mov		ecx, dword ptr arange
			mov		ebx, dword ptr adiff
			add		dword ptr a, ebx
			cmp		dword ptr a, ecx
			jae		EndOfKLoop

            jmp 	TopOfALoop

TestIt:

			// OK, we have got a bitmap hit.
			mov		ebx, dword ptr [edi+4]
			mov		edi, dword ptr R0
			mov		ecx, ebx
			and		ebx, 0xFFFF
			shr		ecx, 16
			mov		esi, dword ptr [edi+ebx*8]
			mov		edi, dword ptr [edi+ebx*8+4]
			xor		esi, eax
			xor		edi, edx
			or		esi, edi
			jnz		AfterHit1

			mov		dword ptr b, ebx
			pushad
		}

#else

asm(			".intel_syntax noprefix");

// Using already defined global

asm("mode 		= 		_mode");
asm("			fildq		p");
asm("			fld1		");
asm("			fdivrp		ST(1), ST(0)");

asm("			mov		eax, DWORD PTR p");
asm("			mov		edx, DWORD PTR p+4");
asm("			add		eax, 1");
asm("			adc		edx, 0");
asm("			shr		edx, 1");
asm("			rcr		eax, 1");

asm("			mov		DWORD PTR halftoMinNum, eax");
asm("			mov		DWORD PTR halftoarange, eax");
asm("			mov		DWORD PTR halftoMinNum+4, edx");
asm("			mov		DWORD PTR halftoarange+4, edx");

asm("			mov		ecx, DWORD PTR firstbit");
asm("			mov		ebx, DWORD PTR nvalue1");

asm("			cmp		DWORD PTR firstbit, 0");
asm("			je		FClabel3a");

asm("FCloop0:");
asm("			fildq		halftoMinNum");
asm("			mul		eax");
asm("			fmul		ST(0), ST(0)");
asm("			mov		esi, eax");
asm("			mov		edi, edx");
asm("			mov		eax, DWORD PTR halftoMinNum");
asm("			fmul		ST(0), ST(1)");
asm("			mul		DWORD PTR halftoMinNum+4");
asm("			fistpq		halftoMinNum");
asm("			add		edi, eax");
asm("			add		edi, eax");
asm("			mov		eax, DWORD PTR p");
asm("			mul		DWORD PTR halftoMinNum");
asm("			sub		esi, eax");
asm("			sbb		edi, edx");
asm("			mov		eax, DWORD PTR p+4");
asm("			mul		DWORD PTR halftoMinNum");
asm("			sub		edi, eax");
asm("			mov		eax, DWORD PTR p");
asm("			mul		DWORD PTR halftoMinNum+4");
asm("			sub		edi, eax");
asm("			mov		eax, esi");

asm("			test		ecx, ebx");
asm("			je		FClabel3");

asm("			mov		edx, edi");
asm("			add		esi, dword ptr p");
asm("			adc		edx, dword ptr p+4");

asm("			test		eax, 1");

asm("			cmovnz		eax, esi");
asm("			cmovnz		edi, edx");

asm("			shr		edi, 1");
asm("			rcr		eax, 1");

asm("FClabel3:");
asm("			mov		DWORD PTR halftoMinNum, eax");
asm("			mov		DWORD PTR halftoMinNum+4, edi");
asm("			shr		ecx, 1");
asm("			jne		FCloop0");

asm("FClabel3a:");
asm("			mov		eax, DWORD PTR halftoarange");

asm("			mov		ecx, DWORD PTR firstbit3");
asm("			mov		ebx, DWORD PTR nvalue3");
asm("FCloop1:");
asm("			fildq		halftoarange");
asm("			mul		eax");
asm("			fmul		ST(0), ST(0)");
asm("			mov		esi, eax");
asm("			mov		edi, edx");
asm("			mov		eax, DWORD PTR halftoarange");
asm("			fmul		ST(0), ST(1)");
asm("			mul		DWORD PTR halftoarange+4");
asm("			fistpq		halftoarange");
asm("			add		edi, eax");
asm("			add		edi, eax");
asm("			mov		eax, DWORD PTR p");
asm("			mul		DWORD PTR halftoarange");
asm("			sub		esi, eax");
asm("			sbb		edi, edx");
asm("			mov		eax, DWORD PTR p+4");
asm("			mul		DWORD PTR halftoarange");
asm("			sub		edi, eax");
asm("			mov		eax, DWORD PTR p");
asm("			mul		DWORD PTR halftoarange+4");
asm("			sub		edi, eax");
asm("			mov		eax, esi");

asm("			test		ecx, ebx");
asm("			je		FClabel7");

asm("			mov		edx, edi");
asm("			add		esi, dword ptr p");
asm("			adc		edx, dword ptr p+4");

asm("			test	eax, 1");

asm("			cmovnz	eax, esi");
asm("			cmovnz	edi, edx");
asm("			shr		edi, 1");
asm("			rcr		eax, 1");

asm("FClabel7:");
asm("			mov		DWORD PTR halftoarange, eax");
asm("			mov		DWORD PTR halftoarange+4, edi");
asm("			shr		ecx, 1");
asm("			jne		FCloop1");

		// The above assembler has left 1/p on the FPU stack.

asm("			test		DWORD PTR mode, "MODE_MINUS_GNUC"");
asm("			jnz		NoNegate");

		// Negate halftoMinNum: halftoMinNum = p-halftoMinNum

asm("			mov eax, dword ptr p");
asm("			mov	ecx, dword ptr halftoMinNum");
asm("			mov ebx, dword ptr p+4");
asm("			mov	edx, dword ptr halftoMinNum+4");

asm("			sub	eax, ecx");
asm("			sbb ebx, edx");

asm("			mov dword ptr halftoMinNum, eax");
asm("			mov dword ptr halftoMinNum+4, ebx");

asm("NoNegate:");

		// OK, lets do the 'b' loop

asm("			xor		esi, esi");

asm("			fildq		halftoarange");
asm("			fmul		st(0), st(1)");

asm("TopOfBLoop:");

asm("			mov		eax, dword ptr R0");
asm("			mov		ecx, dword ptr halftoMinNum");
asm("			mov		edi, dword ptr halftoMinNum+4");
asm("			fildq		halftoMinNum");

asm("			mov		dword ptr [eax+esi*8], ecx ");
asm("			mov		dword ptr [eax+esi*8+4], edi");

asm("			and		ecx, "BITMAPAND"");
asm("			mov		edi, ecx");
asm("			shr		edi, 5");

asm("			mov		eax, dword ptr Bitmap2andR0Hash");
asm("			lea		edi, [eax+edi*8]");
asm("			fmul		st(0), st(1)");

asm("			mov		ebx, 1");
asm("			shl		ebx, cl");
asm("			or		dword ptr [edi], ebx");

			// Bit set now. Now do the next byte.

asm("			mov		edx, dword ptr R0miss");
asm("			mov		eax, dword ptr [edi+4]");
asm("			mov		dword ptr [edx+esi*4], eax");

asm("			and		eax, 0xFFFF");
asm("			mov		ebx, esi");
asm("			shl		ebx, 16");
asm("			or		eax, ebx");
asm("			mov		dword ptr [edi+4], eax");

asm("			fistpq	res64b");

asm("			mov		eax, dword ptr res64b");

		// pre-fetch
		// halftoMinNum *= halftoarange (mod p)

asm("			mov		eax, dword ptr halftoMinNum");
asm("			mul		dword ptr halftoarange");
asm("			mov		ecx, eax");
asm("			mov		eax, dword ptr halftoMinNum");
asm("			mov		edi, edx");
asm("			mul		dword ptr halftoarange+4");
asm("			add		edi, eax");
asm("			mov		eax, dword ptr halftoMinNum+4");
asm("			mul		dword ptr halftoarange");
asm("			add		edi, eax");
asm("			mov		eax, dword ptr p");
asm("			mul		dword ptr res64b");
asm("			sub		ecx, eax");
asm("			sbb		edi, edx");
asm("			mov		eax, dword ptr p+4");
asm("			mul		dword ptr res64b");
asm("			sub		edi, eax");
asm("			mov		eax, dword ptr p");
asm("			mul		dword ptr res64b+4");
asm("			sub		edi, eax");

asm("			mov		dword ptr halftoMinNum, ecx");
asm("			mov		dword ptr halftoMinNum+4, edi");

			// End of loop:

asm("			mov		edx, dword ptr brange");
asm("			inc		esi");
asm("			cmp		esi, edx");
asm("			jb		TopOfBLoop");

asm("			fstp		st(0)");

			// OK Now for the baby-steps loop!

asm("			mov		ebx, dword ptr astart");
asm("			mov		dword ptr a, ebx");

			// Mod reduce startk by p....

asm("			fildq		startk");
asm("			mov		eax, dword ptr startk");
asm("			xor		edi, edi");
asm("			fmul		st(0), st(1)");
asm("			fistpq		res64b");
asm("			add		edi, 0");
asm("			mov		eax, dword ptr startk+4");
asm("			mov		esi, dword ptr startk");
asm("			add		edi, eax");
asm("			mov		eax, dword ptr p");
asm("			mul		dword ptr res64b");
asm("			sub		esi, eax");
asm("			sbb		edi, edx");
asm("			mov		eax, dword ptr p+4");
asm("			mul		dword ptr res64b");
asm("			sub		edi, eax");
asm("			mov		eax, dword ptr p");
asm("			mul		dword ptr res64b+4");
asm("			sub		edi, eax");

asm("			mov		eax, esi");
asm("			mov		edx, edi");

			// OK, lets go!
asm("TopOfALoop:");
asm("			mov		ebx, dword ptr Bitmap2andR0Hash");
asm("			mov		edi, eax");
asm("			and		edi, "BITMAPAND"");
asm("			shr		edi, 5");
asm("			lea		edi, [ebx+edi*8]");
asm("			mov		ebx, dword ptr [edi]");
asm("			mov		ecx, eax");

asm("			mov		esi, 1");
asm("			shl		esi, cl");
asm("			test		ebx, esi");
asm("			jne		TestIt");

asm("DoubleIt:");
asm("			cmp		dword ptr adiff, 24");
asm("			ja		DoubleByMultiply");

asm("			mov		ecx, dword ptr adiff");
asm("			add		dword ptr a, ecx");

asm("DoubleByDouble:");
asm("			add		eax, eax");
asm("			adc		edx, edx");

asm("			mov		esi, eax");
asm("			mov		edi, edx");

asm("			sub		esi, dword ptr p");
asm("			sbb		edi, dword ptr p+4");

asm("			cmovnb		eax, esi");
asm("			cmovnb		edx, edi");

asm("			dec		ecx");
asm("			jnz		DoubleByDouble");

asm("			mov		ecx, dword ptr arange");
asm("			cmp		dword ptr a, ecx");
asm("			jae		EndOfKLoop");

asm("			jmp 		TopOfALoop");

asm("DoubleByMultiply:");

			// Find edx:eax * kdiff (mod p) 

asm("			mov		dword ptr res64b, eax");
asm("			mov		dword ptr res64b+4, edx");
asm("			fildq		res64b");

asm("			mov		esi, dword ptr res64b");

			//pre-fetch ; avoiding penalty

asm("			fildq		kdiff");
asm("			mul		dword ptr kdiff");
asm("			fmulp		");
asm("			mov		esi, eax");
asm("			mov		eax, dword ptr res64b");
asm("			mov		edi, edx");
asm("			fmul		st(0), st(1)");
asm("			mul		dword ptr kdiff+4");
asm("			add		edi, eax");
asm("			mov		eax, dword ptr res64b+4");
asm("			mul		dword ptr kdiff");
asm("			fistpq		res64b");
asm("			add		edi, eax");
asm("			mov		eax, dword ptr p");
asm("			mul		dword ptr res64b");
asm("			sub		esi, eax");
asm("			sbb		edi, edx");
asm("			mov		eax, dword ptr p+4");
asm("			mul		dword ptr res64b");
asm("			sub		edi, eax");
asm("			mov		eax, dword ptr p");
asm("			mul		dword ptr res64b+4");
asm("			sub		edi, eax");

asm("			mov		eax, esi");
asm("			mov		edx, edi");

//AfterDoubles:

asm("			mov		ecx, dword ptr arange");
asm("			mov		ebx, dword ptr adiff");
asm("			add		dword ptr a, ebx");
asm("			cmp		dword ptr a, ecx");
asm("			jae		EndOfKLoop");

asm("			jmp 	TopOfALoop");

asm("TestIt:");

			// OK, we have got a bitmap hit.

asm("			mov		ebx, dword ptr [edi+4]");
asm("			mov		edi, dword ptr R0");
asm("			mov		ecx, ebx");
asm("			and		ebx, 0xFFFF");
asm("			shr		ecx, 16");
asm("			mov		esi, dword ptr [edi+ebx*8]");
asm("			mov		edi, dword ptr [edi+ebx*8+4]");
asm("			xor		esi, eax");
asm("			xor		edi, edx");
asm("			or		esi, edi");
asm("			jnz		AfterHit1");

asm("			mov		dword ptr b, ebx");
asm("			pushad		");
asm("			.att_syntax" );


#endif

		if (a+b*arange < maxval && GetBit (a+b*arange))
		{
			ClearBit (a+b*arange);
			removed = MinNum+a+b*arange;

			if (LogDeleted && p > 1000000)
			{
				FILE *fptr;
				do
				{
					fptr = fopen ("NewPGen.del", "a");
					if (fptr == NULL) Sleep (10);
				} while (fptr == NULL);
				fprintf (fptr, "p="LL_FORMAT" divides n="LL_FORMAT"\n", p, removed);
				fclose (fptr);
			}
			nvalsleft--;
		}

#ifndef __GNUC__

		_asm
		{
			popad

			AfterHit1:
			test	ecx, ecx
			je		DoubleIt

			// We have got another b value to try...
			mov		edi, dword ptr R0
			mov		ebx, dword ptr R0miss
			mov		esi, dword ptr [edi+ecx*8]
			mov		edi, dword ptr [edi+ecx*8+4]
			mov		ebx, dword ptr [ebx+ecx*4]
			xor		esi, eax
			xor		edi, edx
			or		esi, edi
			jnz		AfterHit2

			mov		dword ptr b, ecx
		
			WhileLoop:

			pushad
		}

#else

asm("			.intel_syntax noprefix");
asm("			popad		");

asm("AfterHit1:");
asm("			test		ecx, ecx");
asm("			je		DoubleIt");

			// We have got another b value to try...

asm("			mov		edi, dword ptr R0");
asm("			mov		ebx, dword ptr R0miss");
asm("			mov		esi, dword ptr [edi+ecx*8]");
asm("			mov		edi, dword ptr [edi+ecx*8+4]");
asm("			mov		ebx, dword ptr [ebx+ecx*4]");
asm("			xor		esi, eax");
asm("			xor		edi, edx");
asm("			or		esi, edi");
asm("			jnz		AfterHit2");

asm("			mov		dword ptr b, ecx");

asm("WhileLoop:");

asm("			pushad		");
asm("			.att_syntax" );

#endif

		if (a+b*arange < maxval && GetBit (a+b*arange))
		{
			ClearBit (a+b*arange);
			removed = MinNum+a+b*arange;

			if (LogDeleted && p > 1000000)
			{
				FILE *fptr;
				do
				{
					fptr = fopen ("NewPGen.del", "a");
					if (fptr == NULL) Sleep (10);
				} while (fptr == NULL);
				fprintf (fptr, "p="LL_FORMAT" divides n="LL_FORMAT"\n", p, removed);
				fclose (fptr);
			}
			nvalsleft--;
		}

#ifndef __GNUC__

		_asm
		{
			popad

			AfterHit2:

			shr		ebx, 16
			test	ebx, ebx
			je		DoubleIt

			mov		edi, dword ptr R0
			mov		ecx, dword ptr R0miss
			mov		esi, dword ptr [edi+ebx*8]
			mov		edi, dword ptr [edi+ebx*8+4]
			mov		dword ptr b, ebx
			mov		ebx, dword ptr [ecx+ebx*4]
			xor		esi, eax
			xor		edi, edx
			or		esi, edi
			jnz		AfterHit2

			jmp		WhileLoop

		EndOfKLoop:

			fstp	st(0)

		// Clean up

			mov		esi, dword ptr R0
			mov		edi, dword ptr Bitmap2andR0Hash
			xor		ecx, ecx
			
			align 16

TopOfClearLoop:
			mov		eax, dword ptr [esi+ecx*8]
			and		eax, BITMAPAND
			shr		eax, 5
			mov		dword ptr [edi+eax*8], 0
			mov		dword ptr [edi+eax*8+4], 0

			inc		ecx
			cmp		ecx, dword ptr brange
			jb		TopOfClearLoop

		}

#else

asm("			.intel_syntax noprefix");
asm("			popad");

asm("AfterHit2:");

asm("			shr		ebx, 16");
asm("			test		ebx, ebx");
asm("			je		DoubleIt");

asm("			mov		edi, dword ptr R0");
asm("			mov		ecx, dword ptr R0miss");
asm("			mov		esi, dword ptr [edi+ebx*8]");
asm("			mov		edi, dword ptr [edi+ebx*8+4]");
asm("			mov		dword ptr b, ebx");
asm("			mov		ebx, dword ptr [ecx+ebx*4]");
asm("			xor		esi, eax");
asm("			xor		edi, edx");
asm("			or		esi, edi");
asm("			jnz		AfterHit2");

asm("			jmp		WhileLoop");

asm("EndOfKLoop:");

asm("			fstp		st(0)");

		// Clean up

asm("			mov		esi, dword ptr R0");
asm("			mov		edi, dword ptr Bitmap2andR0Hash");
asm("			xor		ecx, ecx");

asm("			.align 16");

asm("TopOfClearLoop:");
asm("			mov		eax, dword ptr [esi+ecx*8]");
asm("			and		eax, "BITMAPAND"");
asm("			shr		eax, 5");
asm("			mov		dword ptr [edi+eax*8], 0");
asm("			mov		dword ptr [edi+eax*8+4], 0");

asm("			inc		ecx");
asm("			cmp		ecx, dword ptr brange");
asm("			jb		TopOfClearLoop");
asm("			.att_syntax" );

#endif

		if (removed)
		{
			if (fVerify) Verify (nvalue, removed, p);
			if (fReport)
			{
				ClearReport (time (NULL), p, removed);
				fReport = false;
			}

			if (nvalsleft == 0)
			{
				if (State == 2)
				{
					// Don't stop if generating...
					State = 0;
					print ("#o**** All values removed! You do not need to test these values!!");
					outputandtidyvals (p, outbuff, fAppend);
					print ("##");
					STOPSIEVING;
				}
				else
				{
					if (!AllRemoved)
					{
						print ("#r**** All values removed in this range.");
						AllRemoved = true;
					}
				}
			}
		}

		if (p == 701)
		{
			firstp = 702;
			return;
		}

	}

	free (R0);
	free (R0miss);
	free (Bitmap2andR0Hash);

	return;
}

static void DoKSieve (const __int64 &p)
{
	static unsigned int nvalsleftbefore;	
	static __int64 kvalue;
	static unsigned arange, brange;
	static unsigned maxval, r0size, r0incr;
	static __int64 *r0 = NULL;
	static unsigned int *bitmap2 = NULL;
	static int fKroneker;
	static unsigned int arangefirstbit;
		
	if (fFirstTime)
	{
		fFirstTime = false;

		maxval = (unsigned)(1+MaxNum-MinNum);
		arange = 1+(unsigned)sqrt (maxval);
		brange = 1+maxval/arange;

		arangefirstbit = 0x80000000;
		while ((arange & arangefirstbit) == 0) arangefirstbit >>= 1;
		arangefirstbit >>= 1;

		if (r0) delete[]r0;
		r0 = new __int64[arange];

		if (bitmap2) free (bitmap2);
		bitmap2 = (unsigned int *)calloc (0x40000, 1);

		if (fMyPrimorial)
		{
			fKroneker = 1;

			for (unsigned int i = 0; i < nPackPrimorial; i++)
				fKroneker = (int)mulmodp2 (fKroneker, PackPrimorial[i], 3);
		}
		else if (mode & MODE_PRIMORIAL) 
		{ 
			fKroneker = 0;
		} 
		else 
		{
			fKroneker = nvalue % 3;
		} 
		
		if (mode & MODE_PLUS) fKroneker = -fKroneker;
		else fKroneker = (3-fKroneker)%3; 

		if (mode & MODE_MOREHEAD)
		{
			fKroneker = -2;
		}
	}

	if (mode & MODE_DUAL) 
	{ 
		kvalue = 1; 
	}
	else
	{
		if (fMyPrimorial)
		{
			kvalue = 1;

			for (unsigned int i = 0; i < nPackPrimorial; i++)
			{
				kvalue = mulmodp2 (kvalue, PackPrimorial[i], p);
			}

			if (!kvalue) return;
		}
		else if (mode & MODE_PRIMORIAL) 
		{ 
			kvalue = GetPrimorialModP (p);	// kvalue = nvalue# (mod p) 

			if (!kvalue) return;
		} 
		else 
		{ 
			kvalue = nvalue; 
		} 
 

		if (fKroneker)
		{
			if (p > 3 && Kroneker (fKroneker*kvalue, p) != 1) return; 
		}
		else if (p > 3)
		{
			if (Kroneker (((mode & MODE_MINUS) ? 2 : -2)*kvalue, p) != 1 && 
			    Kroneker (((mode & MODE_MINUS) ? 1 : -1)*kvalue, p) != 1)
			{
				return;
			}
		}
	}

	// Fill r0[].

	__int64 twotou = fastkbasepownmodp (kvalue, (unsigned)MinNum, p);
	if (!(mode & MODE_DUAL) && (mode & MODE_PLUS))
	{
		twotou = p-twotou;
	}

	unsigned a;

	for (a = 0; a < arange; a++)
	{
		r0[a] = twotou;
		bitmap2[(twotou&0x1fffff)>>5] |= onebits[twotou&0x1F];

#ifndef __GNUC__

		_asm
		{
			shl dword ptr twotou, 1
			rcl dword ptr twotou+4, 1
		}

#else


		twotou <<= 1;

#endif
		if (twotou>=p) twotou -= p;
	}

	__int64 r = halfpownmodp (arange, arangefirstbit, p);

	nvalsleftbefore = nvalsleft;
	__int64 removed;

	// r contains (1/2)^arange
	__int64 k = 1;
	if (mode & MODE_DUAL)
	{
		if (mode & MODE_PLUS)
		{
			k = p-nvalue;
			while (k < 0) k += p;
		}
		else
		{
			k = nvalue % p;
		}
	}

	for (unsigned b = 0; b < brange; b++)
	{
		if (bitmap2[(k&0x1fffff)>>5] & onebits[k&0x1F])
		{
			// HIT!!!
			for (a = 0; a < arange; a++)
			{
				if (k == r0[a])
				{
					if (a+b*arange < maxval && GetBit (a+b*arange))
					{
						ClearBit (a+b*arange);
						removed = MinNum + a+b*arange;
						if (LogDeleted && p > 1000000)
						{
							FILE *fptr;
							do
							{
								fptr = fopen ("NewPGen.del", "a");
								if (fptr == NULL) Sleep (10);
							} while (fptr == NULL);
							fprintf (fptr, "p="LL_FORMAT" divides n="LL_FORMAT"\n", p, MinNum+a+b*arange, a, b, arange);
							fclose (fptr);
						}
						nvalsleft--;
					}
				}
			}
		}

		k = mulmodp2 (k, r, p);	// k *= (1/2)^arange (mod p)
	}

	// Clear bitmap
	for (a = 0; a < arange; a++)
	{
		bitmap2[(r0[a]&0x1fffff)>>5] = 0;
	}

	if (nvalsleftbefore == nvalsleft) return;

	if (fVerify)
	{
		Verify (nvalue, (unsigned)removed, p);
	}

	time_t Now;
	time (&Now);

	if (Now != LastTime[rateindex])
	{
		ClearReport (Now, p, removed);
	}

	if (nvalsleft == 0)
	{
		if (State == 2)
		{
			// Don't stop if generating...
			State = 0;
			print ("#o**** All values removed! You do not need to test these values!!");
			outputandtidyvals (p, outbuff, fAppend);
			print ("##");
			STOPSIEVING;
		}
		else
		{
			if (!AllRemoved)
			{
				print ("#r**** All values removed in this range.");
				AllRemoved = true;
			}
		}
	}
}

static void DoKSieve_tiny (const __int64 &p) 
{ 
	static unsigned int nvalsleftbefore;	 
	static __int64 kvalue, ntest; 
 
	static unsigned arange, brange; 
	static unsigned maxval, r0size, r0incr; 
	static __int64 *r0 = NULL; 
	static unsigned int *bitmap2 = NULL; 
	static int fKroneker; 
	static unsigned int arangefirstbit;

	if (fFirstTime) 
	{ 
		fFirstTime = false; 
 
		maxval = (unsigned)(1+MaxNum-MinNum); 
		arange = 1+(unsigned)sqrt (maxval); 
		brange = 1+maxval/arange; 
 
		arangefirstbit = 0x80000000;
		while ((arange & arangefirstbit) == 0) arangefirstbit >>= 1;
		arangefirstbit >>= 1;

		if (r0) delete[]r0; 
		r0 = new __int64[arange]; 
 
		if (bitmap2) free (bitmap2); 
		bitmap2 = (unsigned int *)calloc (0x40000, 1);
 
		if (fMyPrimorial)
		{
			fKroneker = 1;

			for (unsigned int i = 0; i < nPackPrimorial; i++)
				fKroneker = (int)mulmodp2 (fKroneker, PackPrimorial[i], 3);
		}
		else if (mode & MODE_PRIMORIAL) 
		{ 
			fKroneker = 0;
		} 
		else 
		{
			fKroneker = nvalue % 3;
		} 
		
		if (mode & MODE_PLUS) fKroneker = -fKroneker;
		else fKroneker = (3-fKroneker)%3; 

		if (mode & MODE_MOREHEAD)
		{
			fKroneker = -2;
		}
	} 
 
	if (mode & MODE_DUAL) 
	{ 
		kvalue = 1; 
	}
	else
	{
		if (fMyPrimorial)
		{
			kvalue = 1;

			for (unsigned int i = 0; i < nPackPrimorial; i++)
			{
				kvalue = mulmodp2 (kvalue, PackPrimorial[i], p);
			}

			if (!kvalue) return;
		}
		else if (mode & MODE_PRIMORIAL) 
		{ 
			kvalue = GetPrimorialModP (p);	// kvalue = nvalue# (mod p) 

			if (!kvalue) return;
		} 
		else 
		{ 
			kvalue = nvalue; 
		} 
 
		if (fKroneker)
		{
			if (p > 3 && Kroneker (fKroneker*kvalue, p) != 1) return; 
		}
		else if (p > 3)
		{
			if (Kroneker (((mode & MODE_MINUS) ? 2 : -2)*kvalue, p) != 1 && 
			    Kroneker (((mode & MODE_MINUS) ? 1 : -1)*kvalue, p) != 1)
			{
				return;
			}
		}
	}
	
	// Fill r0[]. 
 

	__int64 twotou = fastkbasepownmodp (kvalue, (unsigned)MinNum, p); 
	if (!(mode & MODE_DUAL) && (mode & MODE_PLUS)) 
	{ 
		twotou = p-twotou; 
	} 
 
	unsigned a;

	for (a = 0; a < arange; a++) 
	{ 
		r0[a] = twotou; 
		bitmap2[(twotou&0x1fffff)>>5] |= onebits[twotou&0x1F];

#ifndef __GNUC__

		_asm
		{
			shl dword ptr twotou, 1
			rcl dword ptr twotou+4, 1
		}

#else

		twotou <<= 1;

#endif

		if (twotou>=p) twotou -= p; 
	} 
 
	__int64 r = halfpownmodp (arange, arangefirstbit, p);
 
	nvalsleftbefore = nvalsleft; 
	__int64 removed, firstremoved = -1; 
 
 
	// r contains (1/2)^arange 
	__int64 k = 1; 
	if (mode & MODE_DUAL) 
	{ 
		if (mode & MODE_PLUS) 
		{ 
			k = p-nvalue; 
			while (k < 0) k += p; 
		} 
		else 
		{ 
			k = nvalue % p; 
		} 
	} 
 
	for (unsigned b = 0; b < brange; b++) 
	{ 
		if (bitmap2[(k&0x1fffff)>>5] & onebits[k&0x1F])
		{ 
			// HIT!!! 
			for (a = 0; a < arange; a++) 
			{ 
				if (k == r0[a]) 
				{ 
					if (a+b*arange < maxval && GetBit (a+b*arange)) 
					{ 
						ClearBit (a+b*arange); 
						removed = MinNum + a+b*arange; 
						if (firstremoved == -1)
							firstremoved = removed;
						if (LogDeleted && p > 1000000) 
						{ 
							FILE *fptr; 
							do 
							{ 
								fptr = fopen ("NewPGen.del", "a"); 
								if (fptr == NULL) Sleep (10); 
							} while (fptr == NULL); 
							fprintf (fptr, "p="LL_FORMAT" divides n="LL_FORMAT"\n", p, MinNum+a+b*arange, a, b, arange); 
							fclose (fptr); 
						} 
						nvalsleft--; 
					} 
				} 
			} 
		} 
 
		k = mulmodp2 (k, r, p);	// k *= (1/2)^arange (mod p) 
	} 
 
	// Clear bitmap 
	for (a = 0; a < arange; a++) 
	{ 
		bitmap2[(r0[a]&0x1fffff)>>5] = 0;
	} 
 
	if (nvalsleftbefore == nvalsleft) return; 
 
	if (firstremoved < maxtiny) {
	    printf ("firstremoved = %qi, maxtiny = %d\n", firstremoved, maxtiny);
	    if (mode & MODE_DUAL) {
		k_base_power_n = kbasepown (1, (unsigned)firstremoved);
		ntest = (mode & MODE_PLUS) ? k_base_power_n + nvalue : k_base_power_n - nvalue;
		if (ntest < 0)
		    ntest = -ntest;
	    }
	    else {
		k_base_power_n = kbasepown (kvalue, (unsigned)firstremoved);
		ntest = (mode & MODE_PLUS) ? k_base_power_n + 1 : k_base_power_n - 1;
	    }
	    if (ntest == p) {	// This value has been removed as dividing itself !
		SetBit ((unsigned)(firstremoved - MinNum));
		nvalsleft++;
	    }
	}

	if (fVerify) 
	{ 
		Verify (nvalue, (unsigned)removed, p); 
	} 
 
	time_t Now; 
	time (&Now); 
 
	if (Now != LastTime[rateindex]) 
	{ 
		ClearReport (Now, p, removed); 
	} 
 
	if (nvalsleft == 0) 
	{ 
		if (State == 2) 
		{ 
			// Don't stop if generating... 
			State = 0; 
			print ("#o**** All values removed! You do not need to test these values!!"); 
			outputandtidyvals (p, outbuff, fAppend); 
			print ("##"); 
			STOPSIEVING; 
		} 
		else 
		{ 
			if (!AllRemoved) 
			{ 
				print ("#r**** All values removed in this range."); 
				AllRemoved = true; 
			} 
		} 
	} 
} 
 
static void DoKSieveOld (const __int64 &p)
{
	static unsigned int nvalsleftbefore;	
	static __int64 kvalue;

	first32 = (unsigned)-1;

	MinNum32 = (unsigned int)MinNum;
	MaxNum32 = (unsigned int)MaxNum;
	// k=199 from n=100000 to 200000: up to p=412147 in 30 secs

	pp64 = p;

	if (fMyPrimorial)
	{
		kvalue = 1;

		for (unsigned int i = 0; i < nPackPrimorial; i++)
		{
			kvalue = mulmodp2 (kvalue, PackPrimorial[i], p);
		}

		if (!kvalue) return;
	}
	else if (mode & MODE_PRIMORIAL) 
	{ 
		kvalue = GetPrimorialModP (p);	// kvalue = nvalue# (mod p) 

		if (!kvalue) return;
	} 
	else 
	{ 
		kvalue = nvalue; 
	} 

	if (p < TWOTO32)
	{
		bb64 = findk2pownmodp ((unsigned int)kvalue, MaxNum32, p);

		doksieveasm1(); 

		if (first32 == (unsigned)-1) return;
		nvalsleftbefore = nvalsleft;
		revfastclear (first32-MinNum32, n32);
		if (nvalsleftbefore == nvalsleft) return;
	}
	else
	{
		bb64 = fastkbasepownmodp (kvalue, MinNum32, p);
		firstb64 = bb64;
		
		doksieveasm2(); 

		if (first32 == -1) return;
		nvalsleftbefore = nvalsleft;
		fastclear (first32-MinNum32, 1 + n32 - MinNum32);
		if (nvalsleftbefore == nvalsleft) return;
	}

	if (fVerify)
	{
		Verify (nvalue, first32, p);
	}

	time_t Now;
	time (&Now);

	if (Now != LastTime[rateindex])
	{
		ClearReport (Now, p, first32);
	}

	if (nvalsleft == 0)
	{
		if (State == 2)
		{
			// Don't stop if generating...
			State = 0;
			print ("#o**** All values removed! You do not need to test these values!!");
			outputandtidyvals (p, outbuff, fAppend);
			print ("##");
			STOPSIEVING;
		}
		else
		{
			if (!AllRemoved)
			{
				print ("#r**** All values removed in this range.");
				AllRemoved = true;
			}
		}
	}
}


static void DoKSieveOld_tiny (const __int64 &p) 
{ 
	static unsigned int nvalsleftbefore, leastn;	 
	static __int64 kvalue, ntest; 
	bool perhapsprime;
 
	first32 = (unsigned)-1; 
 
	MinNum32 = (unsigned int)MinNum; 
	MaxNum32 = (unsigned int)MaxNum; 
	// k=199 from n=100000 to 200000: up to p=412147 in 30 secs 
 
	pp64 = p; 
 
	if (fMyPrimorial)
	{
		kvalue = 1;

		for (unsigned int i = 0; i < nPackPrimorial; i++)
		{
			kvalue = mulmodp2 (kvalue, PackPrimorial[i], p);
		}

		if (!kvalue) return;
	}
	else if (mode & MODE_PRIMORIAL) 
	{ 
		kvalue = GetPrimorialModP (p);	// kvalue = nvalue# (mod p) 

		if (!kvalue) return;
	} 
	else 
	{ 
		kvalue = nvalue; 
	} 
 
	if (p < TWOTO32) 
	{ 
		bb64 = findk2pownmodp ((unsigned int)kvalue, MaxNum32, p); 
 
		doksieveasm1();  
 
		if (first32 == (unsigned)-1) return; 
		nvalsleftbefore = nvalsleft; 
		leastn = first32%n32;		// Compute the first n to clear
		if ((!(mode & MODE_PRIMORIAL) || tinyPrimorial < p) && leastn < maxtiny && leastn >= MinNum32) {
		    perhapsprime = (GetBit (leastn - MinNum32) != 0); // n may yield a prime
		    if (perhapsprime) {		// test if leastn yields the prime p
			k_base_power_n = kbasepown (kvalue, leastn);
			ntest = (mode & MODE_PLUS) ? k_base_power_n + 1 : k_base_power_n - 1;
		    }
		}
		else
		    perhapsprime = false;
		revfastclear (first32-MinNum32, n32); 
		if (nvalsleftbefore == nvalsleft) return; 
		if (perhapsprime && ntest == p) {
		    SetBit (leastn - MinNum32);	// ntest is prime, but has been
		    nvalsleft++;		// cleared, due to dividing itself !
		}
	} 
	else 
	{ 
		bb64 = fastkbasepownmodp (kvalue, MinNum32, p); 
		firstb64 = bb64; 
		 
		doksieveasm2();  
 
		if (first32 == -1) return; 
		nvalsleftbefore = nvalsleft; 
		leastn = first32;		// Compute the first n to clear
		if ((!(mode & MODE_PRIMORIAL) || tinyPrimorial < p) && leastn < maxtiny && leastn >= MinNum32) {
		    perhapsprime = (GetBit (leastn - MinNum32) != 0); // n may yield a prime
		    if (perhapsprime) {		// test if leastn yields the prime p
			k_base_power_n = kbasepown (kvalue, leastn);
			ntest = (mode & MODE_PLUS) ? k_base_power_n + 1 : k_base_power_n - 1;
		    }
		}
		else
		    perhapsprime = false;
		fastclear (first32-MinNum32, 1 + n32 - MinNum32); 
		if (nvalsleftbefore == nvalsleft) return; 
		if (perhapsprime && ntest == p) {
		    SetBit (leastn - MinNum32);	// ntest is prime, but has been
		    nvalsleft++;		// cleared, due to dividing itself !
		}
	} 
 
	if (fVerify) 
	{ 
		Verify (nvalue, first32, p); 
	} 
 
	time_t Now; 
	time (&Now); 
 
	if (Now != LastTime[rateindex]) 
	{ 
		ClearReport (Now, p, first32); 
	} 
 
	if (nvalsleft == 0) 
	{ 
		if (State == 2) 
		{ 
			// Don't stop if generating... 
			State = 0; 
			print ("#o**** All values removed! You do not need to test these values!!"); 
			outputandtidyvals (p, outbuff, fAppend); 
			print ("##"); 
			STOPSIEVING; 
		} 
		else 
		{ 
			if (!AllRemoved) 
			{ 
				print ("#r**** All values removed in this range."); 
				AllRemoved = true; 
			} 
		} 
	} 
} 

static void DoKSieveOtherBases (const __int64 &p)
{
	static unsigned int nvalsleftbefore;	
	static __int64 kvalue;

	static unsigned arange, brange;
	static unsigned maxval;
	static __int64 *r0 = NULL;
	static unsigned int *bitmap2 = NULL;
	unsigned a;
		
	if (fFirstTime)
	{
		fFirstTime = false;

		maxval = (unsigned)(1+MaxNum-MinNum);
		arange = 1+(unsigned)sqrt (maxval);
		brange = 1+maxval/arange;

		if (r0) delete[]r0;
		r0 = new __int64[maxval];

		for (unsigned i = 0; i < maxval; i++) r0[i] = 0;

		if (bitmap2) free (bitmap2);
		bitmap2 = (unsigned int *)calloc (0x40000, 1);
	}

    if (mode & MODE_DUAL)
    {
        kvalue = 1;
    }
    else
    {
	    kvalue = nvalue;
    }

	if (baseinverses[(unsigned)(p % base)] == 0) return;

	// Fill r0[].
	__int64 basetou = fastkbasepownmodp (kvalue, (unsigned)MinNum, p);
	if (!(mode & MODE_DUAL) && (mode & MODE_PLUS))
	{
		basetou = p-basetou;
	}

	for (a = 0; a < arange; a++)
	{
		r0[a] = basetou;
		bitmap2[(basetou&0x1fffff)>>5] |= onebits[basetou&0x1F];
		basetou *= base;
		if (basetou >= p) basetou %= p;
	}

	unsigned int i;
	__int64 x = (1+baseinverses[(unsigned)(p % base)]*p)/base;
	__int64 r=1;

	for (i=arange;i!=1;i>>=1)
	{
		if (i & 1)
			r = mulmodp2 (r, x, p);
		x = mulmodp2 (x, x, p);
	}
	r = mulmodp2 (r, x, p);

	nvalsleftbefore = nvalsleft;
	__int64 removed;


	// r contains (base)^-arange
	__int64 k = 1;
    if (mode & MODE_DUAL)
    {
		if (mode & MODE_PLUS)
		{
			k = p-nvalue;
			while (k < 0) k += p;
		}
		else
		{
			k = nvalue;
            if (k >= p) k %= p;
		}
    }

	for (unsigned b = 0; b < brange; b++)
	{
		if (bitmap2[(k&0x1fffff)>>5] & onebits[k&0x1F])
		{
			// HIT!!!
			for (a = 0; a < arange; a++)
			{
				if (k == r0[a])
				{
					if (a+b*arange < maxval && GetBit (a+b*arange))
					{
						ClearBit (a+b*arange);
						removed = MinNum + a+b*arange;

						if (LogDeleted && p > 1000000)
						{
							FILE *fptr;
							do
							{
								fptr = fopen ("NewPGen.del", "a");
								if (fptr == NULL) Sleep (10);
							} while (fptr == NULL);
							fprintf (fptr, "p="LL_FORMAT" divides n="LL_FORMAT"\n", p, MinNum+a+b*arange, a, b, arange);
							fclose (fptr);
						}
						nvalsleft--;
					}
				}
			}
		}

		k = mulmodp2 (k, r, p);
	}

	// Clear bitmap
	for (a = 0; a < arange; a++)
	{
		bitmap2[(r0[a]&0x1fffff)>>5] = 0;
	}

	if (nvalsleftbefore == nvalsleft) return;

	if (fVerify)
	{
		Verify (nvalue, (unsigned)removed, p);
	}

	time_t Now;
	time (&Now);

	if (Now != LastTime[rateindex])
	{
		ClearReport (Now, p, removed);
	}

	if (nvalsleft == 0)
	{
		if (State == 2)
		{
			// Don't stop if generating...
			State = 0;
			print ("#o**** All values removed! You do not need to test these values!!");
			outputandtidyvals (p, outbuff, fAppend);
			print ("##");
			STOPSIEVING;
		}
		else
		{
			if (!AllRemoved)
			{
				print ("#r**** All values removed in this range.");
				AllRemoved = true;
			}
		}
	}
}

  
// These are used to save values of p and b.
__int64 saveb, savep, svb2;

// I renamed this last "b" global as "svb2" to avoid conflicting
// with previous definition of "b" for "Base2KSieve()" function on GNUC platforms.
// Jean Penn�, 13 March 2003.

int pindex;
static __int64 *pptr[6] = {&p064, &p164, &p264, &p364, &p464, &p564};

// Two helper routines for the primorial sieves
__inline void DoPrimorial (const __int64 &p, __int64 &b)
{
	if (b != 0)	b = Get48bitInverse (b, p);
	if (b != 0) (*RemoveRoutine) (p, b);
}

__inline void DoPrimorial_AP (const __int64 &p, __int64 &b)
{
	b--;
	b = p - b;
	if (b & 1) b += p;
	b >>= 1;
	(*RemoveRoutine) (p, b);
}

// Now the routines themselves

static void WorkProcPrimorial_AP_Bigp (const __int64 &p)
{
	svb2 = GetPrimorialModP (p);
	DoPrimorial_AP (p, svb2);
}

static void WorkProcPrimorial_AP_Smallp (const __int64 &p)
{
	if (p > TWOTO32)
	{
		workprocedure = WorkProcPrimorial_AP_Bigp;

		if (savep)
		{
			pair_GetPrimorialModP (savep, 100, saveb, svb2);

			DoPrimorial_AP (savep, saveb);
			savep = 0;
		}
		(*workprocedure) (p);
	}
	else if (savep)
	{
			pair_GetPrimorialModP (savep, p, saveb, svb2);
			DoPrimorial_AP (savep, saveb);
			DoPrimorial_AP (p, svb2);
			savep = 0;
	}
	else
	{
		savep = p;
	}
}

EXTERNC	unsigned __int64 PackPrimorial[20000];
EXTERNC	unsigned int nPackPrimorial;

static void WorkProcPrimorial_Bigp (const __int64 &p)
{
	svb2 = GetPrimorialModP (p);
	DoPrimorial (p, svb2);
}

static void WorkProcPrimorial_Smallp (const __int64 &p)
{
	if (p > TWOTO32)
	{
		workprocedure = WorkProcPrimorial_Bigp;

		if (savep)
		{
			pair_GetPrimorialModP (savep, 100, saveb, svb2);

			DoPrimorial (savep, saveb);
			savep = 0;
		}
		(*workprocedure) (p);
	}
	else if (savep)
	{
			pair_GetPrimorialModP (savep, p, saveb, svb2);
			DoPrimorial (savep, saveb);
			DoPrimorial (p, svb2);
			savep = 0;
	}
	else
	{
		savep = p;
	}
}

// These are used by the work procedure when the base is not 2.
static unsigned euclid_extended (const unsigned a, const unsigned base)
{
	__int64 u = 0, d = base, v1 = 1, v3 = a, t1, t3;

	while (v3)
	{
		__int64 q = d/v3;
		t3 = d-(q*v3);
		t1 = u-q*v1;

		u = v1;
		d = v3;
		v1 = t1;
		v3 = t3;
	}
	return (d == 1) ? (unsigned)((u>0)?base-u:-u) : 0;
}

static bool FindBaseInverses ()
{
	if (baseinverses) delete []baseinverses;
	baseinverses = NULL;

	if (base > 255255) return false;

	baseinverses = new unsigned[base];

	baseinverses[0] = 0;
	baseinverses[1] = base-1;

	for (unsigned i = 2; i < base; i++)
		baseinverses[i] = euclid_extended (i, base);

	return true;
}

static void WorkProcNotBase2_NoInverses (const __int64 &p)
{
	// k.b^n+-1; b != 2
	if ((baseinverse = GetBaseInverse (p)) != 0)
	{
		// The inverse exists, ie p really is prime
		(*RemoveRoutine) (p, findbotherbases (p));
	}
}

__int64 MaxpForWorkProcNotBase2;

static void WorkProcNotBase2 (const __int64 &p)
{
	if (p > MaxpForWorkProcNotBase2)
	{
		WorkProcNotBase2_NoInverses (p);
		workprocedure = WorkProcNotBase2_NoInverses;
		return;
	}
	// k.b^n+-1; b != 2
	if (svb2 = baseinverses[(unsigned)(p % base)])
	{
		baseinverse = (1+svb2*p)/base;
		(*RemoveRoutine) (p, findbotherbases (p));
	}
}

static void WorkProcNotBase2_AP (const __int64 &p)
{
	(*RemoveRoutine) (p, findbasepownmodp (p));
}

static void WorkProcBase2_AP_Bigp (const __int64 &p)
{
	(*RemoveRoutine) (p, find2pownmodp (p));
}

static void WorkProcBase2_AP_Smallp (const __int64 &p)
{
	if (p > TWOTO32)
	{
		workprocedure = WorkProcBase2_AP_Bigp;
		if (savep)
		{
			pair_find2pownmodp (savep, savep, saveb, svb2);
			(*RemoveRoutine) (savep, saveb);
			savep = 0;
		}
		(*workprocedure) (p);
	}
	else if (savep)
	{
		pair_find2pownmodp (savep, p, saveb, svb2);
		(*RemoveRoutine) (savep, saveb);
		(*RemoveRoutine) (p, svb2);
		savep = 0;	
	}
	else
	{
		savep = p;
	}
}

static void WorkProcBase2_VeryBigp (const __int64 &p)
{
	*pptr[pindex++] = p;
	if (pindex == 6)
	{
		pindex = 0;
		find_k0_bigp ();
		(*RemoveRoutine) (p064,k064);
		(*RemoveRoutine) (p164,k164);
		(*RemoveRoutine) (p264,k264);
		(*RemoveRoutine) (p364,k364);
		(*RemoveRoutine) (p464,k464);
		(*RemoveRoutine) (p564,k564);
	}
}

static void WorkProcBase2_NoCMOV_Bigp (const __int64 &p)
{
	*pptr[pindex++] = p;
	if (pindex == 6)
	{
		pindex = 0;
		find_k0_nocmov_bigp ();
		(*RemoveRoutine) (p064,k064);
		(*RemoveRoutine) (p164,k164);
		(*RemoveRoutine) (p264,k264);
		(*RemoveRoutine) (p364,k364);
		(*RemoveRoutine) (p464,k464);
		(*RemoveRoutine) (p564,k564);
	}
}

#ifdef __GNUC__

/*
 *  JEAN: I have got an obj file containing the SSE2 code, that I link in. You will probably
 *  have to do the same, but with some additional name changes (to be #defined in here).
 */

static	__int64 p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11;

/*
 * PAUL : I translated the "sse2.cpp" source code for the GNUC in line assembler.
 * The new source code is in file "sse2gnuc.cpp".
 * Also, I added GNUC code in the "LoadPValues_Macro".
 * So, the only thing to do here is to define the p0... p11 variables as static.
*/

#endif

#ifndef _DEBUG

#include "sse2.h"

static void WorkProcBase2_SSE2_Bigp (const __int64 &p)
{
#ifndef __GNUC__
	__int64 p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11;
#endif

	p0 = p;
	p1 = soe2_next ();
	p2 = soe2_next ();
	p3 = soe2_next ();
	p4 = soe2_next ();
	p5 = soe2_next ();
	p6 = soe2_next ();
	p7 = soe2_next ();
	p8 = soe2_next ();
	p9 = soe2_next ();
	p10 = soe2_next ();
	p11 = soe2_next ();

	LoadPValues_Macro(p0,p1,p0p1);
	LoadPValues_Macro(p2,p3,p2p3);
	LoadPValues_Macro(p4,p5,p4p5);
	LoadPValues_Macro(p6,p7,p6p7);
	LoadPValues_Macro(p8,p9,p8p9);
	LoadPValues_Macro(p10,p11,p10p11);

	findk0xM_SSE2();

	(*RemoveRoutine) (p0, k0k1[0]);
	(*RemoveRoutine) (p1, k0k1[1]);
	(*RemoveRoutine) (p2, k2k3[0]);
	(*RemoveRoutine) (p3, k2k3[1]);
	(*RemoveRoutine) (p4, k4k5[0]);
	(*RemoveRoutine) (p5, k4k5[1]);
	(*RemoveRoutine) (p6, k6k7[0]);
	(*RemoveRoutine) (p7, k6k7[1]);
	(*RemoveRoutine) (p8, k8k9[0]);
	(*RemoveRoutine) (p9, k8k9[1]);
	(*RemoveRoutine) (p10, k10k11[0]);
	(*RemoveRoutine) (p11, k10k11[1]);
}

#endif

static void WorkProcBase2_Bigp (const __int64 &p)
{

	if (((int *)&p)[1] & 0x4000)	//	if (p >= TWOTO47) - but this compiles to fewer tests
	{
		workprocedure = WorkProcBase2_VeryBigp;
		(*workprocedure) (p);
		return;
	}

	p064 = p;
	p164 = soe2_next ();
	p264 = soe2_next ();
	p364 = soe2_next ();
	p464 = soe2_next ();
	p564 = soe2_next ();
	find_k0 ();
	(*RemoveRoutine) (p064,k064);
	(*RemoveRoutine) (p164,k164);
	(*RemoveRoutine) (p264,k264);
	(*RemoveRoutine) (p364,k364);
	(*RemoveRoutine) (p464,k464);
	(*RemoveRoutine) (p564,k564);
}

static void WorkProcBase2_Plus_Bigp (const __int64 &p)
{

	if (((int *)&p)[1] & 0x4000)	//	if (p >= TWOTO47) - but this compiles to fewer tests
	{
		workprocedure = WorkProcBase2_VeryBigp;
		(*workprocedure) (p);
		return;
	}

	p064 = p;
	p164 = soe2_next ();
	p264 = soe2_next ();
	p364 = soe2_next ();
	p464 = soe2_next ();
	p564 = soe2_next ();
	find_k0 ();
	CLEAR (p064-k064,p064);
	CLEAR (p164-k164,p164);
	CLEAR (p264-k264,p264);
	CLEAR (p364-k364,p364);
	CLEAR (p464-k464,p464);
	CLEAR (p564-k564,p564);
}

static void WorkProcBase2_Minus_Bigp (const __int64 &p)
{
	if (((int *)&p)[1] & 0x4000)	//	if (p >= TWOTO47) - but this compiles to fewer tests
	{
		workprocedure = WorkProcBase2_VeryBigp;
		(*workprocedure) (p);
		return;
	}

	p064 = p;
	p164 = soe2_next ();
	p264 = soe2_next ();
	p364 = soe2_next ();
	p464 = soe2_next ();
	p564 = soe2_next ();
	find_k0 ();
	CLEAR (k064,p064);
	CLEAR (k164,p164);
	CLEAR (k264,p264);
	CLEAR (k364,p364);
	CLEAR (k464,p464);
	CLEAR (k564,p564);
}

static void WorkProcBase2_Twin_Bigp (const __int64 &p)
{
	if (((int *)&p)[1] & 0x4000)	//	if (p >= TWOTO47) - but this compiles to fewer tests
	{
		workprocedure = WorkProcBase2_VeryBigp;
		(*workprocedure) (p);
		return;
	}

	p064 = p;
	p164 = soe2_next ();
	p264 = soe2_next ();
	p364 = soe2_next ();
	p464 = soe2_next ();
	p564 = soe2_next ();
	find_k0 ();
	CLEAR (p064-k064,p064);
	CLEAR (p164-k164,p164);
	CLEAR (p264-k264,p264);
	CLEAR (p364-k364,p364);
	CLEAR (p464-k464,p464);
	CLEAR (p564-k564,p564);
	CLEAR (k064,p064);
	CLEAR (k164,p164);
	CLEAR (k264,p264);
	CLEAR (k364,p364);
	CLEAR (k464,p464);
	CLEAR (k564,p564);
}

static void WorkProcBase2_Smallp (const __int64 &p)
{
	if (p > TWOTO32)				// Similar tricks don't work here, though.
	{
		if (!fCMOV)
		{
			workprocedure = WorkProcBase2_NoCMOV_Bigp;
		}
#ifndef _DEBUG
		else if (fSSE2)
		{
			workprocedure = WorkProcBase2_SSE2_Bigp;
		}
#endif
        else if (RemoveRoutine == Remove_Plus)
		{
			workprocedure = WorkProcBase2_Plus_Bigp;
		}
		else if (RemoveRoutine == Remove_Minus)
		{
			workprocedure = WorkProcBase2_Minus_Bigp;
		}
		else if (RemoveRoutine == Remove_Twin)
		{
			workprocedure = WorkProcBase2_Twin_Bigp;
		}
		else
		{
			workprocedure = WorkProcBase2_Bigp;
		}

		if (savep)
		{
			pair_findbbase2 (savep, savep, saveb, svb2);
			(*RemoveRoutine) (savep, saveb);
			savep = 0;
		}
		(*workprocedure) (p);
	}
	else if (savep)
	{
		pair_findbbase2 (savep, p, saveb, svb2);
		(*RemoveRoutine) (savep, saveb);
		(*RemoveRoutine) (p, svb2);
		savep = 0;	
	}
	else
	{
		savep = p;
	}
}

static void EstimateSize ()
{
	int mindigits, maxdigits;

	if ((mode & (MODE_PRIMORIAL|MODE_KSIEVE)) == (MODE_PRIMORIAL|MODE_KSIEVE))
	{
		mindigits = (int)((log((double)(__int64)PackPrimorial[nPackPrimorial-1])+(nPackPrimorial-1)*48*log(2.0)+MinNum*log(2.0))/log(10.0));
		maxdigits = (int)((log((double)(__int64)PackPrimorial[nPackPrimorial-1])+(nPackPrimorial-1)*48*log(2.0)+MaxNum*log(2.0))/log(10.0));
	}
	else if (mode & MODE_PRIMORIAL)
	{
		mindigits = (int)((log((double)(__int64)PackPrimorial[nPackPrimorial-1])+(nPackPrimorial-1)*48*log(2.0)+log((double)MinNum))/log(10.0));
		maxdigits = (int)((log((double)(__int64)PackPrimorial[nPackPrimorial-1])+(nPackPrimorial-1)*48*log(2.0)+log((double)MaxNum))/log(10.0));
	}
	else if (mode & MODE_KSIEVE)
	{
		mindigits = (int)((MinNum*log(base)+log(nvalue))/log(10));
		maxdigits = (int)((MaxNum*log(base)+log(nvalue))/log(10));
	}
	else if (mode & MODE_DUAL)
	{
		mindigits = (int)((MinNum*log(base))/log(10));
		maxdigits = (int)((MaxNum*log(base))/log(10));
	}
	else
	{
		mindigits = (int)((nvalue*log(base)+log ((double)MinNum))/log(10.0));
		maxdigits = (int)((nvalue*log(base)+log ((double)MaxNum))/log(10.0));
	}
	char buff[1024];
	if (mindigits == maxdigits)
	{
		sprintf (buff, "Sieving numbers with %d decimal digits", mindigits+1);
	}
	else
	{
		sprintf (buff, "Sieving numbers with %d to %d decimal digits", mindigits+1, maxdigits+1);
	}
	print (buff);
}

/**************************************
 * This is the bitmap Sieve of Erastosthenes code, called by DoSieve()
 **************************************/
#define SIEVEDWORDS 4096
#define SIEVEBITS (SIEVEDWORDS<<5)
unsigned *sieve;
#define SOE2PRIMES 10432 		// Must be divisible by 64

#define SMALLPRIMEVALS1 (5*29*31)
#define SMALLPRIMELEN1 (SMALLPRIMEVALS1+SIEVEDWORDS)

	// Paul - I defined "COND_STATIC" as "static" on VC, "" on GNUC, 
	// because my external assembler code needs global variables here. 

COND_STATIC unsigned *smallprimesieve1;
COND_STATIC int smallprimesieveindex1;

#define SMALLPRIMEVALS2 (3*7*13*17)
#define SMALLPRIMELEN2 (SMALLPRIMEVALS2+SIEVEDWORDS)
COND_STATIC unsigned *smallprimesieve2;
COND_STATIC int smallprimesieveindex2;

#define SMALLPRIMEVALS3 (11*19*23)
#define SMALLPRIMELEN3 (SMALLPRIMEVALS3+SIEVEDWORDS)
COND_STATIC unsigned *smallprimesieve3;
COND_STATIC int smallprimesieveindex3;

#define MAXADDITIONAL 2000000
__int64 maxpforadditional;

COND_STATIC unsigned *additional = NULL;
COND_STATIC int nadditional;


#ifdef __GNUC__

// These symbols must be redefined for GNUC inline assembler...

#define SIEVEDWORDSA "4096"
#define SIEVEBITSA "4096*32"
#define SOE2PRIMESA "10432" 
#define SMALLPRIMEVALS1A "5*29*31"
#define SMALLPRIMEVALS2A "3*7*13*17"
#define SMALLPRIMEVALS3A "11*19*23"

#endif

typedef struct 
{
	unsigned prime, ixt;
} _primetable2;

_primetable2 *primetable2;

unsigned *pr_ixt;

static void soe2_iterate ()
{
	/*
	 * Jean - for the sake of performance, I really want this code to be here
	 * rather than in an external module.
	 */
#ifndef __GNUC__	 

	_asm
	{
		mov esi, smallprimesieve1
		mov edx, dword ptr smallprimesieveindex1
		lea esi, [esi+4*edx]
		add edx, SIEVEDWORDS
		cmp edx, SMALLPRIMEVALS1
		sbb edi, edi
		not edi
		and edi, SMALLPRIMEVALS1
		sub edx, edi
		mov dword ptr smallprimesieveindex1, edx

		mov ebx, smallprimesieve2
		mov edx, dword ptr smallprimesieveindex2
		lea ebx, [ebx+4*edx]
		add edx, SIEVEDWORDS
		cmp edx, SMALLPRIMEVALS2
		sbb edi, edi
		not edi
		and edi, SMALLPRIMEVALS2
		sub edx, edi
		mov dword ptr smallprimesieveindex2, edx

		mov ecx, smallprimesieve3
		mov edx, dword ptr smallprimesieveindex3
		lea ecx, [ecx+4*edx]
		add edx, SIEVEDWORDS
		cmp edx, SMALLPRIMEVALS3
		sbb edi, edi
		not edi
		and edi, SMALLPRIMEVALS3
		sub edx, edi
		mov dword ptr smallprimesieveindex3, edx

		mov eax, SIEVEDWORDS

PrefetchLoop1:
		mov edx, dword ptr [esi+4*eax-256]
		mov edx, dword ptr [esi+4*eax-192]
		mov edx, dword ptr [esi+4*eax-128]
		mov edx, dword ptr [esi+4*eax- 64]
		mov edx, dword ptr [ebx+4*eax-256]
		mov edx, dword ptr [ebx+4*eax-192]
		mov edx, dword ptr [ebx+4*eax-128]
		mov edx, dword ptr [ebx+4*eax- 64]
		mov edx, dword ptr [ecx+4*eax-256]
		mov edx, dword ptr [ecx+4*eax-192]
		mov edx, dword ptr [ecx+4*eax-128]
		mov edx, dword ptr [ecx+4*eax- 64]
		sub eax, 64
		jnz PrefetchLoop1

		emms

		mov edi, sieve
		mov eax, SIEVEDWORDS/2

writeloop:
		movq mm0, qword ptr [esi+eax*8-64]
		movq mm1, qword ptr [esi+eax*8-64+8]
		movq mm2, qword ptr [esi+eax*8-64+16]
		movq mm3, qword ptr [esi+eax*8-64+24]
		movq mm4, qword ptr [esi+eax*8-64+32]
		movq mm5, qword ptr [esi+eax*8-64+40]
		movq mm6, qword ptr [esi+eax*8-64+48]
		movq mm7, qword ptr [esi+eax*8-64+56]

		pand mm0, qword ptr [ebx+eax*8-64]
		pand mm1, qword ptr [ebx+eax*8-64+8]
		pand mm2, qword ptr [ebx+eax*8-64+16]
		pand mm3, qword ptr [ebx+eax*8-64+24]
		pand mm4, qword ptr [ebx+eax*8-64+32]
		pand mm5, qword ptr [ebx+eax*8-64+40]
		pand mm6, qword ptr [ebx+eax*8-64+48]
		pand mm7, qword ptr [ebx+eax*8-64+56]

		pand mm0, qword ptr [ecx+eax*8-64]
		pand mm1, qword ptr [ecx+eax*8-64+8]
		pand mm2, qword ptr [ecx+eax*8-64+16]
		pand mm3, qword ptr [ecx+eax*8-64+24]
		pand mm4, qword ptr [ecx+eax*8-64+32]
		pand mm5, qword ptr [ecx+eax*8-64+40]
		pand mm6, qword ptr [ecx+eax*8-64+48]
		pand mm7, qword ptr [ecx+eax*8-64+56]

		movq qword ptr [edi+eax*8-64], mm0
		movq qword ptr [edi+eax*8-64+8], mm1
		movq qword ptr [edi+eax*8-64+16], mm2
		movq qword ptr [edi+eax*8-64+24], mm3
		movq qword ptr [edi+eax*8-64+32], mm4
		movq qword ptr [edi+eax*8-64+40], mm5
		movq qword ptr [edi+eax*8-64+48], mm6
		movq qword ptr [edi+eax*8-64+56], mm7

		sub eax, 8
		jnz writeloop

		emms

		// Do the first bit
		mov esi, dword ptr pr_ixt

		// Prefetch pr_ixt
		mov ecx, SOE2PRIMES

PrefetchLoop4:
		mov ebx, dword ptr [esi+4*ecx-256]
		mov ebx, dword ptr [esi+4*ecx-192]
		mov ebx, dword ptr [esi+4*ecx-128]
		mov ebx, dword ptr [esi+4*ecx- 64]
		sub ecx, 64
		jz Clear0
		jmp PrefetchLoop4

		// ecx = 0 at this point

		// See the comment below for the rationale for this align 16+3 nop bytes.
		align 16
		_emit 0x8d		// "DB 08dh,004h,020h" is a 3 byte NOP
		_emit 0x04		// It is one way of saying "lea eax, [eax]"
		_emit 0x20		// (but not the usual one, which is 2 bytes)

Clear0:
		mov eax, dword ptr [esi+4*ecx]
		mov ebx, eax
		shr ebx, 16					// ebx is 'i'
		and eax, 0xFFFF				// eax is s

		// This loop is at the heart of the code, so we want it to be 
		// all in one 16 byte chunk together. The code from Clear0: to this
		// point is 13 bytes, so the "align 16" followed by 3 nop bytes above 
		// will ensure that the top of this loop is on a 16 byte boundary.

Clear0loop:
		btr dword ptr [edi], ebx
		add ebx, eax
		btr dword ptr [edi], ebx
		add ebx, eax

		cmp ebx, SIEVEBITS
		jb Clear0loop

		sub ebx, SIEVEBITS
		cmp ebx, eax
		sbb edx, edx
		not edx
		and edx, eax
		sub ebx, edx

		shl ebx, 16
		or eax, ebx
		mov dword ptr [esi+4*ecx], eax

		inc ecx
		cmp ecx, 20
		jb Clear0

		align 16
		_emit 0x8d
		_emit 0x04
		_emit 0x20

Clear1:
		mov eax, dword ptr [esi+4*ecx]
		mov ebx, eax
		shr ebx, 16					// ebx is 'i'
		and eax, 0xFFFF				// eax is s

Clear1loop:
		btr dword ptr [edi], ebx
		add ebx, eax

		cmp ebx, SIEVEBITS
		jb Clear1loop

		sub ebx, SIEVEBITS

		shl ebx, 16
		or eax, ebx
		mov dword ptr [esi+4*ecx], eax

		inc ecx
		cmp ecx, 6531
		jb Clear1

		align 16

Clear2:
		mov eax, dword ptr [esi+4*ecx]
		mov ebx, eax
		shr eax, 17					// ebx is 'i'
		and ebx, 0x1FFFF			// eax is s
		or  eax, 0x10000

		btr dword ptr [edi], ebx
		add ebx, eax
		cmp ebx, SIEVEBITS
		jae Done2

		btr dword ptr [edi], ebx
		add ebx, eax
Done2:
		shl eax, 17
		sub ebx, SIEVEBITS
		or eax, ebx
		mov dword ptr [esi+4*ecx], eax

		inc ecx
		cmp ecx, 9428
		jb Clear2

Clear3:
		mov eax, dword ptr [esi+4*ecx]
		mov ebx, eax
		shr eax, 17					// ebx is 'i'
		and ebx, 0x1FFFF			// eax is s
		or  eax, 0x18000

		btr dword ptr [edi], ebx
		add ebx, eax

		cmp ebx, SIEVEBITS
		jae Done3

		btr dword ptr [edi], ebx
		add ebx, eax
Done3:
		shl eax, 17
		sub ebx, SIEVEBITS
		or eax, ebx
		mov dword ptr [esi+4*ecx], eax

		inc ecx
		cmp ecx, SOE2PRIMES
		jb Clear3

		mov esi, dword ptr additional
		mov ecx, 0
		cmp dword ptr nadditional, 0
		je AllDone

Clear4:
		mov eax, dword ptr [esi+4*ecx]
		mov ebx, dword ptr [esi+4*ecx+4]

		cmp ebx, SIEVEBITS
		jae Done4

		btr dword ptr [edi], ebx
		add ebx, eax

		cmp ebx, SIEVEBITS
		jae Done4

		btr dword ptr [edi], ebx
		add ebx, eax
Done4:
		sub ebx, SIEVEBITS
		mov dword ptr [esi+4*ecx+4], ebx

		add ecx,2
		cmp ecx, dword ptr nadditional
		jb Clear4


Alldone:
	}

#else

	/*
	 * Jean - put your call to an external routine here. If I change the asm above, 
	 * I will also change it in your code
	 */

//	soe2_iterateasm ();

	/*
	 * Paul - I am now using inline GNUC assembler, so I don't need the previous
	 * call more, and you can also inline this code.
	 */

asm("		.intel_syntax noprefix");
asm("		mov esi, smallprimesieve1");
asm("		mov edx, dword ptr smallprimesieveindex1");
asm("		lea esi, [esi+edx*4]");
asm("		add edx, "SIEVEDWORDSA"");
asm("		cmp edx, "SMALLPRIMEVALS1A"");
asm("		sbb edi, edi");
asm("		not edi");
asm("		and edi, "SMALLPRIMEVALS1A"");
asm("		sub edx, edi");
asm("		mov dword ptr smallprimesieveindex1, edx");

asm("		mov ebx, smallprimesieve2");
asm("		mov edx, dword ptr smallprimesieveindex2");
asm("		lea ebx, [ebx+edx*4]");
asm("		add edx, "SIEVEDWORDSA"");
asm("		cmp edx, "SMALLPRIMEVALS2A"");
asm("		sbb edi, edi");
asm("		not edi");
asm("		and edi, "SMALLPRIMEVALS2A"");
asm("		sub edx, edi");
asm("		mov dword ptr smallprimesieveindex2, edx");

asm("		mov ecx, smallprimesieve3");
asm("		mov edx, dword ptr smallprimesieveindex3");
asm("		lea ecx, [ecx+edx*4]");
asm("		add edx, "SIEVEDWORDSA"");
asm("		cmp edx, "SMALLPRIMEVALS3A"");
asm("		sbb edi, edi");
asm("		not edi");
asm("		and edi, "SMALLPRIMEVALS3A"");
asm("		sub edx, edi");
asm("		mov dword ptr smallprimesieveindex3, edx");

asm("		mov eax, "SIEVEDWORDSA"");

asm("PrefetchLoop1:");
asm("		mov edx, dword ptr [esi+eax*4-256]");
asm("		mov edx, dword ptr [esi+eax*4-192]");
asm("		mov edx, dword ptr [esi+eax*4-128]");
asm("		mov edx, dword ptr [esi+eax*4-64]");
asm("		mov edx, dword ptr [ebx+eax*4-256]");
asm("		mov edx, dword ptr [ebx+eax*4-192]");
asm("		mov edx, dword ptr [ebx+eax*4-128]");
asm("		mov edx, dword ptr [ebx+eax*4-64]");
asm("		mov edx, dword ptr [ecx+eax*4-256]");
asm("		mov edx, dword ptr [ecx+eax*4-192]");
asm("		mov edx, dword ptr [ecx+eax*4-128]");
asm("		mov edx, dword ptr [ecx+eax*4-64]");
asm("		sub eax, 64");
asm("		jnz 	PrefetchLoop1");

asm("		emms	");

asm("		mov edi, sieve");
asm("		mov eax, "SIEVEDWORDSA"/2");

asm("writeloop:");
asm("		.att_syntax" );

// GNUC assembler seems not to work properly for movq and pand
// when written using Intel syntax, so I am using Att syntax here !

asm("		movq -64(%esi,%eax,8),%mm0			");
asm("		movq -56(%esi,%eax,8),%mm1			");
asm("		movq -48(%esi,%eax,8),%mm2			");
asm("		movq -40(%esi,%eax,8),%mm3			");
asm("		movq -32(%esi,%eax,8),%mm4			");
asm("		movq -24(%esi,%eax,8),%mm5			");
asm("		movq -16(%esi,%eax,8),%mm6			");
asm("		movq -8(%esi,%eax,8),%mm7			");

asm("		pand -64(%ebx,%eax,8),%mm0			");
asm("		pand -56(%ebx,%eax,8),%mm1			");
asm("		pand -48(%ebx,%eax,8),%mm2			");
asm("		pand -40(%ebx,%eax,8),%mm3			");
asm("		pand -32(%ebx,%eax,8),%mm4			");
asm("		pand -24(%ebx,%eax,8),%mm5			");
asm("		pand -16(%ebx,%eax,8),%mm6			");
asm("		pand -8(%ebx,%eax,8),%mm7			");

asm("		pand -64(%ecx,%eax,8),%mm0			");
asm("		pand -56(%ecx,%eax,8),%mm1			");
asm("		pand -48(%ecx,%eax,8),%mm2			");
asm("		pand -40(%ecx,%eax,8),%mm3			");
asm("		pand -32(%ecx,%eax,8),%mm4			");
asm("		pand -24(%ecx,%eax,8),%mm5			");
asm("		pand -16(%ecx,%eax,8),%mm6			");
asm("		pand -8(%ecx,%eax,8),%mm7			");

asm("		movq %mm0,-64(%edi,%eax,8)			");
asm("		movq %mm1,-56(%edi,%eax,8)			");
asm("		movq %mm2,-48(%edi,%eax,8)			");
asm("		movq %mm3,-40(%edi,%eax,8)			");
asm("		movq %mm4,-32(%edi,%eax,8)			");
asm("		movq %mm5,-24(%edi,%eax,8)			");
asm("		movq %mm6,-16(%edi,%eax,8)			");
asm("		movq %mm7,-8(%edi,%eax,8)			");

// Ooops, what a boredom !

asm("		.intel_syntax noprefix");
asm("		sub eax, 8");
asm("		jnz writeloop");

asm("		emms	");

		// Do the first bit

asm("		mov esi, dword ptr pr_ixt");

		// Prefetch pr_ixt

asm("		mov ecx, "SOE2PRIMESA"");

asm("PrefetchLoop4:");
asm("		mov ebx, dword ptr [esi+ecx*4-256]");
asm("		mov ebx, dword ptr [esi+ecx*4-192]");
asm("		mov ebx, dword ptr [esi+ecx*4-128]");
asm("		mov ebx, dword ptr [esi+ecx*4-64]");
asm("		sub ecx, 64");
asm("		jz  Clear0");
asm("		jmp PrefetchLoop4");

		// ecx = 0 at this point.

		// See the comment below for the rationale for this align 16+3 nop bytes.

asm("		.align 16");
asm("		.byte 0x8d");
asm("		.byte 0x04");
asm("		.byte 0x20");

asm("Clear0:");
asm("		mov eax, dword ptr [esi+ecx*4]");
asm("		mov ebx, eax");
asm("		shr ebx, 16");		// ebx is 'i'
asm("		and eax, 0xFFFF");	// eax is s

		// This loop is at the heart of the code, so we want it to be
		// all in one 16 byte chunk together. The code from Clear0: to this
		// point is 13 bytes, so the 'align 16' followed by 3 nop bytes above
		// will ensure that the top of this loop is on a 16 byte boundary.

asm("Clear0loop:");
asm("		btr dword ptr [edi], ebx");
asm("		add ebx, eax");
asm("		btr dword ptr [edi], ebx");
asm("		add ebx, eax");

asm("		cmp ebx, "SIEVEBITSA"");
asm("		jb Clear0loop");

asm("		sub ebx, "SIEVEBITSA"");
asm("		cmp ebx, eax");
asm("		sbb edx, edx");
asm("		not edx");
asm("		and edx, eax");
asm("		sub ebx, edx");

asm("		shl ebx, 16");
asm("		or eax, ebx");
asm("		mov dword ptr [esi+ecx*4], eax");

asm("		inc ecx");
asm("		cmp ecx, 20");
asm("		jb Clear0");

asm("		.align 16");
asm("		.byte 0x8d");
asm("		.byte 0x04");
asm("		.byte 0x20");

asm("Clear1:");
asm("		mov eax, dword ptr [esi+ecx*4]");
asm("		mov ebx, eax");
asm("		shr ebx, 16");		// ebx is 'i'
asm("		and eax, 0xFFFF");	// eax is s

asm("Clear1loop:");
asm("		btr dword ptr [edi], ebx");
asm("		add ebx, eax");

asm("		cmp ebx, "SIEVEBITSA"");
asm("		jb Clear1loop");

asm("		sub ebx, "SIEVEBITSA"");

asm("		shl ebx, 16");
asm("		or eax, ebx");
asm("		mov dword ptr [esi+ecx*4], eax");

asm("		inc ecx");
asm("		cmp ecx, 6531");
asm("		jb Clear1");

asm("		.align 16");

asm("Clear2:");
asm("		mov eax, dword ptr [esi+ecx*4]");
asm("		mov ebx, eax");
asm("		shr eax, 17");		// ebx is 'i'
asm("		and ebx, 0x1FFFF");	// eax is s
asm("		or  eax, 0x10000");

asm("		btr dword ptr [edi], ebx");
asm("		add ebx, eax");
asm("		cmp ebx, "SIEVEBITSA"");
asm("		jae Done2");

asm("		btr dword ptr [edi], ebx");
asm("		add ebx, eax");
asm("Done2:");
asm("		shl eax, 17");
asm("		sub ebx, "SIEVEBITSA"");
asm("		or eax, ebx");
asm("		mov dword ptr [esi+ecx*4], eax");

asm("		inc ecx");
asm("		cmp ecx, 9428");
asm("		jb Clear2");

asm("Clear3:");
asm("		mov eax, dword ptr [esi+ecx*4]");
asm("		mov ebx, eax");
asm("		shr eax, 17");		// ebx is 'i'
asm("		and ebx, 0x1FFFF");	// eax is s
asm("		or  eax, 0x18000");

asm("		btr dword ptr [edi], ebx");
asm("		add ebx, eax");

asm("		cmp ebx, "SIEVEBITSA"");
asm("		jae Done3");

asm("		btr dword ptr [edi], ebx");
asm("		add ebx, eax");
asm("Done3:");
asm("		shl eax, 17");
asm("		sub ebx, "SIEVEBITSA"");
asm("		or eax, ebx");
asm("		mov dword ptr [esi+ecx*4], eax");

asm("		inc ecx");
asm("		cmp ecx, "SOE2PRIMESA"");
asm("		jb Clear3");

asm("		mov esi, dword ptr additional");
asm("		xor	ecx, ecx");
asm("		cmp dword ptr nadditional, 0");
asm("		je Alldone");

asm("Clear4:");
asm("		mov eax, dword ptr [esi+ecx*4]");
asm("		mov ebx, dword ptr [esi+ecx*4+4]");

asm("		cmp ebx, "SIEVEBITSA"");
asm("		jae Done4");

asm("		btr dword ptr [edi], ebx");
asm("		add ebx, eax");

asm("		cmp ebx, "SIEVEBITSA"");
asm("		jae Done4");

asm("		btr dword ptr [edi], ebx");
asm("		add ebx, eax");
asm("Done4:");
asm("		sub ebx, "SIEVEBITSA"");
asm("		mov dword ptr [esi+ecx*4+4], ebx");

asm("		add ecx,2");
asm("		cmp ecx, dword ptr nadditional");
asm("		jb Clear4");


asm("Alldone:");
asm("		.att_syntax" );

#endif
}


static void soe2_iteratefirsttime ()
{
	unsigned int i,j,s;

	// Do the small primes (3, 5, 7, 11, and 13) ...
	for (i = 0; i < SIEVEDWORDS; i++)
	{
		sieve[i] = smallprimesieve1[smallprimesieveindex1++];
		if (smallprimesieveindex1 == SMALLPRIMEVALS1) smallprimesieveindex1 = 0;

		sieve[i] &= smallprimesieve2[smallprimesieveindex2++];
		if (smallprimesieveindex2 == SMALLPRIMEVALS2) smallprimesieveindex2 = 0;

		sieve[i] &= smallprimesieve3[smallprimesieveindex3++];
		if (smallprimesieveindex3 == SMALLPRIMEVALS3) smallprimesieveindex3 = 0;
	}
	

	// First bit: primes up to FFFF. These fit perfectly okay.
	for (j = 0; j < 6531; j++)
	{
		s = primetable2[j].prime;
		i = primetable2[j].ixt;

		if (i<SIEVEBITS)
		{
			do
			{
				sieve[i>>5] &= notonebits[i&0x1F];
				i += s;
			} while (i<SIEVEBITS);
		}
		i -= SIEVEBITS;
		pr_ixt[j] = s | (i<<16);
	}

	// Then remaining primes. One bit is pinched by ixt.
	for (; j < SOE2PRIMES; j++)
	{
		s = primetable2[j].prime;
		i = primetable2[j].ixt;

		if (i<SIEVEBITS)
		{
			do
			{
				sieve[i>>5] &= notonebits[i&0x1F];
				i += s;
			} while (i<SIEVEBITS);
		}
		i -= SIEVEBITS;

		pr_ixt[j] = (s<<17) | i;
	}

	// Finally any additional ones
	for (j = 0; j < nadditional; j++)
	{
		s = additional[j++];
		i = additional[j];

		if (i<SIEVEBITS)
		{
			do
			{
				sieve[i>>5] &= notonebits[i&0x1F];
				i += s;
			} while (i<SIEVEBITS);
		}
		i -= SIEVEBITS;

		additional[j] = i;
	}
		
}

void soe2_memory (int KbCache)
{
	unsigned i;

	if (sieve == NULL)
	{
		sieve = new unsigned[SIEVEDWORDS+4];
	}

	if (smallprimesieve1 == NULL)
	{
		smallprimesieve1 = new unsigned[SMALLPRIMELEN1];
		smallprimesieve2 = new unsigned[SMALLPRIMELEN2];
		smallprimesieve3 = new unsigned[SMALLPRIMELEN3];

		memset (smallprimesieve1, 0xFF, SMALLPRIMELEN1<<2);
		memset (smallprimesieve2, 0xFF, SMALLPRIMELEN2<<2);
		memset (smallprimesieve3, 0xFF, SMALLPRIMELEN3<<2);

		for (i = 2; i < SMALLPRIMELEN2<<5; i+= 3) smallprimesieve2[i>>5] &= notonebits[i&0x1F];
		for (i = 3; i < SMALLPRIMELEN1<<5; i+= 5) smallprimesieve1[i>>5] &= notonebits[i&0x1F];
		for (i = 4; i < SMALLPRIMELEN2<<5; i+= 7) smallprimesieve2[i>>5] &= notonebits[i&0x1F];
		for (i = 6; i < SMALLPRIMELEN3<<5; i+=11) smallprimesieve3[i>>5] &= notonebits[i&0x1F];
		for (i = 7; i < SMALLPRIMELEN2<<5; i+=13) smallprimesieve2[i>>5] &= notonebits[i&0x1F];
		for (i = 9; i < SMALLPRIMELEN2<<5; i+=17) smallprimesieve2[i>>5] &= notonebits[i&0x1F];
		for (i =10; i < SMALLPRIMELEN3<<5; i+=19) smallprimesieve3[i>>5] &= notonebits[i&0x1F];
		for (i =12; i < SMALLPRIMELEN3<<5; i+=23) smallprimesieve3[i>>5] &= notonebits[i&0x1F];
		for (i =15; i < SMALLPRIMELEN1<<5; i+=29) smallprimesieve1[i>>5] &= notonebits[i&0x1F];
		for (i =16; i < SMALLPRIMELEN1<<5; i+=31) smallprimesieve1[i>>5] &= notonebits[i&0x1F];
	}

	if (primetable2 == NULL)
	{
		primetable2 = new _primetable2[SOE2PRIMES];

		for (i = 0; i < SOE2PRIMES; i++)
		{
			primetable2[i].prime = primetable[i+10];
		}
	}

	if (pr_ixt == NULL)
	{
		pr_ixt = new unsigned[SOE2PRIMES];
	}
}

unsigned __int64 *soe2primes = NULL;
int soe2primesindex;
__int64 soe2base;
unsigned *sieveptr, *endsieveptr;

static void soe2_fill ()
{
	/*
	 * Jean - again for the sake of performance, I really want this code to be here
	 * rather than in an external module, so it can be inlined.
	 *

	*/
#ifndef __GNUC__	 

	_asm
	{
		mov esi, dword ptr soe2base
		mov ecx, dword ptr soe2base+4
		mov ebx, sieveptr
		mov edi, dword ptr soe2primes
		mov edx, dword ptr [ebx+12]
		add esi, 256					// soe2base += 256
		adc ecx, 0
		mov dword ptr soe2base, esi		// Save it away.
		mov dword ptr soe2base+4, ecx
		bsr eax, edx
		jz done3

topof3loop:
		btr edx, eax
		lea eax, [esi+eax*2+191]
		mov dword ptr [edi], eax
		mov dword ptr [edi+4], ecx

		add edi, 8

		bsr eax, edx
		jnz topof3loop

done3:
		mov edx, dword ptr [ebx+8]
		bsr eax, edx
		jz done2

topof2loop:
		btr edx, eax
		lea eax, [esi+eax*2+127]
		mov dword ptr [edi], eax
		mov dword ptr [edi+4], ecx

		add edi, 8

		bsr eax, edx
		jnz topof2loop

done2:
		mov edx, dword ptr [ebx+4]
		bsr eax, edx
		jz done1

topof1loop:
		btr edx, eax
		lea eax, [esi+eax*2+63]
		mov dword ptr [edi], eax
		mov dword ptr [edi+4], ecx

		add edi, 8

		bsr eax, edx
		jnz topof1loop

done1:
		mov edx, dword ptr [ebx]
		bsr eax, edx
		jz alldone

topof0loop:
		btr edx, eax
		lea eax, [esi+eax*2]		// *Not* lea eax,[esi+eax*2-1]
		sub eax, 1
		sbb ecx, 0
		mov dword ptr [edi], eax
		mov dword ptr [edi+4], ecx

		add edi, 8

		bsr eax, edx
		jnz topof0loop

alldone:
		sub edi, dword ptr soe2primes
		add ebx, 16
		shr edi, 3
		mov dword ptr soe2primesindex, edi
		mov dword ptr sieveptr, ebx
	}

#else

	/*
	 * Jean - put your call to an external routine here. If I change the asm above, 
	 * I will also change it in your code
	 */

//	soe2_fillasm ();

	/*
	 * Paul - I am now using inline GNUC assembler, so I don't need the previous
	 * call more, and you can also inline this code.
	 */

asm(		".intel_syntax noprefix");
asm("		mov esi, dword ptr soe2base");
asm("		mov ecx, dword ptr soe2base+4");
asm("		mov ebx, sieveptr");
asm("		mov edi, dword ptr soe2primes");
asm("		mov edx, dword ptr [ebx+12]");
asm("		add esi, 256");			// soe2base += 256
asm("		adc ecx, 0");
asm("		mov dword ptr soe2base, esi");	// Save it away.
asm("		mov dword ptr soe2base+4, ecx");
asm("		bsr eax, edx");
asm("		jz done3");

asm("topof3loop:");
asm("		btr edx, eax");
asm("		lea eax, [esi+eax*2+191]");
asm("		mov dword ptr [edi], eax");
asm("		mov dword ptr [edi+4], ecx");

asm("		add edi, 8");

asm("		bsr eax, edx");
asm("		jnz topof3loop");

asm("done3:");
asm("		mov edx, dword ptr [ebx+8]");
asm("		bsr eax, edx");
asm("		jz done2");

asm("topof2loop:");
asm("		btr edx, eax");
asm("		lea eax, [esi+eax*2+127]");
asm("		mov dword ptr [edi], eax");
asm("		mov dword ptr [edi+4], ecx");

asm("		add edi, 8");

asm("		bsr eax, edx");
asm("		jnz topof2loop");

asm("done2:");
asm("		mov edx, dword ptr [ebx+4]");
asm("		bsr eax, edx");
asm("		jz done1");

asm("topof1loop:");
asm("		btr edx, eax");
asm("		lea eax, [esi+eax*2+63]");
asm("		mov dword ptr [edi], eax");
asm("		mov dword ptr [edi+4], ecx");

asm("		add edi, 8");

asm("		bsr eax, edx");
asm("		jnz topof1loop");

asm("done1:");
asm("		mov edx, dword ptr [ebx]");
asm("		bsr eax, edx");
asm("		jz alldone");

asm("topof0loop:");
asm("		btr edx, eax");
asm("		lea eax, [esi+eax*2]");		// *Not* lea eax,[esi+eax*2-1]
asm("		sub eax, 1");
asm("		sbb ecx, 0");
asm("		mov dword ptr [edi], eax");
asm("		mov dword ptr [edi+4], ecx");

asm("		add edi, 8");

asm("		bsr eax, edx");
asm("		jnz topof0loop");

asm("alldone:");
asm("		sub edi, dword ptr soe2primes");
asm("		add ebx, 16");
asm("		shr edi, 3");
asm("		mov dword ptr soe2primesindex, edi");
asm("		mov dword ptr sieveptr, ebx");
asm("		.att_syntax" );

#endif
}

inline __int64 soe2_next ()
{
	__int64 p;

	while (soe2primesindex == 0) 
	{
		if (sieveptr == endsieveptr)
		{
			if (soe2base > maxpforadditional && nadditional < MAXADDITIONAL)
			{
				nadditional += 1000;
				maxpforadditional = additional[nadditional-2];
				maxpforadditional *= maxpforadditional;
				maxpforadditional -= 100000;

				for (int i = nadditional-1000; i < nadditional; i++)
				{
					__int64 j1 = (soe2base+256)/2;

					unsigned candidate = additional[i++];
					additional[i]=(candidate*3+1)>>1;
					additional[i] -= (int)(j1%candidate);
					if (additional[i] > candidate) 
						additional[i] -= candidate;
				}
			}
			soe2_iterate ();
			sieveptr = sieve;
		}

		soe2_fill ();
	}

	p = soe2primes[--soe2primesindex];
	
	return p;
}

__int64 soe2_peek ()
{
	while (soe2primesindex == 0) 
	{
		if (sieveptr == endsieveptr)
		{
			soe2_iterate ();
			sieveptr = sieve;
		}
		soe2_fill ();
	}

	return soe2primes[soe2primesindex-1];
}

void soe2_init (__int64 firstp, bool fKeepPrime)
{
	__int64 j1;
	int j;

	// Set up the sieve...
	for(j=0;j<SOE2PRIMES;j++)
		primetable2[j].ixt=(primetable2[j].prime*3+1)>>1;

	j1 = firstp/(SIEVEBITS*2);

	if (j1)
	{
		for(j=0;j<SOE2PRIMES;j++)
		{
			primetable2[j].ixt -= (int)((j1*SIEVEBITS)%primetable2[j].prime);
			if (primetable2[j].ixt > primetable2[j].prime) 
				primetable2[j].ixt -= primetable2[j].prime;
		}
	}

	// ...done.

	smallprimesieveindex1 = (int)((j1*SIEVEDWORDS)%SMALLPRIMEVALS1);
	smallprimesieveindex2 = (int)((j1*SIEVEDWORDS)%SMALLPRIMEVALS2);
	smallprimesieveindex3 = (int)((j1*SIEVEDWORDS)%SMALLPRIMEVALS3);
	soe2base = j1*SIEVEBITS*2-256;

#ifndef __GNUC__
	maxpforadditional = 0x3FFFFFFFFFFFFFFF;
#else
	maxpforadditional = 0x3FFFFFFFFFFFFFFFLL;
#endif

	if (fKeepPrime)
	{
		// Get additional primes
		if (additional) free (additional);
		nadditional = 0;

		additional = (unsigned *)malloc (MAXADDITIONAL*sizeof (unsigned));

		maxpforadditional = primetable2[SOE2PRIMES-1].prime;
		maxpforadditional *= maxpforadditional;
		maxpforadditional -= 100000;

		__int64 save = maxpforadditional;

		soe2_init (primetable2[SOE2PRIMES-1].prime+1, false);

		for (j= 0; j < MAXADDITIONAL; j+=2)
		{
			additional[j] = soe2_next ();
		}

		maxpforadditional = save;

		while (firstp > maxpforadditional && nadditional < MAXADDITIONAL)
		{
			nadditional += 1000;
			maxpforadditional = additional[nadditional-2];
			maxpforadditional *= maxpforadditional;
			maxpforadditional -= 100000;
		}

		save = maxpforadditional;

		for (j = 0; j < nadditional; j++)
		{
			unsigned candidate = additional[j++];
			additional[j]=(candidate*3+1)>>1;
			additional[j] -= (int)((j1*SIEVEBITS)%candidate);
			if (additional[j] > candidate) 
				additional[j] -= candidate;
		}

		// Get things straightened out again.
		soe2_init (firstp, false);

		maxpforadditional = save;

		return;
	}

	soe2_iteratefirsttime ();
	sieveptr = sieve;
	endsieveptr = sieveptr+SIEVEDWORDS;
	soe2primesindex = 0;

	if (soe2primes == NULL) soe2primes = new unsigned __int64[128];
	if (j1 == 0) 
	{
		// Make sure that the '3', 5, 7, 11, etc bits are set.
		// But clear the '-1' and '1' bits.
		sieve[0] = 0xC96996DC;
	}

	while (soe2_peek () <= firstp)
	{
		soe2_next ();
	}

	MAXGUAR = primetable2[SOE2PRIMES-1].prime;
	MAXGUAR *= primetable2[SOE2PRIMES-1].prime;
}


/**************************************
 * This does the meat of the work.
 * It goes potential divisors, ensuring that they are not divisible
 * by the primes less than MAX_PRIMECANDIDATE
 **************************************/
static void dosieve (bool fOccasionalWrites)
{
	__int64 p = 0;
	time_t WriteIterationsTime = time (NULL) + 60*WriteIterations;
	unsigned int i;
	unsigned int expn = (mode & (MODE_KSIEVE|MODE_DUAL)) ? 1<<20 : 1<<24;
	unsigned int last_pandexpn = (unsigned int)(firstp&expn);

	multivals_lastprime = 0;
	AllRemoved = false;
	LastNow = time (NULL);
	nopsthreshold = 10000000;
	nops = 0;
	
	fFirstTime = true;

	EstimateSize ();

//	Paul - This code is only used for some messages in Primorial mode...

	char*	kExprptr = kExpression;
	if (fMyPrimorial)
	{
		for (i = 0; i < nMyPrimorial; i++)
		{
			sprintf (kExprptr, LL_FORMAT"*", MyPrimorial[i]);
			kExprptr += strlen(kExprptr);
		}
		kExpression[strlen(kExpression)-1] = 0;
	}

	/* 
	 * Paul - The following code, executed one time per sieve (so, yielding
	 * no penalty...), has two goals : 
	 * Firstly, it tests if maxp is greater than the square root of the max.
	 * value to sieve, and, if so, adjust the maxp value ; in this case, the
	 * sieve will give an all primes result !
	 * Secondly, it looks for the possibility that smallest values could
	 * be cleared due to dividing themselves, althoug beeing prime...
	 * this happens really if n (or k, in fixed k modes) is very small.
	 * the code sets a "tiny" boolean in these cases.
	 * only if "tiny" is set, special remove routines (or work routines, in
	 * fixed k modes) are used instead of the standard ones, so the
	 * performances of the program are always preserved.
	 */ 
 


	sievelimit = 0;				// Means no sieve limit...
	allprimes = false;
	char prbuff[1024];

	if (mode & MODE_KSIEVE)
 	    if (mode & MODE_PRIMORIAL) {	// Used by PrimoProth modes
		if ((LogPrimorial + MaxNum * log ((double)base)) < 87.33)
		    sievelimit = (__int64)ceil (exp ((LogPrimorial + MaxNum * log ((double)base))/2)) + 10;
		if (sievelimit && maxp > sievelimit) {
		    maxp = sievelimit;	// maxp is greater than the square root
		    allprimes = true;	// of the greatest number to test, so
		}			// the sieve will yield all primes result !!
		tiny = ((LogPrimorial + MinNum * log ((double)base)) <= log ((double)maxp)) ? true : false;
		if (tiny) {
		    tinyPrimorial = PackPrimorial[0];
		    k_base_power_n = kbasepown (tinyPrimorial, (unsigned int)MinNum);
		    if (maxp > tinyPrimorial)
			maxtiny = (unsigned int)floor((log ((double)maxp) - LogPrimorial)/log ((double)base));
		    else
			maxtiny = 0;
		    if (!fMyPrimorial)
			sprintf (prbuff, "k is tiny : %d#*%d^%d = "LL_FORMAT, (unsigned int)nvalue, base, (unsigned int)MinNum, k_base_power_n);
		    else
			sprintf (prbuff, "k is tiny : %s*%d^%d = "LL_FORMAT, kExpression, base, (unsigned int)MinNum, k_base_power_n);
		    print (prbuff);
		}
	    }
	    else {				// Used by k fixed k*2^n�1 modes
		if ((log ((double)nvalue) + MaxNum * log ((double)base)) < 87.33)
		    sievelimit = (__int64)ceil (exp ((log((double)nvalue) + MaxNum * log ((double)base))/2)) + 10;
		if (sievelimit && maxp > sievelimit) {
		    maxp = sievelimit;	// maxp is greater than the square root
		    allprimes = true;	// of the greatest number to test, so
		}			// the sieve will yield all primes result !!
		tiny = ((log ((double)nvalue) + MinNum * log ((double)base)) <= log ((double)maxp)) ? true : false;
		if (tiny) {
		    k_base_power_n = kbasepown(nvalue, (unsigned int)MinNum);
		    if (maxp > nvalue)
			maxtiny = (unsigned int)floor((log ((double)maxp) - log((double)nvalue))/log ((double)base));
		    else
			maxtiny = 0;
		    sprintf (prbuff, "k is tiny : %d*%d^%d = "LL_FORMAT, (unsigned int)nvalue, base, (unsigned int)MinNum, k_base_power_n);
		    print (prbuff);
		}
	    }
	else if (mode & MODE_DUAL) {		// Used by k fixed 2^n�k modes
		if ((MaxNum * log ((double)base)) < 87.33)
		    sievelimit = (__int64)ceil (exp ((MaxNum * log ((double)base))/2)) + nvalue;
		if (sievelimit && maxp > sievelimit) {
		    maxp = sievelimit;	// maxp is greater than the square root
		    allprimes = true;	// of the greatest number to test, so
		}			// the sieve will yield all primes result !!
		tiny = ((MinNum * log ((double)base)) <= log ((double)maxp)) ? true : false;
		if (tiny) {
		    k_base_power_n = kbasepown(1, (unsigned int)MinNum);
		    if ((mode & MODE_PLUS) && maxp > nvalue) {
			maxtiny = (unsigned int)floor(log ((double)(maxp - nvalue))/log ((double)base));
			sprintf (prbuff, "k is tiny : %d^%d+%d = "LL_FORMAT, base, (unsigned int)MinNum, (unsigned int)nvalue, k_base_power_n + nvalue);
			print (prbuff);
		    }
		    else if (mode & MODE_MINUS) {
			maxtiny = (unsigned int)floor(log ((double)(maxp + nvalue))/log ((double)base));
			sprintf (prbuff, "k is tiny : %d^%d-%d = "LL_FORMAT, base, (unsigned int)MinNum, (unsigned int)nvalue, k_base_power_n - nvalue);
			print (prbuff);
		    }
		    else {
			tiny = false;
			maxtiny = 0;
		    }
		}
	}
	else if (mode & MODE_AP)
 	    if (mode & MODE_PRIMORIAL) {		// Used by n#+2*k-1 modes
		if (LogPrimorial < 87.33)
		    sievelimit = (__int64)ceil (exp (LogPrimorial/2) + sqrt (2.0*(double)MaxNum - 1.0));
		if (sievelimit && maxp > sievelimit) {
		    maxp = sievelimit;	// maxp is greater than the square root
		    allprimes = true;	// of the greatest number to test, so
		}			// the sieve will yield all primes result !!
		tiny = (LogPrimorial < log ((double)maxp + 1. -2.0*(double)MinNum)) ? true : false;
		if (tiny) {
		    tinyPrimorial = PackPrimorial[0];
		    sprintf (prbuff, "n is tiny : %d#+2*%d-1 = "LL_FORMAT, (unsigned int)nvalue, (unsigned int)MinNum, tinyPrimorial+2*MinNum-1);
		    print (prbuff);
		}
	    }
	    else {				// Used by base^n+2*k-1 modes
		if ((nvalue * log ((double)base)) < 87.33)
		    sievelimit = (__int64)ceil (exp (nvalue * log ((double)base)/2) + sqrt (2.0*(double)MaxNum - 1.0));
		if (sievelimit && maxp > sievelimit) {
		    maxp = sievelimit;	// maxp is greater than the square root
		    allprimes = true;	// of the greatest number to test, so
		}			// the sieve will yield all primes result !!
		tiny = (nvalue * log ((double)base) < log ((double)maxp + 1. -2.0*(double)MinNum)) ? true : false;
		if (tiny) {
		    base_power_n = kbasepown (1, (unsigned int)nvalue);
		    sprintf (prbuff, "n is tiny : %d^%d+2*%d-1 = "LL_FORMAT, base, (unsigned int)nvalue, (unsigned int)MinNum, base_power_n+2*MinNum-1);
		    print (prbuff);
		}
	    }
	else					// Used by all other n fixed modes
 	    if (mode & MODE_PRIMORIAL) {
		if ((log ((double)MaxNum) + LogPrimorial) < 87.33)
		    sievelimit = (__int64)ceil (
			
			exp (
			    (log ((double)MaxNum) + LogPrimorial)/2
				)
			
			) + 10;

		if (sievelimit && maxp > sievelimit) {
		    maxp = sievelimit;	// maxp is greater than the square root
		    allprimes = true;	// of the greatest number to test, so
		}			// the sieve will yield all primes result !!
		tiny = ((log ((double)MinNum) + LogPrimorial) <= log ((double)maxp)) ? true : false;
		if (tiny) {
		    tinyPrimorial = PackPrimorial[0];
		    sprintf (prbuff, "n is tiny : %d*%d# = "LL_FORMAT, (unsigned int)MinNum, (unsigned int)nvalue, MinNum * tinyPrimorial);
		    print (prbuff);
		}
	    }
	    else {
		if ((log ((double)MaxNum) + nvalue * log ((double)base)) < 87.33)
		    sievelimit = (__int64)ceil (exp ((log((double)MaxNum) + nvalue * log ((double)base))/2)) + 10;
		if (sievelimit && maxp > sievelimit) {
		    maxp = sievelimit;	// maxp is greater than the square root
		    allprimes = true;	// of the greatest number to test, so
		}			// the sieve will yield all primes result !!
		tiny = ((log ((double)MinNum) + nvalue * log ((double)base)) <= log ((double)maxp)) ? true : false;
		if (tiny) {
		    k_base_power_n = kbasepown (MinNum, (unsigned int)nvalue);
		    base_power_n = kbasepown (1, (unsigned int)nvalue);
		    sprintf (prbuff, "n is tiny : %d*%d^%d = "LL_FORMAT, (unsigned int)MinNum, base, (unsigned int)nvalue, k_base_power_n);
		    print (prbuff);
		}
    }

	saveb = savep = pindex = 0;

	for (i = 0; i < 20; i++)
	{
		LastTime[i] = savenvalsleft[i] = 0;
	}
	rateindex = 0;
	trailrateindex = 1;

	print ("#s");
	print ("Initialising sieve...");
	
	// Get the function pointing at the relevant routine to do the work 
	// depending on the type of sieve

	if (mode & MODE_KSIEVE)
	{
		if (base != 2 && !(mode & MODE_PRIMORIAL) && !(mode & MODE_DUAL))
		{
			FindBaseInverses ();
			workprocedure = DoKSieveOtherBases;
		}
		else if (MaxNum-MinNum >= NEWFIXEDKTHRESHOLD)
			workprocedure = (tiny) ? DoKSieve_tiny : DoKSieve;
		else
			workprocedure = (tiny) ? DoKSieveOld_tiny : DoKSieveOld;
	}
	else if (mode & MODE_DUAL)
    {
		if (base != 2 && !(mode & MODE_PRIMORIAL))
		{
			FindBaseInverses ();
			workprocedure = DoKSieveOtherBases;
		}
        else
        {
		    workprocedure = (tiny) ? DoKSieve_tiny : DoKSieve;
        }
    }
	else if (mode & MODE_PRIMORIAL)
	{
		if (mode & MODE_AP)
		{
			if (firstp < TWOTO32)
				workprocedure = WorkProcPrimorial_AP_Smallp;
			else
				workprocedure = WorkProcPrimorial_AP_Bigp;
		}
		else
		{
			if (firstp < TWOTO32)
				workprocedure = WorkProcPrimorial_Smallp;
			else
				workprocedure = WorkProcPrimorial_Bigp;
		}
	}
	else if (base != 2)
	{
		if (mode & MODE_AP)
			workprocedure = WorkProcNotBase2_AP;
		else if (FindBaseInverses ())
		{
			MaxpForWorkProcNotBase2 = TWOTO63/base;
			workprocedure = WorkProcNotBase2;
		}
		else
			workprocedure = WorkProcNotBase2_NoInverses;
	}
	else
	{
		if (firstp < TWOTO32)
		{
			if (mode & MODE_AP)
				workprocedure = WorkProcBase2_AP_Smallp;
			else
				workprocedure = WorkProcBase2_Smallp;
		}
		else if (mode & MODE_AP)
			workprocedure = WorkProcBase2_AP_Bigp;
#ifndef _DEBUG
        else if (fSSE2)
			workprocedure = WorkProcBase2_SSE2_Bigp;
#endif
		else if (!fCMOV)
			workprocedure = WorkProcBase2_NoCMOV_Bigp;
		else if (firstp < TWOTO47)
			workprocedure = WorkProcBase2_Bigp;
		else
			workprocedure = WorkProcBase2_VeryBigp;
	}

	// Get the remove routine pointing at the relevant procedure.
	switch (mode & ~(MODE_PRIMORIAL|MODE_NOTGENERALISED|MODE_MOREHEAD|MODE_EVENKS))
	{
	case MODE_PLUS:
		RemoveRoutine = (tiny) ? Remove_Plus_tiny : Remove_Plus;
		if (!tiny && workprocedure == WorkProcBase2_Bigp)
			workprocedure = WorkProcBase2_Plus_Bigp;
		break;
	case MODE_MINUS:
		RemoveRoutine = (tiny) ? Remove_Minus_tiny : Remove_Minus;
		if (!tiny && workprocedure == WorkProcBase2_Bigp)
			workprocedure = WorkProcBase2_Minus_Bigp;
		break;
	case MODE_TWIN:
		RemoveRoutine = (tiny) ? Remove_Twin_tiny : Remove_Twin;
		if (!tiny && workprocedure == WorkProcBase2_Bigp)
			workprocedure = WorkProcBase2_Twin_Bigp;
		break;
	case MODE_SG:
		//RemoveRoutine = Remove_Special;
		RemoveRoutine = (tiny) ? Remove_SG_tiny : Remove_SG;
		break;
	case MODE_CC:
		RemoveRoutine = (tiny) ? Remove_CC_tiny : Remove_CC;
		break;
	case MODE_BI:
		RemoveRoutine = (tiny) ? Remove_Bi_tiny : Remove_Bi;
		break;
	case MODE_IJ:
		RemoveRoutine = (tiny) ? Remove_IJ_tiny : Remove_IJ;
		break;
	case MODE_IJ2:
		RemoveRoutine = (tiny) ? Remove_IJ2_tiny : Remove_IJ2;
		break;
	case MODE_LP:
		RemoveRoutine = (tiny) ? Remove_LP_tiny : Remove_LP;
		break;
	case MODE_LM:
		RemoveRoutine = (tiny) ? Remove_LM_tiny : Remove_LM;
		break;
	case MODE_CC13:
		RemoveRoutine = (tiny) ? Remove_CC13_tiny : Remove_CC13;
		if (tiny) {
		    if (b_array != NULL)
			free (b_array);
		    b_array = (__int64 *)malloc ((unsigned int)len3plus*8);
		}
		break;
	case MODE_CC23:
		RemoveRoutine = (tiny) ? Remove_CC23_tiny : Remove_CC23;
		if (tiny) {
		    if (b_array != NULL)
			free (b_array);
		    b_array = (__int64 *)malloc ((unsigned int)len3plus*8);
		}
		break;
	case MODE_BI3:
		RemoveRoutine = (tiny) ? Remove_BI3_tiny : Remove_BI3;
		if (tiny) {
		    if (b_array != NULL)
			free (b_array);
		    b_array = (__int64 *)malloc ((unsigned int)len3plus*8);
		}
		break;
	case MODE_AP:
		RemoveRoutine = (tiny) ? Remove_AP_tiny : Remove_AP;
		break;
	case MODE_3TUPLE:
		RemoveRoutine = (tiny) ? Remove_3tuple_tiny : Remove_3tuple;
		break;
	case MODE_4TUPLE:
		RemoveRoutine = (tiny) ? Remove_4tuple_tiny : Remove_4tuple;
		break;
	case MODE_PLUSKSIEVE:
		RemoveRoutine = Remove_Plus;
		break;
	case MODE_MINUSKSIEVE:
		RemoveRoutine = Remove_Minus;
		break;
	case MODE_SG3:
		RemoveRoutine = (tiny) ? Remove_SG3_tiny : Remove_SG3;
		break;
	}

	// Get the 'clear' routine pointing at the right procedure.
	if (fUseHash)
	{
		ClearRoutine = ClearHash;
	}
	else if (fUseBitMap)
	{
		switch (mode & ~(MODE_PRIMORIAL|MODE_NOTGENERALISED|MODE_EVENKS|MODE_MOREHEAD))
		{
		case MODE_PLUS:
		case MODE_MINUS:
		case MODE_AP:
		case MODE_PLUSKSIEVE:
		case MODE_MINUSKSIEVE:
		case MODE_PLUSDUAL:
		case MODE_MINUSDUAL:
			ClearRoutine = ClearBitmapSmallp;
			break;
		default:
			ClearRoutine = ClearBitmapSmallpMultivals;
			break;
		}
	}
	else
	{
		if ((log (nvals)*(MaxNum-MinNum))/((double)nvals * firstp * (fIncIsTwo ? 2 : 1)) < SPARSE_FACTOR)
		{
			ClearRoutine = ClearArray;
		}
		else
		{
			ClearRoutine = ClearSparseArray;
			print ("Using sparse array algorithm");
		}
	}

	// Find the top set bit in nvalue, then move down 1 bit...
	if (! (mode & (MODE_KSIEVE|MODE_DUAL)))
	{
		firstbit32 = 0x80000000;
		while ((nvalue & firstbit32) == 0) firstbit32 >>= 1;
		firstbit32 >>= 1;
	}
	else
	{
		firstbit32 = 0x80000000;
		while ((MaxNum & firstbit32) == 0) firstbit32 >>= 1;
		firstbit32 >>= 1;
	}
	// ...done.

	_control87(_PC_64, MCW_PC);		// Just in case... I once saw the FPU jump out of 64 bit mode, I don't know why.

	// Initialise the SoE
	soe2_init (firstp, false);

	print ("Done.");

	time_t Now = time (NULL);
	struct tm *newtime = localtime( &Now);
	char *asctim = asctime( newtime );
	asctim[19] = 0;
	asctim += 11;

	fprint ("%s Starting sieve %s", asctim, (firstp < 1000000000 && !(mode & (MODE_KSIEVE|MODE_DUAL)))?"(reduced screen output while p < 1 billion)" : "");

    if (fCMOV && ((mode&~MODE_MOREHEAD) == (MODE_KSIEVE|MODE_PLUS) || (mode&~MODE_MOREHEAD) == (MODE_KSIEVE|MODE_MINUS)) && base == 2)
    {
		if (firstp != 702) Base2KSieve ();
		if (firstp == 702) Base2KSieve ();
        return;
    }

	// OK, this is the sieve. 
	for (;;)
	{
		p = soe2_next ();

		// Output to screen/to file every now and then.
		if ((((unsigned)p&expn) != last_pandexpn) || !(State & 3) || p >= maxp)
		{
			static double num;
			static char* format;


	/* 
	 * Paul - I implemented "QueryPerformanceCounter()" function for GNUC,
	 * using "gettimeofday()" ; it seems to be OK, so, you can even use your
	 * test code on these platforms.
	 */ 
 
			if (fTest)
			{
				static __int64 last = 0;
				LARGE_INTEGER now;
				static double ave = 0.0;
				static int count = 0;

				QueryPerformanceCounter (&now);
				if (last)
				{
					ave *= (count-1);
					ave += now.QuadPart - last;
					ave /= count;

					fprint ("microsecs: Last: %I64d; ave: %.0f", now.QuadPart - last, ave);
				}
				count++;
				last = now.QuadPart;
			}

			last_pandexpn = ((unsigned)p&expn);

			if (p < MILLION)
			{
				fprint ("#sSieved up to "LL_FORMAT"", p);
			}
			else
			{
				if (p > MILLION) {num = p /1000000.0; format = "million";}
				if (p > BILLION) {num = p /1000000000.0; format = "billion";}
				if (p > TRILLION) {num = p /1000000000000.0; format = "trillion";}

				fprint ("#sSieved up to "LL_FORMAT" (%.1f %s)", p, num-0.05, format);
			}
			time_t Now = time (NULL);

			int secs = Now - LastNow;

			if (secs > 5)
			{
				double factor = 2.0/secs;
				factor *= nopsthreshold;
				if (factor < BIGFACTOR) nopsthreshold = (unsigned)factor; else nopsthreshold = BIGFACTOR;
			}

			if (State == 2 && StopCriterion == DATETIME && Now > StopTime + StopValue*3600)
			{
				State = 0;
			}

			if (((State == 2 || State == 1) && fOccasionalWrites && Now > WriteIterationsTime) || (State != 2 && State != 1) || p >= maxp)
			{
				if (allprimes && p > maxp)
					print ("#rSieve terminated : All remaining values yield prime numbers !!");
				if ((State != 2 && State != 1) || p >= maxp || (State == 2 && StopCriterion == DATETIME && Now > StopTime + StopValue*3600)) 
				{
					if (fAppend && State == 4) return;

					if (ClearRoutine == ClearBitmapSmallpMultivals)
					{
						// There will still be a value waiting to go.
						(*ClearRoutine)(1,2);
					}
					
					outputandtidyvals (p, outbuff, fAppend);

					if (State != 1)
					{
						fprint ("#oOutput file '%s' generated, contains %u %c's", outbuff, nvalsleft, k_n); 
					}
					firstp = p;
					return;
				}
				else
				{
					WriteIterationsTime = Now + 60*WriteIterations;
					outputandtidyvals (p, outbuff, fAppend);
				}

			}
		}

		// OK, do some work.
		(*workprocedure) (p);

		// Stop this range if all values removed
		if (AllRemoved)
		{
			if (!fAppend) 
				// Make sure first line is written!
				outputandtidyvals (p, outbuff, fAppend);
			return;
		}
	}
}

/****************
 * Read the k,n values from a file.
 ***************/

bool readinfile (char *fname)
{
	unsigned int i;
	static char buff[1024];
	FILE *ifptr;
	__int64 kvalue;

	base = 0;
	mode = 1;

	ifptr = fopen (fname, "r");
	if (!ifptr)
	{
		// Can we open the backup?
		char fname2[1024];
		sprintf (fname2, "%s~", fname);
		ifptr = fopen (fname2, "r");
		if (!ifptr)
		{
			print("#mCannot open the input file");
			return false;
		}
	}

	firstp = 1;

	MinNum = 0;

	fMyPrimorial = false;
	
	for (i = 0; !feof (ifptr); i++)
	{
		if (fgets (buff, 1024, ifptr) != NULL)
		{
			buff[strlen (buff)-1] = '\0';
			if (sscanf (buff, LL_FORMAT" %d", &kvalue, &nvalue) != 2)
			{
				if (i == 0)
				{
					char nbuff[1024] = {0};

					// First row - should contain the sieve limit, the type, and len3plus from last time.
					// (Because we write that out to it, in the format <sieve limit>:<modechar>:<len3plus>:<mode value>)
					if (strchr (buff, ':') != NULL)
					{
						char modechar;

						// This contains the sieve limit and the type.
						if (sscanf (buff, "%[^:]:%c:%d:%d:%d", nbuff, &modechar, &len3plus, &base, &mode) != 5)
						{
							// Is it an ABC-format file?
							char *temp = strstr (buff, "//NewPGen:");

							if (temp == NULL || sscanf (temp+10, "%[^:]:%c:%d:%d:%d", nbuff, &modechar, &len3plus, &base, &mode) != 5)
							{
								print ("The file does not appear to be valid (the first line is wrong!)");
								return false;
							}
							else
							{
								// Get anything else set up as required - only the MyPrimorial in this case.
								*temp = 0;
								
								fMyPrimorial = true;

								nMyPrimorial = 0;
								temp = buff+4;
								for (;;)
								{
									MyPrimorial[nMyPrimorial++] = _atoi64 (temp);
									temp = strchr (temp, '*');
									if (!temp) break;
									temp++;
								}
								nMyPrimorial--;
							}
						}

						k_n = (mode&(MODE_KSIEVE|MODE_DUAL))?'n':'k';
						fprint ("Opened the input file - counting the number of %c's and finding the range of %c...", k_n, k_n); 
					}
					firstp = _atoi64 (nbuff);
				}
				i--;
			}
			else
			{
				if (mode & (MODE_KSIEVE|MODE_DUAL))
				{
					unsigned int temp = (unsigned int)kvalue;
					kvalue = nvalue;
					nvalue = temp;
				}

				MaxNum = kvalue;
				if (kvalue <= MinNum)
				{
					// Out of order!
					fprint ("The numbers in the file are not strictly increasing : I saw "LL_FORMAT" followed by "LL_FORMAT"!", MinNum, kvalue);
					return false;
				}
				if (MinNum == 0) MinNum = kvalue;
			}
		}
		else
		{
			break;
		}
	}

	if (i == 0)
	{
		fprint ("#oThe file is empty - there are no %c's to sieve", k_n); 
		return false;
	}
	
	// Delete any data structures that are hanging around
	DeleteBitmap ();
	DeleteVals ();
	DeleteHash ();

	if (MaxNum-MinNum <= BitMapThreshold)
	{
		fUseBitMap = true;
		fUseHash = false;

		range = (unsigned int)(1+MaxNum-MinNum);

		if (range >= 1024*1024*8)
		{
			fprint ("The file contains %u %c's - using bitmap : allocating %.1fMb of RAM...", i, k_n, (32 + range)/(8.0*1024*1024)); 
		}
		else
		{
			fprint ("The file contains %u %c's - using bitmap : allocating %.1fKb of RAM...", i, k_n, (32 + range)/(8.0*1024)); 
		}

		bitmap = (unsigned int *)malloc ((unsigned int)((32 + range)/8));

		if (bitmap != NULL)
		{
			print ("...succeeded");
			for (unsigned int i = 0; i < (32 + range)/32; i++)
				bitmap[i] = 0;
		}
		else
		{
			print ("...failed - you will have to split the file up.");
			print ("(If I just created the file it will be called PROTHGEN.TMP)");
			return false;
		}
	}
	else
	{
		fUseBitMap = false;

		// Can we safely use the Hash? Note that if the sparse array is faster, we
		// will use the sparse array.
		if (log(i)*((double)MaxNum-MinNum)/((double)i * firstp * (fIncIsTwo ? 2 : 1)) < SPARSE_FACTOR
			 && CanCreateHash (i, BitMapThreshold >> 3))
		{
			fUseHash = true;

			if (!CreateHash (i))
			{
				print ("...failed: trying to use array...");
				goto UseArray;
			}
			print ("...succeeded");
		}
		else
		{
UseArray:
			fUseHash = false;

			if (i > 1024*1024/sizeof(__int64))
			{
				fprint ("The file contains %u %c's - using array: allocating %.1fMb of RAM...", i,  k_n, i*sizeof(__int64)/(1024.0*1024)); 
			}
			else 
			{
				fprint ("The file contains %u %c's - using array: allocating %.1fKb of RAM...", i,  k_n, i*sizeof(__int64)/1024.0); 
			}

			vals = new __int64[i];

			if (vals != NULL)
			{
				print ("...succeeded");
			}
			else
			{
				print ("...failed - you will have to split the file up.");
				print ("(If I just created the file it will be called PROTHGEN.TMP)");
				return false;
			}
		}
	}
	rewind (ifptr);

	for (i = 0; !feof (ifptr); i++)
	{
		if (fgets (buff, 1024, ifptr) != NULL)
		{
			if (sscanf (buff, LL_FORMAT" %d", &kvalue, &nvalue) != 2)
			{
				i--;
			}
			else
			{
				if (mode & (MODE_KSIEVE|MODE_DUAL))
				{
					unsigned int temp = (unsigned int)kvalue;
					kvalue = nvalue;
					nvalue = temp;
				}
				if (fUseBitMap)
				{
					SetBit ((unsigned int)(kvalue-MinNum));
				}
				else if (fUseHash)
				{
					AddToHash (kvalue);
				}
				else
				{
					vals[i] = kvalue;
				}
			}
		}
		else
		{
			break;
		}
	}
	nvals = nvalsleft = i;

	fclose (ifptr);

	if ((mode & MASK_4) && !(mode & MODE_PRIMORIAL) && (base == 2 || !(mode & MODE_NOTGENERALISED)))
	{
		nvalue--;
	}

#ifndef __GNUC__ 
	fprint ("#l"LL_FORMAT"", MinNum);
	fprint ("#k"LL_FORMAT"", MaxNum);
#endif 

	return true;
}

bool CreateInitialFileBySplittingUpIntoRanges ()
{
	fUseBitMap = true;
	fUseHash = false;

	fprint ("Using bitmap : allocating %.1fMb of RAM...", (64 + BitMapThreshold)/(8.0*1024*1024));

	range = 1+(unsigned int)BitMapThreshold;

	DeleteBitmap ();
	DeleteVals ();
	DeleteHash ();

	bitmap = (unsigned int *)calloc ((unsigned int)((64 + BitMapThreshold)/32), 4);
	
	if (bitmap == NULL)
	{
		print ("...failed - you will have to decrease the Bitmap size.");
		return false;
	}

	__int64 SaveMinNum = MinNum, SaveMaxNum = MaxNum;

	MaxNum = MinNum + BitMapThreshold;

	if (StopCriterion == MAXP && StopValue < BILLION)
	{
		maxp = StopValue; 	// Taking in account the stop criterion !
	} 
	else 
	{ 
		maxp = BILLION; 
	} 


	char saveoutbuff[1024];
	strcpy (saveoutbuff, outbuff);
	strcpy (outbuff, "PROTHGEN.TMP");

	do
	{
		__int64 first = MinNum, i;
		unsigned int inc = 1;

		for (i = 0; i < ((unsigned int)(32 + range))/32; i++)
			bitmap[i] = 0;


		if (fIncIsTwo)
		{
			inc = 2;
			if ((first & 1) == (base & 1))
			{
				first++;
			}
		}

		for (nvals = 0, i = first; i <= MaxNum; i += inc)
		{
			SetBit ((unsigned int)(i-MinNum));
			nvals++;
		}

		print ("...succeeded");
		nvalsleft = nvals;

		if ((mode & MODE_PRIMORIAL) && !(mode & (MODE_AP|MODE_PLUS5)))
		{
			firstp = nvalue;
		}
		else
		{
			firstp = 1;
		}

		char buff[1024];
	    sprintf (buff, "Sieving from %c = "LL_FORMAT" to %c = "LL_FORMAT"...", k_n, MinNum, k_n, MaxNum);
		print (buff);

		fAppend = (MinNum != SaveMinNum);
		dosieve (false);

		MinNum = MaxNum + 1;
		MaxNum = MinNum + BitMapThreshold;

		if (MaxNum > SaveMaxNum) MaxNum = SaveMaxNum;
	} while (MinNum <= SaveMaxNum && State == 1);

	MinNum = SaveMinNum;
	MaxNum = SaveMaxNum;
	strcpy (outbuff, saveoutbuff);

	return true;
}

unsigned int __cdecl SieveFile (LPVOID fGenerateFile)
{
	static bool fGotCacheSize = false;

	// Set up the FPU state
	_control87(_PC_64, MCW_PC);
	_control87(_RC_NEAR, _MCW_RC);
	fFPURoundDown = false;

	State = 1;
	MArate = 0.0;

	sievefileasm();		// setup convert and call CPUID

	fCMOV = (CPUIDval & 0x00008000) != 0;
	fSSE2 = (CPUIDval & 0x04000000) != 0;

	fprint ("CPU capabilities: CMOV: %supported. SSE2: %supported.", fCMOV ? "S" : "Uns", fSSE2 ? "S" : "Uns");
	if (!fGotCacheSize)
	{
		fGotCacheSize = true;
		unsigned Cval;
		unsigned cachesize = 0;

		for (int i = 1; i <= 4; i++)
		{
			Cval = (i == 1)?Cval1:(i==2)?Cval2:(i==3)?Cval3:Cval4;
			if (!(Cval & 0x80000000))
			{
				for (int j = 0; j < 4; j++)
				{
					switch (Cval & 0xFF)
					{
					case 0x41: cachesize += 128; break;
					case 0x42: cachesize += 256; break;
					case 0x43: cachesize += 512; break;
					case 0x44: cachesize += 1024; break;
					case 0x45: cachesize += 2048; break;
					case 0x22: cachesize += 512; break;
					case 0x23: cachesize += 1024; break;
					case 0x25: cachesize += 2048; break;
					case 0x29: cachesize += 4096; break;
					case 0x79: cachesize += 128; break;
					case 0x7a: cachesize += 256; break;
					case 0x7b: cachesize += 512; break;
					case 0x7c: cachesize += 1024; break;
					case 0x82: cachesize += 256; break;
					case 0x83: cachesize += 512; break;
					case 0x84: cachesize += 1024; break;
					case 0x85: cachesize += 2048; break;
					}
					Cval >>= 8;
				}
			}
		}		

		soe2_memory (cachesize);
	}

	if (!(mode & MODE_PRIMORIAL) && (mode == MODE_LP || mode == MODE_LM)) nvalue--;

	if (mode & MODE_PRIMORIAL)
	{
		if (fMyPrimorial)	FillMyPackPrimorial ();
		else				FillPackPrimorial (nvalue);
	}

	fIncIsTwo = (!(mode & (MODE_PRIMORIAL|MODE_AP|MODE_KSIEVE|MODE_DUAL|MODE_EVENKS)) && (base == 2 || (base & 1)));
	if (mode & MODE_MOREHEAD) fIncIsTwo = true;

	k_n = (mode&(MODE_KSIEVE|MODE_DUAL))?'n':'k';

	switch (mode & ~(MODE_PRIMORIAL|MODE_KSIEVE|MODE_DUAL|MODE_MOREHEAD|MODE_NOTGENERALISED|MODE_EVENKS))
	{
	case MODE_PLUS:	 modechar = 'P'; break;
	case MODE_MINUS: modechar = 'M'; break;
	case MODE_TWIN:  modechar = 'T'; break;
	case MODE_3TUPLE:modechar = 'T'; break;
	case MODE_4TUPLE:modechar = 'T'; break;
	case MODE_AP:	 modechar = 'A'; break;
	case MODE_CC:	 modechar = 'C'; break;
	case MODE_SG:	 modechar = 'S'; break;
	case MODE_SG3:	 modechar = 'P'; break;
	case MODE_IJ:	 modechar = 'J'; break;
	case MODE_IJ2:	 modechar = 'K'; break;
	case MODE_LP:	 modechar = 'Y'; len3plus = 3; break;
	case MODE_LM:	 modechar = 'Z'; len3plus = 3; break;
	case MODE_BI:	 modechar = 'B'; break;
	case MODE_CC13:  modechar = '1'; break;
	case MODE_CC23:  modechar = '2'; break;
	case MODE_BI3:	 modechar = '3'; break;
	}

	if (MaxNum-MinNum > BitMapThreshold)
	{
		fUseBitMap = false;

		if (*(bool *)fGenerateFile)
		{
			if (!CreateInitialFileBySplittingUpIntoRanges () || !readinfile ("PROTHGEN.TMP"))
			{
				State = 0;
				print ("##");
				return 0;
			}
		}

		double num;
		char* format;
		if (firstp < MILLION)
		{
			fprint ("#sSieved up to "LL_FORMAT"", firstp);
		}
		else
		{
			if (firstp > MILLION) {num = firstp/1000000.0; format = "million";}
			if (firstp > BILLION) {num = firstp/1000000000.0; format = "billion";}
			if (firstp > TRILLION) {num = firstp/1000000000000.0; format = "trillion";}

			fprint ("#sSieved up to "LL_FORMAT" (%.1f %s)", firstp, num-0.05, format);
		}
	}
	else
	{
		fUseBitMap = true;
		fUseHash = false;

		range = 1+(unsigned int)(MaxNum-MinNum);

		if (*(bool *)fGenerateFile)
		{
			if (range >= 1024*1024*8)
			{
				fprint ("Using bitmap : allocating %.1fMb of RAM...", (32 + range)/(8.0*1024*1024)); 
			}
			else
			{
				fprint ("Using bitmap : allocating %.1fKb of RAM...", (32 + range)/(8.0*1024)); 
			}

			DeleteBitmap ();
			DeleteVals ();
			DeleteHash ();

			bitmap = (unsigned int *)calloc ((unsigned int)((64 + range)/32), 4);
			
			if (bitmap != NULL)
			{
				__int64 first = MinNum, inc = 1, i;

				if (fIncIsTwo)
				{
					inc = 2;

					if ((first & 1) == (base & 1))
					{
						first++;
					}
				}
				for (nvals = 0, i = first; i <= MaxNum; i += inc)
				{
					SetBit ((unsigned int)(i-MinNum));
					nvals++;
				}
				nvalsleft = nvals;
				print ("...succeeded");
			}
			else
			{
				print ("...failed - you will have to decrease the Bitmap size.");
				print ("##");
				return false;
			}

			if ((mode & MODE_PRIMORIAL) && !(mode & (MODE_AP|MODE_PLUS5)))
			{
				firstp = nvalue;
			}
			else
			{
				firstp = 1;
			}
		}
	}
	State = 2;

	if (StopCriterion == MAXP)
	{
		maxp = StopValue;
	}
	else
	{
		if (base != 2 || mode & (MODE_PRIMORIAL|MODE_AP|MODE_KSIEVE|MODE_DUAL))
		{
			maxp = MAX_PRIMECANDIDATE;
		}
		else
		{
			maxp = MAX_PRIMECANDIDATE_PROTHSIEVE;
		}
	}

	if (StopCriterion == DATETIME)
	{
		StopTime = time (NULL);
	}

	fprint ("#g%d candidates", nvalsleft);

	fAppend = false;
	dosieve (true);

	print ("##");

	return 0;
}
